/* A recursive-descent parser generated by greg 0.4.6 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
struct _GREG;
#define YYRULECOUNT 433

/*

	parser.leg -> parser.c -- Parse (Multi)Markdown plain text for
		conversion into other formats
	
	(c) 2013-2016 Fletcher T. Penney (http://fletcherpenney.net/).

	Derived from peg-multimarkdown, which was forked from peg-markdown,
	which is (c) 2008 John MacFarlane (jgm at berkeley dot edu), and 
	licensed under GNU GPL or MIT.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License or the MIT
	license.  See LICENSE for details.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
*/

#include "parser.h"
#include "writer.h"


/* Define shortcuts to adding nodes, etc. */
#define node(x)       mk_node(x)
#define str(x)        mk_str(x)
#define list(x,y)     mk_list(x, y)

#define ext(x)        extension(x,((parser_data *)G->data)->extensions)

#define YY_INPUT(buf, result, max_size, D) yy_input_func(buf, &result, max_size, (parser_data *)G->data)

/* redefine input buffer so that we draw from the specified source string 
	to make it thread/reentrant safe */
void yy_input_func(char *buf, int *result, int max_size, parser_data *data)
{                                                      \
	int yyc;                                           \
	if (data->charbuf && (*(data->charbuf) != '\0')) { \
		yyc = *(data->charbuf)++;                      \
	} else {                                           \
		yyc= EOF;                                      \
	}                                                  \
	(*result) = (EOF == yyc) ? 0 : (*(buf)= yyc, 1);   \
}


#ifndef YY_ALLOC
#define YY_ALLOC(N, D) malloc(N)
#endif
#ifndef YY_CALLOC
#define YY_CALLOC(N, S, D) calloc(N, S)
#endif
#ifndef YY_REALLOC
#define YY_REALLOC(B, N, D) realloc(B, N)
#endif
#ifndef YY_FREE
#define YY_FREE free
#endif
#ifndef YY_LOCAL
#define YY_LOCAL(T)     static T
#endif
#ifndef YY_ACTION
#define YY_ACTION(T)    static T
#endif
#ifndef YY_RULE
#define YY_RULE(T)      static T
#endif
#ifndef YY_PARSE
#define YY_PARSE(T)     T
#endif
#ifndef YY_NAME
#define YY_NAME(N) yy##N
#endif
#ifndef YY_INPUT
#define YY_INPUT(buf, result, max_size, D)		\
  {							\
    int yyc= getchar();					\
    result= (EOF == yyc) ? 0 : (*(buf)= yyc, 1);	\
    yyprintf((stderr, "<%c>", yyc));			\
  }
#endif
#ifndef YY_BEGIN
#define YY_BEGIN        ( G->begin= G->pos, 1)
#endif
#ifndef YY_END
#define YY_END          ( G->end= G->pos, 1)
#endif
#ifdef YY_DEBUG
# ifndef DEBUG_PARSE
#  define DEBUG_PARSE   1
# endif
# ifndef DEBUG_VERBOSE
#  define DEBUG_VERBOSE 2
# endif
# define yyprintf(args)	         if (G->debug & DEBUG_PARSE)         fprintf args
# define yyprintfv(args)         if (G->debug == (DEBUG_PARSE|DEBUG_VERBOSE)) fprintf args
# define yyprintfGcontext        if (G->debug & DEBUG_PARSE)         yyprintcontext(stderr,G->buf+G->pos)
# define yyprintfvGcontext       if (G->debug == (DEBUG_PARSE|DEBUG_VERBOSE)) yyprintcontext(stderr,G->buf+G->pos)
# define yyprintfvTcontext(text) if (G->debug == (DEBUG_PARSE|DEBUG_VERBOSE)) yyprintcontext(stderr,text)
#else
# define yyprintf(args)
# define yyprintfv(args)
# define yyprintfGcontext
# define yyprintfvGcontext
# define yyprintfvTcontext(text)
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YY_XTYPE
#define YY_XTYPE void *
#endif
#ifndef YY_XVAR
#define YY_XVAR yyxvar
#endif

#ifndef YY_STACK_SIZE
#define YY_STACK_SIZE 128
#endif

#ifndef YY_BUFFER_START_SIZE
#define YY_BUFFER_START_SIZE 1024
#endif

#ifndef YY_PART
#define yydata G->data
#define yy G->ss

struct _yythunk; /* forward declaration */
typedef void (*yyaction)(struct _GREG *G, char *yytext, int yyleng, struct _yythunk *thunkpos, YY_XTYPE YY_XVAR);
typedef struct _yythunk { int begin, end;  yyaction  action; const char *name; struct _yythunk *next; } yythunk;

typedef struct _GREG {
  char *buf;
  int buflen;
  int   offset;
  int   pos;
  int   limit;
  char *text;
  int   textlen;
  int   begin;
  int   end;
  yythunk *thunks;
  int   thunkslen;
  int thunkpos;
  YYSTYPE ss;
  YYSTYPE *val;
  YYSTYPE *vals;
  int valslen;
  YY_XTYPE data;
#ifdef YY_DEBUG
  int debug;
#endif
} GREG;

YY_LOCAL(int) yyrefill(GREG *G)
{
  int yyn;
  while (G->buflen - G->pos < 512)
    {
      G->buflen *= 2;
      G->buf= (char*)YY_REALLOC(G->buf, G->buflen, G->data);
    }
  YY_INPUT((G->buf + G->pos), yyn, (G->buflen - G->pos), G->data);
  if (!yyn) return 0;
  G->limit += yyn;
  return 1;
}

YY_LOCAL(int) yymatchDot(GREG *G)
{
  if (G->pos >= G->limit && !yyrefill(G)) return 0;
  ++G->pos;
  return 1;
}

#ifdef YY_DEBUG
YY_LOCAL(void) yyprintcontext(FILE *stream, char *s)
{
  char *context = s;
  char *nl = strchr(context, 10);
  if (nl) {
    context = (char*)malloc(nl-s+1);
    strncpy(context, s, nl-s);
    context[nl-s] = '\0'; /* replace nl by 0 */
  }
  fprintf(stream, " @ \"%s\"", context);
  if (nl) free(context);
}
#endif

YY_LOCAL(int) yymatchChar(GREG *G, int c)
{
  if (G->pos >= G->limit && !yyrefill(G)) return 0;
  if ((unsigned char)G->buf[G->pos] == c)
    {
      ++G->pos;
      if (c<32) { yyprintf((stderr, "  ok   yymatchChar '0x%x'", c));}
      else      { yyprintf((stderr, "  ok   yymatchChar '%c'", c));}
      yyprintfGcontext;
      yyprintf((stderr, "\n"));
      return 1;
    }
  if (c<32) { yyprintfv((stderr, "  fail yymatchChar '0x%x'", c));}
  else      { yyprintfv((stderr, "  fail yymatchChar '%c'", c));}
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));
  return 0;
}

YY_LOCAL(int) yymatchString(GREG *G, const char *s)
{
  int yysav= G->pos;
  while (*s)
    {
      if (G->pos >= G->limit && !yyrefill(G)) return 0;
      if (G->buf[G->pos] != *s)
        {
          G->pos= yysav;
          return 0;
        }
      ++s;
      ++G->pos;
    }
  return 1;
}

YY_LOCAL(int) yymatchClass(GREG *G, const unsigned char *bits, const char *cclass)
{
  int c;
  if (G->pos >= G->limit && !yyrefill(G)) return 0;
  c= (unsigned char)G->buf[G->pos];
  if (bits[c >> 3] & (1 << (c & 7)))
    {
      ++G->pos;
      yyprintf((stderr, "  ok   yymatchClass [%s]", cclass));
      yyprintfGcontext;
      yyprintf((stderr, "\n"));
      return 1;
    }
  yyprintfv((stderr, "  fail yymatchClass [%s]", cclass));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));
  return 0;
}

YY_LOCAL(void) yyDo(GREG *G, yyaction action, int begin, int end, const char *name)
{
  while (G->thunkpos >= G->thunkslen)
    {
      G->thunkslen *= 2;
      G->thunks= (yythunk*)YY_REALLOC(G->thunks, sizeof(yythunk) * G->thunkslen, G->data);
    }
  G->thunks[G->thunkpos].begin=  begin;
  G->thunks[G->thunkpos].end=    end;
  G->thunks[G->thunkpos].action= action;
  G->thunks[G->thunkpos].name= name;
  ++G->thunkpos;
}

YY_LOCAL(int) yyText(GREG *G, int begin, int end)
{
  int yyleng= end - begin;
  if (yyleng <= 0)
    yyleng= 0;
  else
    {
      while (G->textlen < (yyleng + 1))
        {
          G->textlen *= 2;
          G->text= (char*)YY_REALLOC(G->text, G->textlen, G->data);
        }
      memcpy(G->text, G->buf + begin, yyleng);
    }
  G->text[yyleng]= '\0';
  return yyleng;
}

YY_LOCAL(void) yyDone(GREG *G)
{
  int pos;
  for (pos= 0; pos < G->thunkpos; ++pos)
    {
      yythunk *thunk= &G->thunks[pos];
      int yyleng= thunk->end ? yyText(G, thunk->begin, thunk->end) : thunk->begin;
      yyprintf((stderr, "DO [%d] %s", pos, thunk->name));
      yyprintfvTcontext(G->text);
      yyprintf((stderr, "\n"));
      thunk->action(G, G->text, yyleng, thunk, G->data);
    }
  G->thunkpos= 0;
}

YY_LOCAL(void) yyCommit(GREG *G)
{
  if ((G->limit -= G->pos))
    {
      memmove(G->buf, G->buf + G->pos, G->limit);
    }
  G->offset += G->pos;
  G->begin -= G->pos;
  G->end -= G->pos;
  G->pos= G->thunkpos= 0;
}

YY_LOCAL(int) yyAccept(GREG *G, int tp0)
{
  if (tp0)
    {
      fprintf(stderr, "accept denied at %d\n", tp0);
      return 0;
    }
  else
    {
      yyDone(G);
      yyCommit(G);
    }
  return 1;
}

YY_LOCAL(void) yyPush(GREG *G, char *text, int count, yythunk *thunk, YY_XTYPE YY_XVAR)	{
  size_t off = (G->val - G->vals) + count;
  if (off > G->valslen) {
    while (G->valslen < off + 1)
      G->valslen *= 2;
    G->vals= (YYSTYPE*)YY_REALLOC((void *)G->vals, sizeof(YYSTYPE) * G->valslen, G->data);
    G->val= G->vals + off;
  } else {
    G->val += count;
  }
}
YY_LOCAL(void) yyPop(GREG *G, char *text, int count, yythunk *thunk, YY_XTYPE YY_XVAR)	{ G->val -= count; }
YY_LOCAL(void) yySet(GREG *G, char *text, int count, yythunk *thunk, YY_XTYPE YY_XVAR)	{ G->val[count]= G->ss; }

#endif /* YY_PART */

#define YYACCEPT        yyAccept(G, yythunkpos0)

YY_RULE(int) yy_FalseMatch(GREG *G); /* 433 */
YY_RULE(int) yy_RawString(GREG *G); /* 432 */
YY_RULE(int) yy_DocForCritic(GREG *G); /* 431 */
YY_RULE(int) yy_CriticSubstAdd(GREG *G); /* 430 */
YY_RULE(int) yy_CriticSubstDel(GREG *G); /* 429 */
YY_RULE(int) yy_SubAddString(GREG *G); /* 428 */
YY_RULE(int) yy_SubDelString(GREG *G); /* 427 */
YY_RULE(int) yy_HiString(GREG *G); /* 426 */
YY_RULE(int) yy_DelString(GREG *G); /* 425 */
YY_RULE(int) yy_AddString(GREG *G); /* 424 */
YY_RULE(int) yy_SubDivider(GREG *G); /* 423 */
YY_RULE(int) yy_SubStop(GREG *G); /* 422 */
YY_RULE(int) yy_SubStart(GREG *G); /* 421 */
YY_RULE(int) yy_ComStop(GREG *G); /* 420 */
YY_RULE(int) yy_ComStart(GREG *G); /* 419 */
YY_RULE(int) yy_HiStop(GREG *G); /* 418 */
YY_RULE(int) yy_HiStart(GREG *G); /* 417 */
YY_RULE(int) yy_DelStop(GREG *G); /* 416 */
YY_RULE(int) yy_DelStart(GREG *G); /* 415 */
YY_RULE(int) yy_AddStop(GREG *G); /* 414 */
YY_RULE(int) yy_AddStart(GREG *G); /* 413 */
YY_RULE(int) yy_CleanComment(GREG *G); /* 412 */
YY_RULE(int) yy_CleanHighlight(GREG *G); /* 411 */
YY_RULE(int) yy_CleanSubstitution(GREG *G); /* 410 */
YY_RULE(int) yy_CleanDeletion(GREG *G); /* 409 */
YY_RULE(int) yy_CleanAddition(GREG *G); /* 408 */
YY_RULE(int) yy_CriticClean(GREG *G); /* 407 */
YY_RULE(int) yy_CriticComment(GREG *G); /* 406 */
YY_RULE(int) yy_CriticHighlight(GREG *G); /* 405 */
YY_RULE(int) yy_CriticSubstitution(GREG *G); /* 404 */
YY_RULE(int) yy_CriticDeletion(GREG *G); /* 403 */
YY_RULE(int) yy_CriticAddition(GREG *G); /* 402 */
YY_RULE(int) yy_TOCSectionBlock(GREG *G); /* 401 */
YY_RULE(int) yy_TOCHeadingSection(GREG *G); /* 400 */
YY_RULE(int) yy_TOCPlain(GREG *G); /* 399 */
YY_RULE(int) yy_TOCBlock(GREG *G); /* 398 */
YY_RULE(int) yy_DocForTOC(GREG *G); /* 397 */
YY_RULE(int) yy_OPMLSetextHeading2(GREG *G); /* 396 */
YY_RULE(int) yy_OPMLSetextHeading1(GREG *G); /* 395 */
YY_RULE(int) yy_OPMLSetextHeading(GREG *G); /* 394 */
YY_RULE(int) yy_OPMLAtxHeading(GREG *G); /* 393 */
YY_RULE(int) yy_OPMLSectionBlock(GREG *G); /* 392 */
YY_RULE(int) yy_OPMLHeading(GREG *G); /* 391 */
YY_RULE(int) yy_OPMLPlain(GREG *G); /* 390 */
YY_RULE(int) yy_OPMLHeadingSection(GREG *G); /* 389 */
YY_RULE(int) yy_OPMLBlock(GREG *G); /* 388 */
YY_RULE(int) yy_DocForOPML(GREG *G); /* 387 */
YY_RULE(int) yy_BracketedText2(GREG *G); /* 386 */
YY_RULE(int) yy_BracketedTextz(GREG *G); /* 385 */
YY_RULE(int) yy_RightAlign(GREG *G); /* 384 */
YY_RULE(int) yy_CenterAlign(GREG *G); /* 383 */
YY_RULE(int) yy_LeftAlign(GREG *G); /* 382 */
YY_RULE(int) yy_NaturalAlign(GREG *G); /* 381 */
YY_RULE(int) yy_RightAlignWrap(GREG *G); /* 380 */
YY_RULE(int) yy_CenterAlignWrap(GREG *G); /* 379 */
YY_RULE(int) yy_LeftAlignWrap(GREG *G); /* 378 */
YY_RULE(int) yy_NaturalAlignWrap(GREG *G); /* 377 */
YY_RULE(int) yy_AlignmentCell(GREG *G); /* 376 */
YY_RULE(int) yy_HeaderAlignmentCell(GREG *G); /* 375 */
YY_RULE(int) yy_FullCell(GREG *G); /* 374 */
YY_RULE(int) yy_EmptyCell(GREG *G); /* 373 */
YY_RULE(int) yy_ExtendedCell(GREG *G); /* 372 */
YY_RULE(int) yy_TableCell(GREG *G); /* 371 */
YY_RULE(int) yy_CellDivider(GREG *G); /* 370 */
YY_RULE(int) yy_TableLine(GREG *G); /* 369 */
YY_RULE(int) yy_TableRow(GREG *G); /* 368 */
YY_RULE(int) yy_SeparatorLine(GREG *G); /* 367 */
YY_RULE(int) yy_TableBody(GREG *G); /* 366 */
YY_RULE(int) yy_TableCaption(GREG *G); /* 365 */
YY_RULE(int) yy_InStyleTags(GREG *G); /* 364 */
YY_RULE(int) yy_StyleClose(GREG *G); /* 363 */
YY_RULE(int) yy_StyleOpen(GREG *G); /* 362 */
YY_RULE(int) yy_HtmlBlockType(GREG *G); /* 361 */
YY_RULE(int) yy_MarkdownHtmlAttribute(GREG *G); /* 360 */
YY_RULE(int) yy_HtmlBlockSelfClosing(GREG *G); /* 359 */
YY_RULE(int) yy_HtmlBlockMark(GREG *G); /* 358 */
YY_RULE(int) yy_HtmlBlockCloseMark(GREG *G); /* 357 */
YY_RULE(int) yy_HtmlBlockOpenMark(GREG *G); /* 356 */
YY_RULE(int) yy_HtmlBlockIns(GREG *G); /* 355 */
YY_RULE(int) yy_HtmlBlockCloseIns(GREG *G); /* 354 */
YY_RULE(int) yy_HtmlBlockOpenIns(GREG *G); /* 353 */
YY_RULE(int) yy_HtmlBlockDel(GREG *G); /* 352 */
YY_RULE(int) yy_HtmlBlockCloseDel(GREG *G); /* 351 */
YY_RULE(int) yy_HtmlBlockOpenDel(GREG *G); /* 350 */
YY_RULE(int) yy_HtmlBlockNav(GREG *G); /* 349 */
YY_RULE(int) yy_HtmlBlockCloseNav(GREG *G); /* 348 */
YY_RULE(int) yy_HtmlBlockOpenNav(GREG *G); /* 347 */
YY_RULE(int) yy_HtmlBlockMain(GREG *G); /* 346 */
YY_RULE(int) yy_HtmlBlockCloseMain(GREG *G); /* 345 */
YY_RULE(int) yy_HtmlBlockOpenMain(GREG *G); /* 344 */
YY_RULE(int) yy_HtmlBlockHead(GREG *G); /* 343 */
YY_RULE(int) yy_HtmlBlockCloseHead(GREG *G); /* 342 */
YY_RULE(int) yy_HtmlBlockOpenHead(GREG *G); /* 341 */
YY_RULE(int) yy_HtmlBlockCloseScript(GREG *G); /* 340 */
YY_RULE(int) yy_HtmlBlockOpenScript(GREG *G); /* 339 */
YY_RULE(int) yy_HtmlBlockTr(GREG *G); /* 338 */
YY_RULE(int) yy_HtmlBlockCloseTr(GREG *G); /* 337 */
YY_RULE(int) yy_HtmlBlockOpenTr(GREG *G); /* 336 */
YY_RULE(int) yy_HtmlBlockThead(GREG *G); /* 335 */
YY_RULE(int) yy_HtmlBlockCloseThead(GREG *G); /* 334 */
YY_RULE(int) yy_HtmlBlockOpenThead(GREG *G); /* 333 */
YY_RULE(int) yy_HtmlBlockTh(GREG *G); /* 332 */
YY_RULE(int) yy_HtmlBlockCloseTh(GREG *G); /* 331 */
YY_RULE(int) yy_HtmlBlockOpenTh(GREG *G); /* 330 */
YY_RULE(int) yy_HtmlBlockTfoot(GREG *G); /* 329 */
YY_RULE(int) yy_HtmlBlockCloseTfoot(GREG *G); /* 328 */
YY_RULE(int) yy_HtmlBlockOpenTfoot(GREG *G); /* 327 */
YY_RULE(int) yy_HtmlBlockTd(GREG *G); /* 326 */
YY_RULE(int) yy_HtmlBlockCloseTd(GREG *G); /* 325 */
YY_RULE(int) yy_HtmlBlockOpenTd(GREG *G); /* 324 */
YY_RULE(int) yy_HtmlBlockTbody(GREG *G); /* 323 */
YY_RULE(int) yy_HtmlBlockCloseTbody(GREG *G); /* 322 */
YY_RULE(int) yy_HtmlBlockOpenTbody(GREG *G); /* 321 */
YY_RULE(int) yy_HtmlBlockLi(GREG *G); /* 320 */
YY_RULE(int) yy_HtmlBlockCloseLi(GREG *G); /* 319 */
YY_RULE(int) yy_HtmlBlockOpenLi(GREG *G); /* 318 */
YY_RULE(int) yy_HtmlBlockFrameset(GREG *G); /* 317 */
YY_RULE(int) yy_HtmlBlockCloseFrameset(GREG *G); /* 316 */
YY_RULE(int) yy_HtmlBlockOpenFrameset(GREG *G); /* 315 */
YY_RULE(int) yy_HtmlBlockDt(GREG *G); /* 314 */
YY_RULE(int) yy_HtmlBlockCloseDt(GREG *G); /* 313 */
YY_RULE(int) yy_HtmlBlockOpenDt(GREG *G); /* 312 */
YY_RULE(int) yy_HtmlBlockDd(GREG *G); /* 311 */
YY_RULE(int) yy_HtmlBlockCloseDd(GREG *G); /* 310 */
YY_RULE(int) yy_HtmlBlockOpenDd(GREG *G); /* 309 */
YY_RULE(int) yy_HtmlBlockVideo(GREG *G); /* 308 */
YY_RULE(int) yy_HtmlBlockCloseVideo(GREG *G); /* 307 */
YY_RULE(int) yy_HtmlBlockOpenVideo(GREG *G); /* 306 */
YY_RULE(int) yy_HtmlBlockUl(GREG *G); /* 305 */
YY_RULE(int) yy_HtmlBlockCloseUl(GREG *G); /* 304 */
YY_RULE(int) yy_HtmlBlockOpenUl(GREG *G); /* 303 */
YY_RULE(int) yy_HtmlBlockTable(GREG *G); /* 302 */
YY_RULE(int) yy_HtmlBlockCloseTable(GREG *G); /* 301 */
YY_RULE(int) yy_HtmlBlockOpenTable(GREG *G); /* 300 */
YY_RULE(int) yy_HtmlBlockSection(GREG *G); /* 299 */
YY_RULE(int) yy_HtmlBlockCloseSection(GREG *G); /* 298 */
YY_RULE(int) yy_HtmlBlockOpenSection(GREG *G); /* 297 */
YY_RULE(int) yy_HtmlBlockProgress(GREG *G); /* 296 */
YY_RULE(int) yy_HtmlBlockCloseProgress(GREG *G); /* 295 */
YY_RULE(int) yy_HtmlBlockOpenProgress(GREG *G); /* 294 */
YY_RULE(int) yy_HtmlBlockPre(GREG *G); /* 293 */
YY_RULE(int) yy_HtmlBlockClosePre(GREG *G); /* 292 */
YY_RULE(int) yy_HtmlBlockOpenPre(GREG *G); /* 291 */
YY_RULE(int) yy_HtmlBlockP(GREG *G); /* 290 */
YY_RULE(int) yy_HtmlBlockCloseP(GREG *G); /* 289 */
YY_RULE(int) yy_HtmlBlockOpenP(GREG *G); /* 288 */
YY_RULE(int) yy_HtmlBlockOl(GREG *G); /* 287 */
YY_RULE(int) yy_HtmlBlockCloseOl(GREG *G); /* 286 */
YY_RULE(int) yy_HtmlBlockOpenOl(GREG *G); /* 285 */
YY_RULE(int) yy_HtmlBlockNoscript(GREG *G); /* 284 */
YY_RULE(int) yy_HtmlBlockCloseNoscript(GREG *G); /* 283 */
YY_RULE(int) yy_HtmlBlockOpenNoscript(GREG *G); /* 282 */
YY_RULE(int) yy_HtmlBlockNoframes(GREG *G); /* 281 */
YY_RULE(int) yy_HtmlBlockCloseNoframes(GREG *G); /* 280 */
YY_RULE(int) yy_HtmlBlockOpenNoframes(GREG *G); /* 279 */
YY_RULE(int) yy_HtmlBlockMenu(GREG *G); /* 278 */
YY_RULE(int) yy_HtmlBlockCloseMenu(GREG *G); /* 277 */
YY_RULE(int) yy_HtmlBlockOpenMenu(GREG *G); /* 276 */
YY_RULE(int) yy_HtmlBlockH6(GREG *G); /* 275 */
YY_RULE(int) yy_HtmlBlockCloseH6(GREG *G); /* 274 */
YY_RULE(int) yy_HtmlBlockOpenH6(GREG *G); /* 273 */
YY_RULE(int) yy_HtmlBlockH5(GREG *G); /* 272 */
YY_RULE(int) yy_HtmlBlockCloseH5(GREG *G); /* 271 */
YY_RULE(int) yy_HtmlBlockOpenH5(GREG *G); /* 270 */
YY_RULE(int) yy_HtmlBlockH4(GREG *G); /* 269 */
YY_RULE(int) yy_HtmlBlockCloseH4(GREG *G); /* 268 */
YY_RULE(int) yy_HtmlBlockOpenH4(GREG *G); /* 267 */
YY_RULE(int) yy_HtmlBlockH3(GREG *G); /* 266 */
YY_RULE(int) yy_HtmlBlockCloseH3(GREG *G); /* 265 */
YY_RULE(int) yy_HtmlBlockOpenH3(GREG *G); /* 264 */
YY_RULE(int) yy_HtmlBlockH2(GREG *G); /* 263 */
YY_RULE(int) yy_HtmlBlockCloseH2(GREG *G); /* 262 */
YY_RULE(int) yy_HtmlBlockOpenH2(GREG *G); /* 261 */
YY_RULE(int) yy_HtmlBlockH1(GREG *G); /* 260 */
YY_RULE(int) yy_HtmlBlockCloseH1(GREG *G); /* 259 */
YY_RULE(int) yy_HtmlBlockOpenH1(GREG *G); /* 258 */
YY_RULE(int) yy_HtmlBlockHgroup(GREG *G); /* 257 */
YY_RULE(int) yy_HtmlBlockCloseHgroup(GREG *G); /* 256 */
YY_RULE(int) yy_HtmlBlockOpenHgroup(GREG *G); /* 255 */
YY_RULE(int) yy_HtmlBlockHeader(GREG *G); /* 254 */
YY_RULE(int) yy_HtmlBlockCloseHeader(GREG *G); /* 253 */
YY_RULE(int) yy_HtmlBlockOpenHeader(GREG *G); /* 252 */
YY_RULE(int) yy_HtmlBlockForm(GREG *G); /* 251 */
YY_RULE(int) yy_HtmlBlockCloseForm(GREG *G); /* 250 */
YY_RULE(int) yy_HtmlBlockOpenForm(GREG *G); /* 249 */
YY_RULE(int) yy_HtmlBlockFooter(GREG *G); /* 248 */
YY_RULE(int) yy_HtmlBlockCloseFooter(GREG *G); /* 247 */
YY_RULE(int) yy_HtmlBlockOpenFooter(GREG *G); /* 246 */
YY_RULE(int) yy_HtmlBlockFigure(GREG *G); /* 245 */
YY_RULE(int) yy_HtmlBlockCloseFigure(GREG *G); /* 244 */
YY_RULE(int) yy_HtmlBlockOpenFigure(GREG *G); /* 243 */
YY_RULE(int) yy_HtmlBlockFieldset(GREG *G); /* 242 */
YY_RULE(int) yy_HtmlBlockCloseFieldset(GREG *G); /* 241 */
YY_RULE(int) yy_HtmlBlockOpenFieldset(GREG *G); /* 240 */
YY_RULE(int) yy_HtmlBlockDl(GREG *G); /* 239 */
YY_RULE(int) yy_HtmlBlockCloseDl(GREG *G); /* 238 */
YY_RULE(int) yy_HtmlBlockOpenDl(GREG *G); /* 237 */
YY_RULE(int) yy_HtmlBlockDiv(GREG *G); /* 236 */
YY_RULE(int) yy_HtmlBlockCloseDiv(GREG *G); /* 235 */
YY_RULE(int) yy_HtmlBlockOpenDiv(GREG *G); /* 234 */
YY_RULE(int) yy_HtmlBlockDir(GREG *G); /* 233 */
YY_RULE(int) yy_HtmlBlockCloseDir(GREG *G); /* 232 */
YY_RULE(int) yy_HtmlBlockOpenDir(GREG *G); /* 231 */
YY_RULE(int) yy_HtmlBlockCenter(GREG *G); /* 230 */
YY_RULE(int) yy_HtmlBlockCloseCenter(GREG *G); /* 229 */
YY_RULE(int) yy_HtmlBlockOpenCenter(GREG *G); /* 228 */
YY_RULE(int) yy_HtmlBlockCanvas(GREG *G); /* 227 */
YY_RULE(int) yy_HtmlBlockCloseCanvas(GREG *G); /* 226 */
YY_RULE(int) yy_HtmlBlockOpenCanvas(GREG *G); /* 225 */
YY_RULE(int) yy_HtmlBlockBlockquote(GREG *G); /* 224 */
YY_RULE(int) yy_HtmlBlockCloseBlockquote(GREG *G); /* 223 */
YY_RULE(int) yy_HtmlBlockOpenBlockquote(GREG *G); /* 222 */
YY_RULE(int) yy_HtmlBlockAside(GREG *G); /* 221 */
YY_RULE(int) yy_HtmlBlockCloseAside(GREG *G); /* 220 */
YY_RULE(int) yy_HtmlBlockOpenAside(GREG *G); /* 219 */
YY_RULE(int) yy_HtmlBlockArticle(GREG *G); /* 218 */
YY_RULE(int) yy_HtmlBlockCloseArticle(GREG *G); /* 217 */
YY_RULE(int) yy_HtmlBlockOpenArticle(GREG *G); /* 216 */
YY_RULE(int) yy_HtmlBlockAddress(GREG *G); /* 215 */
YY_RULE(int) yy_HtmlBlockCloseAddress(GREG *G); /* 214 */
YY_RULE(int) yy_HtmlBlockOpenAddress(GREG *G); /* 213 */
YY_RULE(int) yy_ListBlockLine(GREG *G); /* 212 */
YY_RULE(int) yy_ListContinuationBlock(GREG *G); /* 211 */
YY_RULE(int) yy_ListBlock(GREG *G); /* 210 */
YY_RULE(int) yy_ListItem(GREG *G); /* 209 */
YY_RULE(int) yy_EnumeratorNoSpace(GREG *G); /* 208 */
YY_RULE(int) yy_EmptyList(GREG *G); /* 207 */
YY_RULE(int) yy_Enumerator(GREG *G); /* 206 */
YY_RULE(int) yy_ListItemTight(GREG *G); /* 205 */
YY_RULE(int) yy_ListLoose(GREG *G); /* 204 */
YY_RULE(int) yy_ListTight(GREG *G); /* 203 */
YY_RULE(int) yy_BulletNoSpace(GREG *G); /* 202 */
YY_RULE(int) yy_Bullet(GREG *G); /* 201 */
YY_RULE(int) yy_Definition(GREG *G); /* 200 */
YY_RULE(int) yy_Term(GREG *G); /* 199 */
YY_RULE(int) yy_TermLine(GREG *G); /* 198 */
YY_RULE(int) yy_VerbatimChunk(GREG *G); /* 197 */
YY_RULE(int) yy_NonblankIndentedLine(GREG *G); /* 196 */
YY_RULE(int) yy_BackTickStart(GREG *G); /* 195 */
YY_RULE(int) yy_BackTickEnd(GREG *G); /* 194 */
YY_RULE(int) yy_DoubleQuoteEnd(GREG *G); /* 193 */
YY_RULE(int) yy_DoubleQuoteStart(GREG *G); /* 192 */
YY_RULE(int) yy_SingleQuoteEnd(GREG *G); /* 191 */
YY_RULE(int) yy_SingleQuoteStart(GREG *G); /* 190 */
YY_RULE(int) yy_EnDash(GREG *G); /* 189 */
YY_RULE(int) yy_EmDash(GREG *G); /* 188 */
YY_RULE(int) yy_Apostrophe(GREG *G); /* 187 */
YY_RULE(int) yy_BackTickQuoted(GREG *G); /* 186 */
YY_RULE(int) yy_DoubleQuoted(GREG *G); /* 185 */
YY_RULE(int) yy_SingleQuoted(GREG *G); /* 184 */
YY_RULE(int) yy_Dash(GREG *G); /* 183 */
YY_RULE(int) yy_Ellipsis(GREG *G); /* 182 */
YY_RULE(int) yy_FenceType(GREG *G); /* 181 */
YY_RULE(int) yy_Ticks5(GREG *G); /* 180 */
YY_RULE(int) yy_Ticks4(GREG *G); /* 179 */
YY_RULE(int) yy_Ticks3(GREG *G); /* 178 */
YY_RULE(int) yy_Ticks2(GREG *G); /* 177 */
YY_RULE(int) yy_Ticks1(GREG *G); /* 176 */
YY_RULE(int) yy_RawNoteBlock(GREG *G); /* 175 */
YY_RULE(int) yy_GlossarySortKey(GREG *G); /* 174 */
YY_RULE(int) yy_GlossaryTerm(GREG *G); /* 173 */
YY_RULE(int) yy_RawNoteReference(GREG *G); /* 172 */
YY_RULE(int) yy_RawInline(GREG *G); /* 171 */
YY_RULE(int) yy_Label2(GREG *G); /* 170 */
YY_RULE(int) yy_EmptyTitle(GREG *G); /* 169 */
YY_RULE(int) yy_RefTitleParens(GREG *G); /* 168 */
YY_RULE(int) yy_RefTitleDouble(GREG *G); /* 167 */
YY_RULE(int) yy_RefTitleSingle(GREG *G); /* 166 */
YY_RULE(int) yy_UnQuotedValue(GREG *G); /* 165 */
YY_RULE(int) yy_QuotedValue(GREG *G); /* 164 */
YY_RULE(int) yy_AttrValue(GREG *G); /* 163 */
YY_RULE(int) yy_AttrKey(GREG *G); /* 162 */
YY_RULE(int) yy_Attribute(GREG *G); /* 161 */
YY_RULE(int) yy_Attributes(GREG *G); /* 160 */
YY_RULE(int) yy_RefTitle(GREG *G); /* 159 */
YY_RULE(int) yy_RefSrc(GREG *G); /* 158 */
YY_RULE(int) yy_AutoLinkEmail(GREG *G); /* 157 */
YY_RULE(int) yy_AutoLinkUrl(GREG *G); /* 156 */
YY_RULE(int) yy_TitleDouble(GREG *G); /* 155 */
YY_RULE(int) yy_TitleSingle(GREG *G); /* 154 */
YY_RULE(int) yy_SourceContents(GREG *G); /* 153 */
YY_RULE(int) yy_Title(GREG *G); /* 152 */
YY_RULE(int) yy_Source(GREG *G); /* 151 */
YY_RULE(int) yy_RawCitationReference(GREG *G); /* 150 */
YY_RULE(int) yy_CitationReferenceSingle(GREG *G); /* 149 */
YY_RULE(int) yy_CitationReferenceDouble(GREG *G); /* 148 */
YY_RULE(int) yy_Label(GREG *G); /* 147 */
YY_RULE(int) yy_ReferenceLinkSingle(GREG *G); /* 146 */
YY_RULE(int) yy_ReferenceLinkDouble(GREG *G); /* 145 */
YY_RULE(int) yy_AutoLink(GREG *G); /* 144 */
YY_RULE(int) yy_ReferenceLink(GREG *G); /* 143 */
YY_RULE(int) yy_ExplicitLink(GREG *G); /* 142 */
YY_RULE(int) yy_StrongUlClose(GREG *G); /* 141 */
YY_RULE(int) yy_StrongUlOpen(GREG *G); /* 140 */
YY_RULE(int) yy_StrongStarClose(GREG *G); /* 139 */
YY_RULE(int) yy_StrongStarOpen(GREG *G); /* 138 */
YY_RULE(int) yy_StrongUl(GREG *G); /* 137 */
YY_RULE(int) yy_EmphUlClose(GREG *G); /* 136 */
YY_RULE(int) yy_EmphUlOpen(GREG *G); /* 135 */
YY_RULE(int) yy_StrongStar(GREG *G); /* 134 */
YY_RULE(int) yy_BracketedText(GREG *G); /* 133 */
YY_RULE(int) yy_StrongMatch(GREG *G); /* 132 */
YY_RULE(int) yy_ThreeStar(GREG *G); /* 131 */
YY_RULE(int) yy_OneTwoStar(GREG *G); /* 130 */
YY_RULE(int) yy_TwoStar(GREG *G); /* 129 */
YY_RULE(int) yy_OneStar(GREG *G); /* 128 */
YY_RULE(int) yy_EmphStarClose(GREG *G); /* 127 */
YY_RULE(int) yy_EmphStarOpen(GREG *G); /* 126 */
YY_RULE(int) yy_EmphUl(GREG *G); /* 125 */
YY_RULE(int) yy_EmphStar(GREG *G); /* 124 */
YY_RULE(int) yy_EmphMatch(GREG *G); /* 123 */
YY_RULE(int) yy_Whitespace(GREG *G); /* 122 */
YY_RULE(int) yy_StarLine(GREG *G); /* 121 */
YY_RULE(int) yy_UlLine(GREG *G); /* 120 */
YY_RULE(int) yy_MathSpanText(GREG *G); /* 119 */
YY_RULE(int) yy_MathText(GREG *G); /* 118 */
YY_RULE(int) yy_DoubleDollarMathText(GREG *G); /* 117 */
YY_RULE(int) yy_DoubleDollarMath(GREG *G); /* 116 */
YY_RULE(int) yy_DoubleDollarMathEnd(GREG *G); /* 115 */
YY_RULE(int) yy_DoubleDollarMathStart(GREG *G); /* 114 */
YY_RULE(int) yy_SingleDollarMathText(GREG *G); /* 113 */
YY_RULE(int) yy_SingleDollarMath(GREG *G); /* 112 */
YY_RULE(int) yy_SingleDollarMathEnd(GREG *G); /* 111 */
YY_RULE(int) yy_SingleDollarMathStart(GREG *G); /* 110 */
YY_RULE(int) yy_AposChunk(GREG *G); /* 109 */
YY_RULE(int) yy_Subscript(GREG *G); /* 108 */
YY_RULE(int) yy_Superscript(GREG *G); /* 107 */
YY_RULE(int) yy_StrChunk(GREG *G); /* 106 */
YY_RULE(int) yy_voidNormalEndline(GREG *G); /* 105 */
YY_RULE(int) yy_NormalEndline(GREG *G); /* 104 */
YY_RULE(int) yy_TerminalEndline(GREG *G); /* 103 */
YY_RULE(int) yy_LineBreak(GREG *G); /* 102 */
YY_RULE(int) yy_Smart(GREG *G); /* 101 */
YY_RULE(int) yy_MarkdownHtmlTagOpen(GREG *G); /* 100 */
YY_RULE(int) yy_Code(GREG *G); /* 99 */
YY_RULE(int) yy_Image(GREG *G); /* 98 */
YY_RULE(int) yy_Link(GREG *G); /* 97 */
YY_RULE(int) yy_NoteReference(GREG *G); /* 96 */
YY_RULE(int) yy_Variable(GREG *G); /* 95 */
YY_RULE(int) yy_CitationReference(GREG *G); /* 94 */
YY_RULE(int) yy_Emph(GREG *G); /* 93 */
YY_RULE(int) yy_Strong(GREG *G); /* 92 */
YY_RULE(int) yy_Space(GREG *G); /* 91 */
YY_RULE(int) yy_UlOrStarLine(GREG *G); /* 90 */
YY_RULE(int) yy_MathSpan(GREG *G); /* 89 */
YY_RULE(int) yy_Str(GREG *G); /* 88 */
YY_RULE(int) yy_DollarMath(GREG *G); /* 87 */
YY_RULE(int) yy_CriticMarkup(GREG *G); /* 86 */
YY_RULE(int) yy_voidEndline(GREG *G); /* 85 */
YY_RULE(int) yy_Inlines(GREG *G); /* 84 */
YY_RULE(int) yy_Entity(GREG *G); /* 83 */
YY_RULE(int) yy_EscapedChar(GREG *G); /* 82 */
YY_RULE(int) yy_Symbol(GREG *G); /* 81 */
YY_RULE(int) yy_OptionallyIndentedLine(GREG *G); /* 80 */
YY_RULE(int) yy_IndentedLine(GREG *G); /* 79 */
YY_RULE(int) yy_Indent(GREG *G); /* 78 */
YY_RULE(int) yy_CharEntity(GREG *G); /* 77 */
YY_RULE(int) yy_DecEntity(GREG *G); /* 76 */
YY_RULE(int) yy_HexEntity(GREG *G); /* 75 */
YY_RULE(int) yy_Digit(GREG *G); /* 74 */
YY_RULE(int) yy_Alphanumeric(GREG *G); /* 73 */
YY_RULE(int) yy_HtmlBlockScript(GREG *G); /* 72 */
YY_RULE(int) yy_RawHtml(GREG *G); /* 71 */
YY_RULE(int) yy_HtmlTag(GREG *G); /* 70 */
YY_RULE(int) yy_HtmlComment(GREG *G); /* 69 */
YY_RULE(int) yy_HtmlAttribute(GREG *G); /* 68 */
YY_RULE(int) yy_Quoted(GREG *G); /* 67 */
YY_RULE(int) yy_NonPunctuation(GREG *G); /* 66 */
YY_RULE(int) yy_Punctuation(GREG *G); /* 65 */
YY_RULE(int) yy_ExtendedSpecialChar(GREG *G); /* 64 */
YY_RULE(int) yy_SpecialChar(GREG *G); /* 63 */
YY_RULE(int) yy_NormalChar(GREG *G); /* 62 */
YY_RULE(int) yy_Nonspacechar(GREG *G); /* 61 */
YY_RULE(int) yy_Spnl(GREG *G); /* 60 */
YY_RULE(int) yy_Spacechar(GREG *G); /* 59 */
YY_RULE(int) yy_NonMatchingRawLine(GREG *G); /* 58 */
YY_RULE(int) yy_Eof(GREG *G); /* 57 */
YY_RULE(int) yy_Line(GREG *G); /* 56 */
YY_RULE(int) yy_BlockQuoteMarker(GREG *G); /* 55 */
YY_RULE(int) yy_BlockQuoteRaw(GREG *G); /* 54 */
YY_RULE(int) yy_Endline(GREG *G); /* 53 */
YY_RULE(int) yy_SetextHeading2(GREG *G); /* 52 */
YY_RULE(int) yy_SetextHeading1(GREG *G); /* 51 */
YY_RULE(int) yy_NonindentSpace(GREG *G); /* 50 */
YY_RULE(int) yy_AtxStart(GREG *G); /* 49 */
YY_RULE(int) yy_Inline(GREG *G); /* 48 */
YY_RULE(int) yy_AutoLabel(GREG *G); /* 47 */
YY_RULE(int) yy_AtxInline(GREG *G); /* 46 */
YY_RULE(int) yy_AtxHeading(GREG *G); /* 45 */
YY_RULE(int) yy_HeadingSectionBlock(GREG *G); /* 44 */
YY_RULE(int) yy_Plain(GREG *G); /* 43 */
YY_RULE(int) yy_Para(GREG *G); /* 42 */
YY_RULE(int) yy_HtmlBlockInTags(GREG *G); /* 41 */
YY_RULE(int) yy_TOC(GREG *G); /* 40 */
YY_RULE(int) yy_ImageBlock(GREG *G); /* 39 */
YY_RULE(int) yy_Table(GREG *G); /* 38 */
YY_RULE(int) yy_StyleBlock(GREG *G); /* 37 */
YY_RULE(int) yy_MarkdownHtmlBlock(GREG *G); /* 36 */
YY_RULE(int) yy_BulletList(GREG *G); /* 35 */
YY_RULE(int) yy_OrderedList(GREG *G); /* 34 */
YY_RULE(int) yy_Heading(GREG *G); /* 33 */
YY_RULE(int) yy_HeadingSection(GREG *G); /* 32 */
YY_RULE(int) yy_HorizontalRule(GREG *G); /* 31 */
YY_RULE(int) yy_Abbreviation(GREG *G); /* 30 */
YY_RULE(int) yy_LinkReference(GREG *G); /* 29 */
YY_RULE(int) yy_Note(GREG *G); /* 28 */
YY_RULE(int) yy_Glossary(GREG *G); /* 27 */
YY_RULE(int) yy_DefinitionList(GREG *G); /* 26 */
YY_RULE(int) yy_Verbatim(GREG *G); /* 25 */
YY_RULE(int) yy_Fenced(GREG *G); /* 24 */
YY_RULE(int) yy_BlockQuote(GREG *G); /* 23 */
YY_RULE(int) yy_SetextBottom2(GREG *G); /* 22 */
YY_RULE(int) yy_SetextBottom1(GREG *G); /* 21 */
YY_RULE(int) yy_HtmlBlock(GREG *G); /* 20 */
YY_RULE(int) yy_SkipBlock(GREG *G); /* 19 */
YY_RULE(int) yy_DocForMetaDataOnly(GREG *G); /* 18 */
YY_RULE(int) yy_RawLine(GREG *G); /* 17 */
YY_RULE(int) yy_SingleLineMetaKeyValue(GREG *G); /* 16 */
YY_RULE(int) yy_AlphanumericAscii(GREG *G); /* 15 */
YY_RULE(int) yy_MetaDataValue(GREG *G); /* 14 */
YY_RULE(int) yy_YAMLStop(GREG *G); /* 13 */
YY_RULE(int) yy_MetaDataKeyValue(GREG *G); /* 12 */
YY_RULE(int) yy_SetextHeading(GREG *G); /* 11 */
YY_RULE(int) yy_BlankLine(GREG *G); /* 10 */
YY_RULE(int) yy_Block(GREG *G); /* 9 */
YY_RULE(int) yy_MetaData(GREG *G); /* 8 */
YY_RULE(int) yy_Newline(GREG *G); /* 7 */
YY_RULE(int) yy_Sp(GREG *G); /* 6 */
YY_RULE(int) yy_MetaDataKey(GREG *G); /* 5 */
YY_RULE(int) yy_YAMLStart(GREG *G); /* 4 */
YY_RULE(int) yy_StartList(GREG *G); /* 3 */
YY_RULE(int) yy_BOM(GREG *G); /* 2 */
YY_RULE(int) yy_Doc(GREG *G); /* 1 */

YY_ACTION(void) yy_1_FalseMatch(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_FalseMatch"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_RawString(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RawString"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_5_DocForCritic(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_5_DocForCritic"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {((parser_data *)G->data)->result = reverse_list(a); }\n"));
  ((parser_data *)G->data)->result = reverse_list(a); ;
#undef a
}
YY_ACTION(void) yy_4_DocForCritic(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_4_DocForCritic"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_DocForCritic(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_DocForCritic"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_DocForCritic(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_DocForCritic"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_DocForCritic(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_DocForCritic"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_CriticComment(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_CriticComment"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = CRITICCOMMENT;\n\
\t}\n"));
  
		yy = str(yytext);
		yy->key = CRITICCOMMENT;
	;
}
YY_ACTION(void) yy_2_CriticHighlight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_CriticHighlight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(CRITICHIGHLIGHT, a);\n\
\t}\n"));
  
		yy = list(CRITICHIGHLIGHT, a);
	;
#undef a
}
YY_ACTION(void) yy_1_CriticHighlight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_CriticHighlight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_CriticSubstAdd(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_CriticSubstAdd"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(CRITICADDITION, a);\n\
\t}\n"));
  
		yy = list(CRITICADDITION, a);
	;
#undef a
}
YY_ACTION(void) yy_1_CriticSubstAdd(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_CriticSubstAdd"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_CriticSubstDel(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_CriticSubstDel"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(CRITICDELETION, a);\n\
\t}\n"));
  
		yy = list(CRITICDELETION, a);
	;
#undef a
}
YY_ACTION(void) yy_1_CriticSubstDel(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_CriticSubstDel"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_CriticSubstitution(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_CriticSubstitution"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(CRITICSUBSTITUTION, a);\n\
\t}\n"));
  
		yy = list(CRITICSUBSTITUTION, a);
	;
#undef a
}
YY_ACTION(void) yy_2_CriticSubstitution(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_CriticSubstitution"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy,a); }\n"));
  a = cons(yy,a); ;
#undef a
}
YY_ACTION(void) yy_1_CriticSubstitution(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_CriticSubstitution"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy,a); }\n"));
  a = cons(yy,a); ;
#undef a
}
YY_ACTION(void) yy_2_CriticDeletion(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_CriticDeletion"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(CRITICDELETION, a);\n\
\t}\n"));
  
		yy = list(CRITICDELETION, a);
	;
#undef a
}
YY_ACTION(void) yy_1_CriticDeletion(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_CriticDeletion"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_CriticAddition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_CriticAddition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(CRITICADDITION, a);\n\
\t}\n"));
  
		yy = list(CRITICADDITION, a);
	;
#undef a
}
YY_ACTION(void) yy_1_CriticAddition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_CriticAddition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_SubAddString(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_SubAddString"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_SubDelString(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_SubDelString"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_HiString(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_HiString"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_DelString(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_DelString"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_AddString(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AddString"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_2_TOCPlain(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define z G->val[-1]
#define y G->val[-2]
  yyprintf((stderr, "do yy_2_TOCPlain"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {free_node_tree(z); }\n"));
  free_node_tree(z); ;
#undef z
#undef y
}
YY_ACTION(void) yy_1_TOCPlain(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define z G->val[-1]
#define y G->val[-2]
  yyprintf((stderr, "do yy_1_TOCPlain"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {free_node_tree(y); }\n"));
  free_node_tree(y); ;
#undef z
#undef y
}
YY_ACTION(void) yy_2_TOCHeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_TOCHeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = list(HEADINGSECTION, a); }\n"));
  yy = list(HEADINGSECTION, a); ;
#undef a
}
YY_ACTION(void) yy_1_TOCHeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_TOCHeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_DocForTOC(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define z G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_DocForTOC"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {((parser_data *)G->data)->result = reverse_list(a); }\n"));
  ((parser_data *)G->data)->result = reverse_list(a); ;
#undef z
#undef a
}
YY_ACTION(void) yy_2_DocForTOC(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define z G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_DocForTOC"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef z
#undef a
}
YY_ACTION(void) yy_1_DocForTOC(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define z G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_DocForTOC"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {free_node_tree(z); }\n"));
  free_node_tree(z); ;
#undef z
#undef a
}
YY_ACTION(void) yy_2_OPMLPlain(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_OPMLPlain"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = list(PLAIN, a); }\n"));
  yy = list(PLAIN, a); ;
#undef a
}
YY_ACTION(void) yy_1_OPMLPlain(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_OPMLPlain"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy,a); }\n"));
  a = cons(yy,a); ;
#undef a
}
YY_ACTION(void) yy_1_OPMLSetextHeading2(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_OPMLSetextHeading2"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = H2; }\n"));
  yy = str(yytext); yy->key = H2; ;
}
YY_ACTION(void) yy_1_OPMLSetextHeading1(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_OPMLSetextHeading1"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = H1; }\n"));
  yy = str(yytext); yy->key = H1; ;
}
YY_ACTION(void) yy_1_OPMLAtxHeading(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define s G->val[-1]
  yyprintf((stderr, "do yy_1_OPMLAtxHeading"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = str(yytext);\n\
\t\t\tyy->key = s->key;\n\
\t\t\tfree_node(s);\n\
\t\t}\n"));
  
			yy = str(yytext);
			yy->key = s->key;
			free_node(s);
		;
#undef s
}
YY_ACTION(void) yy_3_OPMLHeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_OPMLHeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = list(HEADINGSECTION, a);}\n"));
  yy = list(HEADINGSECTION, a);;
#undef a
}
YY_ACTION(void) yy_2_OPMLHeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_OPMLHeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_OPMLHeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_OPMLHeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_DocForOPML(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_DocForOPML"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {((parser_data *)G->data)->result = reverse_list(a); }\n"));
  ((parser_data *)G->data)->result = reverse_list(a); ;
#undef a
}
YY_ACTION(void) yy_2_DocForOPML(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_DocForOPML"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_DocForOPML(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_DocForOPML"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_RawNoteBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_RawNoteBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a, true);\n\
\t\t\tyy->key = RAW;\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a, true);
			yy->key = RAW;
		;
#undef a
}
YY_ACTION(void) yy_2_RawNoteBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_RawNoteBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext), a); }\n"));
  a = cons(str(yytext), a); ;
#undef a
}
YY_ACTION(void) yy_1_RawNoteBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_RawNoteBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_Note(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
#define ref G->val[-2]
  yyprintf((stderr, "do yy_3_Note"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tnode *label;\n\
\t\t\tlabel = str(ref->str);\n\
\t\t\tlabel->key = NOTELABEL;\n\
\t\t\ta = cons(label,a);\n\
\t\t\tyy = list(NOTESOURCE, a);\n\
\t\t\tyy->str = strdup(ref->str);\n\
\t\t\t\n\
\t\t\tfree_node(ref);\n\
\t\t}\n"));
  
			node *label;
			label = str(ref->str);
			label->key = NOTELABEL;
			a = cons(label,a);
			yy = list(NOTESOURCE, a);
			yy->str = strdup(ref->str);
			
			free_node(ref);
		;
#undef a
#undef ref
}
YY_ACTION(void) yy_2_Note(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
#define ref G->val[-2]
  yyprintf((stderr, "do yy_2_Note"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
#undef ref
}
YY_ACTION(void) yy_1_Note(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
#define ref G->val[-2]
  yyprintf((stderr, "do yy_1_Note"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
#undef ref
}
YY_ACTION(void) yy_1_RawNoteReference(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RawNoteReference"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = str(yytext);\n\
\t\t}\n"));
  
			yy = str(yytext);
		;
}
YY_ACTION(void) yy_3_TableCaption(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define c G->val[-1]
#define a G->val[-2]
#define b G->val[-3]
  yyprintf((stderr, "do yy_3_TableCaption"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = a;\n\
\n\
\t\t\tif (yy != NULL) {\n\
\t\t\t\tyy->key = TABLECAPTION;\n\
\t\t\t}\n\
\n\
\t\t\tif ( (b != NULL) && (b->key == TABLELABEL) ) {\n\
\t\t\t\tif (yy == NULL)\n\
\t\t\t\t\tyy = node(TABLECAPTION);\n\
\n\
\t\t\t\tb->next = yy->children;\n\
\t\t\t\tyy->children = b;\n\
\t\t\t}\n\
\t\t}\n"));
  
			yy = a;

			if (yy != NULL) {
				yy->key = TABLECAPTION;
			}

			if ( (b != NULL) && (b->key == TABLELABEL) ) {
				if (yy == NULL)
					yy = node(TABLECAPTION);

				b->next = yy->children;
				yy->children = b;
			}
		;
#undef c
#undef a
#undef b
}
YY_ACTION(void) yy_2_TableCaption(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define c G->val[-1]
#define a G->val[-2]
#define b G->val[-3]
  yyprintf((stderr, "do yy_2_TableCaption"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {b = c; b->key = TABLELABEL;}\n"));
  b = c; b->key = TABLELABEL;;
#undef c
#undef a
#undef b
}
YY_ACTION(void) yy_1_TableCaption(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define c G->val[-1]
#define a G->val[-2]
#define b G->val[-3]
  yyprintf((stderr, "do yy_1_TableCaption"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyytext[strlen(yytext) - 1] = '\\0';\n\
\t\ta = markdown_chunk_to_node(&yytext[1], ((parser_data *)G->data)->extensions);\n\
\t}\n"));
  
		yytext[strlen(yytext) - 1] = '\0';
		a = markdown_chunk_to_node(&yytext[1], ((parser_data *)G->data)->extensions);
	;
#undef c
#undef a
#undef b
}
YY_ACTION(void) yy_1_RightAlign(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RightAlign"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"r\");}\n"));
  yy = str("r");;
}
YY_ACTION(void) yy_1_RightAlignWrap(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RightAlignWrap"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"R\");}\n"));
  yy = str("R");;
}
YY_ACTION(void) yy_1_CenterAlign(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_CenterAlign"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"c\");}\n"));
  yy = str("c");;
}
YY_ACTION(void) yy_1_CenterAlignWrap(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_CenterAlignWrap"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"C\");}\n"));
  yy = str("C");;
}
YY_ACTION(void) yy_1_LeftAlign(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_LeftAlign"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"l\");}\n"));
  yy = str("l");;
}
YY_ACTION(void) yy_1_LeftAlignWrap(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_LeftAlignWrap"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"L\");}\n"));
  yy = str("L");;
}
YY_ACTION(void) yy_1_NaturalAlign(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_NaturalAlign"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"n\");}\n"));
  yy = str("n");;
}
YY_ACTION(void) yy_1_NaturalAlignWrap(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_NaturalAlignWrap"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(\"N\");}\n"));
  yy = str("N");;
}
YY_ACTION(void) yy_3_SeparatorLine(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_SeparatorLine"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a,false);\n\
\t\t\tyy->key = TABLESEPARATOR;\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a,false);
			yy->key = TABLESEPARATOR;
		;
#undef a
}
YY_ACTION(void) yy_2_SeparatorLine(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_SeparatorLine"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_SeparatorLine(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_SeparatorLine"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"h\"), a); a = cons(yy, a);}\n"));
  a = cons(str("h"), a); a = cons(yy, a);;
#undef a
}
YY_ACTION(void) yy_1_EmptyCell(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_EmptyCell"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = node(TABLECELL);\n\
\t\t}\n"));
  
			yy = node(TABLECELL);
		;
}
YY_ACTION(void) yy_2_FullCell(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_FullCell"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(TABLECELL,a);\n\
\t\t}\n"));
  
			yy = list(TABLECELL,a);
		;
#undef a
}
YY_ACTION(void) yy_1_FullCell(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_FullCell"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy,a)}\n"));
  a = cons(yy,a);
#undef a
}
YY_ACTION(void) yy_1_ExtendedCell(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_ExtendedCell"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tnode *span;\n\
\t\tspan = str(yytext);\n\
\t\tspan->key = CELLSPAN;\n\
\t\tspan->next = yy->children;\n\
\t\tyy->children = span;\n\
    }\n"));
  
		node *span;
		span = str(yytext);
		span->key = CELLSPAN;
		span->next = yy->children;
		yy->children = span;
    ;
}
YY_ACTION(void) yy_2_TableRow(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_TableRow"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(TABLEROW, a);\n\
\t\t}\n"));
  
			yy = list(TABLEROW, a);
		;
#undef a
}
YY_ACTION(void) yy_1_TableRow(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_TableRow"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_TableBody(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_TableBody"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(TABLEBODY, a);\n\
\t\t}\n"));
  
			yy = list(TABLEBODY, a);
		;
#undef a
}
YY_ACTION(void) yy_1_TableBody(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_TableBody"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a);}\n"));
  a = cons(yy, a);;
#undef a
}
YY_ACTION(void) yy_7_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_7_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (b != NULL) { append_list(b,a); };\n\
\t\t\tyy = list(TABLE, a);\n\
\t\t}\n"));
  
			if (b != NULL) { append_list(b,a); };
			yy = list(TABLE, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_6_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_6_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {b = cons(yy, b);}\n"));
  b = cons(yy, b);;
#undef b
#undef a
}
YY_ACTION(void) yy_5_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_5_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_4_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_4_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a);}\n"));
  a = cons(yy, a);;
#undef b
#undef a
}
YY_ACTION(void) yy_3_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (a == NULL)\n\
\t\t\t\ta = yy;\n\
\t\t\telse\n\
\t\t\t\tappend_list(yy,a); }\n"));
  
			if (a == NULL)
				a = yy;
			else
				append_list(yy,a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_2_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy->key = TABLEHEAD; a = cons(yy, a); }\n"));
  yy->key = TABLEHEAD; a = cons(yy, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_1_Table(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_Table"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {b = cons(yy, b);}\n"));
  b = cons(yy, b);;
#undef b
#undef a
}
YY_ACTION(void) yy_1_StyleBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_StyleBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (ext(EXT_FILTER_STYLES)) {\n\
\t\t\t\tyy = list(LIST, NULL);\n\
\t\t\t} else {\n\
\t\t\t\tyy = str(yytext);\n\
\t\t\t\tyy->key = HTMLBLOCK;\n\
\t\t\t}\n\
\t\t}\n"));
  
			if (ext(EXT_FILTER_STYLES)) {
				yy = list(LIST, NULL);
			} else {
				yy = str(yytext);
				yy->key = HTMLBLOCK;
			}
		;
}
YY_ACTION(void) yy_6_MarkdownHtmlTagOpen(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_6_MarkdownHtmlTagOpen"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\t\tyy = mk_str_from_list(a,false);\n\
\t\t\t\tyy->key = HTML;\n\
\t\t\t}\n"));
  
				yy = mk_str_from_list(a,false);
				yy->key = HTML;
			;
#undef a
}
YY_ACTION(void) yy_5_MarkdownHtmlTagOpen(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_5_MarkdownHtmlTagOpen"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\">\"),a);}\n"));
  a = cons(str(">"),a);;
#undef a
}
YY_ACTION(void) yy_4_MarkdownHtmlTagOpen(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_4_MarkdownHtmlTagOpen"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\" \"),a);\n\
\t\t\t\ta = cons(str(yytext),a);}\n"));
  a = cons(str(" "),a);
				a = cons(str(yytext),a);;
#undef a
}
YY_ACTION(void) yy_3_MarkdownHtmlTagOpen(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_MarkdownHtmlTagOpen"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\" \"),a);\n\
\t\t\t\ta = cons(str(yytext),a);}\n"));
  a = cons(str(" "),a);
				a = cons(str(yytext),a);;
#undef a
}
YY_ACTION(void) yy_2_MarkdownHtmlTagOpen(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_MarkdownHtmlTagOpen"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext),a);}\n"));
  a = cons(str(yytext),a);;
#undef a
}
YY_ACTION(void) yy_1_MarkdownHtmlTagOpen(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_MarkdownHtmlTagOpen"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"<\"),a);}\n"));
  a = cons(str("<"),a);;
#undef a
}
YY_ACTION(void) yy_1_MarkdownHtmlBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_MarkdownHtmlBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = RAW; }\n"));
  yy = str(yytext); yy->key = RAW; ;
}
YY_ACTION(void) yy_1_HtmlBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_HtmlBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (ext(EXT_FILTER_HTML)) {\n\
\t\t\t\tyy = list(LIST, NULL);\n\
\t\t\t} else {\n\
\t\t\t\tyy = str(yytext);\n\
\t\t\t\tif ( ext(EXT_PROCESS_HTML)) yy->key = RAW;\n\
\t\t\t\telse yy->key = HTMLBLOCK;\n\
\t\t\t}\n\
\t\t}\n"));
  
			if (ext(EXT_FILTER_HTML)) {
				yy = list(LIST, NULL);
			} else {
				yy = str(yytext);
				if ( ext(EXT_PROCESS_HTML)) yy->key = RAW;
				else yy->key = HTMLBLOCK;
			}
		;
}
YY_ACTION(void) yy_1_OrderedList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_OrderedList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy->key = ORDEREDLIST; }\n"));
  yy->key = ORDEREDLIST; ;
}
YY_ACTION(void) yy_3_ListContinuationBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_ListContinuationBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a, false);\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a, false);
		;
#undef a
}
YY_ACTION(void) yy_2_ListContinuationBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_ListContinuationBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_ListContinuationBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_ListContinuationBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (strlen(yytext) == 0)\n\
\t\t\t\ta = cons(str(\"\\001\"), a); /* block separator */\n\
\t\t\telse\n\
\t\t\t\ta = cons(str(yytext), a);\n\
\t\t}\n"));
  
			if (strlen(yytext) == 0)
				a = cons(str("\001"), a); /* block separator */
			else
				a = cons(str(yytext), a);
		;
#undef a
}
YY_ACTION(void) yy_3_ListBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_ListBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a, false);\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a, false);
		;
#undef a
}
YY_ACTION(void) yy_2_ListBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_ListBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_ListBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_ListBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_EmptyList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_EmptyList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = str(\"\");\n\
\t\t}\n"));
  
			yy = str("");
		;
}
YY_ACTION(void) yy_3_ListItemTight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_ListItemTight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tnode *raw;\n\
\t\t\traw = mk_str_from_list(a, false);\n\
\t\t\traw->key = RAW;\n\
\t\t\tyy = node(LISTITEM);\n\
\t\t\tyy->children = raw;\n\
\t\t}\n"));
  
			node *raw;
			raw = mk_str_from_list(a, false);
			raw->key = RAW;
			yy = node(LISTITEM);
			yy->children = raw;
		;
#undef a
}
YY_ACTION(void) yy_2_ListItemTight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_ListItemTight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_ListItemTight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_ListItemTight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_ListItem(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_ListItem"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tnode *raw;\n\
\t\t\traw = mk_str_from_list(a, false);\n\
\t\t\traw->key = RAW;\n\
\t\t\tyy = node(LISTITEM);\n\
\t\t\tyy->children = raw;\n\
\t\t}\n"));
  
			node *raw;
			raw = mk_str_from_list(a, false);
			raw->key = RAW;
			yy = node(LISTITEM);
			yy->children = raw;
		;
#undef a
}
YY_ACTION(void) yy_2_ListItem(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_ListItem"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_ListItem(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_ListItem"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_ListLoose(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_ListLoose"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(LIST, a);\n\
\t\t}\n"));
  
			yy = list(LIST, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_1_ListLoose(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_ListLoose"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tnode *li;\n\
\t\t\tli = b->children;\n\
\t\t\tsize_t size = strlen(li->str);\n\
\t\t\tli->str = realloc(li->str, size + 3);\n\
\t\t\tstrncat(li->str + size, \"\\n\\n\", 2);  /* In loose list, \\n\\n added to end of each element */\n\
\t\t\ta = cons(b, a);\n\
\t\t}\n"));
  
			node *li;
			li = b->children;
			size_t size = strlen(li->str);
			li->str = realloc(li->str, size + 3);
			strncat(li->str + size, "\n\n", 2);  /* In loose list, \n\n added to end of each element */
			a = cons(b, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_2_ListTight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_ListTight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(LIST, a);\n\
\t\t}\n"));
  
			yy = list(LIST, a);
		;
#undef a
}
YY_ACTION(void) yy_1_ListTight(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_ListTight"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_BulletList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_BulletList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy->key = BULLETLIST; }\n"));
  yy->key = BULLETLIST; ;
}
YY_ACTION(void) yy_7_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_7_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (b != NULL) { a = cons(b,a);}\n\
\t\t\tnode *raw = mk_str_from_list(a, false);\n\
\t\t\traw->key = RAW;\n\
\t\t\tyy = list(DEFINITION,raw);\n\
\t\t}\n"));
  
			if (b != NULL) { a = cons(b,a);}
			node *raw = mk_str_from_list(a, false);
			raw->key = RAW;
			yy = list(DEFINITION,raw);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_6_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_6_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"\\n\"),a);}\n"));
  a = cons(str("\n"),a);;
#undef b
#undef a
}
YY_ACTION(void) yy_5_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_5_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy,a);}\n"));
  a = cons(yy,a);;
#undef b
#undef a
}
YY_ACTION(void) yy_4_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_4_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"\\n\"),a);}\n"));
  a = cons(str("\n"),a);;
#undef b
#undef a
}
YY_ACTION(void) yy_3_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext), a);}\n"));
  a = cons(str(yytext), a);;
#undef b
#undef a
}
YY_ACTION(void) yy_2_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext), a);}\n"));
  a = cons(str(yytext), a);;
#undef b
#undef a
}
YY_ACTION(void) yy_1_Definition(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_Definition"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {b = cons(str(\"\\n\"),b); }\n"));
  b = cons(str("\n"),b); ;
#undef b
#undef a
}
YY_ACTION(void) yy_2_Term(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_Term"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(TERM,a);\n\
\t}\n"));
  
		yy = list(TERM,a);
	;
#undef a
}
YY_ACTION(void) yy_1_Term(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Term"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a);}\n"));
  a = cons(yy, a);;
#undef a
}
YY_ACTION(void) yy_3_DefinitionList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_DefinitionList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(LIST, a);\n\
\t\t\tyy->key = DEFLIST;\n\
\t\t}\n"));
  
			yy = list(LIST, a);
			yy->key = DEFLIST;
		;
#undef a
}
YY_ACTION(void) yy_2_DefinitionList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_DefinitionList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a);}\n"));
  a = cons(yy, a);;
#undef a
}
YY_ACTION(void) yy_1_DefinitionList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_DefinitionList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_HorizontalRule(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_HorizontalRule"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = node(HRULE);\n\
\t\t}\n"));
  
			yy = node(HRULE);
		;
}
YY_ACTION(void) yy_2_Verbatim(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_Verbatim"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a, false);\n\
\t\t\tyy->key = VERBATIM;\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a, false);
			yy->key = VERBATIM;
		;
#undef a
}
YY_ACTION(void) yy_1_Verbatim(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Verbatim"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_VerbatimChunk(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_VerbatimChunk"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a, false);\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a, false);
		;
#undef a
}
YY_ACTION(void) yy_2_VerbatimChunk(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_VerbatimChunk"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_VerbatimChunk(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_VerbatimChunk"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"\\n\"), a); }\n"));
  a = cons(str("\n"), a); ;
#undef a
}
YY_ACTION(void) yy_2_BackTickQuoted(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_BackTickQuoted"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(DOUBLEQUOTED, a);\n\
\t\t}\n"));
  
			yy = list(DOUBLEQUOTED, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_1_BackTickQuoted(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_BackTickQuoted"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(b, a); }\n"));
  a = cons(b, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_2_DoubleQuoted(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_DoubleQuoted"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = list(DOUBLEQUOTED, a); }\n"));
  yy = list(DOUBLEQUOTED, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_1_DoubleQuoted(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_DoubleQuoted"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(b, a); }\n"));
  a = cons(b, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_2_SingleQuoted(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_SingleQuoted"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(SINGLEQUOTED, a);\n\
\t\t}\n"));
  
			yy = list(SINGLEQUOTED, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_1_SingleQuoted(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_SingleQuoted"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(b, a); }\n"));
  a = cons(b, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_1_EmDash(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_EmDash"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = EMDASH; }\n"));
  yy = str(yytext); yy->key = EMDASH; ;
}
YY_ACTION(void) yy_1_EnDash(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_EnDash"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = ENDASH; }\n"));
  yy = str(yytext); yy->key = ENDASH; ;
}
YY_ACTION(void) yy_1_Ellipsis(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Ellipsis"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = ELLIPSIS; }\n"));
  yy = str(yytext); yy->key = ELLIPSIS; ;
}
YY_ACTION(void) yy_1_Apostrophe(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Apostrophe"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = APOSTROPHE; }\n"));
  yy = str(yytext); yy->key = APOSTROPHE; ;
}
YY_ACTION(void) yy_1_Fenced(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Fenced"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = VERBATIMFENCE;\n\
\t\tyy->children = a;\n\
\t}\n"));
  
		yy = str(yytext);
		yy->key = VERBATIMFENCE;
		yy->children = a;
	;
#undef a
}
YY_ACTION(void) yy_1_FenceType(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_FenceType"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = VERBATIMTYPE; }\n"));
  yy = str(yytext); yy->key = VERBATIMTYPE; ;
}
YY_ACTION(void) yy_1_Code(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Code"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
       \t\tyy = str(yytext);\n\
       \t\tyy->key = CODE;\n\
       \t}\n"));
  
       		yy = str(yytext);
       		yy->key = CODE;
       	;
}
YY_ACTION(void) yy_1_GlossarySortKey(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_GlossarySortKey"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = GLOSSARYSORTKEY;\n\
\t}\n"));
  
		yy = str(yytext);
		yy->key = GLOSSARYSORTKEY;
	;
}
YY_ACTION(void) yy_1_GlossaryTerm(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_GlossaryTerm"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(LIST, NULL);\n\
\t\tyy->str = 0;\n\
\t\tyy->children = str(yytext);\n\
\t\tyy->key = GLOSSARYTERM;\n\
\t}\n"));
  
		yy = list(LIST, NULL);
		yy->str = 0;
		yy->children = str(yytext);
		yy->key = GLOSSARYTERM;
	;
}
YY_ACTION(void) yy_5_Glossary(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define ref G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_5_Glossary"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tnode *label;\n\
\t\t\tlabel = str(ref->str);\n\
\t\t\tlabel->key = GLOSSARYLABEL;\n\
\t\t\ta = cons(label,a);\n\
\t\t\tyy = list(GLOSSARYSOURCE, a);\n\
\t\t\tyy->str = strdup(ref->str);\n\
\t\t\tfree_node(ref);\n\
\t\t}\n"));
  
			node *label;
			label = str(ref->str);
			label->key = GLOSSARYLABEL;
			a = cons(label,a);
			yy = list(GLOSSARYSOURCE, a);
			yy->str = strdup(ref->str);
			free_node(ref);
		;
#undef ref
#undef a
}
YY_ACTION(void) yy_4_Glossary(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define ref G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_4_Glossary"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef ref
#undef a
}
YY_ACTION(void) yy_3_Glossary(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define ref G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_Glossary"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef ref
#undef a
}
YY_ACTION(void) yy_2_Glossary(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define ref G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_Glossary"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef ref
#undef a
}
YY_ACTION(void) yy_1_Glossary(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define ref G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_Glossary"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef ref
#undef a
}
YY_ACTION(void) yy_1_NoteReference(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_NoteReference"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t/* Copy entire label, and ensure we are treated as a paragraph */\n\
\t\tGString *original = g_string_new(yytext);\n\
\t\tg_string_append_c(original,'\\n');\n\
\t\tg_string_append_c(original,'\\n');\n\
\n\
\t\t/* Create a note reference */\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = NOTEREFERENCE;\n\
\t\t\n\
\t\t/* Include RAW version for parsing in case this is an inline footnote */\n\
\t\tnode *raw = str(original->str);\n\
\t\traw->key = RAW;\n\
\t\tnode *source = list(NOTESOURCE, raw);\n\
\t\tsource->str = strdup(\"\");\n\
\t\t\n\
\t\tyy->children = source;\n\
\n\
\t\tg_string_free(original, true);\n\
\t}\n"));
  
		/* Copy entire label, and ensure we are treated as a paragraph */
		GString *original = g_string_new(yytext);
		g_string_append_c(original,'\n');
		g_string_append_c(original,'\n');

		/* Create a note reference */
		yy = str(yytext);
		yy->key = NOTEREFERENCE;
		
		/* Include RAW version for parsing in case this is an inline footnote */
		node *raw = str(original->str);
		raw->key = RAW;
		node *source = list(NOTESOURCE, raw);
		source->str = strdup("");
		
		yy->children = source;

		g_string_free(original, true);
	;
}
YY_ACTION(void) yy_1_AutoLabel(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AutoLabel"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\tnode *ref;\n\
\tyy = str(yytext);\n\
\tyy->key = AUTOLABEL;\n\
\t\n\
\t/* And create a LINKREFERENCE so we can use it */\n\
\tchar *label = label_from_string(yytext);\n\
\tGString *anchor = g_string_new(label);\n\
\tg_string_prepend(anchor, \"#\");\n\
\tref = mk_link(NULL, label, anchor->str, NULL, NULL);\n\
\n\
\tg_string_free(anchor, true);\n\
\tfree(label);\n\
\t((parser_data *)G->data)->autolabels = cons(ref,((parser_data *)G->data)->autolabels);\n\
\tref->key = LINKREFERENCE;\n\
}\n"));
  
	node *ref;
	yy = str(yytext);
	yy->key = AUTOLABEL;
	
	/* And create a LINKREFERENCE so we can use it */
	char *label = label_from_string(yytext);
	GString *anchor = g_string_new(label);
	g_string_prepend(anchor, "#");
	ref = mk_link(NULL, label, anchor->str, NULL, NULL);

	g_string_free(anchor, true);
	free(label);
	((parser_data *)G->data)->autolabels = cons(ref,((parser_data *)G->data)->autolabels);
	ref->key = LINKREFERENCE;
;
}
YY_ACTION(void) yy_2_Label2(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_Label2"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(LIST, a);\n\
\t}\n"));
  
		yy = list(LIST, a);
	;
#undef a
}
YY_ACTION(void) yy_1_Label2(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Label2"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_Label(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Label"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyytext[strlen(yytext) - 1] = '\\0';\n\
\t\tyy = markdown_chunk_to_node(&yytext[1], ((parser_data *)G->data)->extensions);\n\
\t\tif (yy == NULL) {\n\
\t\t\tyy = str(\"\");\n\
\t\t} else {\n\
\t\t\tyy->key = LIST;\t\t\n\
\t\t}\n\
\t}\n"));
  
		yytext[strlen(yytext) - 1] = '\0';
		yy = markdown_chunk_to_node(&yytext[1], ((parser_data *)G->data)->extensions);
		if (yy == NULL) {
			yy = str("");
		} else {
			yy->key = LIST;		
		}
	;
}
YY_ACTION(void) yy_1_Image(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Image"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy->key = IMAGE;\n\
\t\t}\n"));
  
			yy->key = IMAGE;
		;
}
YY_ACTION(void) yy_1_ImageBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_ImageBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tif (yy->key == IMAGE)\n\
\t\t\tyy->key = IMAGEBLOCK;\n\
\t}\n"));
  
		if (yy->key == IMAGE)
			yy->key = IMAGEBLOCK;
	;
}
YY_ACTION(void) yy_1_Abbreviation(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define l G->val[-1]
  yyprintf((stderr, "do yy_1_Abbreviation"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = ABBREVIATION;\n\
\n\
\t\tyy->children = l;\n\
\t}\n"));
  
		yy = str(yytext);
		yy->key = ABBREVIATION;

		yy->children = l;
	;
#undef l
}
YY_ACTION(void) yy_1_RefTitle(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RefTitle"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = RAW; }\n"));
  yy = str(yytext); yy->key = RAW; ;
}
YY_ACTION(void) yy_1_RefSrc(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RefSrc"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tchar *tmp = strdup(yytext);\n\
\t\tif ((tmp[0] == '<') &&\n\
\t\t\t(tmp[strlen(tmp) - 1] == '>')) {\n\
\t\t\ttmp[strlen(tmp) - 1] = '\\0';\n\
\t\t\tyy = str(&tmp[1]);\n\
\t\t} else {\n\
\t\t\tyy = str(yytext);\n\
\t\t}\n\
\t\tyy->key = HTML;\n\
\t\tfree(tmp);\n\
\t}\n"));
  
		char *tmp = strdup(yytext);
		if ((tmp[0] == '<') &&
			(tmp[strlen(tmp) - 1] == '>')) {
			tmp[strlen(tmp) - 1] = '\0';
			yy = str(&tmp[1]);
		} else {
			yy = str(yytext);
		}
		yy->key = HTML;
		free(tmp);
	;
}
YY_ACTION(void) yy_1_AttrValue(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AttrValue"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = ATTRVALUE; }\n"));
  yy = str(yytext); yy->key = ATTRVALUE; ;
}
YY_ACTION(void) yy_1_AttrKey(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AttrKey"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tchar *lab;\n\
\t\tlab = label_from_string(yytext);\n\
\t\tyy = str(lab);\n\
\t\tyy->key = ATTRKEY;\n\
\t\tfree(lab);\n\
\t}\n"));
  
		char *lab;
		lab = label_from_string(yytext);
		yy = str(lab);
		yy->key = ATTRKEY;
		free(lab);
	;
}
YY_ACTION(void) yy_1_Attribute(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_Attribute"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = a;\n\
\t\tyy->children = b;\n\
\t}\n"));
  
		yy = a;
		yy->children = b;
	;
#undef b
#undef a
}
YY_ACTION(void) yy_2_Attributes(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_Attributes"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = a; }\n"));
  yy = a; ;
#undef a
}
YY_ACTION(void) yy_1_Attributes(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Attributes"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy,a); }\n"));
  a = cons(yy,a); ;
#undef a
}
YY_ACTION(void) yy_2_LinkReference(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define t G->val[-1]
#define s G->val[-2]
#define l G->val[-3]
#define a G->val[-4]
  yyprintf((stderr, "do yy_2_LinkReference"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\t/* Get label for referencing */\n\
\t\t\tGString *text = g_string_new(\"\");\n\
\t\t\tchar *clean;\n\
\t\t\tprint_raw_node_tree(text, l->children);\n\
\t\t\tclean = clean_string(text->str);\n\
\t\t\t\n\
\t\t\tif (a == NULL) {\n\
\t\t\t\t/* no attributes */\n\
\t\t\t\tyy = mk_link(NULL, clean, s->str, t->str, NULL);\n\
\t\t\t} else {\n\
\t\t\t\tyy = mk_link(NULL, clean, s->str, t->str, a);\n\
\t\t\t}\n\
\t\t\tg_string_free(text, TRUE);\n\
\t\t\tfree_node(s);\n\
\t\t\tfree_node(t);\n\
\t\t\tfree_node_tree(l);\n\
\t\t\tfree(clean);\n\
\t\t\tyy->key = LINKREFERENCE;\n\
\t\t}\n"));
  
			/* Get label for referencing */
			GString *text = g_string_new("");
			char *clean;
			print_raw_node_tree(text, l->children);
			clean = clean_string(text->str);
			
			if (a == NULL) {
				/* no attributes */
				yy = mk_link(NULL, clean, s->str, t->str, NULL);
			} else {
				yy = mk_link(NULL, clean, s->str, t->str, a);
			}
			g_string_free(text, TRUE);
			free_node(s);
			free_node(t);
			free_node_tree(l);
			free(clean);
			yy->key = LINKREFERENCE;
		;
#undef t
#undef s
#undef l
#undef a
}
YY_ACTION(void) yy_1_LinkReference(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define t G->val[-1]
#define s G->val[-2]
#define l G->val[-3]
#define a G->val[-4]
  yyprintf((stderr, "do yy_1_LinkReference"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = reverse_list(yy); }\n"));
  a = reverse_list(yy); ;
#undef t
#undef s
#undef l
#undef a
}
YY_ACTION(void) yy_1_AutoLinkEmail(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AutoLinkEmail"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tchar *mailto = malloc(strlen(yytext) + 8);\n\
\t\tsprintf(mailto, \"mailto:%%s\", yytext);\n\
\t\tyy = mk_link(str(yytext), NULL, mailto, NULL, NULL);\n\
\t\tfree(mailto);\n\
\t}\n"));
  
		char *mailto = malloc(strlen(yytext) + 8);
		sprintf(mailto, "mailto:%s", yytext);
		yy = mk_link(str(yytext), NULL, mailto, NULL, NULL);
		free(mailto);
	;
}
YY_ACTION(void) yy_1_AutoLinkUrl(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AutoLinkUrl"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = mk_link(str(yytext), NULL, yytext, NULL, NULL);\n\
\t}\n"));
  
		yy = mk_link(str(yytext), NULL, yytext, NULL, NULL);
	;
}
YY_ACTION(void) yy_1_Title(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Title"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = TITLE; }\n"));
  yy = str(yytext); yy->key = TITLE; ;
}
YY_ACTION(void) yy_1_Source(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Source"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = SOURCE; }\n"));
  yy = str(yytext); yy->key = SOURCE; ;
}
YY_ACTION(void) yy_1_ExplicitLink(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define t G->val[-1]
#define s G->val[-2]
#define l G->val[-3]
  yyprintf((stderr, "do yy_1_ExplicitLink"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = mk_link(l, NULL, s->str, t->str, NULL);\n\
\t\tfree_node_tree(s);\n\
\t\tfree_node_tree(t);\n\
\t}\n"));
  
		yy = mk_link(l, NULL, s->str, t->str, NULL);
		free_node_tree(s);
		free_node_tree(t);
	;
#undef t
#undef s
#undef l
}
YY_ACTION(void) yy_1_Variable(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Variable"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = VARIABLE;\n\
\t}\n"));
  
		yy = str(yytext);
		yy->key = VARIABLE;
	;
}
YY_ACTION(void) yy_1_RawCitationReference(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RawCitationReference"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = str(yytext);\n\
\t\t}\n"));
  
			yy = str(yytext);
		;
}
YY_ACTION(void) yy_1_CitationReferenceSingle(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
  yyprintf((stderr, "do yy_1_CitationReferenceSingle"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = mk_link(NULL, b->str, NULL, NULL, NULL);\n\
\t\tyy->key = CITATION;\n\
\t\tfree_node_tree(b);\n\
\t}\n"));
  
		yy = mk_link(NULL, b->str, NULL, NULL, NULL);
		yy->key = CITATION;
		free_node_tree(b);
	;
#undef b
}
YY_ACTION(void) yy_1_CitationReferenceDouble(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_CitationReferenceDouble"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tchar *label;\n\
\t\tlabel = label_from_node_tree(a);\n\
\t\tyy = mk_link(a, b->str, NULL, NULL, NULL);\n\
\t\tyy->key = CITATION;\n\
\t\t\n\
\t\tif (strcmp(label,\"notcited\") == 0)\n\
\t\t\tyy->key = NOCITATION;\n\
\t\tfree(label);\n\
\t\tfree_node_tree(b);\n\
\t}\n"));
  
		char *label;
		label = label_from_node_tree(a);
		yy = mk_link(a, b->str, NULL, NULL, NULL);
		yy->key = CITATION;
		
		if (strcmp(label,"notcited") == 0)
			yy->key = NOCITATION;
		free(label);
		free_node_tree(b);
	;
#undef b
#undef a
}
YY_ACTION(void) yy_1_ReferenceLinkSingle(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_ReferenceLinkSingle"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = mk_link(a, NULL, NULL, NULL, NULL);\n\
\t\t/* stash copy of raw source in case we need if */\n\
\t\tyy->str = strdup(yytext);\n\
\t}\n"));
  
		yy = mk_link(a, NULL, NULL, NULL, NULL);
		/* stash copy of raw source in case we need if */
		yy->str = strdup(yytext);
	;
#undef a
}
YY_ACTION(void) yy_1_ReferenceLinkDouble(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_ReferenceLinkDouble"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tGString *text = g_string_new(\"\");\n\
\t\tprint_raw_node_tree(text, b->children);\n\
\t\tyy = mk_link(a, text->str, NULL, NULL, NULL);\n\
\t\tg_string_free(text, TRUE);\n\
\t\tfree_node_tree(b);\n\
\t}\n"));
  
		GString *text = g_string_new("");
		print_raw_node_tree(text, b->children);
		yy = mk_link(a, text->str, NULL, NULL, NULL);
		g_string_free(text, TRUE);
		free_node_tree(b);
	;
#undef b
#undef a
}
YY_ACTION(void) yy_1_Strong(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Strong"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyytext[strlen(yytext) - 2] = '\\0';\n\
\n\
\t\t\tyy = markdown_chunk_to_node(&yytext[2], ((parser_data *)G->data)->extensions );\n\
\t\t\tif (yy != NULL) {\n\
\t\t\t\tyy->key = STRONG;\n\
\t\t\t}\n\
\t\t}\n"));
  
			yytext[strlen(yytext) - 2] = '\0';

			yy = markdown_chunk_to_node(&yytext[2], ((parser_data *)G->data)->extensions );
			if (yy != NULL) {
				yy->key = STRONG;
			}
		;
}
YY_ACTION(void) yy_1_Emph(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Emph"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyytext[strlen(yytext) - 1] = '\\0';\n\
\n\
\t\tyy = markdown_chunk_to_node(&yytext[1], ((parser_data *)G->data)->extensions);\n\
\t\tif (yy != NULL) {\n\
\t\t\tyy->key = EMPH;\n\
\t\t}\n\
\t}\n"));
  
		yytext[strlen(yytext) - 1] = '\0';

		yy = markdown_chunk_to_node(&yytext[1], ((parser_data *)G->data)->extensions);
		if (yy != NULL) {
			yy->key = EMPH;
		}
	;
}
YY_ACTION(void) yy_1_UlOrStarLine(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_UlOrStarLine"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_DoubleDollarMath(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_DoubleDollarMath"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = MATHSPAN; }\n"));
  yy = str(yytext); yy->key = MATHSPAN; ;
}
YY_ACTION(void) yy_1_SingleDollarMath(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_SingleDollarMath"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = MATHSPAN; }\n"));
  yy = str(yytext); yy->key = MATHSPAN; ;
}
YY_ACTION(void) yy_1_MathSpan(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_MathSpan"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\t/* Basically, these delimiters indicate math in LaTeX syntax, and the\n\
\t\t\t   delimiters are compatible with MathJax and LaTeX\n\
\t\t\t   ASCIIMathML is *not* supported */\n\
\t\t\tyy = str(yytext);\n\
\t\t\tyy->key = MATHSPAN;\n\
\t\t}\n"));
  
			/* Basically, these delimiters indicate math in LaTeX syntax, and the
			   delimiters are compatible with MathJax and LaTeX
			   ASCIIMathML is *not* supported */
			yy = str(yytext);
			yy->key = MATHSPAN;
		;
}
YY_ACTION(void) yy_1_StartList(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_StartList"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = NULL; }\n"));
  yy = NULL; ;
}
YY_ACTION(void) yy_1_Subscript(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Subscript"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = SUBSCRIPT; }\n"));
  yy = str(yytext); yy->key = SUBSCRIPT; ;
}
YY_ACTION(void) yy_1_Superscript(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Superscript"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = SUPERSCRIPT; }\n"));
  yy = str(yytext); yy->key = SUPERSCRIPT; ;
}
YY_ACTION(void) yy_1_AposChunk(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AposChunk"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = node(APOSTROPHE); }\n"));
  yy = node(APOSTROPHE); ;
}
YY_ACTION(void) yy_1_StrChunk(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_StrChunk"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_4_Str(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_4_Str"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (a->next == NULL) {\n\
\t\t\t\tyy = a;\n\
\t\t\t} else {\n\
\t\t\t\tyy = list(LIST, a);\n\
\t\t\t}\n\
\t\t}\n"));
  
			if (a->next == NULL) {
				yy = a;
			} else {
				yy = list(LIST, a);
			}
		;
#undef a
}
YY_ACTION(void) yy_3_Str(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_Str"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_2_Str(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_Str"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_Str(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Str"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext), a); }\n"));
  a = cons(str(yytext), a); ;
#undef a
}
YY_ACTION(void) yy_1_LineBreak(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_LineBreak"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = a;\n\
\t\t\tyy->key = LINEBREAK;\n\
\t\t}\n"));
  
			yy = a;
			yy->key = LINEBREAK;
		;
#undef a
}
YY_ACTION(void) yy_1_TerminalEndline(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_TerminalEndline"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = NULL; }\n"));
  yy = NULL; ;
}
YY_ACTION(void) yy_1_NormalEndline(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_NormalEndline"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = str(\"\\n\");\n\
\t\t\tyy->key = SPACE; \n\
\t\t}\n"));
  
			yy = str("\n");
			yy->key = SPACE; 
		;
}
YY_ACTION(void) yy_1_Space(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Space"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(\" \");\n\
\t\tyy->key = SPACE;\n\
\t}\n"));
  
		yy = str(" ");
		yy->key = SPACE;
	;
}
YY_ACTION(void) yy_3_Inlines(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define c G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_Inlines"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(LIST, a);\n\
\t\t}\n"));
  
			yy = list(LIST, a);
		;
#undef c
#undef a
}
YY_ACTION(void) yy_2_Inlines(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define c G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_Inlines"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(c, a); }\n"));
  a = cons(c, a); ;
#undef c
#undef a
}
YY_ACTION(void) yy_1_Inlines(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define c G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_Inlines"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef c
#undef a
}
YY_ACTION(void) yy_1_Plain(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Plain"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = a;\n\
\t\t\tyy->key = PLAIN;\n\
\t\t}\n"));
  
			yy = a;
			yy->key = PLAIN;
		;
#undef a
}
YY_ACTION(void) yy_1_Para(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_Para"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = a;\n\
\t\t\tyy->key = PARA;\n\
\t\t}\n"));
  
			yy = a;
			yy->key = PARA;
		;
#undef a
}
YY_ACTION(void) yy_1_Entity(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Entity"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = HTML; }\n"));
  yy = str(yytext); yy->key = HTML; ;
}
YY_ACTION(void) yy_1_EscapedChar(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_EscapedChar"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_Symbol(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Symbol"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_RawHtml(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_RawHtml"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tif (ext(EXT_FILTER_HTML)) {\n\
\t\t\tyy = list(LIST, NULL);\n\
\t\t} else {\n\
\t\t\tyy = str(yytext);\n\
\t\t\tyy->key = HTML;\n\
\t\t}\n\
\t}\n"));
  
		if (ext(EXT_FILTER_HTML)) {
			yy = list(LIST, NULL);
		} else {
			yy = str(yytext);
			yy->key = HTML;
		}
	;
}
YY_ACTION(void) yy_1_Line(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_Line"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); }\n"));
  yy = str(yytext); ;
}
YY_ACTION(void) yy_1_BlockQuoteMarker(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_BlockQuoteMarker"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = str(yytext); yy->key = BLOCKQUOTEMARKER; }\n"));
  yy = str(yytext); yy->key = BLOCKQUOTEMARKER; ;
}
YY_ACTION(void) yy_4_BlockQuoteRaw(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define x G->val[-2]
#define a G->val[-3]
  yyprintf((stderr, "do yy_4_BlockQuoteRaw"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = x;\n\
\t\t\tfree_node_tree(x->next);\n\
\t\t\tyy->next = NULL;\n\
\t\t\tnode *raw;\n\
\t\t\traw = mk_str_from_list(a, true);\n\
\t\t\traw->key = RAW;\n\
\t\t\tyy->children = raw;\n\
\t\t}\n"));
  
			yy = x;
			free_node_tree(x->next);
			yy->next = NULL;
			node *raw;
			raw = mk_str_from_list(a, true);
			raw->key = RAW;
			yy->children = raw;
		;
#undef b
#undef x
#undef a
}
YY_ACTION(void) yy_3_BlockQuoteRaw(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define x G->val[-2]
#define a G->val[-3]
  yyprintf((stderr, "do yy_3_BlockQuoteRaw"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"\\n\"), a); }\n"));
  a = cons(str("\n"), a); ;
#undef b
#undef x
#undef a
}
YY_ACTION(void) yy_2_BlockQuoteRaw(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define x G->val[-2]
#define a G->val[-3]
  yyprintf((stderr, "do yy_2_BlockQuoteRaw"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef b
#undef x
#undef a
}
YY_ACTION(void) yy_1_BlockQuoteRaw(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define x G->val[-2]
#define a G->val[-3]
  yyprintf((stderr, "do yy_1_BlockQuoteRaw"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); x = cons(b, x); }\n"));
  a = cons(yy, a); x = cons(b, x); ;
#undef b
#undef x
#undef a
}
YY_ACTION(void) yy_1_BlockQuote(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_BlockQuote"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(BLOCKQUOTE,a);\n\
\t}\n"));
  
		yy = list(BLOCKQUOTE,a);
	;
#undef a
}
YY_ACTION(void) yy_3_SetextHeading2(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_SetextHeading2"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(H2, a);\n\
\t\t}\n"));
  
			yy = list(H2, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_2_SetextHeading2(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_SetextHeading2"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {append_list(b,a)}\n"));
  append_list(b,a);
#undef b
#undef a
}
YY_ACTION(void) yy_1_SetextHeading2(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_SetextHeading2"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_3_SetextHeading1(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_SetextHeading1"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(H1, a);\n\
\t\t}\n"));
  
			yy = list(H1, a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_2_SetextHeading1(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_SetextHeading1"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {append_list(b,a);}\n"));
  append_list(b,a);;
#undef b
#undef a
}
YY_ACTION(void) yy_1_SetextHeading1(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_SetextHeading1"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_3_AtxHeading(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
#define s G->val[-3]
  yyprintf((stderr, "do yy_3_AtxHeading"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(s->key,a);\n\
\t\t\tfree(s);\n\
\t\t}\n"));
  
			yy = list(s->key,a);
			free(s);
		;
#undef b
#undef a
#undef s
}
YY_ACTION(void) yy_2_AtxHeading(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
#define s G->val[-3]
  yyprintf((stderr, "do yy_2_AtxHeading"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {append_list(b,a);}\n"));
  append_list(b,a);;
#undef b
#undef a
#undef s
}
YY_ACTION(void) yy_1_AtxHeading(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
#define s G->val[-3]
  yyprintf((stderr, "do yy_1_AtxHeading"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef b
#undef a
#undef s
}
YY_ACTION(void) yy_1_AtxStart(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_AtxStart"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {yy = node(H1 + ((int)strlen(yytext) - 1)); }\n"));
  yy = node(H1 + ((int)strlen(yytext) - 1)); ;
}
YY_ACTION(void) yy_3_HeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_HeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = list(HEADINGSECTION, a);\n\
\t}\n"));
  
		yy = list(HEADINGSECTION, a);
	;
#undef a
}
YY_ACTION(void) yy_2_HeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_HeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_1_HeadingSection(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_HeadingSection"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\ta = cons(yy, a);\n\
\t}\n"));
  
		a = cons(yy, a);
	;
#undef a
}
YY_ACTION(void) yy_1_TOC(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_TOC"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = node(TOC);\n\
\t\tyy->children = node(RAW);\n\
\t\tyy->children->str = markdown_to_string(((parser_data *)G->data)->original, 0, TOC_FORMAT);\n\
\t}\n"));
  
		yy = node(TOC);
		yy->children = node(RAW);
		yy->children->str = markdown_to_string(((parser_data *)G->data)->original, 0, TOC_FORMAT);
	;
}
YY_ACTION(void) yy_1_SkipBlock(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_SkipBlock"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {free_node_tree(yy); }\n"));
  free_node_tree(yy); ;
}
YY_ACTION(void) yy_2_DocForMetaDataOnly(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_DocForMetaDataOnly"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\t((parser_data *)G->data)->result = reverse_list(a);\n\
\t\t}\n"));
  
			((parser_data *)G->data)->result = reverse_list(a);
		;
#undef a
}
YY_ACTION(void) yy_1_DocForMetaDataOnly(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_DocForMetaDataOnly"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_4_MetaDataValue(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_4_MetaDataValue"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = mk_str_from_list(a, false);\n\
\t\t\tyy->key = METAVALUE;\n\
\t\t}\n"));
  
			yy = mk_str_from_list(a, false);
			yy->key = METAVALUE;
		;
#undef a
}
YY_ACTION(void) yy_3_MetaDataValue(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_3_MetaDataValue"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext), a); }\n"));
  a = cons(str(yytext), a); ;
#undef a
}
YY_ACTION(void) yy_2_MetaDataValue(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_MetaDataValue"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(\"\\n\"), a); }\n"));
  a = cons(str("\n"), a); ;
#undef a
}
YY_ACTION(void) yy_1_MetaDataValue(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_MetaDataValue"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(str(yytext), a); }\n"));
  a = cons(str(yytext), a); ;
#undef a
}
YY_ACTION(void) yy_1_MetaDataKey(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
  yyprintf((stderr, "do yy_1_MetaDataKey"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = str(yytext);\n\
\t\tyy->key = METAKEY;\n\
\t}\n"));
  
		yy = str(yytext);
		yy->key = METAKEY;
	;
}
YY_ACTION(void) yy_1_MetaDataKeyValue(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_MetaDataKeyValue"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\tyy = a;\n\
\t\tyy->children = b;\n\
\t}\n"));
  
		yy = a;
		yy->children = b;
	;
#undef b
#undef a
}
YY_ACTION(void) yy_2_MetaData(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_2_MetaData"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tyy = list(METADATA, a);\n\
\t\t}\n"));
  
			yy = list(METADATA, a);
		;
#undef a
}
YY_ACTION(void) yy_1_MetaData(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define a G->val[-1]
  yyprintf((stderr, "do yy_1_MetaData"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef a
}
YY_ACTION(void) yy_3_Doc(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_3_Doc"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {\n\
\t\t\tif (b!= NULL) a = cons(b,a);\n\
\t\t\t((parser_data *)G->data)->result = reverse_list(a);\n\
\t\t}\n"));
  
			if (b!= NULL) a = cons(b,a);
			((parser_data *)G->data)->result = reverse_list(a);
		;
#undef b
#undef a
}
YY_ACTION(void) yy_2_Doc(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_2_Doc"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); }\n"));
  a = cons(yy, a); ;
#undef b
#undef a
}
YY_ACTION(void) yy_1_Doc(GREG *G, char *yytext, int yyleng, yythunk *thunk, YY_XTYPE YY_XVAR)
{
#define b G->val[-1]
#define a G->val[-2]
  yyprintf((stderr, "do yy_1_Doc"));
  yyprintfvTcontext(yytext);
  yyprintf((stderr, "\n  {a = cons(yy, a); b = node(FOOTER); }\n"));
  a = cons(yy, a); b = node(FOOTER); ;
#undef b
#undef a
}

YY_RULE(int) yy_FalseMatch(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "FalseMatch"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1;
  {  int yypos2= G->pos, yythunkpos2= G->thunkpos;  if (!yymatchString(G, "{++")) goto l3;
  goto l2;
  l3:;	  G->pos= yypos2; G->thunkpos= yythunkpos2;  if (!yymatchString(G, "{--")) goto l4;
  goto l2;
  l4:;	  G->pos= yypos2; G->thunkpos= yythunkpos2;  if (!yymatchString(G, "{~~")) goto l5;
  goto l2;
  l5:;	  G->pos= yypos2; G->thunkpos= yythunkpos2;  if (!yymatchString(G, "{==")) goto l6;
  goto l2;
  l6:;	  G->pos= yypos2; G->thunkpos= yythunkpos2;  if (!yymatchString(G, "{>>")) goto l1;

  }
  l2:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1;  yyDo(G, yy_1_FalseMatch, G->begin, G->end, "yy_1_FalseMatch");
  yyprintf((stderr, "  ok   FalseMatch"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "FalseMatch"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawString(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RawString"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l7;
  {  int yypos10= G->pos, yythunkpos10= G->thunkpos;
  {  int yypos11= G->pos, yythunkpos11= G->thunkpos;  if (!yymatchString(G, "{++")) goto l12;
  goto l11;
  l12:;	  G->pos= yypos11; G->thunkpos= yythunkpos11;  if (!yymatchString(G, "{--")) goto l13;
  goto l11;
  l13:;	  G->pos= yypos11; G->thunkpos= yythunkpos11;  if (!yymatchString(G, "{~~")) goto l14;
  goto l11;
  l14:;	  G->pos= yypos11; G->thunkpos= yythunkpos11;  if (!yymatchString(G, "{==")) goto l15;
  goto l11;
  l15:;	  G->pos= yypos11; G->thunkpos= yythunkpos11;  if (!yymatchString(G, "{>>")) goto l10;

  }
  l11:;	  goto l7;
  l10:;	  G->pos= yypos10; G->thunkpos= yythunkpos10;
  }  if (!yymatchDot(G)) goto l7;
  l8:;	
  {  int yypos9= G->pos, yythunkpos9= G->thunkpos;
  {  int yypos16= G->pos, yythunkpos16= G->thunkpos;
  {  int yypos17= G->pos, yythunkpos17= G->thunkpos;  if (!yymatchString(G, "{++")) goto l18;
  goto l17;
  l18:;	  G->pos= yypos17; G->thunkpos= yythunkpos17;  if (!yymatchString(G, "{--")) goto l19;
  goto l17;
  l19:;	  G->pos= yypos17; G->thunkpos= yythunkpos17;  if (!yymatchString(G, "{~~")) goto l20;
  goto l17;
  l20:;	  G->pos= yypos17; G->thunkpos= yythunkpos17;  if (!yymatchString(G, "{==")) goto l21;
  goto l17;
  l21:;	  G->pos= yypos17; G->thunkpos= yythunkpos17;  if (!yymatchString(G, "{>>")) goto l16;

  }
  l17:;	  goto l9;
  l16:;	  G->pos= yypos16; G->thunkpos= yythunkpos16;
  }  if (!yymatchDot(G)) goto l9;  goto l8;
  l9:;	  G->pos= yypos9; G->thunkpos= yythunkpos9;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l7;  yyDo(G, yy_1_RawString, G->begin, G->end, "yy_1_RawString");
  yyprintf((stderr, "  ok   RawString"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l7:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawString"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DocForCritic(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "DocForCritic"));

  {  int yypos23= G->pos, yythunkpos23= G->thunkpos;  if (!yy_BOM(G))  goto l23;
  goto l24;
  l23:;	  G->pos= yypos23; G->thunkpos= yythunkpos23;
  }
  l24:;	  if (!yy_StartList(G))  goto l22;
  yyDo(G, yySet, -1, 0, "yySet");

  l25:;	
  {  int yypos26= G->pos, yythunkpos26= G->thunkpos;
  {  int yypos27= G->pos, yythunkpos27= G->thunkpos;  if (!yy_CriticMarkup(G))  goto l28;
  yyDo(G, yy_1_DocForCritic, G->begin, G->end, "yy_1_DocForCritic");
  goto l27;
  l28:;	  G->pos= yypos27; G->thunkpos= yythunkpos27;  if (!yy_RawString(G))  goto l29;
  yyDo(G, yy_2_DocForCritic, G->begin, G->end, "yy_2_DocForCritic");
  goto l27;
  l29:;	  G->pos= yypos27; G->thunkpos= yythunkpos27;  if (!yy_FalseMatch(G))  goto l26;
  yyDo(G, yy_3_DocForCritic, G->begin, G->end, "yy_3_DocForCritic");

  }
  l27:;	  goto l25;
  l26:;	  G->pos= yypos26; G->thunkpos= yythunkpos26;
  }
  l30:;	
  {  int yypos31= G->pos, yythunkpos31= G->thunkpos;  if (!yy_RawString(G))  goto l31;
  yyDo(G, yy_4_DocForCritic, G->begin, G->end, "yy_4_DocForCritic");
  goto l30;
  l31:;	  G->pos= yypos31; G->thunkpos= yythunkpos31;
  }  if (!yy_Eof(G))  goto l22;
  yyDo(G, yy_5_DocForCritic, G->begin, G->end, "yy_5_DocForCritic");
  yyprintf((stderr, "  ok   DocForCritic"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l22:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DocForCritic"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticSubstAdd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CriticSubstAdd"));
  if (!yy_StartList(G))  goto l32;
  yyDo(G, yySet, -1, 0, "yySet");

  l33:;	
  {  int yypos34= G->pos, yythunkpos34= G->thunkpos;
  {  int yypos35= G->pos, yythunkpos35= G->thunkpos;  if (!yy_CriticMarkup(G))  goto l36;
  goto l35;
  l36:;	  G->pos= yypos35; G->thunkpos= yythunkpos35;  if (!yy_SubAddString(G))  goto l34;

  }
  l35:;	  yyDo(G, yy_1_CriticSubstAdd, G->begin, G->end, "yy_1_CriticSubstAdd");
  goto l33;
  l34:;	  G->pos= yypos34; G->thunkpos= yythunkpos34;
  }  yyDo(G, yy_2_CriticSubstAdd, G->begin, G->end, "yy_2_CriticSubstAdd");
  yyprintf((stderr, "  ok   CriticSubstAdd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l32:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticSubstAdd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticSubstDel(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CriticSubstDel"));
  if (!yy_StartList(G))  goto l37;
  yyDo(G, yySet, -1, 0, "yySet");

  l38:;	
  {  int yypos39= G->pos, yythunkpos39= G->thunkpos;
  {  int yypos40= G->pos, yythunkpos40= G->thunkpos;  if (!yy_CriticMarkup(G))  goto l41;
  goto l40;
  l41:;	  G->pos= yypos40; G->thunkpos= yythunkpos40;  if (!yy_SubDelString(G))  goto l39;

  }
  l40:;	  yyDo(G, yy_1_CriticSubstDel, G->begin, G->end, "yy_1_CriticSubstDel");
  goto l38;
  l39:;	  G->pos= yypos39; G->thunkpos= yythunkpos39;
  }  yyDo(G, yy_2_CriticSubstDel, G->begin, G->end, "yy_2_CriticSubstDel");
  yyprintf((stderr, "  ok   CriticSubstDel"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l37:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticSubstDel"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SubAddString(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SubAddString"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l42;
  {  int yypos45= G->pos, yythunkpos45= G->thunkpos;  if (!yy_SubStop(G))  goto l45;
  goto l42;
  l45:;	  G->pos= yypos45; G->thunkpos= yythunkpos45;
  }
  {  int yypos46= G->pos, yythunkpos46= G->thunkpos;  if (!yy_CriticClean(G))  goto l46;
  goto l42;
  l46:;	  G->pos= yypos46; G->thunkpos= yythunkpos46;
  }  if (!yymatchDot(G)) goto l42;
  l43:;	
  {  int yypos44= G->pos, yythunkpos44= G->thunkpos;
  {  int yypos47= G->pos, yythunkpos47= G->thunkpos;  if (!yy_SubStop(G))  goto l47;
  goto l44;
  l47:;	  G->pos= yypos47; G->thunkpos= yythunkpos47;
  }
  {  int yypos48= G->pos, yythunkpos48= G->thunkpos;  if (!yy_CriticClean(G))  goto l48;
  goto l44;
  l48:;	  G->pos= yypos48; G->thunkpos= yythunkpos48;
  }  if (!yymatchDot(G)) goto l44;  goto l43;
  l44:;	  G->pos= yypos44; G->thunkpos= yythunkpos44;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l42;  yyDo(G, yy_1_SubAddString, G->begin, G->end, "yy_1_SubAddString");
  yyprintf((stderr, "  ok   SubAddString"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l42:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SubAddString"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SubDelString(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SubDelString"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l49;
  {  int yypos52= G->pos, yythunkpos52= G->thunkpos;  if (!yy_SubDivider(G))  goto l52;
  goto l49;
  l52:;	  G->pos= yypos52; G->thunkpos= yythunkpos52;
  }
  {  int yypos53= G->pos, yythunkpos53= G->thunkpos;  if (!yy_CriticClean(G))  goto l53;
  goto l49;
  l53:;	  G->pos= yypos53; G->thunkpos= yythunkpos53;
  }  if (!yymatchDot(G)) goto l49;
  l50:;	
  {  int yypos51= G->pos, yythunkpos51= G->thunkpos;
  {  int yypos54= G->pos, yythunkpos54= G->thunkpos;  if (!yy_SubDivider(G))  goto l54;
  goto l51;
  l54:;	  G->pos= yypos54; G->thunkpos= yythunkpos54;
  }
  {  int yypos55= G->pos, yythunkpos55= G->thunkpos;  if (!yy_CriticClean(G))  goto l55;
  goto l51;
  l55:;	  G->pos= yypos55; G->thunkpos= yythunkpos55;
  }  if (!yymatchDot(G)) goto l51;  goto l50;
  l51:;	  G->pos= yypos51; G->thunkpos= yythunkpos51;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l49;  yyDo(G, yy_1_SubDelString, G->begin, G->end, "yy_1_SubDelString");
  yyprintf((stderr, "  ok   SubDelString"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l49:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SubDelString"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HiString(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HiString"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l56;
  {  int yypos59= G->pos, yythunkpos59= G->thunkpos;  if (!yy_HiStop(G))  goto l59;
  goto l56;
  l59:;	  G->pos= yypos59; G->thunkpos= yythunkpos59;
  }
  {  int yypos60= G->pos, yythunkpos60= G->thunkpos;  if (!yy_CriticClean(G))  goto l60;
  goto l56;
  l60:;	  G->pos= yypos60; G->thunkpos= yythunkpos60;
  }  if (!yymatchDot(G)) goto l56;
  l57:;	
  {  int yypos58= G->pos, yythunkpos58= G->thunkpos;
  {  int yypos61= G->pos, yythunkpos61= G->thunkpos;  if (!yy_HiStop(G))  goto l61;
  goto l58;
  l61:;	  G->pos= yypos61; G->thunkpos= yythunkpos61;
  }
  {  int yypos62= G->pos, yythunkpos62= G->thunkpos;  if (!yy_CriticClean(G))  goto l62;
  goto l58;
  l62:;	  G->pos= yypos62; G->thunkpos= yythunkpos62;
  }  if (!yymatchDot(G)) goto l58;  goto l57;
  l58:;	  G->pos= yypos58; G->thunkpos= yythunkpos58;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l56;  yyDo(G, yy_1_HiString, G->begin, G->end, "yy_1_HiString");
  yyprintf((stderr, "  ok   HiString"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l56:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HiString"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DelString(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DelString"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l63;
  {  int yypos66= G->pos, yythunkpos66= G->thunkpos;  if (!yy_DelStop(G))  goto l66;
  goto l63;
  l66:;	  G->pos= yypos66; G->thunkpos= yythunkpos66;
  }
  {  int yypos67= G->pos, yythunkpos67= G->thunkpos;  if (!yy_CriticClean(G))  goto l67;
  goto l63;
  l67:;	  G->pos= yypos67; G->thunkpos= yythunkpos67;
  }  if (!yymatchDot(G)) goto l63;
  l64:;	
  {  int yypos65= G->pos, yythunkpos65= G->thunkpos;
  {  int yypos68= G->pos, yythunkpos68= G->thunkpos;  if (!yy_DelStop(G))  goto l68;
  goto l65;
  l68:;	  G->pos= yypos68; G->thunkpos= yythunkpos68;
  }
  {  int yypos69= G->pos, yythunkpos69= G->thunkpos;  if (!yy_CriticClean(G))  goto l69;
  goto l65;
  l69:;	  G->pos= yypos69; G->thunkpos= yythunkpos69;
  }  if (!yymatchDot(G)) goto l65;  goto l64;
  l65:;	  G->pos= yypos65; G->thunkpos= yythunkpos65;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l63;  yyDo(G, yy_1_DelString, G->begin, G->end, "yy_1_DelString");
  yyprintf((stderr, "  ok   DelString"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l63:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DelString"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AddString(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AddString"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l70;
  {  int yypos73= G->pos, yythunkpos73= G->thunkpos;  if (!yy_AddStop(G))  goto l73;
  goto l70;
  l73:;	  G->pos= yypos73; G->thunkpos= yythunkpos73;
  }
  {  int yypos74= G->pos, yythunkpos74= G->thunkpos;  if (!yy_CriticClean(G))  goto l74;
  goto l70;
  l74:;	  G->pos= yypos74; G->thunkpos= yythunkpos74;
  }  if (!yymatchDot(G)) goto l70;
  l71:;	
  {  int yypos72= G->pos, yythunkpos72= G->thunkpos;
  {  int yypos75= G->pos, yythunkpos75= G->thunkpos;  if (!yy_AddStop(G))  goto l75;
  goto l72;
  l75:;	  G->pos= yypos75; G->thunkpos= yythunkpos75;
  }
  {  int yypos76= G->pos, yythunkpos76= G->thunkpos;  if (!yy_CriticClean(G))  goto l76;
  goto l72;
  l76:;	  G->pos= yypos76; G->thunkpos= yythunkpos76;
  }  if (!yymatchDot(G)) goto l72;  goto l71;
  l72:;	  G->pos= yypos72; G->thunkpos= yythunkpos72;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l70;  yyDo(G, yy_1_AddString, G->begin, G->end, "yy_1_AddString");
  yyprintf((stderr, "  ok   AddString"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l70:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AddString"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SubDivider(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SubDivider"));
  if (!yymatchString(G, "~>")) goto l77;
  yyprintf((stderr, "  ok   SubDivider"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l77:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SubDivider"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SubStop(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SubStop"));
  if (!yymatchString(G, "~~}")) goto l78;
  yyprintf((stderr, "  ok   SubStop"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l78:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SubStop"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SubStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SubStart"));
  if (!yymatchString(G, "{~~")) goto l79;
  yyprintf((stderr, "  ok   SubStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l79:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SubStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ComStop(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ComStop"));
  if (!yymatchString(G, "<<}")) goto l80;
  yyprintf((stderr, "  ok   ComStop"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l80:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ComStop"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ComStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ComStart"));
  if (!yymatchString(G, "{>>")) goto l81;
  yyprintf((stderr, "  ok   ComStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l81:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ComStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HiStop(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HiStop"));
  if (!yymatchString(G, "==}")) goto l82;
  yyprintf((stderr, "  ok   HiStop"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l82:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HiStop"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HiStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HiStart"));
  if (!yymatchString(G, "{==")) goto l83;
  yyprintf((stderr, "  ok   HiStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l83:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HiStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DelStop(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DelStop"));
  if (!yymatchString(G, "--}")) goto l84;
  yyprintf((stderr, "  ok   DelStop"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l84:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DelStop"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DelStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DelStart"));
  if (!yymatchString(G, "{--")) goto l85;
  yyprintf((stderr, "  ok   DelStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l85:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DelStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AddStop(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AddStop"));
  if (!yymatchString(G, "++}")) goto l86;
  yyprintf((stderr, "  ok   AddStop"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l86:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AddStop"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AddStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AddStart"));
  if (!yymatchString(G, "{++")) goto l87;
  yyprintf((stderr, "  ok   AddStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l87:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AddStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CleanComment(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CleanComment"));
  if (!yy_ComStart(G))  goto l88;

  l89:;	
  {  int yypos90= G->pos, yythunkpos90= G->thunkpos;
  {  int yypos91= G->pos, yythunkpos91= G->thunkpos;  if (!yy_CriticClean(G))  goto l92;
  goto l91;
  l92:;	  G->pos= yypos91; G->thunkpos= yythunkpos91;
  {  int yypos93= G->pos, yythunkpos93= G->thunkpos;  if (!yy_ComStop(G))  goto l93;
  goto l90;
  l93:;	  G->pos= yypos93; G->thunkpos= yythunkpos93;
  }  if (!yymatchDot(G)) goto l90;
  }
  l91:;	  goto l89;
  l90:;	  G->pos= yypos90; G->thunkpos= yythunkpos90;
  }  if (!yy_ComStop(G))  goto l88;
  yyprintf((stderr, "  ok   CleanComment"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l88:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CleanComment"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CleanHighlight(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CleanHighlight"));
  if (!yy_HiStart(G))  goto l94;

  l95:;	
  {  int yypos96= G->pos, yythunkpos96= G->thunkpos;
  {  int yypos97= G->pos, yythunkpos97= G->thunkpos;  if (!yy_CriticClean(G))  goto l98;
  goto l97;
  l98:;	  G->pos= yypos97; G->thunkpos= yythunkpos97;
  {  int yypos99= G->pos, yythunkpos99= G->thunkpos;  if (!yy_HiStop(G))  goto l99;
  goto l96;
  l99:;	  G->pos= yypos99; G->thunkpos= yythunkpos99;
  }  if (!yymatchDot(G)) goto l96;
  }
  l97:;	  goto l95;
  l96:;	  G->pos= yypos96; G->thunkpos= yythunkpos96;
  }  if (!yy_HiStop(G))  goto l94;
  yyprintf((stderr, "  ok   CleanHighlight"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l94:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CleanHighlight"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CleanSubstitution(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CleanSubstitution"));
  if (!yy_SubStart(G))  goto l100;

  l101:;	
  {  int yypos102= G->pos, yythunkpos102= G->thunkpos;
  {  int yypos103= G->pos, yythunkpos103= G->thunkpos;  if (!yy_CriticClean(G))  goto l104;
  goto l103;
  l104:;	  G->pos= yypos103; G->thunkpos= yythunkpos103;
  {  int yypos105= G->pos, yythunkpos105= G->thunkpos;  if (!yy_SubDivider(G))  goto l105;
  goto l102;
  l105:;	  G->pos= yypos105; G->thunkpos= yythunkpos105;
  }
  {  int yypos106= G->pos, yythunkpos106= G->thunkpos;  if (!yy_SubStop(G))  goto l106;
  goto l102;
  l106:;	  G->pos= yypos106; G->thunkpos= yythunkpos106;
  }  if (!yymatchDot(G)) goto l102;
  }
  l103:;	  goto l101;
  l102:;	  G->pos= yypos102; G->thunkpos= yythunkpos102;
  }  if (!yy_SubDivider(G))  goto l100;

  l107:;	
  {  int yypos108= G->pos, yythunkpos108= G->thunkpos;
  {  int yypos109= G->pos, yythunkpos109= G->thunkpos;  if (!yy_CriticClean(G))  goto l110;
  goto l109;
  l110:;	  G->pos= yypos109; G->thunkpos= yythunkpos109;
  {  int yypos111= G->pos, yythunkpos111= G->thunkpos;  if (!yy_SubStop(G))  goto l111;
  goto l108;
  l111:;	  G->pos= yypos111; G->thunkpos= yythunkpos111;
  }  if (!yymatchDot(G)) goto l108;
  }
  l109:;	  goto l107;
  l108:;	  G->pos= yypos108; G->thunkpos= yythunkpos108;
  }  if (!yy_SubStop(G))  goto l100;
  yyprintf((stderr, "  ok   CleanSubstitution"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l100:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CleanSubstitution"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CleanDeletion(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CleanDeletion"));
  if (!yy_DelStart(G))  goto l112;

  l113:;	
  {  int yypos114= G->pos, yythunkpos114= G->thunkpos;
  {  int yypos115= G->pos, yythunkpos115= G->thunkpos;  if (!yy_CriticClean(G))  goto l116;
  goto l115;
  l116:;	  G->pos= yypos115; G->thunkpos= yythunkpos115;
  {  int yypos117= G->pos, yythunkpos117= G->thunkpos;  if (!yy_DelStop(G))  goto l117;
  goto l114;
  l117:;	  G->pos= yypos117; G->thunkpos= yythunkpos117;
  }  if (!yymatchDot(G)) goto l114;
  }
  l115:;	  goto l113;
  l114:;	  G->pos= yypos114; G->thunkpos= yythunkpos114;
  }  if (!yy_DelStop(G))  goto l112;
  yyprintf((stderr, "  ok   CleanDeletion"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l112:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CleanDeletion"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CleanAddition(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CleanAddition"));
  if (!yy_AddStart(G))  goto l118;

  l119:;	
  {  int yypos120= G->pos, yythunkpos120= G->thunkpos;
  {  int yypos121= G->pos, yythunkpos121= G->thunkpos;  if (!yy_CriticClean(G))  goto l122;
  goto l121;
  l122:;	  G->pos= yypos121; G->thunkpos= yythunkpos121;
  {  int yypos123= G->pos, yythunkpos123= G->thunkpos;  if (!yy_AddStop(G))  goto l123;
  goto l120;
  l123:;	  G->pos= yypos123; G->thunkpos= yythunkpos123;
  }  if (!yymatchDot(G)) goto l120;
  }
  l121:;	  goto l119;
  l120:;	  G->pos= yypos120; G->thunkpos= yythunkpos120;
  }  if (!yy_AddStop(G))  goto l118;
  yyprintf((stderr, "  ok   CleanAddition"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l118:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CleanAddition"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticClean(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CriticClean"));

  {  int yypos125= G->pos, yythunkpos125= G->thunkpos;  if (!yymatchChar(G, '{')) goto l124;
  G->pos= yypos125; G->thunkpos= yythunkpos125;
  }
  {  int yypos126= G->pos, yythunkpos126= G->thunkpos;  if (!yy_CleanAddition(G))  goto l127;
  goto l126;
  l127:;	  G->pos= yypos126; G->thunkpos= yythunkpos126;  if (!yy_CleanDeletion(G))  goto l128;
  goto l126;
  l128:;	  G->pos= yypos126; G->thunkpos= yythunkpos126;  if (!yy_CleanSubstitution(G))  goto l129;
  goto l126;
  l129:;	  G->pos= yypos126; G->thunkpos= yythunkpos126;  if (!yy_CleanHighlight(G))  goto l130;
  goto l126;
  l130:;	  G->pos= yypos126; G->thunkpos= yythunkpos126;  if (!yy_CleanComment(G))  goto l124;

  }
  l126:;	  yyprintf((stderr, "  ok   CriticClean"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l124:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticClean"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticComment(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CriticComment"));
  if (!yymatchString(G, "{>>")) goto l131;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l131;
  l132:;	
  {  int yypos133= G->pos, yythunkpos133= G->thunkpos;
  {  int yypos134= G->pos, yythunkpos134= G->thunkpos;  if (!yymatchString(G, "<<}")) goto l134;
  goto l133;
  l134:;	  G->pos= yypos134; G->thunkpos= yythunkpos134;
  }  if (!yymatchDot(G)) goto l133;  goto l132;
  l133:;	  G->pos= yypos133; G->thunkpos= yythunkpos133;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l131;  if (!yymatchString(G, "<<}")) goto l131;
  yyDo(G, yy_1_CriticComment, G->begin, G->end, "yy_1_CriticComment");
  yyprintf((stderr, "  ok   CriticComment"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l131:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticComment"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticHighlight(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CriticHighlight"));
  if (!yy_StartList(G))  goto l135;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_HiStart(G))  goto l135;

  l136:;	
  {  int yypos137= G->pos, yythunkpos137= G->thunkpos;
  {  int yypos138= G->pos, yythunkpos138= G->thunkpos;  if (!yy_CriticMarkup(G))  goto l139;
  goto l138;
  l139:;	  G->pos= yypos138; G->thunkpos= yythunkpos138;  if (!yy_HiString(G))  goto l137;

  }
  l138:;	  yyDo(G, yy_1_CriticHighlight, G->begin, G->end, "yy_1_CriticHighlight");
  goto l136;
  l137:;	  G->pos= yypos137; G->thunkpos= yythunkpos137;
  }  if (!yy_HiStop(G))  goto l135;
  yyDo(G, yy_2_CriticHighlight, G->begin, G->end, "yy_2_CriticHighlight");
  yyprintf((stderr, "  ok   CriticHighlight"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l135:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticHighlight"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticSubstitution(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CriticSubstitution"));
  if (!yy_StartList(G))  goto l140;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_SubStart(G))  goto l140;
  if (!yy_CriticSubstDel(G))  goto l140;
  yyDo(G, yy_1_CriticSubstitution, G->begin, G->end, "yy_1_CriticSubstitution");
  if (!yy_SubDivider(G))  goto l140;
  if (!yy_CriticSubstAdd(G))  goto l140;
  yyDo(G, yy_2_CriticSubstitution, G->begin, G->end, "yy_2_CriticSubstitution");
  if (!yy_SubStop(G))  goto l140;
  yyDo(G, yy_3_CriticSubstitution, G->begin, G->end, "yy_3_CriticSubstitution");
  yyprintf((stderr, "  ok   CriticSubstitution"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l140:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticSubstitution"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticDeletion(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CriticDeletion"));
  if (!yy_StartList(G))  goto l141;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_DelStart(G))  goto l141;

  l142:;	
  {  int yypos143= G->pos, yythunkpos143= G->thunkpos;
  {  int yypos144= G->pos, yythunkpos144= G->thunkpos;  if (!yy_CriticMarkup(G))  goto l145;
  goto l144;
  l145:;	  G->pos= yypos144; G->thunkpos= yythunkpos144;  if (!yy_DelString(G))  goto l143;

  }
  l144:;	  yyDo(G, yy_1_CriticDeletion, G->begin, G->end, "yy_1_CriticDeletion");
  goto l142;
  l143:;	  G->pos= yypos143; G->thunkpos= yythunkpos143;
  }  if (!yy_DelStop(G))  goto l141;
  yyDo(G, yy_2_CriticDeletion, G->begin, G->end, "yy_2_CriticDeletion");
  yyprintf((stderr, "  ok   CriticDeletion"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l141:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticDeletion"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticAddition(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CriticAddition"));
  if (!yy_StartList(G))  goto l146;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_AddStart(G))  goto l146;

  l147:;	
  {  int yypos148= G->pos, yythunkpos148= G->thunkpos;
  {  int yypos149= G->pos, yythunkpos149= G->thunkpos;  if (!yy_CriticMarkup(G))  goto l150;
  goto l149;
  l150:;	  G->pos= yypos149; G->thunkpos= yythunkpos149;  if (!yy_AddString(G))  goto l148;

  }
  l149:;	  yyDo(G, yy_1_CriticAddition, G->begin, G->end, "yy_1_CriticAddition");
  goto l147;
  l148:;	  G->pos= yypos148; G->thunkpos= yythunkpos148;
  }  if (!yy_AddStop(G))  goto l146;
  yyDo(G, yy_2_CriticAddition, G->begin, G->end, "yy_2_CriticAddition");
  yyprintf((stderr, "  ok   CriticAddition"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l146:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticAddition"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TOCSectionBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TOCSectionBlock"));

  l152:;	
  {  int yypos153= G->pos, yythunkpos153= G->thunkpos;  if (!yy_BlankLine(G))  goto l153;
  goto l152;
  l153:;	  G->pos= yypos153; G->thunkpos= yythunkpos153;
  }
  {  int yypos154= G->pos, yythunkpos154= G->thunkpos;  if (!yy_Heading(G))  goto l154;
  goto l151;
  l154:;	  G->pos= yypos154; G->thunkpos= yythunkpos154;
  }  if (!yy_TOCPlain(G))  goto l151;
  yyprintf((stderr, "  ok   TOCSectionBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l151:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TOCSectionBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TOCHeadingSection(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "TOCHeadingSection"));
  if (!yy_StartList(G))  goto l155;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Heading(G))  goto l155;
  yyDo(G, yy_1_TOCHeadingSection, G->begin, G->end, "yy_1_TOCHeadingSection");

  l156:;	
  {  int yypos157= G->pos, yythunkpos157= G->thunkpos;  if (!yy_TOCSectionBlock(G))  goto l157;
  goto l156;
  l157:;	  G->pos= yypos157; G->thunkpos= yythunkpos157;
  }  yyDo(G, yy_2_TOCHeadingSection, G->begin, G->end, "yy_2_TOCHeadingSection");
  yyprintf((stderr, "  ok   TOCHeadingSection"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l155:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TOCHeadingSection"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TOCPlain(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "TOCPlain"));

  {  int yypos161= G->pos, yythunkpos161= G->thunkpos;  if (!yy_Fenced(G))  goto l162;
  yyDo(G, yySet, -2, 0, "yySet");
  yyDo(G, yy_1_TOCPlain, G->begin, G->end, "yy_1_TOCPlain");
  goto l161;
  l162:;	  G->pos= yypos161; G->thunkpos= yythunkpos161;
  {  int yypos163= G->pos, yythunkpos163= G->thunkpos;  if (!yy_BlankLine(G))  goto l163;
  goto l158;
  l163:;	  G->pos= yypos163; G->thunkpos= yythunkpos163;
  }
  {  int yypos164= G->pos, yythunkpos164= G->thunkpos;  if (!yy_Heading(G))  goto l164;
  goto l158;
  l164:;	  G->pos= yypos164; G->thunkpos= yythunkpos164;
  }  if (!yy_Line(G))  goto l158;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_2_TOCPlain, G->begin, G->end, "yy_2_TOCPlain");

  }
  l161:;	
  l159:;	
  {  int yypos160= G->pos, yythunkpos160= G->thunkpos;
  {  int yypos165= G->pos, yythunkpos165= G->thunkpos;  if (!yy_Fenced(G))  goto l166;
  yyDo(G, yySet, -2, 0, "yySet");
  yyDo(G, yy_1_TOCPlain, G->begin, G->end, "yy_1_TOCPlain");
  goto l165;
  l166:;	  G->pos= yypos165; G->thunkpos= yythunkpos165;
  {  int yypos167= G->pos, yythunkpos167= G->thunkpos;  if (!yy_BlankLine(G))  goto l167;
  goto l160;
  l167:;	  G->pos= yypos167; G->thunkpos= yythunkpos167;
  }
  {  int yypos168= G->pos, yythunkpos168= G->thunkpos;  if (!yy_Heading(G))  goto l168;
  goto l160;
  l168:;	  G->pos= yypos168; G->thunkpos= yythunkpos168;
  }  if (!yy_Line(G))  goto l160;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_2_TOCPlain, G->begin, G->end, "yy_2_TOCPlain");

  }
  l165:;	  goto l159;
  l160:;	  G->pos= yypos160; G->thunkpos= yythunkpos160;
  }  yyprintf((stderr, "  ok   TOCPlain"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l158:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TOCPlain"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TOCBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TOCBlock"));

  l170:;	
  {  int yypos171= G->pos, yythunkpos171= G->thunkpos;  if (!yy_BlankLine(G))  goto l171;
  goto l170;
  l171:;	  G->pos= yypos171; G->thunkpos= yythunkpos171;
  }  if (!yy_TOCHeadingSection(G))  goto l169;
  yyprintf((stderr, "  ok   TOCBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l169:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TOCBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DocForTOC(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "DocForTOC"));

  {  int yypos173= G->pos, yythunkpos173= G->thunkpos;  if (!yy_BOM(G))  goto l173;
  goto l174;
  l173:;	  G->pos= yypos173; G->thunkpos= yythunkpos173;
  }
  l174:;	  if (!yy_StartList(G))  goto l172;
  yyDo(G, yySet, -2, 0, "yySet");

  {  int yypos175= G->pos, yythunkpos175= G->thunkpos;
  {  int yypos177= G->pos, yythunkpos177= G->thunkpos;
  {  int yypos178= G->pos, yythunkpos178= G->thunkpos;  if (!yy_YAMLStart(G))  goto l178;
  goto l179;
  l178:;	  G->pos= yypos178; G->thunkpos= yythunkpos178;
  }
  l179:;	  if (!yy_MetaDataKey(G))  goto l175;
  if (!yy_Sp(G))  goto l175;
  if (!yymatchChar(G, ':')) goto l175;
  if (!yy_Sp(G))  goto l175;

  {  int yypos180= G->pos, yythunkpos180= G->thunkpos;  if (!yy_Newline(G))  goto l180;
  goto l175;
  l180:;	  G->pos= yypos180; G->thunkpos= yythunkpos180;
  }  G->pos= yypos177; G->thunkpos= yythunkpos177;
  }  if (!yy_MetaData(G))  goto l175;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_DocForTOC, G->begin, G->end, "yy_1_DocForTOC");
  goto l176;
  l175:;	  G->pos= yypos175; G->thunkpos= yythunkpos175;
  }
  l176:;	
  l181:;	
  {  int yypos182= G->pos, yythunkpos182= G->thunkpos;
  {  int yypos183= G->pos, yythunkpos183= G->thunkpos;  if (!yy_TOCBlock(G))  goto l184;
  yyDo(G, yy_2_DocForTOC, G->begin, G->end, "yy_2_DocForTOC");
  goto l183;
  l184:;	  G->pos= yypos183; G->thunkpos= yythunkpos183;  if (!yy_TOCPlain(G))  goto l182;

  }
  l183:;	  goto l181;
  l182:;	  G->pos= yypos182; G->thunkpos= yythunkpos182;
  }
  l185:;	
  {  int yypos186= G->pos, yythunkpos186= G->thunkpos;  if (!yy_BlankLine(G))  goto l186;
  goto l185;
  l186:;	  G->pos= yypos186; G->thunkpos= yythunkpos186;
  }  yyDo(G, yy_3_DocForTOC, G->begin, G->end, "yy_3_DocForTOC");
  yyprintf((stderr, "  ok   DocForTOC"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l172:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DocForTOC"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLSetextHeading2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OPMLSetextHeading2"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l187;
  l188:;	
  {  int yypos189= G->pos, yythunkpos189= G->thunkpos;
  {  int yypos190= G->pos, yythunkpos190= G->thunkpos;  if (!yymatchChar(G, '\r')) goto l190;
  goto l189;
  l190:;	  G->pos= yypos190; G->thunkpos= yythunkpos190;
  }
  {  int yypos191= G->pos, yythunkpos191= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l191;
  goto l189;
  l191:;	  G->pos= yypos191; G->thunkpos= yythunkpos191;
  }  if (!yymatchDot(G)) goto l189;  goto l188;
  l189:;	  G->pos= yypos189; G->thunkpos= yythunkpos189;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l187;  if (!yy_Newline(G))  goto l187;
  if (!yy_SetextBottom2(G))  goto l187;
  yyDo(G, yy_1_OPMLSetextHeading2, G->begin, G->end, "yy_1_OPMLSetextHeading2");
  yyprintf((stderr, "  ok   OPMLSetextHeading2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l187:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLSetextHeading2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLSetextHeading1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OPMLSetextHeading1"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l192;
  l193:;	
  {  int yypos194= G->pos, yythunkpos194= G->thunkpos;
  {  int yypos195= G->pos, yythunkpos195= G->thunkpos;  if (!yymatchChar(G, '\r')) goto l195;
  goto l194;
  l195:;	  G->pos= yypos195; G->thunkpos= yythunkpos195;
  }
  {  int yypos196= G->pos, yythunkpos196= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l196;
  goto l194;
  l196:;	  G->pos= yypos196; G->thunkpos= yythunkpos196;
  }  if (!yymatchDot(G)) goto l194;  goto l193;
  l194:;	  G->pos= yypos194; G->thunkpos= yythunkpos194;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l192;  if (!yy_Newline(G))  goto l192;
  if (!yy_SetextBottom1(G))  goto l192;
  yyDo(G, yy_1_OPMLSetextHeading1, G->begin, G->end, "yy_1_OPMLSetextHeading1");
  yyprintf((stderr, "  ok   OPMLSetextHeading1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l192:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLSetextHeading1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLSetextHeading(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OPMLSetextHeading"));

  {  int yypos198= G->pos, yythunkpos198= G->thunkpos;  if (!yy_OPMLSetextHeading1(G))  goto l199;
  goto l198;
  l199:;	  G->pos= yypos198; G->thunkpos= yythunkpos198;  if (!yy_OPMLSetextHeading2(G))  goto l197;

  }
  l198:;	  yyprintf((stderr, "  ok   OPMLSetextHeading"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l197:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLSetextHeading"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLAtxHeading(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "OPMLAtxHeading"));

  {  int yypos201= G->pos, yythunkpos201= G->thunkpos;  if (!yy_Heading(G))  goto l200;
  G->pos= yypos201; G->thunkpos= yythunkpos201;
  }  if (!yy_AtxStart(G))  goto l200;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Sp(G))  goto l200;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l200;
  l202:;	
  {  int yypos203= G->pos, yythunkpos203= G->thunkpos;
  {  int yypos204= G->pos, yythunkpos204= G->thunkpos;  if (!yy_Newline(G))  goto l204;
  goto l203;
  l204:;	  G->pos= yypos204; G->thunkpos= yythunkpos204;
  }
  {  int yypos205= G->pos, yythunkpos205= G->thunkpos;  if (!yy_Sp(G))  goto l205;

  l206:;	
  {  int yypos207= G->pos, yythunkpos207= G->thunkpos;  if (!yymatchChar(G, '#')) goto l207;
  goto l206;
  l207:;	  G->pos= yypos207; G->thunkpos= yythunkpos207;
  }  if (!yy_Sp(G))  goto l205;
  if (!yy_Newline(G))  goto l205;
  goto l203;
  l205:;	  G->pos= yypos205; G->thunkpos= yythunkpos205;
  }  if (!yymatchDot(G)) goto l203;  goto l202;
  l203:;	  G->pos= yypos203; G->thunkpos= yythunkpos203;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l200;
  {  int yypos208= G->pos, yythunkpos208= G->thunkpos;  if (!yy_Sp(G))  goto l208;
  if (!yymatchChar(G, '#')) goto l208;

  l210:;	
  {  int yypos211= G->pos, yythunkpos211= G->thunkpos;  if (!yymatchChar(G, '#')) goto l211;
  goto l210;
  l211:;	  G->pos= yypos211; G->thunkpos= yythunkpos211;
  }  goto l209;
  l208:;	  G->pos= yypos208; G->thunkpos= yythunkpos208;
  }
  l209:;	  if (!yy_Sp(G))  goto l200;
  if (!yy_Newline(G))  goto l200;
  yyDo(G, yy_1_OPMLAtxHeading, G->begin, G->end, "yy_1_OPMLAtxHeading");
  yyprintf((stderr, "  ok   OPMLAtxHeading"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l200:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLAtxHeading"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLSectionBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OPMLSectionBlock"));

  l213:;	
  {  int yypos214= G->pos, yythunkpos214= G->thunkpos;  if (!yy_BlankLine(G))  goto l214;
  goto l213;
  l214:;	  G->pos= yypos214; G->thunkpos= yythunkpos214;
  }
  {  int yypos215= G->pos, yythunkpos215= G->thunkpos;  if (!yy_OPMLHeading(G))  goto l215;
  goto l212;
  l215:;	  G->pos= yypos215; G->thunkpos= yythunkpos215;
  }  if (!yy_OPMLPlain(G))  goto l212;
  yyprintf((stderr, "  ok   OPMLSectionBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l212:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLSectionBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLHeading(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OPMLHeading"));

  {  int yypos217= G->pos, yythunkpos217= G->thunkpos;  if (!yy_OPMLAtxHeading(G))  goto l218;
  goto l217;
  l218:;	  G->pos= yypos217; G->thunkpos= yythunkpos217;  if (!yy_OPMLSetextHeading(G))  goto l216;

  }
  l217:;	  yyprintf((stderr, "  ok   OPMLHeading"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l216:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLHeading"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLPlain(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "OPMLPlain"));
  if (!yy_StartList(G))  goto l219;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos222= G->pos, yythunkpos222= G->thunkpos;  if (!yy_BlankLine(G))  goto l222;
  goto l219;
  l222:;	  G->pos= yypos222; G->thunkpos= yythunkpos222;
  }
  {  int yypos223= G->pos, yythunkpos223= G->thunkpos;  if (!yy_Heading(G))  goto l223;
  goto l219;
  l223:;	  G->pos= yypos223; G->thunkpos= yythunkpos223;
  }  if (!yy_Line(G))  goto l219;
  yyDo(G, yy_1_OPMLPlain, G->begin, G->end, "yy_1_OPMLPlain");

  l220:;	
  {  int yypos221= G->pos, yythunkpos221= G->thunkpos;
  {  int yypos224= G->pos, yythunkpos224= G->thunkpos;  if (!yy_BlankLine(G))  goto l224;
  goto l221;
  l224:;	  G->pos= yypos224; G->thunkpos= yythunkpos224;
  }
  {  int yypos225= G->pos, yythunkpos225= G->thunkpos;  if (!yy_Heading(G))  goto l225;
  goto l221;
  l225:;	  G->pos= yypos225; G->thunkpos= yythunkpos225;
  }  if (!yy_Line(G))  goto l221;
  yyDo(G, yy_1_OPMLPlain, G->begin, G->end, "yy_1_OPMLPlain");
  goto l220;
  l221:;	  G->pos= yypos221; G->thunkpos= yythunkpos221;
  }  yyDo(G, yy_2_OPMLPlain, G->begin, G->end, "yy_2_OPMLPlain");
  yyprintf((stderr, "  ok   OPMLPlain"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l219:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLPlain"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLHeadingSection(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "OPMLHeadingSection"));
  if (!yy_StartList(G))  goto l226;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_OPMLHeading(G))  goto l226;
  yyDo(G, yy_1_OPMLHeadingSection, G->begin, G->end, "yy_1_OPMLHeadingSection");

  l227:;	
  {  int yypos228= G->pos, yythunkpos228= G->thunkpos;  if (!yy_OPMLSectionBlock(G))  goto l228;
  yyDo(G, yy_2_OPMLHeadingSection, G->begin, G->end, "yy_2_OPMLHeadingSection");
  goto l227;
  l228:;	  G->pos= yypos228; G->thunkpos= yythunkpos228;
  }  yyDo(G, yy_3_OPMLHeadingSection, G->begin, G->end, "yy_3_OPMLHeadingSection");
  yyprintf((stderr, "  ok   OPMLHeadingSection"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l226:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLHeadingSection"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OPMLBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OPMLBlock"));

  l230:;	
  {  int yypos231= G->pos, yythunkpos231= G->thunkpos;  if (!yy_BlankLine(G))  goto l231;
  goto l230;
  l231:;	  G->pos= yypos231; G->thunkpos= yythunkpos231;
  }
  {  int yypos232= G->pos, yythunkpos232= G->thunkpos;  if (!yy_OPMLHeadingSection(G))  goto l233;
  goto l232;
  l233:;	  G->pos= yypos232; G->thunkpos= yythunkpos232;  if (!yy_OPMLPlain(G))  goto l229;

  }
  l232:;	  yyprintf((stderr, "  ok   OPMLBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l229:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OPMLBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DocForOPML(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "DocForOPML"));

  {  int yypos235= G->pos, yythunkpos235= G->thunkpos;  if (!yy_BOM(G))  goto l235;
  goto l236;
  l235:;	  G->pos= yypos235; G->thunkpos= yythunkpos235;
  }
  l236:;	  if (!yy_StartList(G))  goto l234;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos237= G->pos, yythunkpos237= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l237;
  {  int yypos239= G->pos, yythunkpos239= G->thunkpos;
  {  int yypos240= G->pos, yythunkpos240= G->thunkpos;  if (!yy_YAMLStart(G))  goto l240;
  goto l241;
  l240:;	  G->pos= yypos240; G->thunkpos= yythunkpos240;
  }
  l241:;	  if (!yy_MetaDataKey(G))  goto l237;
  if (!yy_Sp(G))  goto l237;
  if (!yymatchChar(G, ':')) goto l237;
  if (!yy_Sp(G))  goto l237;

  {  int yypos242= G->pos, yythunkpos242= G->thunkpos;  if (!yy_Newline(G))  goto l242;
  goto l237;
  l242:;	  G->pos= yypos242; G->thunkpos= yythunkpos242;
  }  G->pos= yypos239; G->thunkpos= yythunkpos239;
  }  if (!yy_MetaData(G))  goto l237;
  yyDo(G, yy_1_DocForOPML, G->begin, G->end, "yy_1_DocForOPML");
  goto l238;
  l237:;	  G->pos= yypos237; G->thunkpos= yythunkpos237;
  }
  l238:;	
  l243:;	
  {  int yypos244= G->pos, yythunkpos244= G->thunkpos;  if (!yy_OPMLBlock(G))  goto l244;
  yyDo(G, yy_2_DocForOPML, G->begin, G->end, "yy_2_DocForOPML");
  goto l243;
  l244:;	  G->pos= yypos244; G->thunkpos= yythunkpos244;
  }
  l245:;	
  {  int yypos246= G->pos, yythunkpos246= G->thunkpos;  if (!yy_BlankLine(G))  goto l246;
  goto l245;
  l246:;	  G->pos= yypos246; G->thunkpos= yythunkpos246;
  }  yyDo(G, yy_3_DocForOPML, G->begin, G->end, "yy_3_DocForOPML");
  yyprintf((stderr, "  ok   DocForOPML"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l234:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DocForOPML"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BracketedText2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BracketedText2"));
  if (!yymatchChar(G, '[')) goto l247;

  l248:;	
  {  int yypos249= G->pos, yythunkpos249= G->thunkpos;
  {  int yypos250= G->pos, yythunkpos250= G->thunkpos;  if (!yymatchChar(G, '\\')) goto l251;
  if (!yymatchDot(G)) goto l251;  goto l250;
  l251:;	  G->pos= yypos250; G->thunkpos= yythunkpos250;
  {  int yypos253= G->pos, yythunkpos253= G->thunkpos;  if (!yymatchChar(G, '[')) goto l253;
  goto l252;
  l253:;	  G->pos= yypos253; G->thunkpos= yythunkpos253;
  }
  {  int yypos254= G->pos, yythunkpos254= G->thunkpos;  if (!yymatchChar(G, ']')) goto l254;
  goto l252;
  l254:;	  G->pos= yypos254; G->thunkpos= yythunkpos254;
  }  if (!yymatchDot(G)) goto l252;  goto l250;
  l252:;	  G->pos= yypos250; G->thunkpos= yythunkpos250;  if (!yy_BracketedText2(G))  goto l249;

  }
  l250:;	  goto l248;
  l249:;	  G->pos= yypos249; G->thunkpos= yythunkpos249;
  }  if (!yymatchChar(G, ']')) goto l247;
  yyprintf((stderr, "  ok   BracketedText2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l247:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BracketedText2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BracketedTextz(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BracketedTextz"));

  {  int yypos256= G->pos, yythunkpos256= G->thunkpos;  if (!yymatchChar(G, '[')) goto l255;

  l257:;	
  {  int yypos258= G->pos, yythunkpos258= G->thunkpos;
  {  int yypos259= G->pos, yythunkpos259= G->thunkpos;  if (!yy_Endline(G))  goto l259;
  if (!yy_Endline(G))  goto l259;
  goto l258;
  l259:;	  G->pos= yypos259; G->thunkpos= yythunkpos259;
  }
  {  int yypos260= G->pos, yythunkpos260= G->thunkpos;  if (!yymatchChar(G, ']')) goto l260;
  goto l258;
  l260:;	  G->pos= yypos260; G->thunkpos= yythunkpos260;
  }  if (!yymatchDot(G)) goto l258;  goto l257;
  l258:;	  G->pos= yypos258; G->thunkpos= yythunkpos258;
  }  if (!yymatchChar(G, ']')) goto l255;
  G->pos= yypos256; G->thunkpos= yythunkpos256;
  }  if (!yy_BracketedText2(G))  goto l255;
  yyprintf((stderr, "  ok   BracketedTextz"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l255:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BracketedTextz"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RightAlign(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RightAlign"));

  {  int yypos262= G->pos, yythunkpos262= G->thunkpos;  if (!yymatchChar(G, '-')) goto l263;

  l264:;	
  {  int yypos265= G->pos, yythunkpos265= G->thunkpos;  if (!yymatchChar(G, '-')) goto l265;
  goto l264;
  l265:;	  G->pos= yypos265; G->thunkpos= yythunkpos265;
  }  goto l262;
  l263:;	  G->pos= yypos262; G->thunkpos= yythunkpos262;  if (!yymatchChar(G, '=')) goto l261;

  l266:;	
  {  int yypos267= G->pos, yythunkpos267= G->thunkpos;  if (!yymatchChar(G, '=')) goto l267;
  goto l266;
  l267:;	  G->pos= yypos267; G->thunkpos= yythunkpos267;
  }
  }
  l262:;	  if (!yymatchChar(G, ':')) goto l261;

  {  int yypos268= G->pos, yythunkpos268= G->thunkpos;
  {  int yypos269= G->pos, yythunkpos269= G->thunkpos;  if (!yymatchChar(G, '-')) goto l269;
  goto l261;
  l269:;	  G->pos= yypos269; G->thunkpos= yythunkpos269;
  }
  {  int yypos270= G->pos, yythunkpos270= G->thunkpos;  if (!yymatchChar(G, '=')) goto l270;
  goto l261;
  l270:;	  G->pos= yypos270; G->thunkpos= yythunkpos270;
  }
  {  int yypos271= G->pos, yythunkpos271= G->thunkpos;  if (!yymatchChar(G, ':')) goto l271;
  goto l261;
  l271:;	  G->pos= yypos271; G->thunkpos= yythunkpos271;
  }  G->pos= yypos268; G->thunkpos= yythunkpos268;
  }  yyDo(G, yy_1_RightAlign, G->begin, G->end, "yy_1_RightAlign");
  yyprintf((stderr, "  ok   RightAlign"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l261:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RightAlign"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CenterAlign(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CenterAlign"));
  if (!yymatchChar(G, ':')) goto l272;

  {  int yypos273= G->pos, yythunkpos273= G->thunkpos;
  {  int yypos275= G->pos, yythunkpos275= G->thunkpos;  if (!yymatchChar(G, '-')) goto l276;

  l277:;	
  {  int yypos278= G->pos, yythunkpos278= G->thunkpos;  if (!yymatchChar(G, '-')) goto l278;
  goto l277;
  l278:;	  G->pos= yypos278; G->thunkpos= yythunkpos278;
  }  goto l275;
  l276:;	  G->pos= yypos275; G->thunkpos= yythunkpos275;  if (!yymatchChar(G, '=')) goto l273;

  l279:;	
  {  int yypos280= G->pos, yythunkpos280= G->thunkpos;  if (!yymatchChar(G, '=')) goto l280;
  goto l279;
  l280:;	  G->pos= yypos280; G->thunkpos= yythunkpos280;
  }
  }
  l275:;	  goto l274;
  l273:;	  G->pos= yypos273; G->thunkpos= yythunkpos273;
  }
  l274:;	  if (!yymatchChar(G, ':')) goto l272;

  {  int yypos281= G->pos, yythunkpos281= G->thunkpos;
  {  int yypos282= G->pos, yythunkpos282= G->thunkpos;  if (!yymatchChar(G, '-')) goto l282;
  goto l272;
  l282:;	  G->pos= yypos282; G->thunkpos= yythunkpos282;
  }
  {  int yypos283= G->pos, yythunkpos283= G->thunkpos;  if (!yymatchChar(G, '=')) goto l283;
  goto l272;
  l283:;	  G->pos= yypos283; G->thunkpos= yythunkpos283;
  }
  {  int yypos284= G->pos, yythunkpos284= G->thunkpos;  if (!yymatchChar(G, ':')) goto l284;
  goto l272;
  l284:;	  G->pos= yypos284; G->thunkpos= yythunkpos284;
  }  G->pos= yypos281; G->thunkpos= yythunkpos281;
  }  yyDo(G, yy_1_CenterAlign, G->begin, G->end, "yy_1_CenterAlign");
  yyprintf((stderr, "  ok   CenterAlign"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l272:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CenterAlign"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_LeftAlign(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "LeftAlign"));

  {  int yypos286= G->pos, yythunkpos286= G->thunkpos;  if (!yymatchChar(G, ':')) goto l286;
  goto l287;
  l286:;	  G->pos= yypos286; G->thunkpos= yythunkpos286;
  }
  l287:;	
  {  int yypos288= G->pos, yythunkpos288= G->thunkpos;  if (!yymatchChar(G, '-')) goto l289;

  l290:;	
  {  int yypos291= G->pos, yythunkpos291= G->thunkpos;  if (!yymatchChar(G, '-')) goto l291;
  goto l290;
  l291:;	  G->pos= yypos291; G->thunkpos= yythunkpos291;
  }  goto l288;
  l289:;	  G->pos= yypos288; G->thunkpos= yythunkpos288;  if (!yymatchChar(G, '=')) goto l285;

  l292:;	
  {  int yypos293= G->pos, yythunkpos293= G->thunkpos;  if (!yymatchChar(G, '=')) goto l293;
  goto l292;
  l293:;	  G->pos= yypos293; G->thunkpos= yythunkpos293;
  }
  }
  l288:;	
  {  int yypos294= G->pos, yythunkpos294= G->thunkpos;
  {  int yypos295= G->pos, yythunkpos295= G->thunkpos;  if (!yymatchChar(G, '-')) goto l295;
  goto l285;
  l295:;	  G->pos= yypos295; G->thunkpos= yythunkpos295;
  }
  {  int yypos296= G->pos, yythunkpos296= G->thunkpos;  if (!yymatchChar(G, ':')) goto l296;
  goto l285;
  l296:;	  G->pos= yypos296; G->thunkpos= yythunkpos296;
  }  G->pos= yypos294; G->thunkpos= yythunkpos294;
  }  yyDo(G, yy_1_LeftAlign, G->begin, G->end, "yy_1_LeftAlign");
  yyprintf((stderr, "  ok   LeftAlign"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l285:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "LeftAlign"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NaturalAlign(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NaturalAlign"));

  {  int yypos298= G->pos, yythunkpos298= G->thunkpos;  if (!yymatchChar(G, '-')) goto l299;

  l300:;	
  {  int yypos301= G->pos, yythunkpos301= G->thunkpos;  if (!yymatchChar(G, '-')) goto l301;
  goto l300;
  l301:;	  G->pos= yypos301; G->thunkpos= yythunkpos301;
  }  goto l298;
  l299:;	  G->pos= yypos298; G->thunkpos= yythunkpos298;  if (!yymatchChar(G, '=')) goto l297;

  l302:;	
  {  int yypos303= G->pos, yythunkpos303= G->thunkpos;  if (!yymatchChar(G, '=')) goto l303;
  goto l302;
  l303:;	  G->pos= yypos303; G->thunkpos= yythunkpos303;
  }
  }
  l298:;	
  {  int yypos304= G->pos, yythunkpos304= G->thunkpos;
  {  int yypos305= G->pos, yythunkpos305= G->thunkpos;  if (!yymatchChar(G, '-')) goto l305;
  goto l297;
  l305:;	  G->pos= yypos305; G->thunkpos= yythunkpos305;
  }
  {  int yypos306= G->pos, yythunkpos306= G->thunkpos;  if (!yymatchChar(G, ':')) goto l306;
  goto l297;
  l306:;	  G->pos= yypos306; G->thunkpos= yythunkpos306;
  }  G->pos= yypos304; G->thunkpos= yythunkpos304;
  }  yyDo(G, yy_1_NaturalAlign, G->begin, G->end, "yy_1_NaturalAlign");
  yyprintf((stderr, "  ok   NaturalAlign"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l297:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NaturalAlign"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RightAlignWrap(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RightAlignWrap"));

  {  int yypos308= G->pos, yythunkpos308= G->thunkpos;  if (!yymatchChar(G, '-')) goto l309;

  l310:;	
  {  int yypos311= G->pos, yythunkpos311= G->thunkpos;  if (!yymatchChar(G, '-')) goto l311;
  goto l310;
  l311:;	  G->pos= yypos311; G->thunkpos= yythunkpos311;
  }  goto l308;
  l309:;	  G->pos= yypos308; G->thunkpos= yythunkpos308;  if (!yymatchChar(G, '=')) goto l307;

  l312:;	
  {  int yypos313= G->pos, yythunkpos313= G->thunkpos;  if (!yymatchChar(G, '=')) goto l313;
  goto l312;
  l313:;	  G->pos= yypos313; G->thunkpos= yythunkpos313;
  }
  }
  l308:;	  if (!yymatchChar(G, ':')) goto l307;
  if (!yymatchChar(G, '+')) goto l307;

  {  int yypos314= G->pos, yythunkpos314= G->thunkpos;
  {  int yypos315= G->pos, yythunkpos315= G->thunkpos;  if (!yymatchChar(G, '-')) goto l315;
  goto l307;
  l315:;	  G->pos= yypos315; G->thunkpos= yythunkpos315;
  }
  {  int yypos316= G->pos, yythunkpos316= G->thunkpos;  if (!yymatchChar(G, '=')) goto l316;
  goto l307;
  l316:;	  G->pos= yypos316; G->thunkpos= yythunkpos316;
  }
  {  int yypos317= G->pos, yythunkpos317= G->thunkpos;  if (!yymatchChar(G, ':')) goto l317;
  goto l307;
  l317:;	  G->pos= yypos317; G->thunkpos= yythunkpos317;
  }  G->pos= yypos314; G->thunkpos= yythunkpos314;
  }  yyDo(G, yy_1_RightAlignWrap, G->begin, G->end, "yy_1_RightAlignWrap");
  yyprintf((stderr, "  ok   RightAlignWrap"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l307:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RightAlignWrap"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CenterAlignWrap(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CenterAlignWrap"));
  if (!yymatchChar(G, ':')) goto l318;

  {  int yypos319= G->pos, yythunkpos319= G->thunkpos;
  {  int yypos321= G->pos, yythunkpos321= G->thunkpos;  if (!yymatchChar(G, '-')) goto l322;

  l323:;	
  {  int yypos324= G->pos, yythunkpos324= G->thunkpos;  if (!yymatchChar(G, '-')) goto l324;
  goto l323;
  l324:;	  G->pos= yypos324; G->thunkpos= yythunkpos324;
  }  goto l321;
  l322:;	  G->pos= yypos321; G->thunkpos= yythunkpos321;  if (!yymatchChar(G, '=')) goto l319;

  l325:;	
  {  int yypos326= G->pos, yythunkpos326= G->thunkpos;  if (!yymatchChar(G, '=')) goto l326;
  goto l325;
  l326:;	  G->pos= yypos326; G->thunkpos= yythunkpos326;
  }
  }
  l321:;	  goto l320;
  l319:;	  G->pos= yypos319; G->thunkpos= yythunkpos319;
  }
  l320:;	  if (!yymatchChar(G, '+')) goto l318;
  if (!yymatchChar(G, ':')) goto l318;

  {  int yypos327= G->pos, yythunkpos327= G->thunkpos;
  {  int yypos328= G->pos, yythunkpos328= G->thunkpos;  if (!yymatchChar(G, '-')) goto l328;
  goto l318;
  l328:;	  G->pos= yypos328; G->thunkpos= yythunkpos328;
  }
  {  int yypos329= G->pos, yythunkpos329= G->thunkpos;  if (!yymatchChar(G, '=')) goto l329;
  goto l318;
  l329:;	  G->pos= yypos329; G->thunkpos= yythunkpos329;
  }
  {  int yypos330= G->pos, yythunkpos330= G->thunkpos;  if (!yymatchChar(G, ':')) goto l330;
  goto l318;
  l330:;	  G->pos= yypos330; G->thunkpos= yythunkpos330;
  }  G->pos= yypos327; G->thunkpos= yythunkpos327;
  }  yyDo(G, yy_1_CenterAlignWrap, G->begin, G->end, "yy_1_CenterAlignWrap");
  yyprintf((stderr, "  ok   CenterAlignWrap"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l318:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CenterAlignWrap"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_LeftAlignWrap(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "LeftAlignWrap"));

  {  int yypos332= G->pos, yythunkpos332= G->thunkpos;  if (!yymatchChar(G, ':')) goto l332;
  goto l333;
  l332:;	  G->pos= yypos332; G->thunkpos= yythunkpos332;
  }
  l333:;	
  {  int yypos334= G->pos, yythunkpos334= G->thunkpos;  if (!yymatchChar(G, '-')) goto l335;

  l336:;	
  {  int yypos337= G->pos, yythunkpos337= G->thunkpos;  if (!yymatchChar(G, '-')) goto l337;
  goto l336;
  l337:;	  G->pos= yypos337; G->thunkpos= yythunkpos337;
  }  goto l334;
  l335:;	  G->pos= yypos334; G->thunkpos= yythunkpos334;  if (!yymatchChar(G, '=')) goto l331;

  l338:;	
  {  int yypos339= G->pos, yythunkpos339= G->thunkpos;  if (!yymatchChar(G, '=')) goto l339;
  goto l338;
  l339:;	  G->pos= yypos339; G->thunkpos= yythunkpos339;
  }
  }
  l334:;	  if (!yymatchChar(G, '+')) goto l331;

  {  int yypos340= G->pos, yythunkpos340= G->thunkpos;
  {  int yypos341= G->pos, yythunkpos341= G->thunkpos;  if (!yymatchChar(G, '-')) goto l341;
  goto l331;
  l341:;	  G->pos= yypos341; G->thunkpos= yythunkpos341;
  }
  {  int yypos342= G->pos, yythunkpos342= G->thunkpos;  if (!yymatchChar(G, '=')) goto l342;
  goto l331;
  l342:;	  G->pos= yypos342; G->thunkpos= yythunkpos342;
  }
  {  int yypos343= G->pos, yythunkpos343= G->thunkpos;  if (!yymatchChar(G, ':')) goto l343;
  goto l331;
  l343:;	  G->pos= yypos343; G->thunkpos= yythunkpos343;
  }  G->pos= yypos340; G->thunkpos= yythunkpos340;
  }  yyDo(G, yy_1_LeftAlignWrap, G->begin, G->end, "yy_1_LeftAlignWrap");
  yyprintf((stderr, "  ok   LeftAlignWrap"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l331:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "LeftAlignWrap"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NaturalAlignWrap(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NaturalAlignWrap"));

  {  int yypos345= G->pos, yythunkpos345= G->thunkpos;  if (!yymatchChar(G, '-')) goto l346;

  l347:;	
  {  int yypos348= G->pos, yythunkpos348= G->thunkpos;  if (!yymatchChar(G, '-')) goto l348;
  goto l347;
  l348:;	  G->pos= yypos348; G->thunkpos= yythunkpos348;
  }  goto l345;
  l346:;	  G->pos= yypos345; G->thunkpos= yythunkpos345;  if (!yymatchChar(G, '=')) goto l344;

  l349:;	
  {  int yypos350= G->pos, yythunkpos350= G->thunkpos;  if (!yymatchChar(G, '=')) goto l350;
  goto l349;
  l350:;	  G->pos= yypos350; G->thunkpos= yythunkpos350;
  }
  }
  l345:;	  if (!yymatchChar(G, '+')) goto l344;

  {  int yypos351= G->pos, yythunkpos351= G->thunkpos;
  {  int yypos352= G->pos, yythunkpos352= G->thunkpos;  if (!yymatchChar(G, '-')) goto l352;
  goto l344;
  l352:;	  G->pos= yypos352; G->thunkpos= yythunkpos352;
  }
  {  int yypos353= G->pos, yythunkpos353= G->thunkpos;  if (!yymatchChar(G, '=')) goto l353;
  goto l344;
  l353:;	  G->pos= yypos353; G->thunkpos= yythunkpos353;
  }
  {  int yypos354= G->pos, yythunkpos354= G->thunkpos;  if (!yymatchChar(G, ':')) goto l354;
  goto l344;
  l354:;	  G->pos= yypos354; G->thunkpos= yythunkpos354;
  }  G->pos= yypos351; G->thunkpos= yythunkpos351;
  }  yyDo(G, yy_1_NaturalAlignWrap, G->begin, G->end, "yy_1_NaturalAlignWrap");
  yyprintf((stderr, "  ok   NaturalAlignWrap"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l344:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NaturalAlignWrap"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AlignmentCell(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AlignmentCell"));
  if (!yy_Sp(G))  goto l355;

  {  int yypos356= G->pos, yythunkpos356= G->thunkpos;  if (!yy_CellDivider(G))  goto l356;
  goto l355;
  l356:;	  G->pos= yypos356; G->thunkpos= yythunkpos356;
  }
  {  int yypos357= G->pos, yythunkpos357= G->thunkpos;  if (!yy_NaturalAlignWrap(G))  goto l358;
  goto l357;
  l358:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_LeftAlignWrap(G))  goto l359;
  goto l357;
  l359:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_CenterAlignWrap(G))  goto l360;
  goto l357;
  l360:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_RightAlignWrap(G))  goto l361;
  goto l357;
  l361:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_NaturalAlign(G))  goto l362;
  goto l357;
  l362:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_LeftAlign(G))  goto l363;
  goto l357;
  l363:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_CenterAlign(G))  goto l364;
  goto l357;
  l364:;	  G->pos= yypos357; G->thunkpos= yythunkpos357;  if (!yy_RightAlign(G))  goto l355;

  }
  l357:;	  if (!yy_Sp(G))  goto l355;

  {  int yypos365= G->pos, yythunkpos365= G->thunkpos;  if (!yy_CellDivider(G))  goto l365;
  goto l366;
  l365:;	  G->pos= yypos365; G->thunkpos= yythunkpos365;
  }
  l366:;	  yyprintf((stderr, "  ok   AlignmentCell"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l355:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AlignmentCell"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HeaderAlignmentCell(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HeaderAlignmentCell"));
  if (!yy_Sp(G))  goto l367;

  {  int yypos368= G->pos, yythunkpos368= G->thunkpos;  if (!yymatchChar(G, ':')) goto l368;
  goto l369;
  l368:;	  G->pos= yypos368; G->thunkpos= yythunkpos368;
  }
  l369:;	  if (!yymatchChar(G, '=')) goto l367;

  l370:;	
  {  int yypos371= G->pos, yythunkpos371= G->thunkpos;  if (!yymatchChar(G, '=')) goto l371;
  goto l370;
  l371:;	  G->pos= yypos371; G->thunkpos= yythunkpos371;
  }  yyprintf((stderr, "  ok   HeaderAlignmentCell"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l367:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HeaderAlignmentCell"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_FullCell(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "FullCell"));
  if (!yy_Sp(G))  goto l372;
  if (!yy_StartList(G))  goto l372;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos375= G->pos, yythunkpos375= G->thunkpos;  if (!yy_Newline(G))  goto l375;
  goto l372;
  l375:;	  G->pos= yypos375; G->thunkpos= yythunkpos375;
  }
  {  int yypos376= G->pos, yythunkpos376= G->thunkpos;  if (!yy_Endline(G))  goto l376;
  goto l372;
  l376:;	  G->pos= yypos376; G->thunkpos= yythunkpos376;
  }
  {  int yypos377= G->pos, yythunkpos377= G->thunkpos;  if (!yy_CellDivider(G))  goto l377;
  goto l372;
  l377:;	  G->pos= yypos377; G->thunkpos= yythunkpos377;
  }
  {  int yypos378= G->pos, yythunkpos378= G->thunkpos;  if (!yy_Sp(G))  goto l378;

  {  int yypos379= G->pos, yythunkpos379= G->thunkpos;  if (!yy_CellDivider(G))  goto l378;
  G->pos= yypos379; G->thunkpos= yythunkpos379;
  }  goto l372;
  l378:;	  G->pos= yypos378; G->thunkpos= yythunkpos378;
  }  if (!yy_Inline(G))  goto l372;
  yyDo(G, yy_1_FullCell, G->begin, G->end, "yy_1_FullCell");

  l373:;	
  {  int yypos374= G->pos, yythunkpos374= G->thunkpos;
  {  int yypos380= G->pos, yythunkpos380= G->thunkpos;  if (!yy_Newline(G))  goto l380;
  goto l374;
  l380:;	  G->pos= yypos380; G->thunkpos= yythunkpos380;
  }
  {  int yypos381= G->pos, yythunkpos381= G->thunkpos;  if (!yy_Endline(G))  goto l381;
  goto l374;
  l381:;	  G->pos= yypos381; G->thunkpos= yythunkpos381;
  }
  {  int yypos382= G->pos, yythunkpos382= G->thunkpos;  if (!yy_CellDivider(G))  goto l382;
  goto l374;
  l382:;	  G->pos= yypos382; G->thunkpos= yythunkpos382;
  }
  {  int yypos383= G->pos, yythunkpos383= G->thunkpos;  if (!yy_Sp(G))  goto l383;

  {  int yypos384= G->pos, yythunkpos384= G->thunkpos;  if (!yy_CellDivider(G))  goto l383;
  G->pos= yypos384; G->thunkpos= yythunkpos384;
  }  goto l374;
  l383:;	  G->pos= yypos383; G->thunkpos= yythunkpos383;
  }  if (!yy_Inline(G))  goto l374;
  yyDo(G, yy_1_FullCell, G->begin, G->end, "yy_1_FullCell");
  goto l373;
  l374:;	  G->pos= yypos374; G->thunkpos= yythunkpos374;
  }  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l372;  if (!yy_Sp(G))  goto l372;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l372;
  {  int yypos385= G->pos, yythunkpos385= G->thunkpos;  if (!yy_CellDivider(G))  goto l385;
  goto l386;
  l385:;	  G->pos= yypos385; G->thunkpos= yythunkpos385;
  }
  l386:;	  yyDo(G, yy_2_FullCell, G->begin, G->end, "yy_2_FullCell");
  yyprintf((stderr, "  ok   FullCell"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l372:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "FullCell"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmptyCell(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmptyCell"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l387;  if (!yy_Sp(G))  goto l387;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l387;  if (!yy_CellDivider(G))  goto l387;
  yyDo(G, yy_1_EmptyCell, G->begin, G->end, "yy_1_EmptyCell");
  yyprintf((stderr, "  ok   EmptyCell"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l387:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmptyCell"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ExtendedCell(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ExtendedCell"));

  {  int yypos389= G->pos, yythunkpos389= G->thunkpos;  if (!yy_EmptyCell(G))  goto l390;
  goto l389;
  l390:;	  G->pos= yypos389; G->thunkpos= yythunkpos389;  if (!yy_FullCell(G))  goto l388;

  }
  l389:;	  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l388;  if (!yy_CellDivider(G))  goto l388;

  l391:;	
  {  int yypos392= G->pos, yythunkpos392= G->thunkpos;  if (!yy_CellDivider(G))  goto l392;
  goto l391;
  l392:;	  G->pos= yypos392; G->thunkpos= yythunkpos392;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l388;  yyDo(G, yy_1_ExtendedCell, G->begin, G->end, "yy_1_ExtendedCell");
  yyprintf((stderr, "  ok   ExtendedCell"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l388:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ExtendedCell"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TableCell(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TableCell"));

  {  int yypos394= G->pos, yythunkpos394= G->thunkpos;  if (!yy_ExtendedCell(G))  goto l395;
  goto l394;
  l395:;	  G->pos= yypos394; G->thunkpos= yythunkpos394;  if (!yy_EmptyCell(G))  goto l396;
  goto l394;
  l396:;	  G->pos= yypos394; G->thunkpos= yythunkpos394;  if (!yy_FullCell(G))  goto l393;

  }
  l394:;	  yyprintf((stderr, "  ok   TableCell"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l393:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TableCell"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CellDivider(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CellDivider"));
  if (!yymatchChar(G, '|')) goto l397;
  yyprintf((stderr, "  ok   CellDivider"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l397:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CellDivider"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TableLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TableLine"));

  l399:;	
  {  int yypos400= G->pos, yythunkpos400= G->thunkpos;
  {  int yypos401= G->pos, yythunkpos401= G->thunkpos;  if (!yy_Newline(G))  goto l401;
  goto l400;
  l401:;	  G->pos= yypos401; G->thunkpos= yythunkpos401;
  }
  {  int yypos402= G->pos, yythunkpos402= G->thunkpos;  if (!yy_CellDivider(G))  goto l402;
  goto l400;
  l402:;	  G->pos= yypos402; G->thunkpos= yythunkpos402;
  }  if (!yymatchDot(G)) goto l400;  goto l399;
  l400:;	  G->pos= yypos400; G->thunkpos= yythunkpos400;
  }  if (!yy_CellDivider(G))  goto l398;
  yyprintf((stderr, "  ok   TableLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l398:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TableLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TableRow(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "TableRow"));
  if (!yy_StartList(G))  goto l403;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos404= G->pos, yythunkpos404= G->thunkpos;  if (!yy_SeparatorLine(G))  goto l404;
  goto l403;
  l404:;	  G->pos= yypos404; G->thunkpos= yythunkpos404;
  }
  {  int yypos405= G->pos, yythunkpos405= G->thunkpos;  if (!yy_TableLine(G))  goto l403;
  G->pos= yypos405; G->thunkpos= yythunkpos405;
  }
  {  int yypos406= G->pos, yythunkpos406= G->thunkpos;  if (!yy_CellDivider(G))  goto l406;
  goto l407;
  l406:;	  G->pos= yypos406; G->thunkpos= yythunkpos406;
  }
  l407:;	  if (!yy_TableCell(G))  goto l403;
  yyDo(G, yy_1_TableRow, G->begin, G->end, "yy_1_TableRow");

  l408:;	
  {  int yypos409= G->pos, yythunkpos409= G->thunkpos;  if (!yy_TableCell(G))  goto l409;
  yyDo(G, yy_1_TableRow, G->begin, G->end, "yy_1_TableRow");
  goto l408;
  l409:;	  G->pos= yypos409; G->thunkpos= yythunkpos409;
  }  if (!yy_Sp(G))  goto l403;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l403;  if (!yy_Newline(G))  goto l403;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l403;  yyDo(G, yy_2_TableRow, G->begin, G->end, "yy_2_TableRow");
  yyprintf((stderr, "  ok   TableRow"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l403:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TableRow"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SeparatorLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "SeparatorLine"));
  if (!yy_StartList(G))  goto l410;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos411= G->pos, yythunkpos411= G->thunkpos;  if (!yy_TableLine(G))  goto l410;
  G->pos= yypos411; G->thunkpos= yythunkpos411;
  }
  {  int yypos412= G->pos, yythunkpos412= G->thunkpos;  if (!yy_CellDivider(G))  goto l412;
  goto l413;
  l412:;	  G->pos= yypos412; G->thunkpos= yythunkpos412;
  }
  l413:;	
  {  int yypos416= G->pos, yythunkpos416= G->thunkpos;
  {  int yypos418= G->pos, yythunkpos418= G->thunkpos;  if (!yy_HeaderAlignmentCell(G))  goto l417;
  G->pos= yypos418; G->thunkpos= yythunkpos418;
  }  if (!yy_AlignmentCell(G))  goto l417;
  yyDo(G, yy_1_SeparatorLine, G->begin, G->end, "yy_1_SeparatorLine");
  goto l416;
  l417:;	  G->pos= yypos416; G->thunkpos= yythunkpos416;  if (!yy_AlignmentCell(G))  goto l410;
  yyDo(G, yy_2_SeparatorLine, G->begin, G->end, "yy_2_SeparatorLine");

  }
  l416:;	
  l414:;	
  {  int yypos415= G->pos, yythunkpos415= G->thunkpos;
  {  int yypos419= G->pos, yythunkpos419= G->thunkpos;
  {  int yypos421= G->pos, yythunkpos421= G->thunkpos;  if (!yy_HeaderAlignmentCell(G))  goto l420;
  G->pos= yypos421; G->thunkpos= yythunkpos421;
  }  if (!yy_AlignmentCell(G))  goto l420;
  yyDo(G, yy_1_SeparatorLine, G->begin, G->end, "yy_1_SeparatorLine");
  goto l419;
  l420:;	  G->pos= yypos419; G->thunkpos= yythunkpos419;  if (!yy_AlignmentCell(G))  goto l415;
  yyDo(G, yy_2_SeparatorLine, G->begin, G->end, "yy_2_SeparatorLine");

  }
  l419:;	  goto l414;
  l415:;	  G->pos= yypos415; G->thunkpos= yythunkpos415;
  }  if (!yy_Sp(G))  goto l410;
  if (!yy_Newline(G))  goto l410;
  yyDo(G, yy_3_SeparatorLine, G->begin, G->end, "yy_3_SeparatorLine");
  yyprintf((stderr, "  ok   SeparatorLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l410:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SeparatorLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TableBody(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "TableBody"));
  if (!yy_StartList(G))  goto l422;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_TableRow(G))  goto l422;
  yyDo(G, yy_1_TableBody, G->begin, G->end, "yy_1_TableBody");

  l423:;	
  {  int yypos424= G->pos, yythunkpos424= G->thunkpos;  if (!yy_TableRow(G))  goto l424;
  yyDo(G, yy_1_TableBody, G->begin, G->end, "yy_1_TableBody");
  goto l423;
  l424:;	  G->pos= yypos424; G->thunkpos= yythunkpos424;
  }  yyDo(G, yy_2_TableBody, G->begin, G->end, "yy_2_TableBody");
  yyprintf((stderr, "  ok   TableBody"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l422:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TableBody"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TableCaption(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 3, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "TableCaption"));
  if (!yy_StartList(G))  goto l425;
  yyDo(G, yySet, -3, 0, "yySet");
  if (!yy_StartList(G))  goto l425;
  yyDo(G, yySet, -2, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l425;  if (!yy_BracketedText(G))  goto l425;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l425;  yyDo(G, yy_1_TableCaption, G->begin, G->end, "yy_1_TableCaption");

  {  int yypos426= G->pos, yythunkpos426= G->thunkpos;  if (!yy_AutoLabel(G))  goto l426;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_2_TableCaption, G->begin, G->end, "yy_2_TableCaption");
  goto l427;
  l426:;	  G->pos= yypos426; G->thunkpos= yythunkpos426;
  }
  l427:;	  if (!yy_Sp(G))  goto l425;
  if (!yy_Newline(G))  goto l425;
  yyDo(G, yy_3_TableCaption, G->begin, G->end, "yy_3_TableCaption");
  yyprintf((stderr, "  ok   TableCaption"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 3, 0, "yyPop");
  return 1;
  l425:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TableCaption"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_InStyleTags(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "InStyleTags"));
  if (!yy_StyleOpen(G))  goto l428;

  l429:;	
  {  int yypos430= G->pos, yythunkpos430= G->thunkpos;
  {  int yypos431= G->pos, yythunkpos431= G->thunkpos;  if (!yy_StyleClose(G))  goto l431;
  goto l430;
  l431:;	  G->pos= yypos431; G->thunkpos= yythunkpos431;
  }  if (!yymatchDot(G)) goto l430;  goto l429;
  l430:;	  G->pos= yypos430; G->thunkpos= yythunkpos430;
  }  if (!yy_StyleClose(G))  goto l428;
  yyprintf((stderr, "  ok   InStyleTags"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l428:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "InStyleTags"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StyleClose(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StyleClose"));
  if (!yymatchChar(G, '<')) goto l432;
  if (!yy_Spnl(G))  goto l432;
  if (!yymatchChar(G, '/')) goto l432;

  {  int yypos433= G->pos, yythunkpos433= G->thunkpos;  if (!yymatchString(G, "style")) goto l434;
  goto l433;
  l434:;	  G->pos= yypos433; G->thunkpos= yythunkpos433;  if (!yymatchString(G, "STYLE")) goto l432;

  }
  l433:;	  if (!yy_Spnl(G))  goto l432;
  if (!yymatchChar(G, '>')) goto l432;
  yyprintf((stderr, "  ok   StyleClose"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l432:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StyleClose"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StyleOpen(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StyleOpen"));
  if (!yymatchChar(G, '<')) goto l435;
  if (!yy_Spnl(G))  goto l435;

  {  int yypos436= G->pos, yythunkpos436= G->thunkpos;  if (!yymatchString(G, "style")) goto l437;
  goto l436;
  l437:;	  G->pos= yypos436; G->thunkpos= yythunkpos436;  if (!yymatchString(G, "STYLE")) goto l435;

  }
  l436:;	  if (!yy_Spnl(G))  goto l435;

  l438:;	
  {  int yypos439= G->pos, yythunkpos439= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l439;
  goto l438;
  l439:;	  G->pos= yypos439; G->thunkpos= yythunkpos439;
  }  if (!yymatchChar(G, '>')) goto l435;
  yyprintf((stderr, "  ok   StyleOpen"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l435:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StyleOpen"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockType(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockType"));

  {  int yypos441= G->pos, yythunkpos441= G->thunkpos;  if (!yymatchString(G, "address")) goto l442;
  goto l441;
  l442:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "blockquote")) goto l443;
  goto l441;
  l443:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "center")) goto l444;
  goto l441;
  l444:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "dir")) goto l445;
  goto l441;
  l445:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "div")) goto l446;
  goto l441;
  l446:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "dl")) goto l447;
  goto l441;
  l447:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "fieldset")) goto l448;
  goto l441;
  l448:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "form")) goto l449;
  goto l441;
  l449:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "h1")) goto l450;
  goto l441;
  l450:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "h2")) goto l451;
  goto l441;
  l451:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "h3")) goto l452;
  goto l441;
  l452:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "h4")) goto l453;
  goto l441;
  l453:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "h5")) goto l454;
  goto l441;
  l454:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "h6")) goto l455;
  goto l441;
  l455:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "hr")) goto l456;
  goto l441;
  l456:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "isindex")) goto l457;
  goto l441;
  l457:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "menu")) goto l458;
  goto l441;
  l458:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "noframes")) goto l459;
  goto l441;
  l459:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "noscript")) goto l460;
  goto l441;
  l460:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "ol")) goto l461;
  goto l441;
  l461:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "pre")) goto l462;
  goto l441;
  l462:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchChar(G, 'p')) goto l463;
  goto l441;
  l463:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "table")) goto l464;
  goto l441;
  l464:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "ul")) goto l465;
  goto l441;
  l465:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "dd")) goto l466;
  goto l441;
  l466:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "dt")) goto l467;
  goto l441;
  l467:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "frameset")) goto l468;
  goto l441;
  l468:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "li")) goto l469;
  goto l441;
  l469:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "tbody")) goto l470;
  goto l441;
  l470:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "td")) goto l471;
  goto l441;
  l471:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "tfoot")) goto l472;
  goto l441;
  l472:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "th")) goto l473;
  goto l441;
  l473:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "thead")) goto l474;
  goto l441;
  l474:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "tr")) goto l475;
  goto l441;
  l475:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "script")) goto l476;
  goto l441;
  l476:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "ADDRESS")) goto l477;
  goto l441;
  l477:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "BLOCKQUOTE")) goto l478;
  goto l441;
  l478:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "CENTER")) goto l479;
  goto l441;
  l479:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "DIR")) goto l480;
  goto l441;
  l480:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "DIV")) goto l481;
  goto l441;
  l481:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "DL")) goto l482;
  goto l441;
  l482:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "FIELDSET")) goto l483;
  goto l441;
  l483:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "FORM")) goto l484;
  goto l441;
  l484:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "H1")) goto l485;
  goto l441;
  l485:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "H2")) goto l486;
  goto l441;
  l486:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "H3")) goto l487;
  goto l441;
  l487:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "H4")) goto l488;
  goto l441;
  l488:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "H5")) goto l489;
  goto l441;
  l489:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "H6")) goto l490;
  goto l441;
  l490:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "HR")) goto l491;
  goto l441;
  l491:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "ISINDEX")) goto l492;
  goto l441;
  l492:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "MENU")) goto l493;
  goto l441;
  l493:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "NOFRAMES")) goto l494;
  goto l441;
  l494:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "NOSCRIPT")) goto l495;
  goto l441;
  l495:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "OL")) goto l496;
  goto l441;
  l496:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "PRE")) goto l497;
  goto l441;
  l497:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchChar(G, 'P')) goto l498;
  goto l441;
  l498:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "TABLE")) goto l499;
  goto l441;
  l499:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "UL")) goto l500;
  goto l441;
  l500:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "DD")) goto l501;
  goto l441;
  l501:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "DT")) goto l502;
  goto l441;
  l502:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "FRAMESET")) goto l503;
  goto l441;
  l503:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "LI")) goto l504;
  goto l441;
  l504:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "TBODY")) goto l505;
  goto l441;
  l505:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "TD")) goto l506;
  goto l441;
  l506:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "TFOOT")) goto l507;
  goto l441;
  l507:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "TH")) goto l508;
  goto l441;
  l508:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "THEAD")) goto l509;
  goto l441;
  l509:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "TR")) goto l510;
  goto l441;
  l510:;	  G->pos= yypos441; G->thunkpos= yythunkpos441;  if (!yymatchString(G, "SCRIPT")) goto l440;

  }
  l441:;	  yyprintf((stderr, "  ok   HtmlBlockType"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l440:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockType"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MarkdownHtmlAttribute(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "MarkdownHtmlAttribute"));

  {  int yypos512= G->pos, yythunkpos512= G->thunkpos;  if (!yymatchString(G, "markdown")) goto l513;
  goto l512;
  l513:;	  G->pos= yypos512; G->thunkpos= yythunkpos512;  if (!yymatchString(G, "MARKDOWN")) goto l511;

  }
  l512:;	  if (!yy_Spnl(G))  goto l511;
  if (!yymatchChar(G, '=')) goto l511;
  if (!yy_Spnl(G))  goto l511;

  {  int yypos514= G->pos, yythunkpos514= G->thunkpos;  if (!yymatchChar(G, '"')) goto l514;
  if (!yy_Spnl(G))  goto l514;
  goto l515;
  l514:;	  G->pos= yypos514; G->thunkpos= yythunkpos514;
  }
  l515:;	  if (!yymatchChar(G, '1')) goto l511;

  {  int yypos516= G->pos, yythunkpos516= G->thunkpos;  if (!yy_Spnl(G))  goto l516;
  if (!yymatchChar(G, '"')) goto l516;
  goto l517;
  l516:;	  G->pos= yypos516; G->thunkpos= yythunkpos516;
  }
  l517:;	  if (!yy_Spnl(G))  goto l511;
  yyprintf((stderr, "  ok   MarkdownHtmlAttribute"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l511:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MarkdownHtmlAttribute"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockSelfClosing(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockSelfClosing"));
  if (!yymatchChar(G, '<')) goto l518;
  if (!yy_Spnl(G))  goto l518;
  if (!yy_HtmlBlockType(G))  goto l518;
  if (!yy_Spnl(G))  goto l518;

  l519:;	
  {  int yypos520= G->pos, yythunkpos520= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l520;
  goto l519;
  l520:;	  G->pos= yypos520; G->thunkpos= yythunkpos520;
  }  if (!yymatchChar(G, '/')) goto l518;
  if (!yy_Spnl(G))  goto l518;
  if (!yymatchChar(G, '>')) goto l518;
  yyprintf((stderr, "  ok   HtmlBlockSelfClosing"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l518:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockSelfClosing"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockMark(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockMark"));
  if (!yy_HtmlBlockOpenMark(G))  goto l521;

  l522:;	
  {  int yypos523= G->pos, yythunkpos523= G->thunkpos;
  {  int yypos524= G->pos, yythunkpos524= G->thunkpos;  if (!yy_HtmlBlockCloseMark(G))  goto l524;
  goto l523;
  l524:;	  G->pos= yypos524; G->thunkpos= yythunkpos524;
  }  if (!yymatchDot(G)) goto l523;  goto l522;
  l523:;	  G->pos= yypos523; G->thunkpos= yythunkpos523;
  }  if (!yy_HtmlBlockCloseMark(G))  goto l521;
  yyprintf((stderr, "  ok   HtmlBlockMark"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l521:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockMark"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseMark(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseMark"));
  if (!yymatchChar(G, '<')) goto l525;
  if (!yy_Spnl(G))  goto l525;
  if (!yymatchChar(G, '/')) goto l525;

  {  int yypos526= G->pos, yythunkpos526= G->thunkpos;  if (!yymatchString(G, "mark")) goto l527;
  goto l526;
  l527:;	  G->pos= yypos526; G->thunkpos= yythunkpos526;  if (!yymatchString(G, "MARK")) goto l525;

  }
  l526:;	  if (!yy_Spnl(G))  goto l525;
  if (!yymatchChar(G, '>')) goto l525;
  yyprintf((stderr, "  ok   HtmlBlockCloseMark"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l525:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseMark"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenMark(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenMark"));
  if (!yymatchChar(G, '<')) goto l528;
  if (!yy_Spnl(G))  goto l528;

  {  int yypos529= G->pos, yythunkpos529= G->thunkpos;  if (!yymatchString(G, "mark")) goto l530;
  goto l529;
  l530:;	  G->pos= yypos529; G->thunkpos= yythunkpos529;  if (!yymatchString(G, "MARK")) goto l528;

  }
  l529:;	  if (!yy_Spnl(G))  goto l528;

  l531:;	
  {  int yypos532= G->pos, yythunkpos532= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l532;
  goto l531;
  l532:;	  G->pos= yypos532; G->thunkpos= yythunkpos532;
  }  if (!yymatchChar(G, '>')) goto l528;
  yyprintf((stderr, "  ok   HtmlBlockOpenMark"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l528:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenMark"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockIns(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockIns"));
  if (!yy_HtmlBlockOpenIns(G))  goto l533;

  l534:;	
  {  int yypos535= G->pos, yythunkpos535= G->thunkpos;
  {  int yypos536= G->pos, yythunkpos536= G->thunkpos;  if (!yy_HtmlBlockCloseIns(G))  goto l536;
  goto l535;
  l536:;	  G->pos= yypos536; G->thunkpos= yythunkpos536;
  }  if (!yymatchDot(G)) goto l535;  goto l534;
  l535:;	  G->pos= yypos535; G->thunkpos= yythunkpos535;
  }  if (!yy_HtmlBlockCloseIns(G))  goto l533;
  yyprintf((stderr, "  ok   HtmlBlockIns"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l533:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockIns"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseIns(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseIns"));
  if (!yymatchChar(G, '<')) goto l537;
  if (!yy_Spnl(G))  goto l537;
  if (!yymatchChar(G, '/')) goto l537;

  {  int yypos538= G->pos, yythunkpos538= G->thunkpos;  if (!yymatchString(G, "ins")) goto l539;
  goto l538;
  l539:;	  G->pos= yypos538; G->thunkpos= yythunkpos538;  if (!yymatchString(G, "INS")) goto l537;

  }
  l538:;	  if (!yy_Spnl(G))  goto l537;
  if (!yymatchChar(G, '>')) goto l537;
  yyprintf((stderr, "  ok   HtmlBlockCloseIns"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l537:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseIns"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenIns(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenIns"));
  if (!yymatchChar(G, '<')) goto l540;
  if (!yy_Spnl(G))  goto l540;

  {  int yypos541= G->pos, yythunkpos541= G->thunkpos;  if (!yymatchString(G, "ins")) goto l542;
  goto l541;
  l542:;	  G->pos= yypos541; G->thunkpos= yythunkpos541;  if (!yymatchString(G, "INS")) goto l540;

  }
  l541:;	  if (!yy_Spnl(G))  goto l540;

  l543:;	
  {  int yypos544= G->pos, yythunkpos544= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l544;
  goto l543;
  l544:;	  G->pos= yypos544; G->thunkpos= yythunkpos544;
  }  if (!yymatchChar(G, '>')) goto l540;
  yyprintf((stderr, "  ok   HtmlBlockOpenIns"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l540:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenIns"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockDel(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockDel"));
  if (!yy_HtmlBlockOpenDel(G))  goto l545;

  l546:;	
  {  int yypos547= G->pos, yythunkpos547= G->thunkpos;
  {  int yypos548= G->pos, yythunkpos548= G->thunkpos;  if (!yy_HtmlBlockCloseDel(G))  goto l548;
  goto l547;
  l548:;	  G->pos= yypos548; G->thunkpos= yythunkpos548;
  }  if (!yymatchDot(G)) goto l547;  goto l546;
  l547:;	  G->pos= yypos547; G->thunkpos= yythunkpos547;
  }  if (!yy_HtmlBlockCloseDel(G))  goto l545;
  yyprintf((stderr, "  ok   HtmlBlockDel"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l545:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockDel"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseDel(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseDel"));
  if (!yymatchChar(G, '<')) goto l549;
  if (!yy_Spnl(G))  goto l549;
  if (!yymatchChar(G, '/')) goto l549;

  {  int yypos550= G->pos, yythunkpos550= G->thunkpos;  if (!yymatchString(G, "del")) goto l551;
  goto l550;
  l551:;	  G->pos= yypos550; G->thunkpos= yythunkpos550;  if (!yymatchString(G, "DEL")) goto l549;

  }
  l550:;	  if (!yy_Spnl(G))  goto l549;
  if (!yymatchChar(G, '>')) goto l549;
  yyprintf((stderr, "  ok   HtmlBlockCloseDel"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l549:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseDel"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenDel(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenDel"));
  if (!yymatchChar(G, '<')) goto l552;
  if (!yy_Spnl(G))  goto l552;

  {  int yypos553= G->pos, yythunkpos553= G->thunkpos;  if (!yymatchString(G, "del")) goto l554;
  goto l553;
  l554:;	  G->pos= yypos553; G->thunkpos= yythunkpos553;  if (!yymatchString(G, "DEL")) goto l552;

  }
  l553:;	  if (!yy_Spnl(G))  goto l552;

  l555:;	
  {  int yypos556= G->pos, yythunkpos556= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l556;
  goto l555;
  l556:;	  G->pos= yypos556; G->thunkpos= yythunkpos556;
  }  if (!yymatchChar(G, '>')) goto l552;
  yyprintf((stderr, "  ok   HtmlBlockOpenDel"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l552:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenDel"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockNav(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockNav"));
  if (!yy_HtmlBlockOpenNav(G))  goto l557;

  l558:;	
  {  int yypos559= G->pos, yythunkpos559= G->thunkpos;
  {  int yypos560= G->pos, yythunkpos560= G->thunkpos;  if (!yy_HtmlBlockCloseNav(G))  goto l560;
  goto l559;
  l560:;	  G->pos= yypos560; G->thunkpos= yythunkpos560;
  }  if (!yymatchDot(G)) goto l559;  goto l558;
  l559:;	  G->pos= yypos559; G->thunkpos= yythunkpos559;
  }  if (!yy_HtmlBlockCloseNav(G))  goto l557;
  yyprintf((stderr, "  ok   HtmlBlockNav"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l557:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockNav"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseNav(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseNav"));
  if (!yymatchChar(G, '<')) goto l561;
  if (!yy_Spnl(G))  goto l561;
  if (!yymatchChar(G, '/')) goto l561;

  {  int yypos562= G->pos, yythunkpos562= G->thunkpos;  if (!yymatchString(G, "nav")) goto l563;
  goto l562;
  l563:;	  G->pos= yypos562; G->thunkpos= yythunkpos562;  if (!yymatchString(G, "NAV")) goto l561;

  }
  l562:;	  if (!yy_Spnl(G))  goto l561;
  if (!yymatchChar(G, '>')) goto l561;
  yyprintf((stderr, "  ok   HtmlBlockCloseNav"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l561:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseNav"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenNav(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenNav"));
  if (!yymatchChar(G, '<')) goto l564;
  if (!yy_Spnl(G))  goto l564;

  {  int yypos565= G->pos, yythunkpos565= G->thunkpos;  if (!yymatchString(G, "nav")) goto l566;
  goto l565;
  l566:;	  G->pos= yypos565; G->thunkpos= yythunkpos565;  if (!yymatchString(G, "NAV")) goto l564;

  }
  l565:;	  if (!yy_Spnl(G))  goto l564;

  l567:;	
  {  int yypos568= G->pos, yythunkpos568= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l568;
  goto l567;
  l568:;	  G->pos= yypos568; G->thunkpos= yythunkpos568;
  }  if (!yymatchChar(G, '>')) goto l564;
  yyprintf((stderr, "  ok   HtmlBlockOpenNav"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l564:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenNav"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockMain(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockMain"));
  if (!yy_HtmlBlockOpenMain(G))  goto l569;

  l570:;	
  {  int yypos571= G->pos, yythunkpos571= G->thunkpos;
  {  int yypos572= G->pos, yythunkpos572= G->thunkpos;  if (!yy_HtmlBlockCloseMain(G))  goto l572;
  goto l571;
  l572:;	  G->pos= yypos572; G->thunkpos= yythunkpos572;
  }  if (!yymatchDot(G)) goto l571;  goto l570;
  l571:;	  G->pos= yypos571; G->thunkpos= yythunkpos571;
  }  if (!yy_HtmlBlockCloseMain(G))  goto l569;
  yyprintf((stderr, "  ok   HtmlBlockMain"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l569:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockMain"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseMain(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseMain"));
  if (!yymatchChar(G, '<')) goto l573;
  if (!yy_Spnl(G))  goto l573;
  if (!yymatchChar(G, '/')) goto l573;

  {  int yypos574= G->pos, yythunkpos574= G->thunkpos;  if (!yymatchString(G, "main")) goto l575;
  goto l574;
  l575:;	  G->pos= yypos574; G->thunkpos= yythunkpos574;  if (!yymatchString(G, "MAIN")) goto l573;

  }
  l574:;	  if (!yy_Spnl(G))  goto l573;
  if (!yymatchChar(G, '>')) goto l573;
  yyprintf((stderr, "  ok   HtmlBlockCloseMain"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l573:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseMain"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenMain(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenMain"));
  if (!yymatchChar(G, '<')) goto l576;
  if (!yy_Spnl(G))  goto l576;

  {  int yypos577= G->pos, yythunkpos577= G->thunkpos;  if (!yymatchString(G, "main")) goto l578;
  goto l577;
  l578:;	  G->pos= yypos577; G->thunkpos= yythunkpos577;  if (!yymatchString(G, "MAIN")) goto l576;

  }
  l577:;	  if (!yy_Spnl(G))  goto l576;

  l579:;	
  {  int yypos580= G->pos, yythunkpos580= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l580;
  goto l579;
  l580:;	  G->pos= yypos580; G->thunkpos= yythunkpos580;
  }  if (!yymatchChar(G, '>')) goto l576;
  yyprintf((stderr, "  ok   HtmlBlockOpenMain"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l576:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenMain"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockHead(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockHead"));
  if (!yy_HtmlBlockOpenHead(G))  goto l581;

  l582:;	
  {  int yypos583= G->pos, yythunkpos583= G->thunkpos;
  {  int yypos584= G->pos, yythunkpos584= G->thunkpos;  if (!yy_HtmlBlockCloseHead(G))  goto l584;
  goto l583;
  l584:;	  G->pos= yypos584; G->thunkpos= yythunkpos584;
  }  if (!yymatchDot(G)) goto l583;  goto l582;
  l583:;	  G->pos= yypos583; G->thunkpos= yythunkpos583;
  }  if (!yy_HtmlBlockCloseHead(G))  goto l581;
  yyprintf((stderr, "  ok   HtmlBlockHead"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l581:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockHead"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseHead(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseHead"));
  if (!yymatchChar(G, '<')) goto l585;
  if (!yy_Spnl(G))  goto l585;
  if (!yymatchChar(G, '/')) goto l585;

  {  int yypos586= G->pos, yythunkpos586= G->thunkpos;  if (!yymatchString(G, "head")) goto l587;
  goto l586;
  l587:;	  G->pos= yypos586; G->thunkpos= yythunkpos586;  if (!yymatchString(G, "HEAD")) goto l585;

  }
  l586:;	  if (!yy_Spnl(G))  goto l585;
  if (!yymatchChar(G, '>')) goto l585;
  yyprintf((stderr, "  ok   HtmlBlockCloseHead"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l585:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseHead"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenHead(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenHead"));
  if (!yymatchChar(G, '<')) goto l588;
  if (!yy_Spnl(G))  goto l588;

  {  int yypos589= G->pos, yythunkpos589= G->thunkpos;  if (!yymatchString(G, "head")) goto l590;
  goto l589;
  l590:;	  G->pos= yypos589; G->thunkpos= yythunkpos589;  if (!yymatchString(G, "HEAD")) goto l588;

  }
  l589:;	  if (!yy_Spnl(G))  goto l588;

  l591:;	
  {  int yypos592= G->pos, yythunkpos592= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l592;
  goto l591;
  l592:;	  G->pos= yypos592; G->thunkpos= yythunkpos592;
  }  if (!yymatchChar(G, '>')) goto l588;
  yyprintf((stderr, "  ok   HtmlBlockOpenHead"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l588:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenHead"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseScript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseScript"));
  if (!yymatchChar(G, '<')) goto l593;
  if (!yy_Spnl(G))  goto l593;
  if (!yymatchChar(G, '/')) goto l593;

  {  int yypos594= G->pos, yythunkpos594= G->thunkpos;  if (!yymatchString(G, "script")) goto l595;
  goto l594;
  l595:;	  G->pos= yypos594; G->thunkpos= yythunkpos594;  if (!yymatchString(G, "SCRIPT")) goto l593;

  }
  l594:;	  if (!yy_Spnl(G))  goto l593;
  if (!yymatchChar(G, '>')) goto l593;
  yyprintf((stderr, "  ok   HtmlBlockCloseScript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l593:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseScript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenScript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenScript"));
  if (!yymatchChar(G, '<')) goto l596;
  if (!yy_Spnl(G))  goto l596;

  {  int yypos597= G->pos, yythunkpos597= G->thunkpos;  if (!yymatchString(G, "script")) goto l598;
  goto l597;
  l598:;	  G->pos= yypos597; G->thunkpos= yythunkpos597;  if (!yymatchString(G, "SCRIPT")) goto l596;

  }
  l597:;	  if (!yy_Spnl(G))  goto l596;

  l599:;	
  {  int yypos600= G->pos, yythunkpos600= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l600;
  goto l599;
  l600:;	  G->pos= yypos600; G->thunkpos= yythunkpos600;
  }  if (!yymatchChar(G, '>')) goto l596;
  yyprintf((stderr, "  ok   HtmlBlockOpenScript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l596:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenScript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockTr(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockTr"));
  if (!yy_HtmlBlockOpenTr(G))  goto l601;

  l602:;	
  {  int yypos603= G->pos, yythunkpos603= G->thunkpos;
  {  int yypos604= G->pos, yythunkpos604= G->thunkpos;  if (!yy_HtmlBlockTr(G))  goto l605;
  goto l604;
  l605:;	  G->pos= yypos604; G->thunkpos= yythunkpos604;
  {  int yypos606= G->pos, yythunkpos606= G->thunkpos;  if (!yy_HtmlBlockCloseTr(G))  goto l606;
  goto l603;
  l606:;	  G->pos= yypos606; G->thunkpos= yythunkpos606;
  }  if (!yymatchDot(G)) goto l603;
  }
  l604:;	  goto l602;
  l603:;	  G->pos= yypos603; G->thunkpos= yythunkpos603;
  }  if (!yy_HtmlBlockCloseTr(G))  goto l601;
  yyprintf((stderr, "  ok   HtmlBlockTr"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l601:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockTr"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseTr(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseTr"));
  if (!yymatchChar(G, '<')) goto l607;
  if (!yy_Spnl(G))  goto l607;
  if (!yymatchChar(G, '/')) goto l607;

  {  int yypos608= G->pos, yythunkpos608= G->thunkpos;  if (!yymatchString(G, "tr")) goto l609;
  goto l608;
  l609:;	  G->pos= yypos608; G->thunkpos= yythunkpos608;  if (!yymatchString(G, "TR")) goto l607;

  }
  l608:;	  if (!yy_Spnl(G))  goto l607;
  if (!yymatchChar(G, '>')) goto l607;
  yyprintf((stderr, "  ok   HtmlBlockCloseTr"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l607:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseTr"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenTr(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenTr"));
  if (!yymatchChar(G, '<')) goto l610;
  if (!yy_Spnl(G))  goto l610;

  {  int yypos611= G->pos, yythunkpos611= G->thunkpos;  if (!yymatchString(G, "tr")) goto l612;
  goto l611;
  l612:;	  G->pos= yypos611; G->thunkpos= yythunkpos611;  if (!yymatchString(G, "TR")) goto l610;

  }
  l611:;	  if (!yy_Spnl(G))  goto l610;

  l613:;	
  {  int yypos614= G->pos, yythunkpos614= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l614;
  goto l613;
  l614:;	  G->pos= yypos614; G->thunkpos= yythunkpos614;
  }  if (!yymatchChar(G, '>')) goto l610;
  yyprintf((stderr, "  ok   HtmlBlockOpenTr"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l610:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenTr"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockThead(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockThead"));
  if (!yy_HtmlBlockOpenThead(G))  goto l615;

  l616:;	
  {  int yypos617= G->pos, yythunkpos617= G->thunkpos;
  {  int yypos618= G->pos, yythunkpos618= G->thunkpos;  if (!yy_HtmlBlockThead(G))  goto l619;
  goto l618;
  l619:;	  G->pos= yypos618; G->thunkpos= yythunkpos618;
  {  int yypos620= G->pos, yythunkpos620= G->thunkpos;  if (!yy_HtmlBlockCloseThead(G))  goto l620;
  goto l617;
  l620:;	  G->pos= yypos620; G->thunkpos= yythunkpos620;
  }  if (!yymatchDot(G)) goto l617;
  }
  l618:;	  goto l616;
  l617:;	  G->pos= yypos617; G->thunkpos= yythunkpos617;
  }  if (!yy_HtmlBlockCloseThead(G))  goto l615;
  yyprintf((stderr, "  ok   HtmlBlockThead"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l615:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockThead"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseThead(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseThead"));
  if (!yymatchChar(G, '<')) goto l621;
  if (!yy_Spnl(G))  goto l621;
  if (!yymatchChar(G, '/')) goto l621;

  {  int yypos622= G->pos, yythunkpos622= G->thunkpos;  if (!yymatchString(G, "thead")) goto l623;
  goto l622;
  l623:;	  G->pos= yypos622; G->thunkpos= yythunkpos622;  if (!yymatchString(G, "THEAD")) goto l621;

  }
  l622:;	  if (!yy_Spnl(G))  goto l621;
  if (!yymatchChar(G, '>')) goto l621;
  yyprintf((stderr, "  ok   HtmlBlockCloseThead"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l621:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseThead"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenThead(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenThead"));
  if (!yymatchChar(G, '<')) goto l624;
  if (!yy_Spnl(G))  goto l624;

  {  int yypos625= G->pos, yythunkpos625= G->thunkpos;  if (!yymatchString(G, "thead")) goto l626;
  goto l625;
  l626:;	  G->pos= yypos625; G->thunkpos= yythunkpos625;  if (!yymatchString(G, "THEAD")) goto l624;

  }
  l625:;	  if (!yy_Spnl(G))  goto l624;

  l627:;	
  {  int yypos628= G->pos, yythunkpos628= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l628;
  goto l627;
  l628:;	  G->pos= yypos628; G->thunkpos= yythunkpos628;
  }  if (!yymatchChar(G, '>')) goto l624;
  yyprintf((stderr, "  ok   HtmlBlockOpenThead"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l624:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenThead"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockTh(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockTh"));
  if (!yy_HtmlBlockOpenTh(G))  goto l629;

  l630:;	
  {  int yypos631= G->pos, yythunkpos631= G->thunkpos;
  {  int yypos632= G->pos, yythunkpos632= G->thunkpos;  if (!yy_HtmlBlockTh(G))  goto l633;
  goto l632;
  l633:;	  G->pos= yypos632; G->thunkpos= yythunkpos632;
  {  int yypos634= G->pos, yythunkpos634= G->thunkpos;  if (!yy_HtmlBlockCloseTh(G))  goto l634;
  goto l631;
  l634:;	  G->pos= yypos634; G->thunkpos= yythunkpos634;
  }  if (!yymatchDot(G)) goto l631;
  }
  l632:;	  goto l630;
  l631:;	  G->pos= yypos631; G->thunkpos= yythunkpos631;
  }  if (!yy_HtmlBlockCloseTh(G))  goto l629;
  yyprintf((stderr, "  ok   HtmlBlockTh"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l629:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockTh"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseTh(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseTh"));
  if (!yymatchChar(G, '<')) goto l635;
  if (!yy_Spnl(G))  goto l635;
  if (!yymatchChar(G, '/')) goto l635;

  {  int yypos636= G->pos, yythunkpos636= G->thunkpos;  if (!yymatchString(G, "th")) goto l637;
  goto l636;
  l637:;	  G->pos= yypos636; G->thunkpos= yythunkpos636;  if (!yymatchString(G, "TH")) goto l635;

  }
  l636:;	  if (!yy_Spnl(G))  goto l635;
  if (!yymatchChar(G, '>')) goto l635;
  yyprintf((stderr, "  ok   HtmlBlockCloseTh"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l635:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseTh"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenTh(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenTh"));
  if (!yymatchChar(G, '<')) goto l638;
  if (!yy_Spnl(G))  goto l638;

  {  int yypos639= G->pos, yythunkpos639= G->thunkpos;  if (!yymatchString(G, "th")) goto l640;
  goto l639;
  l640:;	  G->pos= yypos639; G->thunkpos= yythunkpos639;  if (!yymatchString(G, "TH")) goto l638;

  }
  l639:;	  if (!yy_Spnl(G))  goto l638;

  l641:;	
  {  int yypos642= G->pos, yythunkpos642= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l642;
  goto l641;
  l642:;	  G->pos= yypos642; G->thunkpos= yythunkpos642;
  }  if (!yymatchChar(G, '>')) goto l638;
  yyprintf((stderr, "  ok   HtmlBlockOpenTh"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l638:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenTh"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockTfoot(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockTfoot"));
  if (!yy_HtmlBlockOpenTfoot(G))  goto l643;

  l644:;	
  {  int yypos645= G->pos, yythunkpos645= G->thunkpos;
  {  int yypos646= G->pos, yythunkpos646= G->thunkpos;  if (!yy_HtmlBlockTfoot(G))  goto l647;
  goto l646;
  l647:;	  G->pos= yypos646; G->thunkpos= yythunkpos646;
  {  int yypos648= G->pos, yythunkpos648= G->thunkpos;  if (!yy_HtmlBlockCloseTfoot(G))  goto l648;
  goto l645;
  l648:;	  G->pos= yypos648; G->thunkpos= yythunkpos648;
  }  if (!yymatchDot(G)) goto l645;
  }
  l646:;	  goto l644;
  l645:;	  G->pos= yypos645; G->thunkpos= yythunkpos645;
  }  if (!yy_HtmlBlockCloseTfoot(G))  goto l643;
  yyprintf((stderr, "  ok   HtmlBlockTfoot"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l643:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockTfoot"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseTfoot(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseTfoot"));
  if (!yymatchChar(G, '<')) goto l649;
  if (!yy_Spnl(G))  goto l649;
  if (!yymatchChar(G, '/')) goto l649;

  {  int yypos650= G->pos, yythunkpos650= G->thunkpos;  if (!yymatchString(G, "tfoot")) goto l651;
  goto l650;
  l651:;	  G->pos= yypos650; G->thunkpos= yythunkpos650;  if (!yymatchString(G, "TFOOT")) goto l649;

  }
  l650:;	  if (!yy_Spnl(G))  goto l649;
  if (!yymatchChar(G, '>')) goto l649;
  yyprintf((stderr, "  ok   HtmlBlockCloseTfoot"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l649:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseTfoot"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenTfoot(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenTfoot"));
  if (!yymatchChar(G, '<')) goto l652;
  if (!yy_Spnl(G))  goto l652;

  {  int yypos653= G->pos, yythunkpos653= G->thunkpos;  if (!yymatchString(G, "tfoot")) goto l654;
  goto l653;
  l654:;	  G->pos= yypos653; G->thunkpos= yythunkpos653;  if (!yymatchString(G, "TFOOT")) goto l652;

  }
  l653:;	  if (!yy_Spnl(G))  goto l652;

  l655:;	
  {  int yypos656= G->pos, yythunkpos656= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l656;
  goto l655;
  l656:;	  G->pos= yypos656; G->thunkpos= yythunkpos656;
  }  if (!yymatchChar(G, '>')) goto l652;
  yyprintf((stderr, "  ok   HtmlBlockOpenTfoot"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l652:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenTfoot"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockTd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockTd"));
  if (!yy_HtmlBlockOpenTd(G))  goto l657;

  l658:;	
  {  int yypos659= G->pos, yythunkpos659= G->thunkpos;
  {  int yypos660= G->pos, yythunkpos660= G->thunkpos;  if (!yy_HtmlBlockTd(G))  goto l661;
  goto l660;
  l661:;	  G->pos= yypos660; G->thunkpos= yythunkpos660;
  {  int yypos662= G->pos, yythunkpos662= G->thunkpos;  if (!yy_HtmlBlockCloseTd(G))  goto l662;
  goto l659;
  l662:;	  G->pos= yypos662; G->thunkpos= yythunkpos662;
  }  if (!yymatchDot(G)) goto l659;
  }
  l660:;	  goto l658;
  l659:;	  G->pos= yypos659; G->thunkpos= yythunkpos659;
  }  if (!yy_HtmlBlockCloseTd(G))  goto l657;
  yyprintf((stderr, "  ok   HtmlBlockTd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l657:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockTd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseTd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseTd"));
  if (!yymatchChar(G, '<')) goto l663;
  if (!yy_Spnl(G))  goto l663;
  if (!yymatchChar(G, '/')) goto l663;

  {  int yypos664= G->pos, yythunkpos664= G->thunkpos;  if (!yymatchString(G, "td")) goto l665;
  goto l664;
  l665:;	  G->pos= yypos664; G->thunkpos= yythunkpos664;  if (!yymatchString(G, "TD")) goto l663;

  }
  l664:;	  if (!yy_Spnl(G))  goto l663;
  if (!yymatchChar(G, '>')) goto l663;
  yyprintf((stderr, "  ok   HtmlBlockCloseTd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l663:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseTd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenTd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenTd"));
  if (!yymatchChar(G, '<')) goto l666;
  if (!yy_Spnl(G))  goto l666;

  {  int yypos667= G->pos, yythunkpos667= G->thunkpos;  if (!yymatchString(G, "td")) goto l668;
  goto l667;
  l668:;	  G->pos= yypos667; G->thunkpos= yythunkpos667;  if (!yymatchString(G, "TD")) goto l666;

  }
  l667:;	  if (!yy_Spnl(G))  goto l666;

  l669:;	
  {  int yypos670= G->pos, yythunkpos670= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l670;
  goto l669;
  l670:;	  G->pos= yypos670; G->thunkpos= yythunkpos670;
  }  if (!yymatchChar(G, '>')) goto l666;
  yyprintf((stderr, "  ok   HtmlBlockOpenTd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l666:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenTd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockTbody(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockTbody"));
  if (!yy_HtmlBlockOpenTbody(G))  goto l671;

  l672:;	
  {  int yypos673= G->pos, yythunkpos673= G->thunkpos;
  {  int yypos674= G->pos, yythunkpos674= G->thunkpos;  if (!yy_HtmlBlockTbody(G))  goto l675;
  goto l674;
  l675:;	  G->pos= yypos674; G->thunkpos= yythunkpos674;
  {  int yypos676= G->pos, yythunkpos676= G->thunkpos;  if (!yy_HtmlBlockCloseTbody(G))  goto l676;
  goto l673;
  l676:;	  G->pos= yypos676; G->thunkpos= yythunkpos676;
  }  if (!yymatchDot(G)) goto l673;
  }
  l674:;	  goto l672;
  l673:;	  G->pos= yypos673; G->thunkpos= yythunkpos673;
  }  if (!yy_HtmlBlockCloseTbody(G))  goto l671;
  yyprintf((stderr, "  ok   HtmlBlockTbody"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l671:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockTbody"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseTbody(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseTbody"));
  if (!yymatchChar(G, '<')) goto l677;
  if (!yy_Spnl(G))  goto l677;
  if (!yymatchChar(G, '/')) goto l677;

  {  int yypos678= G->pos, yythunkpos678= G->thunkpos;  if (!yymatchString(G, "tbody")) goto l679;
  goto l678;
  l679:;	  G->pos= yypos678; G->thunkpos= yythunkpos678;  if (!yymatchString(G, "TBODY")) goto l677;

  }
  l678:;	  if (!yy_Spnl(G))  goto l677;
  if (!yymatchChar(G, '>')) goto l677;
  yyprintf((stderr, "  ok   HtmlBlockCloseTbody"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l677:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseTbody"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenTbody(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenTbody"));
  if (!yymatchChar(G, '<')) goto l680;
  if (!yy_Spnl(G))  goto l680;

  {  int yypos681= G->pos, yythunkpos681= G->thunkpos;  if (!yymatchString(G, "tbody")) goto l682;
  goto l681;
  l682:;	  G->pos= yypos681; G->thunkpos= yythunkpos681;  if (!yymatchString(G, "TBODY")) goto l680;

  }
  l681:;	  if (!yy_Spnl(G))  goto l680;

  l683:;	
  {  int yypos684= G->pos, yythunkpos684= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l684;
  goto l683;
  l684:;	  G->pos= yypos684; G->thunkpos= yythunkpos684;
  }  if (!yymatchChar(G, '>')) goto l680;
  yyprintf((stderr, "  ok   HtmlBlockOpenTbody"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l680:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenTbody"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockLi(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockLi"));
  if (!yy_HtmlBlockOpenLi(G))  goto l685;

  l686:;	
  {  int yypos687= G->pos, yythunkpos687= G->thunkpos;
  {  int yypos688= G->pos, yythunkpos688= G->thunkpos;  if (!yy_HtmlBlockLi(G))  goto l689;
  goto l688;
  l689:;	  G->pos= yypos688; G->thunkpos= yythunkpos688;
  {  int yypos690= G->pos, yythunkpos690= G->thunkpos;  if (!yy_HtmlBlockCloseLi(G))  goto l690;
  goto l687;
  l690:;	  G->pos= yypos690; G->thunkpos= yythunkpos690;
  }  if (!yymatchDot(G)) goto l687;
  }
  l688:;	  goto l686;
  l687:;	  G->pos= yypos687; G->thunkpos= yythunkpos687;
  }  if (!yy_HtmlBlockCloseLi(G))  goto l685;
  yyprintf((stderr, "  ok   HtmlBlockLi"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l685:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockLi"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseLi(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseLi"));
  if (!yymatchChar(G, '<')) goto l691;
  if (!yy_Spnl(G))  goto l691;
  if (!yymatchChar(G, '/')) goto l691;

  {  int yypos692= G->pos, yythunkpos692= G->thunkpos;  if (!yymatchString(G, "li")) goto l693;
  goto l692;
  l693:;	  G->pos= yypos692; G->thunkpos= yythunkpos692;  if (!yymatchString(G, "LI")) goto l691;

  }
  l692:;	  if (!yy_Spnl(G))  goto l691;
  if (!yymatchChar(G, '>')) goto l691;
  yyprintf((stderr, "  ok   HtmlBlockCloseLi"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l691:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseLi"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenLi(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenLi"));
  if (!yymatchChar(G, '<')) goto l694;
  if (!yy_Spnl(G))  goto l694;

  {  int yypos695= G->pos, yythunkpos695= G->thunkpos;  if (!yymatchString(G, "li")) goto l696;
  goto l695;
  l696:;	  G->pos= yypos695; G->thunkpos= yythunkpos695;  if (!yymatchString(G, "LI")) goto l694;

  }
  l695:;	  if (!yy_Spnl(G))  goto l694;

  l697:;	
  {  int yypos698= G->pos, yythunkpos698= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l698;
  goto l697;
  l698:;	  G->pos= yypos698; G->thunkpos= yythunkpos698;
  }  if (!yymatchChar(G, '>')) goto l694;
  yyprintf((stderr, "  ok   HtmlBlockOpenLi"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l694:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenLi"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockFrameset(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockFrameset"));
  if (!yy_HtmlBlockOpenFrameset(G))  goto l699;

  l700:;	
  {  int yypos701= G->pos, yythunkpos701= G->thunkpos;
  {  int yypos702= G->pos, yythunkpos702= G->thunkpos;  if (!yy_HtmlBlockFrameset(G))  goto l703;
  goto l702;
  l703:;	  G->pos= yypos702; G->thunkpos= yythunkpos702;
  {  int yypos704= G->pos, yythunkpos704= G->thunkpos;  if (!yy_HtmlBlockCloseFrameset(G))  goto l704;
  goto l701;
  l704:;	  G->pos= yypos704; G->thunkpos= yythunkpos704;
  }  if (!yymatchDot(G)) goto l701;
  }
  l702:;	  goto l700;
  l701:;	  G->pos= yypos701; G->thunkpos= yythunkpos701;
  }  if (!yy_HtmlBlockCloseFrameset(G))  goto l699;
  yyprintf((stderr, "  ok   HtmlBlockFrameset"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l699:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockFrameset"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseFrameset(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseFrameset"));
  if (!yymatchChar(G, '<')) goto l705;
  if (!yy_Spnl(G))  goto l705;
  if (!yymatchChar(G, '/')) goto l705;

  {  int yypos706= G->pos, yythunkpos706= G->thunkpos;  if (!yymatchString(G, "frameset")) goto l707;
  goto l706;
  l707:;	  G->pos= yypos706; G->thunkpos= yythunkpos706;  if (!yymatchString(G, "FRAMESET")) goto l705;

  }
  l706:;	  if (!yy_Spnl(G))  goto l705;
  if (!yymatchChar(G, '>')) goto l705;
  yyprintf((stderr, "  ok   HtmlBlockCloseFrameset"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l705:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseFrameset"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenFrameset(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenFrameset"));
  if (!yymatchChar(G, '<')) goto l708;
  if (!yy_Spnl(G))  goto l708;

  {  int yypos709= G->pos, yythunkpos709= G->thunkpos;  if (!yymatchString(G, "frameset")) goto l710;
  goto l709;
  l710:;	  G->pos= yypos709; G->thunkpos= yythunkpos709;  if (!yymatchString(G, "FRAMESET")) goto l708;

  }
  l709:;	  if (!yy_Spnl(G))  goto l708;

  l711:;	
  {  int yypos712= G->pos, yythunkpos712= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l712;
  goto l711;
  l712:;	  G->pos= yypos712; G->thunkpos= yythunkpos712;
  }  if (!yymatchChar(G, '>')) goto l708;
  yyprintf((stderr, "  ok   HtmlBlockOpenFrameset"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l708:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenFrameset"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockDt(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockDt"));
  if (!yy_HtmlBlockOpenDt(G))  goto l713;

  l714:;	
  {  int yypos715= G->pos, yythunkpos715= G->thunkpos;
  {  int yypos716= G->pos, yythunkpos716= G->thunkpos;  if (!yy_HtmlBlockDt(G))  goto l717;
  goto l716;
  l717:;	  G->pos= yypos716; G->thunkpos= yythunkpos716;
  {  int yypos718= G->pos, yythunkpos718= G->thunkpos;  if (!yy_HtmlBlockCloseDt(G))  goto l718;
  goto l715;
  l718:;	  G->pos= yypos718; G->thunkpos= yythunkpos718;
  }  if (!yymatchDot(G)) goto l715;
  }
  l716:;	  goto l714;
  l715:;	  G->pos= yypos715; G->thunkpos= yythunkpos715;
  }  if (!yy_HtmlBlockCloseDt(G))  goto l713;
  yyprintf((stderr, "  ok   HtmlBlockDt"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l713:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockDt"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseDt(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseDt"));
  if (!yymatchChar(G, '<')) goto l719;
  if (!yy_Spnl(G))  goto l719;
  if (!yymatchChar(G, '/')) goto l719;

  {  int yypos720= G->pos, yythunkpos720= G->thunkpos;  if (!yymatchString(G, "dt")) goto l721;
  goto l720;
  l721:;	  G->pos= yypos720; G->thunkpos= yythunkpos720;  if (!yymatchString(G, "DT")) goto l719;

  }
  l720:;	  if (!yy_Spnl(G))  goto l719;
  if (!yymatchChar(G, '>')) goto l719;
  yyprintf((stderr, "  ok   HtmlBlockCloseDt"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l719:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseDt"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenDt(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenDt"));
  if (!yymatchChar(G, '<')) goto l722;
  if (!yy_Spnl(G))  goto l722;

  {  int yypos723= G->pos, yythunkpos723= G->thunkpos;  if (!yymatchString(G, "dt")) goto l724;
  goto l723;
  l724:;	  G->pos= yypos723; G->thunkpos= yythunkpos723;  if (!yymatchString(G, "DT")) goto l722;

  }
  l723:;	  if (!yy_Spnl(G))  goto l722;

  l725:;	
  {  int yypos726= G->pos, yythunkpos726= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l726;
  goto l725;
  l726:;	  G->pos= yypos726; G->thunkpos= yythunkpos726;
  }  if (!yymatchChar(G, '>')) goto l722;
  yyprintf((stderr, "  ok   HtmlBlockOpenDt"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l722:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenDt"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockDd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockDd"));
  if (!yy_HtmlBlockOpenDd(G))  goto l727;

  l728:;	
  {  int yypos729= G->pos, yythunkpos729= G->thunkpos;
  {  int yypos730= G->pos, yythunkpos730= G->thunkpos;  if (!yy_HtmlBlockDd(G))  goto l731;
  goto l730;
  l731:;	  G->pos= yypos730; G->thunkpos= yythunkpos730;
  {  int yypos732= G->pos, yythunkpos732= G->thunkpos;  if (!yy_HtmlBlockCloseDd(G))  goto l732;
  goto l729;
  l732:;	  G->pos= yypos732; G->thunkpos= yythunkpos732;
  }  if (!yymatchDot(G)) goto l729;
  }
  l730:;	  goto l728;
  l729:;	  G->pos= yypos729; G->thunkpos= yythunkpos729;
  }  if (!yy_HtmlBlockCloseDd(G))  goto l727;
  yyprintf((stderr, "  ok   HtmlBlockDd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l727:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockDd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseDd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseDd"));
  if (!yymatchChar(G, '<')) goto l733;
  if (!yy_Spnl(G))  goto l733;
  if (!yymatchChar(G, '/')) goto l733;

  {  int yypos734= G->pos, yythunkpos734= G->thunkpos;  if (!yymatchString(G, "dd")) goto l735;
  goto l734;
  l735:;	  G->pos= yypos734; G->thunkpos= yythunkpos734;  if (!yymatchString(G, "DD")) goto l733;

  }
  l734:;	  if (!yy_Spnl(G))  goto l733;
  if (!yymatchChar(G, '>')) goto l733;
  yyprintf((stderr, "  ok   HtmlBlockCloseDd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l733:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseDd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenDd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenDd"));
  if (!yymatchChar(G, '<')) goto l736;
  if (!yy_Spnl(G))  goto l736;

  {  int yypos737= G->pos, yythunkpos737= G->thunkpos;  if (!yymatchString(G, "dd")) goto l738;
  goto l737;
  l738:;	  G->pos= yypos737; G->thunkpos= yythunkpos737;  if (!yymatchString(G, "DD")) goto l736;

  }
  l737:;	  if (!yy_Spnl(G))  goto l736;

  l739:;	
  {  int yypos740= G->pos, yythunkpos740= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l740;
  goto l739;
  l740:;	  G->pos= yypos740; G->thunkpos= yythunkpos740;
  }  if (!yymatchChar(G, '>')) goto l736;
  yyprintf((stderr, "  ok   HtmlBlockOpenDd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l736:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenDd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockVideo(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockVideo"));
  if (!yy_HtmlBlockOpenVideo(G))  goto l741;

  l742:;	
  {  int yypos743= G->pos, yythunkpos743= G->thunkpos;
  {  int yypos744= G->pos, yythunkpos744= G->thunkpos;  if (!yy_HtmlBlockVideo(G))  goto l745;
  goto l744;
  l745:;	  G->pos= yypos744; G->thunkpos= yythunkpos744;
  {  int yypos746= G->pos, yythunkpos746= G->thunkpos;  if (!yy_HtmlBlockCloseVideo(G))  goto l746;
  goto l743;
  l746:;	  G->pos= yypos746; G->thunkpos= yythunkpos746;
  }  if (!yymatchDot(G)) goto l743;
  }
  l744:;	  goto l742;
  l743:;	  G->pos= yypos743; G->thunkpos= yythunkpos743;
  }  if (!yy_HtmlBlockCloseVideo(G))  goto l741;
  yyprintf((stderr, "  ok   HtmlBlockVideo"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l741:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockVideo"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseVideo(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseVideo"));
  if (!yymatchChar(G, '<')) goto l747;
  if (!yy_Spnl(G))  goto l747;
  if (!yymatchChar(G, '/')) goto l747;

  {  int yypos748= G->pos, yythunkpos748= G->thunkpos;  if (!yymatchString(G, "video")) goto l749;
  goto l748;
  l749:;	  G->pos= yypos748; G->thunkpos= yythunkpos748;  if (!yymatchString(G, "VIDEO")) goto l747;

  }
  l748:;	  if (!yy_Spnl(G))  goto l747;
  if (!yymatchChar(G, '>')) goto l747;
  yyprintf((stderr, "  ok   HtmlBlockCloseVideo"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l747:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseVideo"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenVideo(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenVideo"));
  if (!yymatchChar(G, '<')) goto l750;
  if (!yy_Spnl(G))  goto l750;

  {  int yypos751= G->pos, yythunkpos751= G->thunkpos;  if (!yymatchString(G, "video")) goto l752;
  goto l751;
  l752:;	  G->pos= yypos751; G->thunkpos= yythunkpos751;  if (!yymatchString(G, "VIDEO")) goto l750;

  }
  l751:;	  if (!yy_Spnl(G))  goto l750;

  l753:;	
  {  int yypos754= G->pos, yythunkpos754= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l754;
  goto l753;
  l754:;	  G->pos= yypos754; G->thunkpos= yythunkpos754;
  }  if (!yymatchChar(G, '>')) goto l750;
  yyprintf((stderr, "  ok   HtmlBlockOpenVideo"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l750:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenVideo"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockUl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockUl"));
  if (!yy_HtmlBlockOpenUl(G))  goto l755;

  l756:;	
  {  int yypos757= G->pos, yythunkpos757= G->thunkpos;
  {  int yypos758= G->pos, yythunkpos758= G->thunkpos;  if (!yy_HtmlBlockUl(G))  goto l759;
  goto l758;
  l759:;	  G->pos= yypos758; G->thunkpos= yythunkpos758;
  {  int yypos760= G->pos, yythunkpos760= G->thunkpos;  if (!yy_HtmlBlockCloseUl(G))  goto l760;
  goto l757;
  l760:;	  G->pos= yypos760; G->thunkpos= yythunkpos760;
  }  if (!yymatchDot(G)) goto l757;
  }
  l758:;	  goto l756;
  l757:;	  G->pos= yypos757; G->thunkpos= yythunkpos757;
  }  if (!yy_HtmlBlockCloseUl(G))  goto l755;
  yyprintf((stderr, "  ok   HtmlBlockUl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l755:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockUl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseUl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseUl"));
  if (!yymatchChar(G, '<')) goto l761;
  if (!yy_Spnl(G))  goto l761;
  if (!yymatchChar(G, '/')) goto l761;

  {  int yypos762= G->pos, yythunkpos762= G->thunkpos;  if (!yymatchString(G, "ul")) goto l763;
  goto l762;
  l763:;	  G->pos= yypos762; G->thunkpos= yythunkpos762;  if (!yymatchString(G, "UL")) goto l761;

  }
  l762:;	  if (!yy_Spnl(G))  goto l761;
  if (!yymatchChar(G, '>')) goto l761;
  yyprintf((stderr, "  ok   HtmlBlockCloseUl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l761:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseUl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenUl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenUl"));
  if (!yymatchChar(G, '<')) goto l764;
  if (!yy_Spnl(G))  goto l764;

  {  int yypos765= G->pos, yythunkpos765= G->thunkpos;  if (!yymatchString(G, "ul")) goto l766;
  goto l765;
  l766:;	  G->pos= yypos765; G->thunkpos= yythunkpos765;  if (!yymatchString(G, "UL")) goto l764;

  }
  l765:;	  if (!yy_Spnl(G))  goto l764;

  l767:;	
  {  int yypos768= G->pos, yythunkpos768= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l768;
  goto l767;
  l768:;	  G->pos= yypos768; G->thunkpos= yythunkpos768;
  }  if (!yymatchChar(G, '>')) goto l764;
  yyprintf((stderr, "  ok   HtmlBlockOpenUl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l764:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenUl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockTable(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockTable"));
  if (!yy_HtmlBlockOpenTable(G))  goto l769;

  l770:;	
  {  int yypos771= G->pos, yythunkpos771= G->thunkpos;
  {  int yypos772= G->pos, yythunkpos772= G->thunkpos;  if (!yy_HtmlBlockTable(G))  goto l773;
  goto l772;
  l773:;	  G->pos= yypos772; G->thunkpos= yythunkpos772;
  {  int yypos774= G->pos, yythunkpos774= G->thunkpos;  if (!yy_HtmlBlockCloseTable(G))  goto l774;
  goto l771;
  l774:;	  G->pos= yypos774; G->thunkpos= yythunkpos774;
  }  if (!yymatchDot(G)) goto l771;
  }
  l772:;	  goto l770;
  l771:;	  G->pos= yypos771; G->thunkpos= yythunkpos771;
  }  if (!yy_HtmlBlockCloseTable(G))  goto l769;
  yyprintf((stderr, "  ok   HtmlBlockTable"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l769:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockTable"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseTable(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseTable"));
  if (!yymatchChar(G, '<')) goto l775;
  if (!yy_Spnl(G))  goto l775;
  if (!yymatchChar(G, '/')) goto l775;

  {  int yypos776= G->pos, yythunkpos776= G->thunkpos;  if (!yymatchString(G, "table")) goto l777;
  goto l776;
  l777:;	  G->pos= yypos776; G->thunkpos= yythunkpos776;  if (!yymatchString(G, "TABLE")) goto l775;

  }
  l776:;	  if (!yy_Spnl(G))  goto l775;
  if (!yymatchChar(G, '>')) goto l775;
  yyprintf((stderr, "  ok   HtmlBlockCloseTable"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l775:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseTable"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenTable(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenTable"));
  if (!yymatchChar(G, '<')) goto l778;
  if (!yy_Spnl(G))  goto l778;

  {  int yypos779= G->pos, yythunkpos779= G->thunkpos;  if (!yymatchString(G, "table")) goto l780;
  goto l779;
  l780:;	  G->pos= yypos779; G->thunkpos= yythunkpos779;  if (!yymatchString(G, "TABLE")) goto l778;

  }
  l779:;	  if (!yy_Spnl(G))  goto l778;

  l781:;	
  {  int yypos782= G->pos, yythunkpos782= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l782;
  goto l781;
  l782:;	  G->pos= yypos782; G->thunkpos= yythunkpos782;
  }  if (!yymatchChar(G, '>')) goto l778;
  yyprintf((stderr, "  ok   HtmlBlockOpenTable"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l778:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenTable"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockSection(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockSection"));
  if (!yy_HtmlBlockOpenSection(G))  goto l783;

  l784:;	
  {  int yypos785= G->pos, yythunkpos785= G->thunkpos;
  {  int yypos786= G->pos, yythunkpos786= G->thunkpos;  if (!yy_HtmlBlockSection(G))  goto l787;
  goto l786;
  l787:;	  G->pos= yypos786; G->thunkpos= yythunkpos786;
  {  int yypos788= G->pos, yythunkpos788= G->thunkpos;  if (!yy_HtmlBlockCloseSection(G))  goto l788;
  goto l785;
  l788:;	  G->pos= yypos788; G->thunkpos= yythunkpos788;
  }  if (!yymatchDot(G)) goto l785;
  }
  l786:;	  goto l784;
  l785:;	  G->pos= yypos785; G->thunkpos= yythunkpos785;
  }  if (!yy_HtmlBlockCloseSection(G))  goto l783;
  yyprintf((stderr, "  ok   HtmlBlockSection"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l783:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockSection"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseSection(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseSection"));
  if (!yymatchChar(G, '<')) goto l789;
  if (!yy_Spnl(G))  goto l789;
  if (!yymatchChar(G, '/')) goto l789;

  {  int yypos790= G->pos, yythunkpos790= G->thunkpos;  if (!yymatchString(G, "section")) goto l791;
  goto l790;
  l791:;	  G->pos= yypos790; G->thunkpos= yythunkpos790;  if (!yymatchString(G, "SECTION")) goto l789;

  }
  l790:;	  if (!yy_Spnl(G))  goto l789;
  if (!yymatchChar(G, '>')) goto l789;
  yyprintf((stderr, "  ok   HtmlBlockCloseSection"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l789:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseSection"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenSection(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenSection"));
  if (!yymatchChar(G, '<')) goto l792;
  if (!yy_Spnl(G))  goto l792;

  {  int yypos793= G->pos, yythunkpos793= G->thunkpos;  if (!yymatchString(G, "section")) goto l794;
  goto l793;
  l794:;	  G->pos= yypos793; G->thunkpos= yythunkpos793;  if (!yymatchString(G, "SECTION")) goto l792;

  }
  l793:;	  if (!yy_Spnl(G))  goto l792;

  l795:;	
  {  int yypos796= G->pos, yythunkpos796= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l796;
  goto l795;
  l796:;	  G->pos= yypos796; G->thunkpos= yythunkpos796;
  }  if (!yymatchChar(G, '>')) goto l792;
  yyprintf((stderr, "  ok   HtmlBlockOpenSection"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l792:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenSection"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockProgress(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockProgress"));
  if (!yy_HtmlBlockOpenProgress(G))  goto l797;

  l798:;	
  {  int yypos799= G->pos, yythunkpos799= G->thunkpos;
  {  int yypos800= G->pos, yythunkpos800= G->thunkpos;  if (!yy_HtmlBlockProgress(G))  goto l801;
  goto l800;
  l801:;	  G->pos= yypos800; G->thunkpos= yythunkpos800;
  {  int yypos802= G->pos, yythunkpos802= G->thunkpos;  if (!yy_HtmlBlockCloseProgress(G))  goto l802;
  goto l799;
  l802:;	  G->pos= yypos802; G->thunkpos= yythunkpos802;
  }  if (!yymatchDot(G)) goto l799;
  }
  l800:;	  goto l798;
  l799:;	  G->pos= yypos799; G->thunkpos= yythunkpos799;
  }  if (!yy_HtmlBlockCloseProgress(G))  goto l797;
  yyprintf((stderr, "  ok   HtmlBlockProgress"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l797:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockProgress"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseProgress(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseProgress"));
  if (!yymatchChar(G, '<')) goto l803;
  if (!yy_Spnl(G))  goto l803;
  if (!yymatchChar(G, '/')) goto l803;

  {  int yypos804= G->pos, yythunkpos804= G->thunkpos;  if (!yymatchString(G, "progress")) goto l805;
  goto l804;
  l805:;	  G->pos= yypos804; G->thunkpos= yythunkpos804;  if (!yymatchString(G, "PROGRESS")) goto l803;

  }
  l804:;	  if (!yy_Spnl(G))  goto l803;
  if (!yymatchChar(G, '>')) goto l803;
  yyprintf((stderr, "  ok   HtmlBlockCloseProgress"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l803:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseProgress"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenProgress(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenProgress"));
  if (!yymatchChar(G, '<')) goto l806;
  if (!yy_Spnl(G))  goto l806;

  {  int yypos807= G->pos, yythunkpos807= G->thunkpos;  if (!yymatchString(G, "progress")) goto l808;
  goto l807;
  l808:;	  G->pos= yypos807; G->thunkpos= yythunkpos807;  if (!yymatchString(G, "PROGRESS")) goto l806;

  }
  l807:;	  if (!yy_Spnl(G))  goto l806;

  l809:;	
  {  int yypos810= G->pos, yythunkpos810= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l810;
  goto l809;
  l810:;	  G->pos= yypos810; G->thunkpos= yythunkpos810;
  }  if (!yymatchChar(G, '>')) goto l806;
  yyprintf((stderr, "  ok   HtmlBlockOpenProgress"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l806:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenProgress"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockPre(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockPre"));
  if (!yy_HtmlBlockOpenPre(G))  goto l811;

  l812:;	
  {  int yypos813= G->pos, yythunkpos813= G->thunkpos;
  {  int yypos814= G->pos, yythunkpos814= G->thunkpos;  if (!yy_HtmlBlockPre(G))  goto l815;
  goto l814;
  l815:;	  G->pos= yypos814; G->thunkpos= yythunkpos814;
  {  int yypos816= G->pos, yythunkpos816= G->thunkpos;  if (!yy_HtmlBlockClosePre(G))  goto l816;
  goto l813;
  l816:;	  G->pos= yypos816; G->thunkpos= yythunkpos816;
  }  if (!yymatchDot(G)) goto l813;
  }
  l814:;	  goto l812;
  l813:;	  G->pos= yypos813; G->thunkpos= yythunkpos813;
  }  if (!yy_HtmlBlockClosePre(G))  goto l811;
  yyprintf((stderr, "  ok   HtmlBlockPre"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l811:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockPre"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockClosePre(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockClosePre"));
  if (!yymatchChar(G, '<')) goto l817;
  if (!yy_Spnl(G))  goto l817;
  if (!yymatchChar(G, '/')) goto l817;

  {  int yypos818= G->pos, yythunkpos818= G->thunkpos;  if (!yymatchString(G, "pre")) goto l819;
  goto l818;
  l819:;	  G->pos= yypos818; G->thunkpos= yythunkpos818;  if (!yymatchString(G, "PRE")) goto l817;

  }
  l818:;	  if (!yy_Spnl(G))  goto l817;
  if (!yymatchChar(G, '>')) goto l817;
  yyprintf((stderr, "  ok   HtmlBlockClosePre"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l817:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockClosePre"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenPre(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenPre"));
  if (!yymatchChar(G, '<')) goto l820;
  if (!yy_Spnl(G))  goto l820;

  {  int yypos821= G->pos, yythunkpos821= G->thunkpos;  if (!yymatchString(G, "pre")) goto l822;
  goto l821;
  l822:;	  G->pos= yypos821; G->thunkpos= yythunkpos821;  if (!yymatchString(G, "PRE")) goto l820;

  }
  l821:;	  if (!yy_Spnl(G))  goto l820;

  l823:;	
  {  int yypos824= G->pos, yythunkpos824= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l824;
  goto l823;
  l824:;	  G->pos= yypos824; G->thunkpos= yythunkpos824;
  }  if (!yymatchChar(G, '>')) goto l820;
  yyprintf((stderr, "  ok   HtmlBlockOpenPre"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l820:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenPre"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockP(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockP"));
  if (!yy_HtmlBlockOpenP(G))  goto l825;

  l826:;	
  {  int yypos827= G->pos, yythunkpos827= G->thunkpos;
  {  int yypos828= G->pos, yythunkpos828= G->thunkpos;  if (!yy_HtmlBlockP(G))  goto l829;
  goto l828;
  l829:;	  G->pos= yypos828; G->thunkpos= yythunkpos828;
  {  int yypos830= G->pos, yythunkpos830= G->thunkpos;  if (!yy_HtmlBlockCloseP(G))  goto l830;
  goto l827;
  l830:;	  G->pos= yypos830; G->thunkpos= yythunkpos830;
  }  if (!yymatchDot(G)) goto l827;
  }
  l828:;	  goto l826;
  l827:;	  G->pos= yypos827; G->thunkpos= yythunkpos827;
  }  if (!yy_HtmlBlockCloseP(G))  goto l825;
  yyprintf((stderr, "  ok   HtmlBlockP"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l825:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockP"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseP(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseP"));
  if (!yymatchChar(G, '<')) goto l831;
  if (!yy_Spnl(G))  goto l831;
  if (!yymatchChar(G, '/')) goto l831;

  {  int yypos832= G->pos, yythunkpos832= G->thunkpos;  if (!yymatchChar(G, 'p')) goto l833;
  goto l832;
  l833:;	  G->pos= yypos832; G->thunkpos= yythunkpos832;  if (!yymatchChar(G, 'P')) goto l831;

  }
  l832:;	  if (!yy_Spnl(G))  goto l831;
  if (!yymatchChar(G, '>')) goto l831;
  yyprintf((stderr, "  ok   HtmlBlockCloseP"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l831:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseP"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenP(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenP"));
  if (!yymatchChar(G, '<')) goto l834;
  if (!yy_Spnl(G))  goto l834;

  {  int yypos835= G->pos, yythunkpos835= G->thunkpos;  if (!yymatchChar(G, 'p')) goto l836;
  goto l835;
  l836:;	  G->pos= yypos835; G->thunkpos= yythunkpos835;  if (!yymatchChar(G, 'P')) goto l834;

  }
  l835:;	  if (!yy_Spnl(G))  goto l834;

  l837:;	
  {  int yypos838= G->pos, yythunkpos838= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l838;
  goto l837;
  l838:;	  G->pos= yypos838; G->thunkpos= yythunkpos838;
  }  if (!yymatchChar(G, '>')) goto l834;
  yyprintf((stderr, "  ok   HtmlBlockOpenP"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l834:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenP"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOl"));
  if (!yy_HtmlBlockOpenOl(G))  goto l839;

  l840:;	
  {  int yypos841= G->pos, yythunkpos841= G->thunkpos;
  {  int yypos842= G->pos, yythunkpos842= G->thunkpos;  if (!yy_HtmlBlockOl(G))  goto l843;
  goto l842;
  l843:;	  G->pos= yypos842; G->thunkpos= yythunkpos842;
  {  int yypos844= G->pos, yythunkpos844= G->thunkpos;  if (!yy_HtmlBlockCloseOl(G))  goto l844;
  goto l841;
  l844:;	  G->pos= yypos844; G->thunkpos= yythunkpos844;
  }  if (!yymatchDot(G)) goto l841;
  }
  l842:;	  goto l840;
  l841:;	  G->pos= yypos841; G->thunkpos= yythunkpos841;
  }  if (!yy_HtmlBlockCloseOl(G))  goto l839;
  yyprintf((stderr, "  ok   HtmlBlockOl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l839:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseOl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseOl"));
  if (!yymatchChar(G, '<')) goto l845;
  if (!yy_Spnl(G))  goto l845;
  if (!yymatchChar(G, '/')) goto l845;

  {  int yypos846= G->pos, yythunkpos846= G->thunkpos;  if (!yymatchString(G, "ol")) goto l847;
  goto l846;
  l847:;	  G->pos= yypos846; G->thunkpos= yythunkpos846;  if (!yymatchString(G, "OL")) goto l845;

  }
  l846:;	  if (!yy_Spnl(G))  goto l845;
  if (!yymatchChar(G, '>')) goto l845;
  yyprintf((stderr, "  ok   HtmlBlockCloseOl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l845:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseOl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenOl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenOl"));
  if (!yymatchChar(G, '<')) goto l848;
  if (!yy_Spnl(G))  goto l848;

  {  int yypos849= G->pos, yythunkpos849= G->thunkpos;  if (!yymatchString(G, "ol")) goto l850;
  goto l849;
  l850:;	  G->pos= yypos849; G->thunkpos= yythunkpos849;  if (!yymatchString(G, "OL")) goto l848;

  }
  l849:;	  if (!yy_Spnl(G))  goto l848;

  l851:;	
  {  int yypos852= G->pos, yythunkpos852= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l852;
  goto l851;
  l852:;	  G->pos= yypos852; G->thunkpos= yythunkpos852;
  }  if (!yymatchChar(G, '>')) goto l848;
  yyprintf((stderr, "  ok   HtmlBlockOpenOl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l848:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenOl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockNoscript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockNoscript"));
  if (!yy_HtmlBlockOpenNoscript(G))  goto l853;

  l854:;	
  {  int yypos855= G->pos, yythunkpos855= G->thunkpos;
  {  int yypos856= G->pos, yythunkpos856= G->thunkpos;  if (!yy_HtmlBlockNoscript(G))  goto l857;
  goto l856;
  l857:;	  G->pos= yypos856; G->thunkpos= yythunkpos856;
  {  int yypos858= G->pos, yythunkpos858= G->thunkpos;  if (!yy_HtmlBlockCloseNoscript(G))  goto l858;
  goto l855;
  l858:;	  G->pos= yypos858; G->thunkpos= yythunkpos858;
  }  if (!yymatchDot(G)) goto l855;
  }
  l856:;	  goto l854;
  l855:;	  G->pos= yypos855; G->thunkpos= yythunkpos855;
  }  if (!yy_HtmlBlockCloseNoscript(G))  goto l853;
  yyprintf((stderr, "  ok   HtmlBlockNoscript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l853:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockNoscript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseNoscript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseNoscript"));
  if (!yymatchChar(G, '<')) goto l859;
  if (!yy_Spnl(G))  goto l859;
  if (!yymatchChar(G, '/')) goto l859;

  {  int yypos860= G->pos, yythunkpos860= G->thunkpos;  if (!yymatchString(G, "noscript")) goto l861;
  goto l860;
  l861:;	  G->pos= yypos860; G->thunkpos= yythunkpos860;  if (!yymatchString(G, "NOSCRIPT")) goto l859;

  }
  l860:;	  if (!yy_Spnl(G))  goto l859;
  if (!yymatchChar(G, '>')) goto l859;
  yyprintf((stderr, "  ok   HtmlBlockCloseNoscript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l859:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseNoscript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenNoscript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenNoscript"));
  if (!yymatchChar(G, '<')) goto l862;
  if (!yy_Spnl(G))  goto l862;

  {  int yypos863= G->pos, yythunkpos863= G->thunkpos;  if (!yymatchString(G, "noscript")) goto l864;
  goto l863;
  l864:;	  G->pos= yypos863; G->thunkpos= yythunkpos863;  if (!yymatchString(G, "NOSCRIPT")) goto l862;

  }
  l863:;	  if (!yy_Spnl(G))  goto l862;

  l865:;	
  {  int yypos866= G->pos, yythunkpos866= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l866;
  goto l865;
  l866:;	  G->pos= yypos866; G->thunkpos= yythunkpos866;
  }  if (!yymatchChar(G, '>')) goto l862;
  yyprintf((stderr, "  ok   HtmlBlockOpenNoscript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l862:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenNoscript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockNoframes(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockNoframes"));
  if (!yy_HtmlBlockOpenNoframes(G))  goto l867;

  l868:;	
  {  int yypos869= G->pos, yythunkpos869= G->thunkpos;
  {  int yypos870= G->pos, yythunkpos870= G->thunkpos;  if (!yy_HtmlBlockNoframes(G))  goto l871;
  goto l870;
  l871:;	  G->pos= yypos870; G->thunkpos= yythunkpos870;
  {  int yypos872= G->pos, yythunkpos872= G->thunkpos;  if (!yy_HtmlBlockCloseNoframes(G))  goto l872;
  goto l869;
  l872:;	  G->pos= yypos872; G->thunkpos= yythunkpos872;
  }  if (!yymatchDot(G)) goto l869;
  }
  l870:;	  goto l868;
  l869:;	  G->pos= yypos869; G->thunkpos= yythunkpos869;
  }  if (!yy_HtmlBlockCloseNoframes(G))  goto l867;
  yyprintf((stderr, "  ok   HtmlBlockNoframes"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l867:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockNoframes"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseNoframes(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseNoframes"));
  if (!yymatchChar(G, '<')) goto l873;
  if (!yy_Spnl(G))  goto l873;
  if (!yymatchChar(G, '/')) goto l873;

  {  int yypos874= G->pos, yythunkpos874= G->thunkpos;  if (!yymatchString(G, "noframes")) goto l875;
  goto l874;
  l875:;	  G->pos= yypos874; G->thunkpos= yythunkpos874;  if (!yymatchString(G, "NOFRAMES")) goto l873;

  }
  l874:;	  if (!yy_Spnl(G))  goto l873;
  if (!yymatchChar(G, '>')) goto l873;
  yyprintf((stderr, "  ok   HtmlBlockCloseNoframes"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l873:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseNoframes"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenNoframes(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenNoframes"));
  if (!yymatchChar(G, '<')) goto l876;
  if (!yy_Spnl(G))  goto l876;

  {  int yypos877= G->pos, yythunkpos877= G->thunkpos;  if (!yymatchString(G, "noframes")) goto l878;
  goto l877;
  l878:;	  G->pos= yypos877; G->thunkpos= yythunkpos877;  if (!yymatchString(G, "NOFRAMES")) goto l876;

  }
  l877:;	  if (!yy_Spnl(G))  goto l876;

  l879:;	
  {  int yypos880= G->pos, yythunkpos880= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l880;
  goto l879;
  l880:;	  G->pos= yypos880; G->thunkpos= yythunkpos880;
  }  if (!yymatchChar(G, '>')) goto l876;
  yyprintf((stderr, "  ok   HtmlBlockOpenNoframes"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l876:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenNoframes"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockMenu(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockMenu"));
  if (!yy_HtmlBlockOpenMenu(G))  goto l881;

  l882:;	
  {  int yypos883= G->pos, yythunkpos883= G->thunkpos;
  {  int yypos884= G->pos, yythunkpos884= G->thunkpos;  if (!yy_HtmlBlockMenu(G))  goto l885;
  goto l884;
  l885:;	  G->pos= yypos884; G->thunkpos= yythunkpos884;
  {  int yypos886= G->pos, yythunkpos886= G->thunkpos;  if (!yy_HtmlBlockCloseMenu(G))  goto l886;
  goto l883;
  l886:;	  G->pos= yypos886; G->thunkpos= yythunkpos886;
  }  if (!yymatchDot(G)) goto l883;
  }
  l884:;	  goto l882;
  l883:;	  G->pos= yypos883; G->thunkpos= yythunkpos883;
  }  if (!yy_HtmlBlockCloseMenu(G))  goto l881;
  yyprintf((stderr, "  ok   HtmlBlockMenu"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l881:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockMenu"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseMenu(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseMenu"));
  if (!yymatchChar(G, '<')) goto l887;
  if (!yy_Spnl(G))  goto l887;
  if (!yymatchChar(G, '/')) goto l887;

  {  int yypos888= G->pos, yythunkpos888= G->thunkpos;  if (!yymatchString(G, "menu")) goto l889;
  goto l888;
  l889:;	  G->pos= yypos888; G->thunkpos= yythunkpos888;  if (!yymatchString(G, "MENU")) goto l887;

  }
  l888:;	  if (!yy_Spnl(G))  goto l887;
  if (!yymatchChar(G, '>')) goto l887;
  yyprintf((stderr, "  ok   HtmlBlockCloseMenu"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l887:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseMenu"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenMenu(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenMenu"));
  if (!yymatchChar(G, '<')) goto l890;
  if (!yy_Spnl(G))  goto l890;

  {  int yypos891= G->pos, yythunkpos891= G->thunkpos;  if (!yymatchString(G, "menu")) goto l892;
  goto l891;
  l892:;	  G->pos= yypos891; G->thunkpos= yythunkpos891;  if (!yymatchString(G, "MENU")) goto l890;

  }
  l891:;	  if (!yy_Spnl(G))  goto l890;

  l893:;	
  {  int yypos894= G->pos, yythunkpos894= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l894;
  goto l893;
  l894:;	  G->pos= yypos894; G->thunkpos= yythunkpos894;
  }  if (!yymatchChar(G, '>')) goto l890;
  yyprintf((stderr, "  ok   HtmlBlockOpenMenu"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l890:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenMenu"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockH6(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockH6"));
  if (!yy_HtmlBlockOpenH6(G))  goto l895;

  l896:;	
  {  int yypos897= G->pos, yythunkpos897= G->thunkpos;
  {  int yypos898= G->pos, yythunkpos898= G->thunkpos;  if (!yy_HtmlBlockH6(G))  goto l899;
  goto l898;
  l899:;	  G->pos= yypos898; G->thunkpos= yythunkpos898;
  {  int yypos900= G->pos, yythunkpos900= G->thunkpos;  if (!yy_HtmlBlockCloseH6(G))  goto l900;
  goto l897;
  l900:;	  G->pos= yypos900; G->thunkpos= yythunkpos900;
  }  if (!yymatchDot(G)) goto l897;
  }
  l898:;	  goto l896;
  l897:;	  G->pos= yypos897; G->thunkpos= yythunkpos897;
  }  if (!yy_HtmlBlockCloseH6(G))  goto l895;
  yyprintf((stderr, "  ok   HtmlBlockH6"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l895:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockH6"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseH6(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseH6"));
  if (!yymatchChar(G, '<')) goto l901;
  if (!yy_Spnl(G))  goto l901;
  if (!yymatchChar(G, '/')) goto l901;

  {  int yypos902= G->pos, yythunkpos902= G->thunkpos;  if (!yymatchString(G, "h6")) goto l903;
  goto l902;
  l903:;	  G->pos= yypos902; G->thunkpos= yythunkpos902;  if (!yymatchString(G, "H6")) goto l901;

  }
  l902:;	  if (!yy_Spnl(G))  goto l901;
  if (!yymatchChar(G, '>')) goto l901;
  yyprintf((stderr, "  ok   HtmlBlockCloseH6"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l901:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseH6"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenH6(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenH6"));
  if (!yymatchChar(G, '<')) goto l904;
  if (!yy_Spnl(G))  goto l904;

  {  int yypos905= G->pos, yythunkpos905= G->thunkpos;  if (!yymatchString(G, "h6")) goto l906;
  goto l905;
  l906:;	  G->pos= yypos905; G->thunkpos= yythunkpos905;  if (!yymatchString(G, "H6")) goto l904;

  }
  l905:;	  if (!yy_Spnl(G))  goto l904;

  l907:;	
  {  int yypos908= G->pos, yythunkpos908= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l908;
  goto l907;
  l908:;	  G->pos= yypos908; G->thunkpos= yythunkpos908;
  }  if (!yymatchChar(G, '>')) goto l904;
  yyprintf((stderr, "  ok   HtmlBlockOpenH6"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l904:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenH6"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockH5(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockH5"));
  if (!yy_HtmlBlockOpenH5(G))  goto l909;

  l910:;	
  {  int yypos911= G->pos, yythunkpos911= G->thunkpos;
  {  int yypos912= G->pos, yythunkpos912= G->thunkpos;  if (!yy_HtmlBlockH5(G))  goto l913;
  goto l912;
  l913:;	  G->pos= yypos912; G->thunkpos= yythunkpos912;
  {  int yypos914= G->pos, yythunkpos914= G->thunkpos;  if (!yy_HtmlBlockCloseH5(G))  goto l914;
  goto l911;
  l914:;	  G->pos= yypos914; G->thunkpos= yythunkpos914;
  }  if (!yymatchDot(G)) goto l911;
  }
  l912:;	  goto l910;
  l911:;	  G->pos= yypos911; G->thunkpos= yythunkpos911;
  }  if (!yy_HtmlBlockCloseH5(G))  goto l909;
  yyprintf((stderr, "  ok   HtmlBlockH5"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l909:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockH5"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseH5(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseH5"));
  if (!yymatchChar(G, '<')) goto l915;
  if (!yy_Spnl(G))  goto l915;
  if (!yymatchChar(G, '/')) goto l915;

  {  int yypos916= G->pos, yythunkpos916= G->thunkpos;  if (!yymatchString(G, "h5")) goto l917;
  goto l916;
  l917:;	  G->pos= yypos916; G->thunkpos= yythunkpos916;  if (!yymatchString(G, "H5")) goto l915;

  }
  l916:;	  if (!yy_Spnl(G))  goto l915;
  if (!yymatchChar(G, '>')) goto l915;
  yyprintf((stderr, "  ok   HtmlBlockCloseH5"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l915:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseH5"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenH5(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenH5"));
  if (!yymatchChar(G, '<')) goto l918;
  if (!yy_Spnl(G))  goto l918;

  {  int yypos919= G->pos, yythunkpos919= G->thunkpos;  if (!yymatchString(G, "h5")) goto l920;
  goto l919;
  l920:;	  G->pos= yypos919; G->thunkpos= yythunkpos919;  if (!yymatchString(G, "H5")) goto l918;

  }
  l919:;	  if (!yy_Spnl(G))  goto l918;

  l921:;	
  {  int yypos922= G->pos, yythunkpos922= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l922;
  goto l921;
  l922:;	  G->pos= yypos922; G->thunkpos= yythunkpos922;
  }  if (!yymatchChar(G, '>')) goto l918;
  yyprintf((stderr, "  ok   HtmlBlockOpenH5"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l918:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenH5"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockH4(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockH4"));
  if (!yy_HtmlBlockOpenH4(G))  goto l923;

  l924:;	
  {  int yypos925= G->pos, yythunkpos925= G->thunkpos;
  {  int yypos926= G->pos, yythunkpos926= G->thunkpos;  if (!yy_HtmlBlockH4(G))  goto l927;
  goto l926;
  l927:;	  G->pos= yypos926; G->thunkpos= yythunkpos926;
  {  int yypos928= G->pos, yythunkpos928= G->thunkpos;  if (!yy_HtmlBlockCloseH4(G))  goto l928;
  goto l925;
  l928:;	  G->pos= yypos928; G->thunkpos= yythunkpos928;
  }  if (!yymatchDot(G)) goto l925;
  }
  l926:;	  goto l924;
  l925:;	  G->pos= yypos925; G->thunkpos= yythunkpos925;
  }  if (!yy_HtmlBlockCloseH4(G))  goto l923;
  yyprintf((stderr, "  ok   HtmlBlockH4"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l923:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockH4"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseH4(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseH4"));
  if (!yymatchChar(G, '<')) goto l929;
  if (!yy_Spnl(G))  goto l929;
  if (!yymatchChar(G, '/')) goto l929;

  {  int yypos930= G->pos, yythunkpos930= G->thunkpos;  if (!yymatchString(G, "h4")) goto l931;
  goto l930;
  l931:;	  G->pos= yypos930; G->thunkpos= yythunkpos930;  if (!yymatchString(G, "H4")) goto l929;

  }
  l930:;	  if (!yy_Spnl(G))  goto l929;
  if (!yymatchChar(G, '>')) goto l929;
  yyprintf((stderr, "  ok   HtmlBlockCloseH4"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l929:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseH4"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenH4(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenH4"));
  if (!yymatchChar(G, '<')) goto l932;
  if (!yy_Spnl(G))  goto l932;

  {  int yypos933= G->pos, yythunkpos933= G->thunkpos;  if (!yymatchString(G, "h4")) goto l934;
  goto l933;
  l934:;	  G->pos= yypos933; G->thunkpos= yythunkpos933;  if (!yymatchString(G, "H4")) goto l932;

  }
  l933:;	  if (!yy_Spnl(G))  goto l932;

  l935:;	
  {  int yypos936= G->pos, yythunkpos936= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l936;
  goto l935;
  l936:;	  G->pos= yypos936; G->thunkpos= yythunkpos936;
  }  if (!yymatchChar(G, '>')) goto l932;
  yyprintf((stderr, "  ok   HtmlBlockOpenH4"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l932:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenH4"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockH3(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockH3"));
  if (!yy_HtmlBlockOpenH3(G))  goto l937;

  l938:;	
  {  int yypos939= G->pos, yythunkpos939= G->thunkpos;
  {  int yypos940= G->pos, yythunkpos940= G->thunkpos;  if (!yy_HtmlBlockH3(G))  goto l941;
  goto l940;
  l941:;	  G->pos= yypos940; G->thunkpos= yythunkpos940;
  {  int yypos942= G->pos, yythunkpos942= G->thunkpos;  if (!yy_HtmlBlockCloseH3(G))  goto l942;
  goto l939;
  l942:;	  G->pos= yypos942; G->thunkpos= yythunkpos942;
  }  if (!yymatchDot(G)) goto l939;
  }
  l940:;	  goto l938;
  l939:;	  G->pos= yypos939; G->thunkpos= yythunkpos939;
  }  if (!yy_HtmlBlockCloseH3(G))  goto l937;
  yyprintf((stderr, "  ok   HtmlBlockH3"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l937:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockH3"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseH3(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseH3"));
  if (!yymatchChar(G, '<')) goto l943;
  if (!yy_Spnl(G))  goto l943;
  if (!yymatchChar(G, '/')) goto l943;

  {  int yypos944= G->pos, yythunkpos944= G->thunkpos;  if (!yymatchString(G, "h3")) goto l945;
  goto l944;
  l945:;	  G->pos= yypos944; G->thunkpos= yythunkpos944;  if (!yymatchString(G, "H3")) goto l943;

  }
  l944:;	  if (!yy_Spnl(G))  goto l943;
  if (!yymatchChar(G, '>')) goto l943;
  yyprintf((stderr, "  ok   HtmlBlockCloseH3"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l943:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseH3"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenH3(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenH3"));
  if (!yymatchChar(G, '<')) goto l946;
  if (!yy_Spnl(G))  goto l946;

  {  int yypos947= G->pos, yythunkpos947= G->thunkpos;  if (!yymatchString(G, "h3")) goto l948;
  goto l947;
  l948:;	  G->pos= yypos947; G->thunkpos= yythunkpos947;  if (!yymatchString(G, "H3")) goto l946;

  }
  l947:;	  if (!yy_Spnl(G))  goto l946;

  l949:;	
  {  int yypos950= G->pos, yythunkpos950= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l950;
  goto l949;
  l950:;	  G->pos= yypos950; G->thunkpos= yythunkpos950;
  }  if (!yymatchChar(G, '>')) goto l946;
  yyprintf((stderr, "  ok   HtmlBlockOpenH3"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l946:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenH3"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockH2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockH2"));
  if (!yy_HtmlBlockOpenH2(G))  goto l951;

  l952:;	
  {  int yypos953= G->pos, yythunkpos953= G->thunkpos;
  {  int yypos954= G->pos, yythunkpos954= G->thunkpos;  if (!yy_HtmlBlockH2(G))  goto l955;
  goto l954;
  l955:;	  G->pos= yypos954; G->thunkpos= yythunkpos954;
  {  int yypos956= G->pos, yythunkpos956= G->thunkpos;  if (!yy_HtmlBlockCloseH2(G))  goto l956;
  goto l953;
  l956:;	  G->pos= yypos956; G->thunkpos= yythunkpos956;
  }  if (!yymatchDot(G)) goto l953;
  }
  l954:;	  goto l952;
  l953:;	  G->pos= yypos953; G->thunkpos= yythunkpos953;
  }  if (!yy_HtmlBlockCloseH2(G))  goto l951;
  yyprintf((stderr, "  ok   HtmlBlockH2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l951:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockH2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseH2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseH2"));
  if (!yymatchChar(G, '<')) goto l957;
  if (!yy_Spnl(G))  goto l957;
  if (!yymatchChar(G, '/')) goto l957;

  {  int yypos958= G->pos, yythunkpos958= G->thunkpos;  if (!yymatchString(G, "h2")) goto l959;
  goto l958;
  l959:;	  G->pos= yypos958; G->thunkpos= yythunkpos958;  if (!yymatchString(G, "H2")) goto l957;

  }
  l958:;	  if (!yy_Spnl(G))  goto l957;
  if (!yymatchChar(G, '>')) goto l957;
  yyprintf((stderr, "  ok   HtmlBlockCloseH2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l957:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseH2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenH2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenH2"));
  if (!yymatchChar(G, '<')) goto l960;
  if (!yy_Spnl(G))  goto l960;

  {  int yypos961= G->pos, yythunkpos961= G->thunkpos;  if (!yymatchString(G, "h2")) goto l962;
  goto l961;
  l962:;	  G->pos= yypos961; G->thunkpos= yythunkpos961;  if (!yymatchString(G, "H2")) goto l960;

  }
  l961:;	  if (!yy_Spnl(G))  goto l960;

  l963:;	
  {  int yypos964= G->pos, yythunkpos964= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l964;
  goto l963;
  l964:;	  G->pos= yypos964; G->thunkpos= yythunkpos964;
  }  if (!yymatchChar(G, '>')) goto l960;
  yyprintf((stderr, "  ok   HtmlBlockOpenH2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l960:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenH2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockH1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockH1"));
  if (!yy_HtmlBlockOpenH1(G))  goto l965;

  l966:;	
  {  int yypos967= G->pos, yythunkpos967= G->thunkpos;
  {  int yypos968= G->pos, yythunkpos968= G->thunkpos;  if (!yy_HtmlBlockH1(G))  goto l969;
  goto l968;
  l969:;	  G->pos= yypos968; G->thunkpos= yythunkpos968;
  {  int yypos970= G->pos, yythunkpos970= G->thunkpos;  if (!yy_HtmlBlockCloseH1(G))  goto l970;
  goto l967;
  l970:;	  G->pos= yypos970; G->thunkpos= yythunkpos970;
  }  if (!yymatchDot(G)) goto l967;
  }
  l968:;	  goto l966;
  l967:;	  G->pos= yypos967; G->thunkpos= yythunkpos967;
  }  if (!yy_HtmlBlockCloseH1(G))  goto l965;
  yyprintf((stderr, "  ok   HtmlBlockH1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l965:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockH1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseH1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseH1"));
  if (!yymatchChar(G, '<')) goto l971;
  if (!yy_Spnl(G))  goto l971;
  if (!yymatchChar(G, '/')) goto l971;

  {  int yypos972= G->pos, yythunkpos972= G->thunkpos;  if (!yymatchString(G, "h1")) goto l973;
  goto l972;
  l973:;	  G->pos= yypos972; G->thunkpos= yythunkpos972;  if (!yymatchString(G, "H1")) goto l971;

  }
  l972:;	  if (!yy_Spnl(G))  goto l971;
  if (!yymatchChar(G, '>')) goto l971;
  yyprintf((stderr, "  ok   HtmlBlockCloseH1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l971:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseH1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenH1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenH1"));
  if (!yymatchChar(G, '<')) goto l974;
  if (!yy_Spnl(G))  goto l974;

  {  int yypos975= G->pos, yythunkpos975= G->thunkpos;  if (!yymatchString(G, "h1")) goto l976;
  goto l975;
  l976:;	  G->pos= yypos975; G->thunkpos= yythunkpos975;  if (!yymatchString(G, "H1")) goto l974;

  }
  l975:;	  if (!yy_Spnl(G))  goto l974;

  l977:;	
  {  int yypos978= G->pos, yythunkpos978= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l978;
  goto l977;
  l978:;	  G->pos= yypos978; G->thunkpos= yythunkpos978;
  }  if (!yymatchChar(G, '>')) goto l974;
  yyprintf((stderr, "  ok   HtmlBlockOpenH1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l974:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenH1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockHgroup(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockHgroup"));
  if (!yy_HtmlBlockOpenHgroup(G))  goto l979;

  l980:;	
  {  int yypos981= G->pos, yythunkpos981= G->thunkpos;
  {  int yypos982= G->pos, yythunkpos982= G->thunkpos;  if (!yy_HtmlBlockHgroup(G))  goto l983;
  goto l982;
  l983:;	  G->pos= yypos982; G->thunkpos= yythunkpos982;
  {  int yypos984= G->pos, yythunkpos984= G->thunkpos;  if (!yy_HtmlBlockCloseHgroup(G))  goto l984;
  goto l981;
  l984:;	  G->pos= yypos984; G->thunkpos= yythunkpos984;
  }  if (!yymatchDot(G)) goto l981;
  }
  l982:;	  goto l980;
  l981:;	  G->pos= yypos981; G->thunkpos= yythunkpos981;
  }  if (!yy_HtmlBlockCloseHgroup(G))  goto l979;
  yyprintf((stderr, "  ok   HtmlBlockHgroup"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l979:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockHgroup"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseHgroup(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseHgroup"));
  if (!yymatchChar(G, '<')) goto l985;
  if (!yy_Spnl(G))  goto l985;
  if (!yymatchChar(G, '/')) goto l985;

  {  int yypos986= G->pos, yythunkpos986= G->thunkpos;  if (!yymatchString(G, "hgroup")) goto l987;
  goto l986;
  l987:;	  G->pos= yypos986; G->thunkpos= yythunkpos986;  if (!yymatchString(G, "HGROUP")) goto l985;

  }
  l986:;	  if (!yy_Spnl(G))  goto l985;
  if (!yymatchChar(G, '>')) goto l985;
  yyprintf((stderr, "  ok   HtmlBlockCloseHgroup"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l985:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseHgroup"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenHgroup(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenHgroup"));
  if (!yymatchChar(G, '<')) goto l988;
  if (!yy_Spnl(G))  goto l988;

  {  int yypos989= G->pos, yythunkpos989= G->thunkpos;  if (!yymatchString(G, "hgroup")) goto l990;
  goto l989;
  l990:;	  G->pos= yypos989; G->thunkpos= yythunkpos989;  if (!yymatchString(G, "HGROUP")) goto l988;

  }
  l989:;	  if (!yy_Spnl(G))  goto l988;

  l991:;	
  {  int yypos992= G->pos, yythunkpos992= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l992;
  goto l991;
  l992:;	  G->pos= yypos992; G->thunkpos= yythunkpos992;
  }  if (!yymatchChar(G, '>')) goto l988;
  yyprintf((stderr, "  ok   HtmlBlockOpenHgroup"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l988:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenHgroup"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockHeader(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockHeader"));
  if (!yy_HtmlBlockOpenHeader(G))  goto l993;

  l994:;	
  {  int yypos995= G->pos, yythunkpos995= G->thunkpos;
  {  int yypos996= G->pos, yythunkpos996= G->thunkpos;  if (!yy_HtmlBlockHeader(G))  goto l997;
  goto l996;
  l997:;	  G->pos= yypos996; G->thunkpos= yythunkpos996;
  {  int yypos998= G->pos, yythunkpos998= G->thunkpos;  if (!yy_HtmlBlockCloseHeader(G))  goto l998;
  goto l995;
  l998:;	  G->pos= yypos998; G->thunkpos= yythunkpos998;
  }  if (!yymatchDot(G)) goto l995;
  }
  l996:;	  goto l994;
  l995:;	  G->pos= yypos995; G->thunkpos= yythunkpos995;
  }  if (!yy_HtmlBlockCloseHeader(G))  goto l993;
  yyprintf((stderr, "  ok   HtmlBlockHeader"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l993:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockHeader"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseHeader(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseHeader"));
  if (!yymatchChar(G, '<')) goto l999;
  if (!yy_Spnl(G))  goto l999;
  if (!yymatchChar(G, '/')) goto l999;

  {  int yypos1000= G->pos, yythunkpos1000= G->thunkpos;  if (!yymatchString(G, "header")) goto l1001;
  goto l1000;
  l1001:;	  G->pos= yypos1000; G->thunkpos= yythunkpos1000;  if (!yymatchString(G, "HEADER")) goto l999;

  }
  l1000:;	  if (!yy_Spnl(G))  goto l999;
  if (!yymatchChar(G, '>')) goto l999;
  yyprintf((stderr, "  ok   HtmlBlockCloseHeader"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l999:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseHeader"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenHeader(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenHeader"));
  if (!yymatchChar(G, '<')) goto l1002;
  if (!yy_Spnl(G))  goto l1002;

  {  int yypos1003= G->pos, yythunkpos1003= G->thunkpos;  if (!yymatchString(G, "header")) goto l1004;
  goto l1003;
  l1004:;	  G->pos= yypos1003; G->thunkpos= yythunkpos1003;  if (!yymatchString(G, "HEADER")) goto l1002;

  }
  l1003:;	  if (!yy_Spnl(G))  goto l1002;

  l1005:;	
  {  int yypos1006= G->pos, yythunkpos1006= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1006;
  goto l1005;
  l1006:;	  G->pos= yypos1006; G->thunkpos= yythunkpos1006;
  }  if (!yymatchChar(G, '>')) goto l1002;
  yyprintf((stderr, "  ok   HtmlBlockOpenHeader"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1002:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenHeader"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockForm(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockForm"));
  if (!yy_HtmlBlockOpenForm(G))  goto l1007;

  l1008:;	
  {  int yypos1009= G->pos, yythunkpos1009= G->thunkpos;
  {  int yypos1010= G->pos, yythunkpos1010= G->thunkpos;  if (!yy_HtmlBlockForm(G))  goto l1011;
  goto l1010;
  l1011:;	  G->pos= yypos1010; G->thunkpos= yythunkpos1010;
  {  int yypos1012= G->pos, yythunkpos1012= G->thunkpos;  if (!yy_HtmlBlockCloseForm(G))  goto l1012;
  goto l1009;
  l1012:;	  G->pos= yypos1012; G->thunkpos= yythunkpos1012;
  }  if (!yymatchDot(G)) goto l1009;
  }
  l1010:;	  goto l1008;
  l1009:;	  G->pos= yypos1009; G->thunkpos= yythunkpos1009;
  }  if (!yy_HtmlBlockCloseForm(G))  goto l1007;
  yyprintf((stderr, "  ok   HtmlBlockForm"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1007:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockForm"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseForm(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseForm"));
  if (!yymatchChar(G, '<')) goto l1013;
  if (!yy_Spnl(G))  goto l1013;
  if (!yymatchChar(G, '/')) goto l1013;

  {  int yypos1014= G->pos, yythunkpos1014= G->thunkpos;  if (!yymatchString(G, "form")) goto l1015;
  goto l1014;
  l1015:;	  G->pos= yypos1014; G->thunkpos= yythunkpos1014;  if (!yymatchString(G, "FORM")) goto l1013;

  }
  l1014:;	  if (!yy_Spnl(G))  goto l1013;
  if (!yymatchChar(G, '>')) goto l1013;
  yyprintf((stderr, "  ok   HtmlBlockCloseForm"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1013:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseForm"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenForm(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenForm"));
  if (!yymatchChar(G, '<')) goto l1016;
  if (!yy_Spnl(G))  goto l1016;

  {  int yypos1017= G->pos, yythunkpos1017= G->thunkpos;  if (!yymatchString(G, "form")) goto l1018;
  goto l1017;
  l1018:;	  G->pos= yypos1017; G->thunkpos= yythunkpos1017;  if (!yymatchString(G, "FORM")) goto l1016;

  }
  l1017:;	  if (!yy_Spnl(G))  goto l1016;

  l1019:;	
  {  int yypos1020= G->pos, yythunkpos1020= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1020;
  goto l1019;
  l1020:;	  G->pos= yypos1020; G->thunkpos= yythunkpos1020;
  }  if (!yymatchChar(G, '>')) goto l1016;
  yyprintf((stderr, "  ok   HtmlBlockOpenForm"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1016:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenForm"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockFooter(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockFooter"));
  if (!yy_HtmlBlockOpenFooter(G))  goto l1021;

  l1022:;	
  {  int yypos1023= G->pos, yythunkpos1023= G->thunkpos;
  {  int yypos1024= G->pos, yythunkpos1024= G->thunkpos;  if (!yy_HtmlBlockFooter(G))  goto l1025;
  goto l1024;
  l1025:;	  G->pos= yypos1024; G->thunkpos= yythunkpos1024;
  {  int yypos1026= G->pos, yythunkpos1026= G->thunkpos;  if (!yy_HtmlBlockCloseFooter(G))  goto l1026;
  goto l1023;
  l1026:;	  G->pos= yypos1026; G->thunkpos= yythunkpos1026;
  }  if (!yymatchDot(G)) goto l1023;
  }
  l1024:;	  goto l1022;
  l1023:;	  G->pos= yypos1023; G->thunkpos= yythunkpos1023;
  }  if (!yy_HtmlBlockCloseFooter(G))  goto l1021;
  yyprintf((stderr, "  ok   HtmlBlockFooter"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1021:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockFooter"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseFooter(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseFooter"));
  if (!yymatchChar(G, '<')) goto l1027;
  if (!yy_Spnl(G))  goto l1027;
  if (!yymatchChar(G, '/')) goto l1027;

  {  int yypos1028= G->pos, yythunkpos1028= G->thunkpos;  if (!yymatchString(G, "footer")) goto l1029;
  goto l1028;
  l1029:;	  G->pos= yypos1028; G->thunkpos= yythunkpos1028;  if (!yymatchString(G, "FOOTER")) goto l1027;

  }
  l1028:;	  if (!yy_Spnl(G))  goto l1027;
  if (!yymatchChar(G, '>')) goto l1027;
  yyprintf((stderr, "  ok   HtmlBlockCloseFooter"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1027:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseFooter"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenFooter(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenFooter"));
  if (!yymatchChar(G, '<')) goto l1030;
  if (!yy_Spnl(G))  goto l1030;

  {  int yypos1031= G->pos, yythunkpos1031= G->thunkpos;  if (!yymatchString(G, "footer")) goto l1032;
  goto l1031;
  l1032:;	  G->pos= yypos1031; G->thunkpos= yythunkpos1031;  if (!yymatchString(G, "FOOTER")) goto l1030;

  }
  l1031:;	  if (!yy_Spnl(G))  goto l1030;

  l1033:;	
  {  int yypos1034= G->pos, yythunkpos1034= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1034;
  goto l1033;
  l1034:;	  G->pos= yypos1034; G->thunkpos= yythunkpos1034;
  }  if (!yymatchChar(G, '>')) goto l1030;
  yyprintf((stderr, "  ok   HtmlBlockOpenFooter"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1030:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenFooter"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockFigure(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockFigure"));
  if (!yy_HtmlBlockOpenFigure(G))  goto l1035;

  l1036:;	
  {  int yypos1037= G->pos, yythunkpos1037= G->thunkpos;
  {  int yypos1038= G->pos, yythunkpos1038= G->thunkpos;  if (!yy_HtmlBlockFigure(G))  goto l1039;
  goto l1038;
  l1039:;	  G->pos= yypos1038; G->thunkpos= yythunkpos1038;
  {  int yypos1040= G->pos, yythunkpos1040= G->thunkpos;  if (!yy_HtmlBlockCloseFigure(G))  goto l1040;
  goto l1037;
  l1040:;	  G->pos= yypos1040; G->thunkpos= yythunkpos1040;
  }  if (!yymatchDot(G)) goto l1037;
  }
  l1038:;	  goto l1036;
  l1037:;	  G->pos= yypos1037; G->thunkpos= yythunkpos1037;
  }  if (!yy_HtmlBlockCloseFigure(G))  goto l1035;
  yyprintf((stderr, "  ok   HtmlBlockFigure"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1035:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockFigure"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseFigure(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseFigure"));
  if (!yymatchChar(G, '<')) goto l1041;
  if (!yy_Spnl(G))  goto l1041;
  if (!yymatchChar(G, '/')) goto l1041;

  {  int yypos1042= G->pos, yythunkpos1042= G->thunkpos;  if (!yymatchString(G, "figure")) goto l1043;
  goto l1042;
  l1043:;	  G->pos= yypos1042; G->thunkpos= yythunkpos1042;  if (!yymatchString(G, "FIGURE")) goto l1041;

  }
  l1042:;	  if (!yy_Spnl(G))  goto l1041;
  if (!yymatchChar(G, '>')) goto l1041;
  yyprintf((stderr, "  ok   HtmlBlockCloseFigure"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1041:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseFigure"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenFigure(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenFigure"));
  if (!yymatchChar(G, '<')) goto l1044;
  if (!yy_Spnl(G))  goto l1044;

  {  int yypos1045= G->pos, yythunkpos1045= G->thunkpos;  if (!yymatchString(G, "figure")) goto l1046;
  goto l1045;
  l1046:;	  G->pos= yypos1045; G->thunkpos= yythunkpos1045;  if (!yymatchString(G, "FIGURE")) goto l1044;

  }
  l1045:;	  if (!yy_Spnl(G))  goto l1044;

  l1047:;	
  {  int yypos1048= G->pos, yythunkpos1048= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1048;
  goto l1047;
  l1048:;	  G->pos= yypos1048; G->thunkpos= yythunkpos1048;
  }  if (!yymatchChar(G, '>')) goto l1044;
  yyprintf((stderr, "  ok   HtmlBlockOpenFigure"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1044:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenFigure"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockFieldset(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockFieldset"));
  if (!yy_HtmlBlockOpenFieldset(G))  goto l1049;

  l1050:;	
  {  int yypos1051= G->pos, yythunkpos1051= G->thunkpos;
  {  int yypos1052= G->pos, yythunkpos1052= G->thunkpos;  if (!yy_HtmlBlockFieldset(G))  goto l1053;
  goto l1052;
  l1053:;	  G->pos= yypos1052; G->thunkpos= yythunkpos1052;
  {  int yypos1054= G->pos, yythunkpos1054= G->thunkpos;  if (!yy_HtmlBlockCloseFieldset(G))  goto l1054;
  goto l1051;
  l1054:;	  G->pos= yypos1054; G->thunkpos= yythunkpos1054;
  }  if (!yymatchDot(G)) goto l1051;
  }
  l1052:;	  goto l1050;
  l1051:;	  G->pos= yypos1051; G->thunkpos= yythunkpos1051;
  }  if (!yy_HtmlBlockCloseFieldset(G))  goto l1049;
  yyprintf((stderr, "  ok   HtmlBlockFieldset"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1049:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockFieldset"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseFieldset(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseFieldset"));
  if (!yymatchChar(G, '<')) goto l1055;
  if (!yy_Spnl(G))  goto l1055;
  if (!yymatchChar(G, '/')) goto l1055;

  {  int yypos1056= G->pos, yythunkpos1056= G->thunkpos;  if (!yymatchString(G, "fieldset")) goto l1057;
  goto l1056;
  l1057:;	  G->pos= yypos1056; G->thunkpos= yythunkpos1056;  if (!yymatchString(G, "FIELDSET")) goto l1055;

  }
  l1056:;	  if (!yy_Spnl(G))  goto l1055;
  if (!yymatchChar(G, '>')) goto l1055;
  yyprintf((stderr, "  ok   HtmlBlockCloseFieldset"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1055:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseFieldset"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenFieldset(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenFieldset"));
  if (!yymatchChar(G, '<')) goto l1058;
  if (!yy_Spnl(G))  goto l1058;

  {  int yypos1059= G->pos, yythunkpos1059= G->thunkpos;  if (!yymatchString(G, "fieldset")) goto l1060;
  goto l1059;
  l1060:;	  G->pos= yypos1059; G->thunkpos= yythunkpos1059;  if (!yymatchString(G, "FIELDSET")) goto l1058;

  }
  l1059:;	  if (!yy_Spnl(G))  goto l1058;

  l1061:;	
  {  int yypos1062= G->pos, yythunkpos1062= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1062;
  goto l1061;
  l1062:;	  G->pos= yypos1062; G->thunkpos= yythunkpos1062;
  }  if (!yymatchChar(G, '>')) goto l1058;
  yyprintf((stderr, "  ok   HtmlBlockOpenFieldset"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1058:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenFieldset"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockDl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockDl"));
  if (!yy_HtmlBlockOpenDl(G))  goto l1063;

  l1064:;	
  {  int yypos1065= G->pos, yythunkpos1065= G->thunkpos;
  {  int yypos1066= G->pos, yythunkpos1066= G->thunkpos;  if (!yy_HtmlBlockDl(G))  goto l1067;
  goto l1066;
  l1067:;	  G->pos= yypos1066; G->thunkpos= yythunkpos1066;
  {  int yypos1068= G->pos, yythunkpos1068= G->thunkpos;  if (!yy_HtmlBlockCloseDl(G))  goto l1068;
  goto l1065;
  l1068:;	  G->pos= yypos1068; G->thunkpos= yythunkpos1068;
  }  if (!yymatchDot(G)) goto l1065;
  }
  l1066:;	  goto l1064;
  l1065:;	  G->pos= yypos1065; G->thunkpos= yythunkpos1065;
  }  if (!yy_HtmlBlockCloseDl(G))  goto l1063;
  yyprintf((stderr, "  ok   HtmlBlockDl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1063:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockDl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseDl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseDl"));
  if (!yymatchChar(G, '<')) goto l1069;
  if (!yy_Spnl(G))  goto l1069;
  if (!yymatchChar(G, '/')) goto l1069;

  {  int yypos1070= G->pos, yythunkpos1070= G->thunkpos;  if (!yymatchString(G, "dl")) goto l1071;
  goto l1070;
  l1071:;	  G->pos= yypos1070; G->thunkpos= yythunkpos1070;  if (!yymatchString(G, "DL")) goto l1069;

  }
  l1070:;	  if (!yy_Spnl(G))  goto l1069;
  if (!yymatchChar(G, '>')) goto l1069;
  yyprintf((stderr, "  ok   HtmlBlockCloseDl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1069:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseDl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenDl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenDl"));
  if (!yymatchChar(G, '<')) goto l1072;
  if (!yy_Spnl(G))  goto l1072;

  {  int yypos1073= G->pos, yythunkpos1073= G->thunkpos;  if (!yymatchString(G, "dl")) goto l1074;
  goto l1073;
  l1074:;	  G->pos= yypos1073; G->thunkpos= yythunkpos1073;  if (!yymatchString(G, "DL")) goto l1072;

  }
  l1073:;	  if (!yy_Spnl(G))  goto l1072;

  l1075:;	
  {  int yypos1076= G->pos, yythunkpos1076= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1076;
  goto l1075;
  l1076:;	  G->pos= yypos1076; G->thunkpos= yythunkpos1076;
  }  if (!yymatchChar(G, '>')) goto l1072;
  yyprintf((stderr, "  ok   HtmlBlockOpenDl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1072:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenDl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockDiv(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockDiv"));
  if (!yy_HtmlBlockOpenDiv(G))  goto l1077;

  l1078:;	
  {  int yypos1079= G->pos, yythunkpos1079= G->thunkpos;
  {  int yypos1080= G->pos, yythunkpos1080= G->thunkpos;  if (!yy_HtmlBlockDiv(G))  goto l1081;
  goto l1080;
  l1081:;	  G->pos= yypos1080; G->thunkpos= yythunkpos1080;
  {  int yypos1082= G->pos, yythunkpos1082= G->thunkpos;  if (!yy_HtmlBlockCloseDiv(G))  goto l1082;
  goto l1079;
  l1082:;	  G->pos= yypos1082; G->thunkpos= yythunkpos1082;
  }  if (!yymatchDot(G)) goto l1079;
  }
  l1080:;	  goto l1078;
  l1079:;	  G->pos= yypos1079; G->thunkpos= yythunkpos1079;
  }  if (!yy_HtmlBlockCloseDiv(G))  goto l1077;
  yyprintf((stderr, "  ok   HtmlBlockDiv"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1077:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockDiv"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseDiv(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseDiv"));
  if (!yymatchChar(G, '<')) goto l1083;
  if (!yy_Spnl(G))  goto l1083;
  if (!yymatchChar(G, '/')) goto l1083;

  {  int yypos1084= G->pos, yythunkpos1084= G->thunkpos;  if (!yymatchString(G, "div")) goto l1085;
  goto l1084;
  l1085:;	  G->pos= yypos1084; G->thunkpos= yythunkpos1084;  if (!yymatchString(G, "DIV")) goto l1083;

  }
  l1084:;	  if (!yy_Spnl(G))  goto l1083;
  if (!yymatchChar(G, '>')) goto l1083;
  yyprintf((stderr, "  ok   HtmlBlockCloseDiv"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1083:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseDiv"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenDiv(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenDiv"));
  if (!yymatchChar(G, '<')) goto l1086;
  if (!yy_Spnl(G))  goto l1086;

  {  int yypos1087= G->pos, yythunkpos1087= G->thunkpos;  if (!yymatchString(G, "div")) goto l1088;
  goto l1087;
  l1088:;	  G->pos= yypos1087; G->thunkpos= yythunkpos1087;  if (!yymatchString(G, "DIV")) goto l1086;

  }
  l1087:;	  if (!yy_Spnl(G))  goto l1086;

  l1089:;	
  {  int yypos1090= G->pos, yythunkpos1090= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1090;
  goto l1089;
  l1090:;	  G->pos= yypos1090; G->thunkpos= yythunkpos1090;
  }  if (!yymatchChar(G, '>')) goto l1086;
  yyprintf((stderr, "  ok   HtmlBlockOpenDiv"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1086:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenDiv"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockDir(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockDir"));
  if (!yy_HtmlBlockOpenDir(G))  goto l1091;

  l1092:;	
  {  int yypos1093= G->pos, yythunkpos1093= G->thunkpos;
  {  int yypos1094= G->pos, yythunkpos1094= G->thunkpos;  if (!yy_HtmlBlockDir(G))  goto l1095;
  goto l1094;
  l1095:;	  G->pos= yypos1094; G->thunkpos= yythunkpos1094;
  {  int yypos1096= G->pos, yythunkpos1096= G->thunkpos;  if (!yy_HtmlBlockCloseDir(G))  goto l1096;
  goto l1093;
  l1096:;	  G->pos= yypos1096; G->thunkpos= yythunkpos1096;
  }  if (!yymatchDot(G)) goto l1093;
  }
  l1094:;	  goto l1092;
  l1093:;	  G->pos= yypos1093; G->thunkpos= yythunkpos1093;
  }  if (!yy_HtmlBlockCloseDir(G))  goto l1091;
  yyprintf((stderr, "  ok   HtmlBlockDir"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1091:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockDir"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseDir(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseDir"));
  if (!yymatchChar(G, '<')) goto l1097;
  if (!yy_Spnl(G))  goto l1097;
  if (!yymatchChar(G, '/')) goto l1097;

  {  int yypos1098= G->pos, yythunkpos1098= G->thunkpos;  if (!yymatchString(G, "dir")) goto l1099;
  goto l1098;
  l1099:;	  G->pos= yypos1098; G->thunkpos= yythunkpos1098;  if (!yymatchString(G, "DIR")) goto l1097;

  }
  l1098:;	  if (!yy_Spnl(G))  goto l1097;
  if (!yymatchChar(G, '>')) goto l1097;
  yyprintf((stderr, "  ok   HtmlBlockCloseDir"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1097:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseDir"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenDir(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenDir"));
  if (!yymatchChar(G, '<')) goto l1100;
  if (!yy_Spnl(G))  goto l1100;

  {  int yypos1101= G->pos, yythunkpos1101= G->thunkpos;  if (!yymatchString(G, "dir")) goto l1102;
  goto l1101;
  l1102:;	  G->pos= yypos1101; G->thunkpos= yythunkpos1101;  if (!yymatchString(G, "DIR")) goto l1100;

  }
  l1101:;	  if (!yy_Spnl(G))  goto l1100;

  l1103:;	
  {  int yypos1104= G->pos, yythunkpos1104= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1104;
  goto l1103;
  l1104:;	  G->pos= yypos1104; G->thunkpos= yythunkpos1104;
  }  if (!yymatchChar(G, '>')) goto l1100;
  yyprintf((stderr, "  ok   HtmlBlockOpenDir"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1100:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenDir"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCenter(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCenter"));
  if (!yy_HtmlBlockOpenCenter(G))  goto l1105;

  l1106:;	
  {  int yypos1107= G->pos, yythunkpos1107= G->thunkpos;
  {  int yypos1108= G->pos, yythunkpos1108= G->thunkpos;  if (!yy_HtmlBlockCenter(G))  goto l1109;
  goto l1108;
  l1109:;	  G->pos= yypos1108; G->thunkpos= yythunkpos1108;
  {  int yypos1110= G->pos, yythunkpos1110= G->thunkpos;  if (!yy_HtmlBlockCloseCenter(G))  goto l1110;
  goto l1107;
  l1110:;	  G->pos= yypos1110; G->thunkpos= yythunkpos1110;
  }  if (!yymatchDot(G)) goto l1107;
  }
  l1108:;	  goto l1106;
  l1107:;	  G->pos= yypos1107; G->thunkpos= yythunkpos1107;
  }  if (!yy_HtmlBlockCloseCenter(G))  goto l1105;
  yyprintf((stderr, "  ok   HtmlBlockCenter"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1105:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCenter"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseCenter(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseCenter"));
  if (!yymatchChar(G, '<')) goto l1111;
  if (!yy_Spnl(G))  goto l1111;
  if (!yymatchChar(G, '/')) goto l1111;

  {  int yypos1112= G->pos, yythunkpos1112= G->thunkpos;  if (!yymatchString(G, "center")) goto l1113;
  goto l1112;
  l1113:;	  G->pos= yypos1112; G->thunkpos= yythunkpos1112;  if (!yymatchString(G, "CENTER")) goto l1111;

  }
  l1112:;	  if (!yy_Spnl(G))  goto l1111;
  if (!yymatchChar(G, '>')) goto l1111;
  yyprintf((stderr, "  ok   HtmlBlockCloseCenter"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1111:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseCenter"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenCenter(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenCenter"));
  if (!yymatchChar(G, '<')) goto l1114;
  if (!yy_Spnl(G))  goto l1114;

  {  int yypos1115= G->pos, yythunkpos1115= G->thunkpos;  if (!yymatchString(G, "center")) goto l1116;
  goto l1115;
  l1116:;	  G->pos= yypos1115; G->thunkpos= yythunkpos1115;  if (!yymatchString(G, "CENTER")) goto l1114;

  }
  l1115:;	  if (!yy_Spnl(G))  goto l1114;

  l1117:;	
  {  int yypos1118= G->pos, yythunkpos1118= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1118;
  goto l1117;
  l1118:;	  G->pos= yypos1118; G->thunkpos= yythunkpos1118;
  }  if (!yymatchChar(G, '>')) goto l1114;
  yyprintf((stderr, "  ok   HtmlBlockOpenCenter"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1114:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenCenter"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCanvas(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCanvas"));
  if (!yy_HtmlBlockOpenCanvas(G))  goto l1119;

  l1120:;	
  {  int yypos1121= G->pos, yythunkpos1121= G->thunkpos;
  {  int yypos1122= G->pos, yythunkpos1122= G->thunkpos;  if (!yy_HtmlBlockCanvas(G))  goto l1123;
  goto l1122;
  l1123:;	  G->pos= yypos1122; G->thunkpos= yythunkpos1122;
  {  int yypos1124= G->pos, yythunkpos1124= G->thunkpos;  if (!yy_HtmlBlockCloseCanvas(G))  goto l1124;
  goto l1121;
  l1124:;	  G->pos= yypos1124; G->thunkpos= yythunkpos1124;
  }  if (!yymatchDot(G)) goto l1121;
  }
  l1122:;	  goto l1120;
  l1121:;	  G->pos= yypos1121; G->thunkpos= yythunkpos1121;
  }  if (!yy_HtmlBlockCloseCanvas(G))  goto l1119;
  yyprintf((stderr, "  ok   HtmlBlockCanvas"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1119:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCanvas"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseCanvas(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseCanvas"));
  if (!yymatchChar(G, '<')) goto l1125;
  if (!yy_Spnl(G))  goto l1125;
  if (!yymatchChar(G, '/')) goto l1125;

  {  int yypos1126= G->pos, yythunkpos1126= G->thunkpos;  if (!yymatchString(G, "canvas")) goto l1127;
  goto l1126;
  l1127:;	  G->pos= yypos1126; G->thunkpos= yythunkpos1126;  if (!yymatchString(G, "CANVAS")) goto l1125;

  }
  l1126:;	  if (!yy_Spnl(G))  goto l1125;
  if (!yymatchChar(G, '>')) goto l1125;
  yyprintf((stderr, "  ok   HtmlBlockCloseCanvas"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1125:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseCanvas"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenCanvas(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenCanvas"));
  if (!yymatchChar(G, '<')) goto l1128;
  if (!yy_Spnl(G))  goto l1128;

  {  int yypos1129= G->pos, yythunkpos1129= G->thunkpos;  if (!yymatchString(G, "canvas")) goto l1130;
  goto l1129;
  l1130:;	  G->pos= yypos1129; G->thunkpos= yythunkpos1129;  if (!yymatchString(G, "CANVAS")) goto l1128;

  }
  l1129:;	  if (!yy_Spnl(G))  goto l1128;

  l1131:;	
  {  int yypos1132= G->pos, yythunkpos1132= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1132;
  goto l1131;
  l1132:;	  G->pos= yypos1132; G->thunkpos= yythunkpos1132;
  }  if (!yymatchChar(G, '>')) goto l1128;
  yyprintf((stderr, "  ok   HtmlBlockOpenCanvas"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1128:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenCanvas"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockBlockquote(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockBlockquote"));
  if (!yy_HtmlBlockOpenBlockquote(G))  goto l1133;

  l1134:;	
  {  int yypos1135= G->pos, yythunkpos1135= G->thunkpos;
  {  int yypos1136= G->pos, yythunkpos1136= G->thunkpos;  if (!yy_HtmlBlockBlockquote(G))  goto l1137;
  goto l1136;
  l1137:;	  G->pos= yypos1136; G->thunkpos= yythunkpos1136;
  {  int yypos1138= G->pos, yythunkpos1138= G->thunkpos;  if (!yy_HtmlBlockCloseBlockquote(G))  goto l1138;
  goto l1135;
  l1138:;	  G->pos= yypos1138; G->thunkpos= yythunkpos1138;
  }  if (!yymatchDot(G)) goto l1135;
  }
  l1136:;	  goto l1134;
  l1135:;	  G->pos= yypos1135; G->thunkpos= yythunkpos1135;
  }  if (!yy_HtmlBlockCloseBlockquote(G))  goto l1133;
  yyprintf((stderr, "  ok   HtmlBlockBlockquote"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1133:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockBlockquote"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseBlockquote(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseBlockquote"));
  if (!yymatchChar(G, '<')) goto l1139;
  if (!yy_Spnl(G))  goto l1139;
  if (!yymatchChar(G, '/')) goto l1139;

  {  int yypos1140= G->pos, yythunkpos1140= G->thunkpos;  if (!yymatchString(G, "blockquote")) goto l1141;
  goto l1140;
  l1141:;	  G->pos= yypos1140; G->thunkpos= yythunkpos1140;  if (!yymatchString(G, "BLOCKQUOTE")) goto l1139;

  }
  l1140:;	  if (!yy_Spnl(G))  goto l1139;
  if (!yymatchChar(G, '>')) goto l1139;
  yyprintf((stderr, "  ok   HtmlBlockCloseBlockquote"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1139:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseBlockquote"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenBlockquote(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenBlockquote"));
  if (!yymatchChar(G, '<')) goto l1142;
  if (!yy_Spnl(G))  goto l1142;

  {  int yypos1143= G->pos, yythunkpos1143= G->thunkpos;  if (!yymatchString(G, "blockquote")) goto l1144;
  goto l1143;
  l1144:;	  G->pos= yypos1143; G->thunkpos= yythunkpos1143;  if (!yymatchString(G, "BLOCKQUOTE")) goto l1142;

  }
  l1143:;	  if (!yy_Spnl(G))  goto l1142;

  l1145:;	
  {  int yypos1146= G->pos, yythunkpos1146= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1146;
  goto l1145;
  l1146:;	  G->pos= yypos1146; G->thunkpos= yythunkpos1146;
  }  if (!yymatchChar(G, '>')) goto l1142;
  yyprintf((stderr, "  ok   HtmlBlockOpenBlockquote"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1142:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenBlockquote"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockAside(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockAside"));
  if (!yy_HtmlBlockOpenAside(G))  goto l1147;

  l1148:;	
  {  int yypos1149= G->pos, yythunkpos1149= G->thunkpos;
  {  int yypos1150= G->pos, yythunkpos1150= G->thunkpos;  if (!yy_HtmlBlockAside(G))  goto l1151;
  goto l1150;
  l1151:;	  G->pos= yypos1150; G->thunkpos= yythunkpos1150;
  {  int yypos1152= G->pos, yythunkpos1152= G->thunkpos;  if (!yy_HtmlBlockCloseAside(G))  goto l1152;
  goto l1149;
  l1152:;	  G->pos= yypos1152; G->thunkpos= yythunkpos1152;
  }  if (!yymatchDot(G)) goto l1149;
  }
  l1150:;	  goto l1148;
  l1149:;	  G->pos= yypos1149; G->thunkpos= yythunkpos1149;
  }  if (!yy_HtmlBlockCloseAside(G))  goto l1147;
  yyprintf((stderr, "  ok   HtmlBlockAside"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1147:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockAside"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseAside(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseAside"));
  if (!yymatchChar(G, '<')) goto l1153;
  if (!yy_Spnl(G))  goto l1153;
  if (!yymatchChar(G, '/')) goto l1153;

  {  int yypos1154= G->pos, yythunkpos1154= G->thunkpos;  if (!yymatchString(G, "aside")) goto l1155;
  goto l1154;
  l1155:;	  G->pos= yypos1154; G->thunkpos= yythunkpos1154;  if (!yymatchString(G, "ASIDE")) goto l1153;

  }
  l1154:;	  if (!yy_Spnl(G))  goto l1153;
  if (!yymatchChar(G, '>')) goto l1153;
  yyprintf((stderr, "  ok   HtmlBlockCloseAside"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1153:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseAside"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenAside(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenAside"));
  if (!yymatchChar(G, '<')) goto l1156;
  if (!yy_Spnl(G))  goto l1156;

  {  int yypos1157= G->pos, yythunkpos1157= G->thunkpos;  if (!yymatchString(G, "aside")) goto l1158;
  goto l1157;
  l1158:;	  G->pos= yypos1157; G->thunkpos= yythunkpos1157;  if (!yymatchString(G, "ASIDE")) goto l1156;

  }
  l1157:;	  if (!yy_Spnl(G))  goto l1156;

  l1159:;	
  {  int yypos1160= G->pos, yythunkpos1160= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1160;
  goto l1159;
  l1160:;	  G->pos= yypos1160; G->thunkpos= yythunkpos1160;
  }  if (!yymatchChar(G, '>')) goto l1156;
  yyprintf((stderr, "  ok   HtmlBlockOpenAside"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1156:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenAside"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockArticle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockArticle"));
  if (!yy_HtmlBlockOpenArticle(G))  goto l1161;

  l1162:;	
  {  int yypos1163= G->pos, yythunkpos1163= G->thunkpos;
  {  int yypos1164= G->pos, yythunkpos1164= G->thunkpos;  if (!yy_HtmlBlockArticle(G))  goto l1165;
  goto l1164;
  l1165:;	  G->pos= yypos1164; G->thunkpos= yythunkpos1164;
  {  int yypos1166= G->pos, yythunkpos1166= G->thunkpos;  if (!yy_HtmlBlockCloseArticle(G))  goto l1166;
  goto l1163;
  l1166:;	  G->pos= yypos1166; G->thunkpos= yythunkpos1166;
  }  if (!yymatchDot(G)) goto l1163;
  }
  l1164:;	  goto l1162;
  l1163:;	  G->pos= yypos1163; G->thunkpos= yythunkpos1163;
  }  if (!yy_HtmlBlockCloseArticle(G))  goto l1161;
  yyprintf((stderr, "  ok   HtmlBlockArticle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1161:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockArticle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseArticle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseArticle"));
  if (!yymatchChar(G, '<')) goto l1167;
  if (!yy_Spnl(G))  goto l1167;
  if (!yymatchChar(G, '/')) goto l1167;

  {  int yypos1168= G->pos, yythunkpos1168= G->thunkpos;  if (!yymatchString(G, "article")) goto l1169;
  goto l1168;
  l1169:;	  G->pos= yypos1168; G->thunkpos= yythunkpos1168;  if (!yymatchString(G, "ARTICLE")) goto l1167;

  }
  l1168:;	  if (!yy_Spnl(G))  goto l1167;
  if (!yymatchChar(G, '>')) goto l1167;
  yyprintf((stderr, "  ok   HtmlBlockCloseArticle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1167:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseArticle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenArticle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenArticle"));
  if (!yymatchChar(G, '<')) goto l1170;
  if (!yy_Spnl(G))  goto l1170;

  {  int yypos1171= G->pos, yythunkpos1171= G->thunkpos;  if (!yymatchString(G, "article")) goto l1172;
  goto l1171;
  l1172:;	  G->pos= yypos1171; G->thunkpos= yythunkpos1171;  if (!yymatchString(G, "ARTICLE")) goto l1170;

  }
  l1171:;	  if (!yy_Spnl(G))  goto l1170;

  l1173:;	
  {  int yypos1174= G->pos, yythunkpos1174= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1174;
  goto l1173;
  l1174:;	  G->pos= yypos1174; G->thunkpos= yythunkpos1174;
  }  if (!yymatchChar(G, '>')) goto l1170;
  yyprintf((stderr, "  ok   HtmlBlockOpenArticle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1170:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenArticle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockAddress(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockAddress"));
  if (!yy_HtmlBlockOpenAddress(G))  goto l1175;

  l1176:;	
  {  int yypos1177= G->pos, yythunkpos1177= G->thunkpos;
  {  int yypos1178= G->pos, yythunkpos1178= G->thunkpos;  if (!yy_HtmlBlockAddress(G))  goto l1179;
  goto l1178;
  l1179:;	  G->pos= yypos1178; G->thunkpos= yythunkpos1178;
  {  int yypos1180= G->pos, yythunkpos1180= G->thunkpos;  if (!yy_HtmlBlockCloseAddress(G))  goto l1180;
  goto l1177;
  l1180:;	  G->pos= yypos1180; G->thunkpos= yythunkpos1180;
  }  if (!yymatchDot(G)) goto l1177;
  }
  l1178:;	  goto l1176;
  l1177:;	  G->pos= yypos1177; G->thunkpos= yythunkpos1177;
  }  if (!yy_HtmlBlockCloseAddress(G))  goto l1175;
  yyprintf((stderr, "  ok   HtmlBlockAddress"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1175:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockAddress"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockCloseAddress(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockCloseAddress"));
  if (!yymatchChar(G, '<')) goto l1181;
  if (!yy_Spnl(G))  goto l1181;
  if (!yymatchChar(G, '/')) goto l1181;

  {  int yypos1182= G->pos, yythunkpos1182= G->thunkpos;  if (!yymatchString(G, "address")) goto l1183;
  goto l1182;
  l1183:;	  G->pos= yypos1182; G->thunkpos= yythunkpos1182;  if (!yymatchString(G, "ADDRESS")) goto l1181;

  }
  l1182:;	  if (!yy_Spnl(G))  goto l1181;
  if (!yymatchChar(G, '>')) goto l1181;
  yyprintf((stderr, "  ok   HtmlBlockCloseAddress"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1181:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockCloseAddress"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockOpenAddress(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockOpenAddress"));
  if (!yymatchChar(G, '<')) goto l1184;
  if (!yy_Spnl(G))  goto l1184;

  {  int yypos1185= G->pos, yythunkpos1185= G->thunkpos;  if (!yymatchString(G, "address")) goto l1186;
  goto l1185;
  l1186:;	  G->pos= yypos1185; G->thunkpos= yythunkpos1185;  if (!yymatchString(G, "ADDRESS")) goto l1184;

  }
  l1185:;	  if (!yy_Spnl(G))  goto l1184;

  l1187:;	
  {  int yypos1188= G->pos, yythunkpos1188= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l1188;
  goto l1187;
  l1188:;	  G->pos= yypos1188; G->thunkpos= yythunkpos1188;
  }  if (!yymatchChar(G, '>')) goto l1184;
  yyprintf((stderr, "  ok   HtmlBlockOpenAddress"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1184:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockOpenAddress"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListBlockLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ListBlockLine"));

  {  int yypos1190= G->pos, yythunkpos1190= G->thunkpos;  if (!yy_BlankLine(G))  goto l1190;
  goto l1189;
  l1190:;	  G->pos= yypos1190; G->thunkpos= yythunkpos1190;
  }
  {  int yypos1191= G->pos, yythunkpos1191= G->thunkpos;  if (!yy_Heading(G))  goto l1191;
  goto l1189;
  l1191:;	  G->pos= yypos1191; G->thunkpos= yythunkpos1191;
  }
  {  int yypos1192= G->pos, yythunkpos1192= G->thunkpos;
  {  int yypos1193= G->pos, yythunkpos1193= G->thunkpos;  if (!yy_Indent(G))  goto l1193;
  goto l1194;
  l1193:;	  G->pos= yypos1193; G->thunkpos= yythunkpos1193;
  }
  l1194:;	
  {  int yypos1195= G->pos, yythunkpos1195= G->thunkpos;  if (!yy_Bullet(G))  goto l1196;
  goto l1195;
  l1196:;	  G->pos= yypos1195; G->thunkpos= yythunkpos1195;  if (!yy_Enumerator(G))  goto l1197;
  goto l1195;
  l1197:;	  G->pos= yypos1195; G->thunkpos= yythunkpos1195;  if (!yy_BulletNoSpace(G))  goto l1198;

  {  int yypos1199= G->pos, yythunkpos1199= G->thunkpos;  if (!yy_EmptyList(G))  goto l1198;
  G->pos= yypos1199; G->thunkpos= yythunkpos1199;
  }  goto l1195;
  l1198:;	  G->pos= yypos1195; G->thunkpos= yythunkpos1195;  if (!yy_EnumeratorNoSpace(G))  goto l1192;

  {  int yypos1200= G->pos, yythunkpos1200= G->thunkpos;  if (!yy_EmptyList(G))  goto l1192;
  G->pos= yypos1200; G->thunkpos= yythunkpos1200;
  }
  }
  l1195:;	  goto l1189;
  l1192:;	  G->pos= yypos1192; G->thunkpos= yythunkpos1192;
  }
  {  int yypos1201= G->pos, yythunkpos1201= G->thunkpos;  if (!yy_HorizontalRule(G))  goto l1201;
  goto l1189;
  l1201:;	  G->pos= yypos1201; G->thunkpos= yythunkpos1201;
  }  if (!yy_OptionallyIndentedLine(G))  goto l1189;
  yyprintf((stderr, "  ok   ListBlockLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1189:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListBlockLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListContinuationBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ListContinuationBlock"));
  if (!yy_StartList(G))  goto l1202;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1202;
  l1203:;	
  {  int yypos1204= G->pos, yythunkpos1204= G->thunkpos;  if (!yy_BlankLine(G))  goto l1204;
  goto l1203;
  l1204:;	  G->pos= yypos1204; G->thunkpos= yythunkpos1204;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1202;  yyDo(G, yy_1_ListContinuationBlock, G->begin, G->end, "yy_1_ListContinuationBlock");
  if (!yy_Indent(G))  goto l1202;

  {  int yypos1207= G->pos, yythunkpos1207= G->thunkpos;  if (!yy_BlankLine(G))  goto l1207;
  goto l1202;
  l1207:;	  G->pos= yypos1207; G->thunkpos= yythunkpos1207;
  }  if (!yy_ListBlock(G))  goto l1202;
  yyDo(G, yy_2_ListContinuationBlock, G->begin, G->end, "yy_2_ListContinuationBlock");

  l1205:;	
  {  int yypos1206= G->pos, yythunkpos1206= G->thunkpos;  if (!yy_Indent(G))  goto l1206;

  {  int yypos1208= G->pos, yythunkpos1208= G->thunkpos;  if (!yy_BlankLine(G))  goto l1208;
  goto l1206;
  l1208:;	  G->pos= yypos1208; G->thunkpos= yythunkpos1208;
  }  if (!yy_ListBlock(G))  goto l1206;
  yyDo(G, yy_2_ListContinuationBlock, G->begin, G->end, "yy_2_ListContinuationBlock");
  goto l1205;
  l1206:;	  G->pos= yypos1206; G->thunkpos= yythunkpos1206;
  }  yyDo(G, yy_3_ListContinuationBlock, G->begin, G->end, "yy_3_ListContinuationBlock");
  yyprintf((stderr, "  ok   ListContinuationBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1202:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListContinuationBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ListBlock"));
  if (!yy_StartList(G))  goto l1209;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos1210= G->pos, yythunkpos1210= G->thunkpos;  if (!yy_EmptyList(G))  goto l1211;
  goto l1210;
  l1211:;	  G->pos= yypos1210; G->thunkpos= yythunkpos1210;
  {  int yypos1212= G->pos, yythunkpos1212= G->thunkpos;  if (!yy_SetextHeading(G))  goto l1212;
  goto l1209;
  l1212:;	  G->pos= yypos1212; G->thunkpos= yythunkpos1212;
  }  if (!yy_Line(G))  goto l1209;

  }
  l1210:;	  yyDo(G, yy_1_ListBlock, G->begin, G->end, "yy_1_ListBlock");

  l1213:;	
  {  int yypos1214= G->pos, yythunkpos1214= G->thunkpos;  if (!yy_ListBlockLine(G))  goto l1214;
  yyDo(G, yy_2_ListBlock, G->begin, G->end, "yy_2_ListBlock");
  goto l1213;
  l1214:;	  G->pos= yypos1214; G->thunkpos= yythunkpos1214;
  }  yyDo(G, yy_3_ListBlock, G->begin, G->end, "yy_3_ListBlock");
  yyprintf((stderr, "  ok   ListBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1209:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListItem(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ListItem"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1215;
  {  int yypos1216= G->pos, yythunkpos1216= G->thunkpos;  if (!yy_Bullet(G))  goto l1217;
  goto l1216;
  l1217:;	  G->pos= yypos1216; G->thunkpos= yythunkpos1216;  if (!yy_Enumerator(G))  goto l1218;
  goto l1216;
  l1218:;	  G->pos= yypos1216; G->thunkpos= yythunkpos1216;  if (!yy_BulletNoSpace(G))  goto l1219;

  {  int yypos1220= G->pos, yythunkpos1220= G->thunkpos;  if (!yy_EmptyList(G))  goto l1219;
  G->pos= yypos1220; G->thunkpos= yythunkpos1220;
  }  goto l1216;
  l1219:;	  G->pos= yypos1216; G->thunkpos= yythunkpos1216;  if (!yy_EnumeratorNoSpace(G))  goto l1215;

  {  int yypos1221= G->pos, yythunkpos1221= G->thunkpos;  if (!yy_EmptyList(G))  goto l1215;
  G->pos= yypos1221; G->thunkpos= yythunkpos1221;
  }
  }
  l1216:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1215;  if (!yy_StartList(G))  goto l1215;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_ListBlock(G))  goto l1215;
  yyDo(G, yy_1_ListItem, G->begin, G->end, "yy_1_ListItem");

  l1222:;	
  {  int yypos1223= G->pos, yythunkpos1223= G->thunkpos;  if (!yy_ListContinuationBlock(G))  goto l1223;
  yyDo(G, yy_2_ListItem, G->begin, G->end, "yy_2_ListItem");
  goto l1222;
  l1223:;	  G->pos= yypos1223; G->thunkpos= yythunkpos1223;
  }  yyDo(G, yy_3_ListItem, G->begin, G->end, "yy_3_ListItem");
  yyprintf((stderr, "  ok   ListItem"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1215:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListItem"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EnumeratorNoSpace(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EnumeratorNoSpace"));
  if (!yy_NonindentSpace(G))  goto l1224;
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l1224;

  l1225:;	
  {  int yypos1226= G->pos, yythunkpos1226= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l1226;
  goto l1225;
  l1226:;	  G->pos= yypos1226; G->thunkpos= yythunkpos1226;
  }  if (!yymatchChar(G, '.')) goto l1224;
  yyprintf((stderr, "  ok   EnumeratorNoSpace"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1224:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EnumeratorNoSpace"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmptyList(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmptyList"));
  if (!yy_BlankLine(G))  goto l1227;
  yyDo(G, yy_1_EmptyList, G->begin, G->end, "yy_1_EmptyList");
  yyprintf((stderr, "  ok   EmptyList"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1227:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmptyList"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Enumerator(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Enumerator"));
  if (!yy_NonindentSpace(G))  goto l1228;
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l1228;

  l1229:;	
  {  int yypos1230= G->pos, yythunkpos1230= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l1230;
  goto l1229;
  l1230:;	  G->pos= yypos1230; G->thunkpos= yythunkpos1230;
  }  if (!yymatchChar(G, '.')) goto l1228;
  if (!yy_Spacechar(G))  goto l1228;

  l1231:;	
  {  int yypos1232= G->pos, yythunkpos1232= G->thunkpos;  if (!yy_Spacechar(G))  goto l1232;
  goto l1231;
  l1232:;	  G->pos= yypos1232; G->thunkpos= yythunkpos1232;
  }  yyprintf((stderr, "  ok   Enumerator"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1228:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Enumerator"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListItemTight(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ListItemTight"));

  {  int yypos1234= G->pos, yythunkpos1234= G->thunkpos;  if (!yy_Bullet(G))  goto l1235;
  goto l1234;
  l1235:;	  G->pos= yypos1234; G->thunkpos= yythunkpos1234;  if (!yy_Enumerator(G))  goto l1236;
  goto l1234;
  l1236:;	  G->pos= yypos1234; G->thunkpos= yythunkpos1234;  if (!yy_BulletNoSpace(G))  goto l1237;

  {  int yypos1238= G->pos, yythunkpos1238= G->thunkpos;  if (!yy_EmptyList(G))  goto l1237;
  G->pos= yypos1238; G->thunkpos= yythunkpos1238;
  }  goto l1234;
  l1237:;	  G->pos= yypos1234; G->thunkpos= yythunkpos1234;  if (!yy_EnumeratorNoSpace(G))  goto l1233;

  {  int yypos1239= G->pos, yythunkpos1239= G->thunkpos;  if (!yy_EmptyList(G))  goto l1233;
  G->pos= yypos1239; G->thunkpos= yythunkpos1239;
  }
  }
  l1234:;	  if (!yy_StartList(G))  goto l1233;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_ListBlock(G))  goto l1233;
  yyDo(G, yy_1_ListItemTight, G->begin, G->end, "yy_1_ListItemTight");

  l1240:;	
  {  int yypos1241= G->pos, yythunkpos1241= G->thunkpos;
  {  int yypos1242= G->pos, yythunkpos1242= G->thunkpos;  if (!yy_BlankLine(G))  goto l1242;
  goto l1241;
  l1242:;	  G->pos= yypos1242; G->thunkpos= yythunkpos1242;
  }  if (!yy_ListContinuationBlock(G))  goto l1241;
  yyDo(G, yy_2_ListItemTight, G->begin, G->end, "yy_2_ListItemTight");
  goto l1240;
  l1241:;	  G->pos= yypos1241; G->thunkpos= yythunkpos1241;
  }
  {  int yypos1243= G->pos, yythunkpos1243= G->thunkpos;  if (!yy_ListContinuationBlock(G))  goto l1243;
  goto l1233;
  l1243:;	  G->pos= yypos1243; G->thunkpos= yythunkpos1243;
  }  yyDo(G, yy_3_ListItemTight, G->begin, G->end, "yy_3_ListItemTight");
  yyprintf((stderr, "  ok   ListItemTight"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1233:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListItemTight"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListLoose(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ListLoose"));
  if (!yy_StartList(G))  goto l1244;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_ListItem(G))  goto l1244;
  yyDo(G, yySet, -1, 0, "yySet");

  l1247:;	
  {  int yypos1248= G->pos, yythunkpos1248= G->thunkpos;  if (!yy_BlankLine(G))  goto l1248;
  goto l1247;
  l1248:;	  G->pos= yypos1248; G->thunkpos= yythunkpos1248;
  }  yyDo(G, yy_1_ListLoose, G->begin, G->end, "yy_1_ListLoose");

  l1245:;	
  {  int yypos1246= G->pos, yythunkpos1246= G->thunkpos;  if (!yy_ListItem(G))  goto l1246;
  yyDo(G, yySet, -1, 0, "yySet");

  l1249:;	
  {  int yypos1250= G->pos, yythunkpos1250= G->thunkpos;  if (!yy_BlankLine(G))  goto l1250;
  goto l1249;
  l1250:;	  G->pos= yypos1250; G->thunkpos= yythunkpos1250;
  }  yyDo(G, yy_1_ListLoose, G->begin, G->end, "yy_1_ListLoose");
  goto l1245;
  l1246:;	  G->pos= yypos1246; G->thunkpos= yythunkpos1246;
  }  yyDo(G, yy_2_ListLoose, G->begin, G->end, "yy_2_ListLoose");
  yyprintf((stderr, "  ok   ListLoose"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1244:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListLoose"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ListTight(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ListTight"));
  if (!yy_StartList(G))  goto l1251;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_ListItemTight(G))  goto l1251;
  yyDo(G, yy_1_ListTight, G->begin, G->end, "yy_1_ListTight");

  l1252:;	
  {  int yypos1253= G->pos, yythunkpos1253= G->thunkpos;  if (!yy_ListItemTight(G))  goto l1253;
  yyDo(G, yy_1_ListTight, G->begin, G->end, "yy_1_ListTight");
  goto l1252;
  l1253:;	  G->pos= yypos1253; G->thunkpos= yythunkpos1253;
  }
  l1254:;	
  {  int yypos1255= G->pos, yythunkpos1255= G->thunkpos;  if (!yy_BlankLine(G))  goto l1255;
  goto l1254;
  l1255:;	  G->pos= yypos1255; G->thunkpos= yythunkpos1255;
  }
  {  int yypos1256= G->pos, yythunkpos1256= G->thunkpos;
  {  int yypos1258= G->pos, yythunkpos1258= G->thunkpos;  if (!yy_Heading(G))  goto l1257;
  G->pos= yypos1258; G->thunkpos= yythunkpos1258;
  }  goto l1256;
  l1257:;	  G->pos= yypos1256; G->thunkpos= yythunkpos1256;
  {  int yypos1259= G->pos, yythunkpos1259= G->thunkpos;
  {  int yypos1260= G->pos, yythunkpos1260= G->thunkpos;  if (!yy_Bullet(G))  goto l1261;
  goto l1260;
  l1261:;	  G->pos= yypos1260; G->thunkpos= yythunkpos1260;  if (!yy_Enumerator(G))  goto l1262;
  goto l1260;
  l1262:;	  G->pos= yypos1260; G->thunkpos= yythunkpos1260;  if (!yy_BulletNoSpace(G))  goto l1263;

  {  int yypos1264= G->pos, yythunkpos1264= G->thunkpos;  if (!yy_EmptyList(G))  goto l1263;
  G->pos= yypos1264; G->thunkpos= yythunkpos1264;
  }  goto l1260;
  l1263:;	  G->pos= yypos1260; G->thunkpos= yythunkpos1260;  if (!yy_EnumeratorNoSpace(G))  goto l1259;

  {  int yypos1265= G->pos, yythunkpos1265= G->thunkpos;  if (!yy_EmptyList(G))  goto l1259;
  G->pos= yypos1265; G->thunkpos= yythunkpos1265;
  }
  }
  l1260:;	  goto l1251;
  l1259:;	  G->pos= yypos1259; G->thunkpos= yythunkpos1259;
  }
  }
  l1256:;	  yyDo(G, yy_2_ListTight, G->begin, G->end, "yy_2_ListTight");
  yyprintf((stderr, "  ok   ListTight"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1251:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ListTight"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BulletNoSpace(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BulletNoSpace"));

  {  int yypos1267= G->pos, yythunkpos1267= G->thunkpos;  if (!yy_HorizontalRule(G))  goto l1267;
  goto l1266;
  l1267:;	  G->pos= yypos1267; G->thunkpos= yythunkpos1267;
  }  if (!yy_NonindentSpace(G))  goto l1266;

  {  int yypos1268= G->pos, yythunkpos1268= G->thunkpos;  if (!yymatchChar(G, '+')) goto l1269;
  goto l1268;
  l1269:;	  G->pos= yypos1268; G->thunkpos= yythunkpos1268;  if (!yymatchChar(G, '*')) goto l1270;
  goto l1268;
  l1270:;	  G->pos= yypos1268; G->thunkpos= yythunkpos1268;  if (!yymatchChar(G, '-')) goto l1266;

  }
  l1268:;	  yyprintf((stderr, "  ok   BulletNoSpace"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1266:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BulletNoSpace"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Bullet(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Bullet"));

  {  int yypos1272= G->pos, yythunkpos1272= G->thunkpos;  if (!yy_HorizontalRule(G))  goto l1272;
  goto l1271;
  l1272:;	  G->pos= yypos1272; G->thunkpos= yythunkpos1272;
  }  if (!yy_NonindentSpace(G))  goto l1271;

  {  int yypos1273= G->pos, yythunkpos1273= G->thunkpos;  if (!yymatchChar(G, '+')) goto l1274;
  goto l1273;
  l1274:;	  G->pos= yypos1273; G->thunkpos= yythunkpos1273;  if (!yymatchChar(G, '*')) goto l1275;
  goto l1273;
  l1275:;	  G->pos= yypos1273; G->thunkpos= yythunkpos1273;  if (!yymatchChar(G, '-')) goto l1271;

  }
  l1273:;	  if (!yy_Spacechar(G))  goto l1271;

  l1276:;	
  {  int yypos1277= G->pos, yythunkpos1277= G->thunkpos;  if (!yy_Spacechar(G))  goto l1277;
  goto l1276;
  l1277:;	  G->pos= yypos1277; G->thunkpos= yythunkpos1277;
  }  yyprintf((stderr, "  ok   Bullet"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1271:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Bullet"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Definition(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Definition"));
  if (!yy_StartList(G))  goto l1278;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_StartList(G))  goto l1278;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos1279= G->pos, yythunkpos1279= G->thunkpos;  if (!yy_BlankLine(G))  goto l1279;
  yyDo(G, yy_1_Definition, G->begin, G->end, "yy_1_Definition");
  goto l1280;
  l1279:;	  G->pos= yypos1279; G->thunkpos= yythunkpos1279;
  }
  l1280:;	  if (!yy_NonindentSpace(G))  goto l1278;
  if (!yymatchChar(G, ':')) goto l1278;
  if (!yy_Sp(G))  goto l1278;
  if (!yy_RawLine(G))  goto l1278;
  yyDo(G, yy_2_Definition, G->begin, G->end, "yy_2_Definition");

  l1281:;	
  {  int yypos1282= G->pos, yythunkpos1282= G->thunkpos;
  {  int yypos1283= G->pos, yythunkpos1283= G->thunkpos;  if (!yymatchChar(G, ':')) goto l1283;
  goto l1282;
  l1283:;	  G->pos= yypos1283; G->thunkpos= yythunkpos1283;
  }
  {  int yypos1284= G->pos, yythunkpos1284= G->thunkpos;  if (!yy_BlankLine(G))  goto l1284;
  goto l1282;
  l1284:;	  G->pos= yypos1284; G->thunkpos= yythunkpos1284;
  }  if (!yy_RawLine(G))  goto l1282;
  yyDo(G, yy_3_Definition, G->begin, G->end, "yy_3_Definition");
  goto l1281;
  l1282:;	  G->pos= yypos1282; G->thunkpos= yythunkpos1282;
  }
  l1285:;	
  {  int yypos1286= G->pos, yythunkpos1286= G->thunkpos;  if (!yy_BlankLine(G))  goto l1286;
  yyDo(G, yy_4_Definition, G->begin, G->end, "yy_4_Definition");
  if (!yy_IndentedLine(G))  goto l1286;
  yyDo(G, yy_5_Definition, G->begin, G->end, "yy_5_Definition");

  l1287:;	
  {  int yypos1288= G->pos, yythunkpos1288= G->thunkpos;  if (!yy_IndentedLine(G))  goto l1288;
  yyDo(G, yy_5_Definition, G->begin, G->end, "yy_5_Definition");
  goto l1287;
  l1288:;	  G->pos= yypos1288; G->thunkpos= yythunkpos1288;
  }  yyDo(G, yy_6_Definition, G->begin, G->end, "yy_6_Definition");
  goto l1285;
  l1286:;	  G->pos= yypos1286; G->thunkpos= yythunkpos1286;
  }  yyDo(G, yy_7_Definition, G->begin, G->end, "yy_7_Definition");
  yyprintf((stderr, "  ok   Definition"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1278:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Definition"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Term(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Term"));
  if (!yy_StartList(G))  goto l1289;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos1290= G->pos, yythunkpos1290= G->thunkpos;  if (!yy_BlankLine(G))  goto l1290;
  goto l1289;
  l1290:;	  G->pos= yypos1290; G->thunkpos= yythunkpos1290;
  }
  {  int yypos1291= G->pos, yythunkpos1291= G->thunkpos;  if (!yymatchChar(G, ':')) goto l1291;
  goto l1289;
  l1291:;	  G->pos= yypos1291; G->thunkpos= yythunkpos1291;
  }
  {  int yypos1294= G->pos, yythunkpos1294= G->thunkpos;  if (!yy_Newline(G))  goto l1294;
  goto l1289;
  l1294:;	  G->pos= yypos1294; G->thunkpos= yythunkpos1294;
  }
  {  int yypos1295= G->pos, yythunkpos1295= G->thunkpos;  if (!yy_Endline(G))  goto l1295;
  goto l1289;
  l1295:;	  G->pos= yypos1295; G->thunkpos= yythunkpos1295;
  }  if (!yy_Inline(G))  goto l1289;
  yyDo(G, yy_1_Term, G->begin, G->end, "yy_1_Term");

  l1292:;	
  {  int yypos1293= G->pos, yythunkpos1293= G->thunkpos;
  {  int yypos1296= G->pos, yythunkpos1296= G->thunkpos;  if (!yy_Newline(G))  goto l1296;
  goto l1293;
  l1296:;	  G->pos= yypos1296; G->thunkpos= yythunkpos1296;
  }
  {  int yypos1297= G->pos, yythunkpos1297= G->thunkpos;  if (!yy_Endline(G))  goto l1297;
  goto l1293;
  l1297:;	  G->pos= yypos1297; G->thunkpos= yythunkpos1297;
  }  if (!yy_Inline(G))  goto l1293;
  yyDo(G, yy_1_Term, G->begin, G->end, "yy_1_Term");
  goto l1292;
  l1293:;	  G->pos= yypos1293; G->thunkpos= yythunkpos1293;
  }  if (!yy_Sp(G))  goto l1289;
  if (!yy_Newline(G))  goto l1289;
  yyDo(G, yy_2_Term, G->begin, G->end, "yy_2_Term");
  yyprintf((stderr, "  ok   Term"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1289:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Term"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TermLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TermLine"));

  {  int yypos1299= G->pos, yythunkpos1299= G->thunkpos;  if (!yymatchChar(G, ':')) goto l1299;
  goto l1298;
  l1299:;	  G->pos= yypos1299; G->thunkpos= yythunkpos1299;
  }
  {  int yypos1300= G->pos, yythunkpos1300= G->thunkpos;  if (!yy_BlankLine(G))  goto l1300;
  goto l1298;
  l1300:;	  G->pos= yypos1300; G->thunkpos= yythunkpos1300;
  }
  l1301:;	
  {  int yypos1302= G->pos, yythunkpos1302= G->thunkpos;
  {  int yypos1303= G->pos, yythunkpos1303= G->thunkpos;  if (!yy_Newline(G))  goto l1303;
  goto l1302;
  l1303:;	  G->pos= yypos1303; G->thunkpos= yythunkpos1303;
  }  if (!yymatchDot(G)) goto l1302;  goto l1301;
  l1302:;	  G->pos= yypos1302; G->thunkpos= yythunkpos1302;
  }  if (!yy_Newline(G))  goto l1298;
  yyprintf((stderr, "  ok   TermLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1298:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TermLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_VerbatimChunk(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "VerbatimChunk"));
  if (!yy_StartList(G))  goto l1304;
  yyDo(G, yySet, -1, 0, "yySet");

  l1305:;	
  {  int yypos1306= G->pos, yythunkpos1306= G->thunkpos;  if (!yy_BlankLine(G))  goto l1306;
  yyDo(G, yy_1_VerbatimChunk, G->begin, G->end, "yy_1_VerbatimChunk");
  goto l1305;
  l1306:;	  G->pos= yypos1306; G->thunkpos= yythunkpos1306;
  }  if (!yy_NonblankIndentedLine(G))  goto l1304;
  yyDo(G, yy_2_VerbatimChunk, G->begin, G->end, "yy_2_VerbatimChunk");

  l1307:;	
  {  int yypos1308= G->pos, yythunkpos1308= G->thunkpos;  if (!yy_NonblankIndentedLine(G))  goto l1308;
  yyDo(G, yy_2_VerbatimChunk, G->begin, G->end, "yy_2_VerbatimChunk");
  goto l1307;
  l1308:;	  G->pos= yypos1308; G->thunkpos= yythunkpos1308;
  }  yyDo(G, yy_3_VerbatimChunk, G->begin, G->end, "yy_3_VerbatimChunk");
  yyprintf((stderr, "  ok   VerbatimChunk"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1304:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "VerbatimChunk"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NonblankIndentedLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NonblankIndentedLine"));

  {  int yypos1310= G->pos, yythunkpos1310= G->thunkpos;  if (!yy_BlankLine(G))  goto l1310;
  goto l1309;
  l1310:;	  G->pos= yypos1310; G->thunkpos= yythunkpos1310;
  }  if (!yy_IndentedLine(G))  goto l1309;
  yyprintf((stderr, "  ok   NonblankIndentedLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1309:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NonblankIndentedLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BackTickStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BackTickStart"));
  if (!yymatchString(G, "``")) goto l1311;
  yyprintf((stderr, "  ok   BackTickStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1311:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BackTickStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BackTickEnd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BackTickEnd"));
  if (!yymatchString(G, "\'\'")) goto l1312;
  yyprintf((stderr, "  ok   BackTickEnd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1312:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BackTickEnd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleQuoteEnd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DoubleQuoteEnd"));
  if (!yymatchChar(G, '"')) goto l1313;
  yyprintf((stderr, "  ok   DoubleQuoteEnd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1313:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleQuoteEnd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleQuoteStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DoubleQuoteStart"));
  if (!yymatchChar(G, '"')) goto l1314;
  yyprintf((stderr, "  ok   DoubleQuoteStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1314:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleQuoteStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleQuoteEnd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleQuoteEnd"));
  if (!yymatchChar(G, '\'')) goto l1315;

  {  int yypos1316= G->pos, yythunkpos1316= G->thunkpos;  if (!yy_Alphanumeric(G))  goto l1316;
  goto l1315;
  l1316:;	  G->pos= yypos1316; G->thunkpos= yythunkpos1316;
  }  yyprintf((stderr, "  ok   SingleQuoteEnd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1315:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleQuoteEnd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleQuoteStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleQuoteStart"));
  if (!yymatchChar(G, '\'')) goto l1317;

  {  int yypos1318= G->pos, yythunkpos1318= G->thunkpos;
  {  int yypos1319= G->pos, yythunkpos1319= G->thunkpos;  if (!yy_Spacechar(G))  goto l1320;
  goto l1319;
  l1320:;	  G->pos= yypos1319; G->thunkpos= yythunkpos1319;  if (!yy_Newline(G))  goto l1318;

  }
  l1319:;	  goto l1317;
  l1318:;	  G->pos= yypos1318; G->thunkpos= yythunkpos1318;
  }  yyprintf((stderr, "  ok   SingleQuoteStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1317:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleQuoteStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EnDash(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EnDash"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1321;
  {  int yypos1322= G->pos, yythunkpos1322= G->thunkpos;  if (!yymatchString(G, "--")) goto l1323;
  goto l1322;
  l1323:;	  G->pos= yypos1322; G->thunkpos= yythunkpos1322;  if (!yymatchChar(G, '-')) goto l1321;

  {  int yypos1324= G->pos, yythunkpos1324= G->thunkpos;  if (!yy_Digit(G))  goto l1321;
  G->pos= yypos1324; G->thunkpos= yythunkpos1324;
  }
  }
  l1322:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1321;  yyDo(G, yy_1_EnDash, G->begin, G->end, "yy_1_EnDash");
  yyprintf((stderr, "  ok   EnDash"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1321:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EnDash"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmDash(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmDash"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1325;  if (!yymatchString(G, "---")) goto l1325;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1325;  yyDo(G, yy_1_EmDash, G->begin, G->end, "yy_1_EmDash");
  yyprintf((stderr, "  ok   EmDash"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1325:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmDash"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Apostrophe(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Apostrophe"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1326;  if (!yymatchChar(G, '\'')) goto l1326;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1326;  yyDo(G, yy_1_Apostrophe, G->begin, G->end, "yy_1_Apostrophe");
  yyprintf((stderr, "  ok   Apostrophe"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1326:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Apostrophe"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BackTickQuoted(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "BackTickQuoted"));
  if (!yy_BackTickStart(G))  goto l1327;
  if (!yy_StartList(G))  goto l1327;
  yyDo(G, yySet, -2, 0, "yySet");

  l1328:;	
  {  int yypos1329= G->pos, yythunkpos1329= G->thunkpos;
  {  int yypos1330= G->pos, yythunkpos1330= G->thunkpos;  if (!yy_DoubleQuoteEnd(G))  goto l1330;
  goto l1329;
  l1330:;	  G->pos= yypos1330; G->thunkpos= yythunkpos1330;
  }
  {  int yypos1331= G->pos, yythunkpos1331= G->thunkpos;  if (!yy_BackTickEnd(G))  goto l1331;
  goto l1329;
  l1331:;	  G->pos= yypos1331; G->thunkpos= yythunkpos1331;
  }  if (!yy_Inline(G))  goto l1329;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_BackTickQuoted, G->begin, G->end, "yy_1_BackTickQuoted");
  goto l1328;
  l1329:;	  G->pos= yypos1329; G->thunkpos= yythunkpos1329;
  }  if (!yy_BackTickEnd(G))  goto l1327;
  yyDo(G, yy_2_BackTickQuoted, G->begin, G->end, "yy_2_BackTickQuoted");
  yyprintf((stderr, "  ok   BackTickQuoted"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1327:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BackTickQuoted"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleQuoted(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "DoubleQuoted"));
  if (!yy_DoubleQuoteStart(G))  goto l1332;
  if (!yy_StartList(G))  goto l1332;
  yyDo(G, yySet, -2, 0, "yySet");

  l1333:;	
  {  int yypos1334= G->pos, yythunkpos1334= G->thunkpos;
  {  int yypos1335= G->pos, yythunkpos1335= G->thunkpos;  if (!yy_DoubleQuoteEnd(G))  goto l1335;
  goto l1334;
  l1335:;	  G->pos= yypos1335; G->thunkpos= yythunkpos1335;
  }
  {  int yypos1336= G->pos, yythunkpos1336= G->thunkpos;  if (!yy_BackTickEnd(G))  goto l1336;
  goto l1334;
  l1336:;	  G->pos= yypos1336; G->thunkpos= yythunkpos1336;
  }
  {  int yypos1337= G->pos, yythunkpos1337= G->thunkpos;  if (!yy_BackTickStart(G))  goto l1337;
  goto l1334;
  l1337:;	  G->pos= yypos1337; G->thunkpos= yythunkpos1337;
  }  if (!yy_Inline(G))  goto l1334;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_DoubleQuoted, G->begin, G->end, "yy_1_DoubleQuoted");
  goto l1333;
  l1334:;	  G->pos= yypos1334; G->thunkpos= yythunkpos1334;
  }  if (!yy_DoubleQuoteEnd(G))  goto l1332;
  yyDo(G, yy_2_DoubleQuoted, G->begin, G->end, "yy_2_DoubleQuoted");
  yyprintf((stderr, "  ok   DoubleQuoted"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1332:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleQuoted"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleQuoted(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "SingleQuoted"));
  if (!yy_SingleQuoteStart(G))  goto l1338;
  if (!yy_StartList(G))  goto l1338;
  yyDo(G, yySet, -2, 0, "yySet");

  l1339:;	
  {  int yypos1340= G->pos, yythunkpos1340= G->thunkpos;
  {  int yypos1341= G->pos, yythunkpos1341= G->thunkpos;  if (!yy_SingleQuoteEnd(G))  goto l1341;
  goto l1340;
  l1341:;	  G->pos= yypos1341; G->thunkpos= yythunkpos1341;
  }  if (!yy_Inline(G))  goto l1340;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_SingleQuoted, G->begin, G->end, "yy_1_SingleQuoted");
  goto l1339;
  l1340:;	  G->pos= yypos1340; G->thunkpos= yythunkpos1340;
  }  if (!yy_SingleQuoteEnd(G))  goto l1338;
  yyDo(G, yy_2_SingleQuoted, G->begin, G->end, "yy_2_SingleQuoted");
  yyprintf((stderr, "  ok   SingleQuoted"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1338:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleQuoted"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Dash(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Dash"));

  {  int yypos1343= G->pos, yythunkpos1343= G->thunkpos;  if (!yy_EmDash(G))  goto l1344;
  goto l1343;
  l1344:;	  G->pos= yypos1343; G->thunkpos= yythunkpos1343;  if (!yy_EnDash(G))  goto l1342;

  }
  l1343:;	  yyprintf((stderr, "  ok   Dash"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1342:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Dash"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Ellipsis(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Ellipsis"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1345;
  {  int yypos1346= G->pos, yythunkpos1346= G->thunkpos;  if (!yymatchString(G, "...")) goto l1347;
  goto l1346;
  l1347:;	  G->pos= yypos1346; G->thunkpos= yythunkpos1346;  if (!yymatchString(G, ". . .")) goto l1345;

  }
  l1346:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1345;  yyDo(G, yy_1_Ellipsis, G->begin, G->end, "yy_1_Ellipsis");
  yyprintf((stderr, "  ok   Ellipsis"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1345:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Ellipsis"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_FenceType(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "FenceType"));
  if (!yy_Sp(G))  goto l1348;

  {  int yypos1349= G->pos, yythunkpos1349= G->thunkpos;
  l1350:;	
  {  int yypos1351= G->pos, yythunkpos1351= G->thunkpos;
  {  int yypos1352= G->pos, yythunkpos1352= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l1352;
  goto l1351;
  l1352:;	  G->pos= yypos1352; G->thunkpos= yythunkpos1352;
  }
  {  int yypos1353= G->pos, yythunkpos1353= G->thunkpos;  if (!yymatchChar(G, '\r')) goto l1353;
  goto l1351;
  l1353:;	  G->pos= yypos1353; G->thunkpos= yythunkpos1353;
  }
  {  int yypos1354= G->pos, yythunkpos1354= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1354;
  goto l1351;
  l1354:;	  G->pos= yypos1354; G->thunkpos= yythunkpos1354;
  }  if (!yymatchDot(G)) goto l1351;  goto l1350;
  l1351:;	  G->pos= yypos1351; G->thunkpos= yythunkpos1351;
  }  if (!yy_Newline(G))  goto l1348;
  G->pos= yypos1349; G->thunkpos= yythunkpos1349;
  }  if (!yy_RawLine(G))  goto l1348;
  yyDo(G, yy_1_FenceType, G->begin, G->end, "yy_1_FenceType");
  yyprintf((stderr, "  ok   FenceType"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1348:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "FenceType"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Ticks5(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Ticks5"));
  if (!yymatchString(G, "`````")) goto l1355;

  {  int yypos1356= G->pos, yythunkpos1356= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1356;
  goto l1355;
  l1356:;	  G->pos= yypos1356; G->thunkpos= yythunkpos1356;
  }  yyprintf((stderr, "  ok   Ticks5"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1355:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Ticks5"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Ticks4(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Ticks4"));
  if (!yymatchString(G, "````")) goto l1357;

  {  int yypos1358= G->pos, yythunkpos1358= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1358;
  goto l1357;
  l1358:;	  G->pos= yypos1358; G->thunkpos= yythunkpos1358;
  }  yyprintf((stderr, "  ok   Ticks4"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1357:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Ticks4"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Ticks3(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Ticks3"));
  if (!yymatchString(G, "```")) goto l1359;

  {  int yypos1360= G->pos, yythunkpos1360= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1360;
  goto l1359;
  l1360:;	  G->pos= yypos1360; G->thunkpos= yythunkpos1360;
  }  yyprintf((stderr, "  ok   Ticks3"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1359:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Ticks3"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Ticks2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Ticks2"));
  if (!yymatchString(G, "``")) goto l1361;

  {  int yypos1362= G->pos, yythunkpos1362= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1362;
  goto l1361;
  l1362:;	  G->pos= yypos1362; G->thunkpos= yythunkpos1362;
  }  yyprintf((stderr, "  ok   Ticks2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1361:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Ticks2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Ticks1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Ticks1"));
  if (!yymatchChar(G, '`')) goto l1363;

  {  int yypos1364= G->pos, yythunkpos1364= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1364;
  goto l1363;
  l1364:;	  G->pos= yypos1364; G->thunkpos= yythunkpos1364;
  }  yyprintf((stderr, "  ok   Ticks1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1363:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Ticks1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawNoteBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "RawNoteBlock"));
  if (!yy_StartList(G))  goto l1365;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos1368= G->pos, yythunkpos1368= G->thunkpos;  if (!yy_BlankLine(G))  goto l1368;
  goto l1365;
  l1368:;	  G->pos= yypos1368; G->thunkpos= yythunkpos1368;
  }
  {  int yypos1369= G->pos, yythunkpos1369= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l1369;
  if (!yy_RawNoteReference(G))  goto l1369;
  if (!yymatchChar(G, ':')) goto l1369;
  goto l1365;
  l1369:;	  G->pos= yypos1369; G->thunkpos= yythunkpos1369;
  }  if (!yy_OptionallyIndentedLine(G))  goto l1365;
  yyDo(G, yy_1_RawNoteBlock, G->begin, G->end, "yy_1_RawNoteBlock");

  l1366:;	
  {  int yypos1367= G->pos, yythunkpos1367= G->thunkpos;
  {  int yypos1370= G->pos, yythunkpos1370= G->thunkpos;  if (!yy_BlankLine(G))  goto l1370;
  goto l1367;
  l1370:;	  G->pos= yypos1370; G->thunkpos= yythunkpos1370;
  }
  {  int yypos1371= G->pos, yythunkpos1371= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l1371;
  if (!yy_RawNoteReference(G))  goto l1371;
  if (!yymatchChar(G, ':')) goto l1371;
  goto l1367;
  l1371:;	  G->pos= yypos1371; G->thunkpos= yythunkpos1371;
  }  if (!yy_OptionallyIndentedLine(G))  goto l1367;
  yyDo(G, yy_1_RawNoteBlock, G->begin, G->end, "yy_1_RawNoteBlock");
  goto l1366;
  l1367:;	  G->pos= yypos1367; G->thunkpos= yythunkpos1367;
  }  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1365;
  l1372:;	
  {  int yypos1373= G->pos, yythunkpos1373= G->thunkpos;  if (!yy_BlankLine(G))  goto l1373;
  goto l1372;
  l1373:;	  G->pos= yypos1373; G->thunkpos= yythunkpos1373;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1365;  yyDo(G, yy_2_RawNoteBlock, G->begin, G->end, "yy_2_RawNoteBlock");
  yyDo(G, yy_3_RawNoteBlock, G->begin, G->end, "yy_3_RawNoteBlock");
  yyprintf((stderr, "  ok   RawNoteBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1365:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawNoteBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_GlossarySortKey(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "GlossarySortKey"));
  if (!yymatchChar(G, '(')) goto l1374;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1374;
  l1375:;	
  {  int yypos1376= G->pos, yythunkpos1376= G->thunkpos;
  {  int yypos1377= G->pos, yythunkpos1377= G->thunkpos;  if (!yymatchChar(G, ')')) goto l1377;
  goto l1376;
  l1377:;	  G->pos= yypos1377; G->thunkpos= yythunkpos1377;
  }
  {  int yypos1378= G->pos, yythunkpos1378= G->thunkpos;  if (!yy_Newline(G))  goto l1378;
  goto l1376;
  l1378:;	  G->pos= yypos1378; G->thunkpos= yythunkpos1378;
  }  if (!yymatchDot(G)) goto l1376;  goto l1375;
  l1376:;	  G->pos= yypos1376; G->thunkpos= yythunkpos1376;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1374;  if (!yymatchChar(G, ')')) goto l1374;
  yyDo(G, yy_1_GlossarySortKey, G->begin, G->end, "yy_1_GlossarySortKey");
  yyprintf((stderr, "  ok   GlossarySortKey"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1374:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "GlossarySortKey"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_GlossaryTerm(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "GlossaryTerm"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1379;
  {  int yypos1382= G->pos, yythunkpos1382= G->thunkpos;  if (!yy_Newline(G))  goto l1382;
  goto l1379;
  l1382:;	  G->pos= yypos1382; G->thunkpos= yythunkpos1382;
  }
  {  int yypos1383= G->pos, yythunkpos1383= G->thunkpos;  if (!yymatchChar(G, '(')) goto l1383;
  goto l1379;
  l1383:;	  G->pos= yypos1383; G->thunkpos= yythunkpos1383;
  }  if (!yymatchDot(G)) goto l1379;
  l1380:;	
  {  int yypos1381= G->pos, yythunkpos1381= G->thunkpos;
  {  int yypos1384= G->pos, yythunkpos1384= G->thunkpos;  if (!yy_Newline(G))  goto l1384;
  goto l1381;
  l1384:;	  G->pos= yypos1384; G->thunkpos= yythunkpos1384;
  }
  {  int yypos1385= G->pos, yythunkpos1385= G->thunkpos;  if (!yymatchChar(G, '(')) goto l1385;
  goto l1381;
  l1385:;	  G->pos= yypos1385; G->thunkpos= yythunkpos1385;
  }  if (!yymatchDot(G)) goto l1381;  goto l1380;
  l1381:;	  G->pos= yypos1381; G->thunkpos= yythunkpos1381;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1379;  yyDo(G, yy_1_GlossaryTerm, G->begin, G->end, "yy_1_GlossaryTerm");
  yyprintf((stderr, "  ok   GlossaryTerm"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1379:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "GlossaryTerm"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawNoteReference(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RawNoteReference"));

  {  int yypos1387= G->pos, yythunkpos1387= G->thunkpos;  if (!yymatchString(G, "[^")) goto l1388;
  goto l1387;
  l1388:;	  G->pos= yypos1387; G->thunkpos= yythunkpos1387;  if (!yymatchString(G, "[#")) goto l1386;

  }
  l1387:;	  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1386;
  {  int yypos1391= G->pos, yythunkpos1391= G->thunkpos;  if (!yy_Newline(G))  goto l1391;
  goto l1386;
  l1391:;	  G->pos= yypos1391; G->thunkpos= yythunkpos1391;
  }
  {  int yypos1392= G->pos, yythunkpos1392= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1392;
  goto l1386;
  l1392:;	  G->pos= yypos1392; G->thunkpos= yythunkpos1392;
  }  if (!yymatchDot(G)) goto l1386;
  l1389:;	
  {  int yypos1390= G->pos, yythunkpos1390= G->thunkpos;
  {  int yypos1393= G->pos, yythunkpos1393= G->thunkpos;  if (!yy_Newline(G))  goto l1393;
  goto l1390;
  l1393:;	  G->pos= yypos1393; G->thunkpos= yythunkpos1393;
  }
  {  int yypos1394= G->pos, yythunkpos1394= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1394;
  goto l1390;
  l1394:;	  G->pos= yypos1394; G->thunkpos= yythunkpos1394;
  }  if (!yymatchDot(G)) goto l1390;  goto l1389;
  l1390:;	  G->pos= yypos1390; G->thunkpos= yythunkpos1390;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1386;  if (!yymatchChar(G, ']')) goto l1386;
  yyDo(G, yy_1_RawNoteReference, G->begin, G->end, "yy_1_RawNoteReference");
  yyprintf((stderr, "  ok   RawNoteReference"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1386:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawNoteReference"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawInline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RawInline"));

  {  int yypos1396= G->pos, yythunkpos1396= G->thunkpos;  if (!yymatchChar(G, '[')) goto l1397;

  l1398:;	
  {  int yypos1399= G->pos, yythunkpos1399= G->thunkpos;
  {  int yypos1400= G->pos, yythunkpos1400= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1400;
  goto l1399;
  l1400:;	  G->pos= yypos1400; G->thunkpos= yythunkpos1400;
  }  if (!yymatchDot(G)) goto l1399;  goto l1398;
  l1399:;	  G->pos= yypos1399; G->thunkpos= yythunkpos1399;
  }  if (!yymatchChar(G, ']')) goto l1397;
  goto l1396;
  l1397:;	  G->pos= yypos1396; G->thunkpos= yythunkpos1396;  if (!yymatchDot(G)) goto l1395;
  }
  l1396:;	  yyprintf((stderr, "  ok   RawInline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1395:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawInline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Label2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Label2"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1401;  if (!yymatchChar(G, '[')) goto l1401;

  {  int yypos1402= G->pos, yythunkpos1402= G->thunkpos;
  {  int yypos1404= G->pos, yythunkpos1404= G->thunkpos;  if (!yymatchString(G, "[%")) goto l1403;
  G->pos= yypos1404; G->thunkpos= yythunkpos1404;
  }  goto l1402;
  l1403:;	  G->pos= yypos1402; G->thunkpos= yythunkpos1402;
  {  int yypos1405= G->pos, yythunkpos1405= G->thunkpos;  if (!yymatchChar(G, '[')) goto l1405;
  goto l1401;
  l1405:;	  G->pos= yypos1405; G->thunkpos= yythunkpos1405;
  }
  {  int yypos1406= G->pos, yythunkpos1406= G->thunkpos;
  {  int yypos1408= G->pos, yythunkpos1408= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1408;
  goto l1407;
  l1408:;	  G->pos= yypos1408; G->thunkpos= yythunkpos1408;
  }
  {  int yypos1409= G->pos, yythunkpos1409= G->thunkpos;  if (!yymatchChar(G, '#')) goto l1409;
  goto l1407;
  l1409:;	  G->pos= yypos1409; G->thunkpos= yythunkpos1409;
  }  yyText(G, G->begin, G->end);  if (!( ext(EXT_NOTES) )) goto l1407;  goto l1406;
  l1407:;	  G->pos= yypos1406; G->thunkpos= yythunkpos1406;
  {  int yypos1410= G->pos, yythunkpos1410= G->thunkpos;  if (!yymatchDot(G)) goto l1401;  G->pos= yypos1410; G->thunkpos= yythunkpos1410;
  }  yyText(G, G->begin, G->end);  if (!( !ext(EXT_NOTES) )) goto l1401;
  }
  l1406:;	
  }
  l1402:;	  if (!yy_StartList(G))  goto l1401;
  yyDo(G, yySet, -1, 0, "yySet");

  l1411:;	
  {  int yypos1412= G->pos, yythunkpos1412= G->thunkpos;
  {  int yypos1413= G->pos, yythunkpos1413= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1413;
  goto l1412;
  l1413:;	  G->pos= yypos1413; G->thunkpos= yythunkpos1413;
  }  if (!yy_Inline(G))  goto l1412;
  yyDo(G, yy_1_Label2, G->begin, G->end, "yy_1_Label2");
  goto l1411;
  l1412:;	  G->pos= yypos1412; G->thunkpos= yythunkpos1412;
  }  if (!yymatchChar(G, ']')) goto l1401;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1401;  yyDo(G, yy_2_Label2, G->begin, G->end, "yy_2_Label2");
  yyprintf((stderr, "  ok   Label2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1401:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Label2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmptyTitle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmptyTitle"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1414;  if (!yymatchString(G, "")) goto l1414;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1414;  yyprintf((stderr, "  ok   EmptyTitle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1414:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmptyTitle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RefTitleParens(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RefTitleParens"));
  if (!yy_Spnl(G))  goto l1415;
  if (!yymatchChar(G, '(')) goto l1415;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1415;
  l1416:;	
  {  int yypos1417= G->pos, yythunkpos1417= G->thunkpos;
  {  int yypos1418= G->pos, yythunkpos1418= G->thunkpos;
  {  int yypos1419= G->pos, yythunkpos1419= G->thunkpos;  if (!yymatchChar(G, ')')) goto l1420;
  if (!yy_Sp(G))  goto l1420;
  if (!yy_Newline(G))  goto l1420;
  goto l1419;
  l1420:;	  G->pos= yypos1419; G->thunkpos= yythunkpos1419;  if (!yy_Newline(G))  goto l1421;
  goto l1419;
  l1421:;	  G->pos= yypos1419; G->thunkpos= yythunkpos1419;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l1418;  if (!yymatchChar(G, ')')) goto l1418;
  if (!yy_Sp(G))  goto l1418;
  if (!yy_AlphanumericAscii(G))  goto l1418;

  l1422:;	
  {  int yypos1423= G->pos, yythunkpos1423= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l1423;
  goto l1422;
  l1423:;	  G->pos= yypos1423; G->thunkpos= yythunkpos1423;
  }  if (!yymatchChar(G, '=')) goto l1418;

  }
  l1419:;	  goto l1417;
  l1418:;	  G->pos= yypos1418; G->thunkpos= yythunkpos1418;
  }  if (!yymatchDot(G)) goto l1417;  goto l1416;
  l1417:;	  G->pos= yypos1417; G->thunkpos= yythunkpos1417;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1415;  if (!yymatchChar(G, ')')) goto l1415;
  yyprintf((stderr, "  ok   RefTitleParens"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1415:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RefTitleParens"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RefTitleDouble(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RefTitleDouble"));
  if (!yy_Spnl(G))  goto l1424;
  if (!yymatchChar(G, '"')) goto l1424;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1424;
  l1425:;	
  {  int yypos1426= G->pos, yythunkpos1426= G->thunkpos;
  {  int yypos1427= G->pos, yythunkpos1427= G->thunkpos;
  {  int yypos1428= G->pos, yythunkpos1428= G->thunkpos;  if (!yymatchChar(G, '"')) goto l1429;
  if (!yy_Sp(G))  goto l1429;
  if (!yy_Newline(G))  goto l1429;
  goto l1428;
  l1429:;	  G->pos= yypos1428; G->thunkpos= yythunkpos1428;  if (!yy_Newline(G))  goto l1430;
  goto l1428;
  l1430:;	  G->pos= yypos1428; G->thunkpos= yythunkpos1428;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l1427;  if (!yymatchChar(G, '"')) goto l1427;
  if (!yy_Sp(G))  goto l1427;
  if (!yy_AlphanumericAscii(G))  goto l1427;

  l1431:;	
  {  int yypos1432= G->pos, yythunkpos1432= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l1432;
  goto l1431;
  l1432:;	  G->pos= yypos1432; G->thunkpos= yythunkpos1432;
  }  if (!yymatchChar(G, '=')) goto l1427;

  }
  l1428:;	  goto l1426;
  l1427:;	  G->pos= yypos1427; G->thunkpos= yythunkpos1427;
  }  if (!yymatchDot(G)) goto l1426;  goto l1425;
  l1426:;	  G->pos= yypos1426; G->thunkpos= yythunkpos1426;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1424;  if (!yymatchChar(G, '"')) goto l1424;
  yyprintf((stderr, "  ok   RefTitleDouble"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1424:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RefTitleDouble"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RefTitleSingle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RefTitleSingle"));
  if (!yy_Spnl(G))  goto l1433;
  if (!yymatchChar(G, '\'')) goto l1433;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1433;
  l1434:;	
  {  int yypos1435= G->pos, yythunkpos1435= G->thunkpos;
  {  int yypos1436= G->pos, yythunkpos1436= G->thunkpos;
  {  int yypos1437= G->pos, yythunkpos1437= G->thunkpos;  if (!yymatchChar(G, '\'')) goto l1438;
  if (!yy_Sp(G))  goto l1438;
  if (!yy_Newline(G))  goto l1438;
  goto l1437;
  l1438:;	  G->pos= yypos1437; G->thunkpos= yythunkpos1437;  if (!yy_Newline(G))  goto l1439;
  goto l1437;
  l1439:;	  G->pos= yypos1437; G->thunkpos= yythunkpos1437;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l1436;  if (!yymatchChar(G, '\'')) goto l1436;
  if (!yy_Sp(G))  goto l1436;
  if (!yy_AlphanumericAscii(G))  goto l1436;

  l1440:;	
  {  int yypos1441= G->pos, yythunkpos1441= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l1441;
  goto l1440;
  l1441:;	  G->pos= yypos1441; G->thunkpos= yythunkpos1441;
  }  if (!yymatchChar(G, '=')) goto l1436;

  }
  l1437:;	  goto l1435;
  l1436:;	  G->pos= yypos1436; G->thunkpos= yythunkpos1436;
  }  if (!yymatchDot(G)) goto l1435;  goto l1434;
  l1435:;	  G->pos= yypos1435; G->thunkpos= yythunkpos1435;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1433;  if (!yymatchChar(G, '\'')) goto l1433;
  yyprintf((stderr, "  ok   RefTitleSingle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1433:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RefTitleSingle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_UnQuotedValue(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "UnQuotedValue"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1442;
  {  int yypos1445= G->pos, yythunkpos1445= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l1446;
  goto l1445;
  l1446:;	  G->pos= yypos1445; G->thunkpos= yythunkpos1445;  if (!yymatchChar(G, '.')) goto l1442;

  }
  l1445:;	
  l1443:;	
  {  int yypos1444= G->pos, yythunkpos1444= G->thunkpos;
  {  int yypos1447= G->pos, yythunkpos1447= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l1448;
  goto l1447;
  l1448:;	  G->pos= yypos1447; G->thunkpos= yythunkpos1447;  if (!yymatchChar(G, '.')) goto l1444;

  }
  l1447:;	  goto l1443;
  l1444:;	  G->pos= yypos1444; G->thunkpos= yythunkpos1444;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1442;  yyprintf((stderr, "  ok   UnQuotedValue"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1442:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "UnQuotedValue"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_QuotedValue(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "QuotedValue"));
  if (!yymatchChar(G, '"')) goto l1449;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1449;
  l1450:;	
  {  int yypos1451= G->pos, yythunkpos1451= G->thunkpos;
  {  int yypos1452= G->pos, yythunkpos1452= G->thunkpos;  if (!yymatchChar(G, '"')) goto l1452;
  goto l1451;
  l1452:;	  G->pos= yypos1452; G->thunkpos= yythunkpos1452;
  }  if (!yymatchDot(G)) goto l1451;  goto l1450;
  l1451:;	  G->pos= yypos1451; G->thunkpos= yythunkpos1451;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1449;  if (!yymatchChar(G, '"')) goto l1449;
  yyprintf((stderr, "  ok   QuotedValue"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1449:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "QuotedValue"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AttrValue(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AttrValue"));

  {  int yypos1454= G->pos, yythunkpos1454= G->thunkpos;  if (!yy_QuotedValue(G))  goto l1455;
  goto l1454;
  l1455:;	  G->pos= yypos1454; G->thunkpos= yythunkpos1454;  if (!yy_UnQuotedValue(G))  goto l1453;

  }
  l1454:;	  yyDo(G, yy_1_AttrValue, G->begin, G->end, "yy_1_AttrValue");
  yyprintf((stderr, "  ok   AttrValue"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1453:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AttrValue"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AttrKey(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AttrKey"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1456;  if (!yy_AlphanumericAscii(G))  goto l1456;

  l1457:;	
  {  int yypos1458= G->pos, yythunkpos1458= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l1458;
  goto l1457;
  l1458:;	  G->pos= yypos1458; G->thunkpos= yythunkpos1458;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1456;  yyDo(G, yy_1_AttrKey, G->begin, G->end, "yy_1_AttrKey");
  yyprintf((stderr, "  ok   AttrKey"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1456:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AttrKey"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Attribute(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Attribute"));
  if (!yy_Spnl(G))  goto l1459;
  if (!yy_AttrKey(G))  goto l1459;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yymatchChar(G, '=')) goto l1459;
  if (!yy_AttrValue(G))  goto l1459;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_Attribute, G->begin, G->end, "yy_1_Attribute");
  yyprintf((stderr, "  ok   Attribute"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1459:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Attribute"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Attributes(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Attributes"));
  if (!yy_StartList(G))  goto l1460;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Attribute(G))  goto l1460;
  yyDo(G, yy_1_Attributes, G->begin, G->end, "yy_1_Attributes");

  l1461:;	
  {  int yypos1462= G->pos, yythunkpos1462= G->thunkpos;  if (!yy_Attribute(G))  goto l1462;
  yyDo(G, yy_1_Attributes, G->begin, G->end, "yy_1_Attributes");
  goto l1461;
  l1462:;	  G->pos= yypos1462; G->thunkpos= yythunkpos1462;
  }  yyDo(G, yy_2_Attributes, G->begin, G->end, "yy_2_Attributes");
  yyprintf((stderr, "  ok   Attributes"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1460:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Attributes"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RefTitle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RefTitle"));

  {  int yypos1464= G->pos, yythunkpos1464= G->thunkpos;  if (!yy_RefTitleSingle(G))  goto l1465;
  goto l1464;
  l1465:;	  G->pos= yypos1464; G->thunkpos= yythunkpos1464;  if (!yy_RefTitleDouble(G))  goto l1466;
  goto l1464;
  l1466:;	  G->pos= yypos1464; G->thunkpos= yythunkpos1464;  if (!yy_RefTitleParens(G))  goto l1467;
  goto l1464;
  l1467:;	  G->pos= yypos1464; G->thunkpos= yythunkpos1464;  if (!yy_EmptyTitle(G))  goto l1463;

  }
  l1464:;	  yyDo(G, yy_1_RefTitle, G->begin, G->end, "yy_1_RefTitle");
  yyprintf((stderr, "  ok   RefTitle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1463:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RefTitle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RefSrc(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RefSrc"));

  {  int yypos1469= G->pos, yythunkpos1469= G->thunkpos;  if (!yymatchChar(G, '<')) goto l1470;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1470;
  {  int yypos1473= G->pos, yythunkpos1473= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1473;
  goto l1470;
  l1473:;	  G->pos= yypos1473; G->thunkpos= yythunkpos1473;
  }  if (!yy_Nonspacechar(G))  goto l1470;

  l1471:;	
  {  int yypos1472= G->pos, yythunkpos1472= G->thunkpos;
  {  int yypos1474= G->pos, yythunkpos1474= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1474;
  goto l1472;
  l1474:;	  G->pos= yypos1474; G->thunkpos= yythunkpos1474;
  }  if (!yy_Nonspacechar(G))  goto l1472;
  goto l1471;
  l1472:;	  G->pos= yypos1472; G->thunkpos= yythunkpos1472;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1470;  if (!yymatchChar(G, '>')) goto l1470;
  goto l1469;
  l1470:;	  G->pos= yypos1469; G->thunkpos= yythunkpos1469;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1468;  if (!yy_Nonspacechar(G))  goto l1468;

  l1475:;	
  {  int yypos1476= G->pos, yythunkpos1476= G->thunkpos;  if (!yy_Nonspacechar(G))  goto l1476;
  goto l1475;
  l1476:;	  G->pos= yypos1476; G->thunkpos= yythunkpos1476;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1468;
  }
  l1469:;	  yyDo(G, yy_1_RefSrc, G->begin, G->end, "yy_1_RefSrc");
  yyprintf((stderr, "  ok   RefSrc"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1468:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RefSrc"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AutoLinkEmail(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AutoLinkEmail"));
  if (!yymatchChar(G, '<')) goto l1477;

  {  int yypos1478= G->pos, yythunkpos1478= G->thunkpos;  if (!yymatchString(G, "mailto:")) goto l1478;
  goto l1479;
  l1478:;	  G->pos= yypos1478; G->thunkpos= yythunkpos1478;
  }
  l1479:;	  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1477;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\062\350\377\003\376\377\377\207\376\377\377\107\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "-A-Za-z0-9+_./!%%~$")) goto l1477;

  l1480:;	
  {  int yypos1481= G->pos, yythunkpos1481= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\062\350\377\003\376\377\377\207\376\377\377\107\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "-A-Za-z0-9+_./!%%~$")) goto l1481;
  goto l1480;
  l1481:;	  G->pos= yypos1481; G->thunkpos= yythunkpos1481;
  }  if (!yymatchChar(G, '@')) goto l1477;

  {  int yypos1484= G->pos, yythunkpos1484= G->thunkpos;  if (!yy_Newline(G))  goto l1484;
  goto l1477;
  l1484:;	  G->pos= yypos1484; G->thunkpos= yythunkpos1484;
  }
  {  int yypos1485= G->pos, yythunkpos1485= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1485;
  goto l1477;
  l1485:;	  G->pos= yypos1485; G->thunkpos= yythunkpos1485;
  }  if (!yymatchDot(G)) goto l1477;
  l1482:;	
  {  int yypos1483= G->pos, yythunkpos1483= G->thunkpos;
  {  int yypos1486= G->pos, yythunkpos1486= G->thunkpos;  if (!yy_Newline(G))  goto l1486;
  goto l1483;
  l1486:;	  G->pos= yypos1486; G->thunkpos= yythunkpos1486;
  }
  {  int yypos1487= G->pos, yythunkpos1487= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1487;
  goto l1483;
  l1487:;	  G->pos= yypos1487; G->thunkpos= yythunkpos1487;
  }  if (!yymatchDot(G)) goto l1483;  goto l1482;
  l1483:;	  G->pos= yypos1483; G->thunkpos= yythunkpos1483;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1477;  if (!yymatchChar(G, '>')) goto l1477;
  yyDo(G, yy_1_AutoLinkEmail, G->begin, G->end, "yy_1_AutoLinkEmail");
  yyprintf((stderr, "  ok   AutoLinkEmail"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1477:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AutoLinkEmail"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AutoLinkUrl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AutoLinkUrl"));
  if (!yymatchChar(G, '<')) goto l1488;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1488;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z")) goto l1488;

  l1489:;	
  {  int yypos1490= G->pos, yythunkpos1490= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z")) goto l1490;
  goto l1489;
  l1490:;	  G->pos= yypos1490; G->thunkpos= yythunkpos1490;
  }  if (!yymatchString(G, "://")) goto l1488;

  {  int yypos1493= G->pos, yythunkpos1493= G->thunkpos;  if (!yy_Newline(G))  goto l1493;
  goto l1488;
  l1493:;	  G->pos= yypos1493; G->thunkpos= yythunkpos1493;
  }
  {  int yypos1494= G->pos, yythunkpos1494= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1494;
  goto l1488;
  l1494:;	  G->pos= yypos1494; G->thunkpos= yythunkpos1494;
  }  if (!yymatchDot(G)) goto l1488;
  l1491:;	
  {  int yypos1492= G->pos, yythunkpos1492= G->thunkpos;
  {  int yypos1495= G->pos, yythunkpos1495= G->thunkpos;  if (!yy_Newline(G))  goto l1495;
  goto l1492;
  l1495:;	  G->pos= yypos1495; G->thunkpos= yythunkpos1495;
  }
  {  int yypos1496= G->pos, yythunkpos1496= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1496;
  goto l1492;
  l1496:;	  G->pos= yypos1496; G->thunkpos= yythunkpos1496;
  }  if (!yymatchDot(G)) goto l1492;  goto l1491;
  l1492:;	  G->pos= yypos1492; G->thunkpos= yythunkpos1492;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1488;  if (!yymatchChar(G, '>')) goto l1488;
  yyDo(G, yy_1_AutoLinkUrl, G->begin, G->end, "yy_1_AutoLinkUrl");
  yyprintf((stderr, "  ok   AutoLinkUrl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1488:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AutoLinkUrl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TitleDouble(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TitleDouble"));
  if (!yymatchChar(G, '"')) goto l1497;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1497;
  l1498:;	
  {  int yypos1499= G->pos, yythunkpos1499= G->thunkpos;
  {  int yypos1500= G->pos, yythunkpos1500= G->thunkpos;  if (!yymatchChar(G, '"')) goto l1500;
  if (!yy_Sp(G))  goto l1500;

  {  int yypos1501= G->pos, yythunkpos1501= G->thunkpos;  if (!yymatchChar(G, ')')) goto l1502;
  goto l1501;
  l1502:;	  G->pos= yypos1501; G->thunkpos= yythunkpos1501;  if (!yy_Newline(G))  goto l1500;

  }
  l1501:;	  goto l1499;
  l1500:;	  G->pos= yypos1500; G->thunkpos= yythunkpos1500;
  }
  {  int yypos1503= G->pos, yythunkpos1503= G->thunkpos;  if (!yy_BlankLine(G))  goto l1503;
  goto l1499;
  l1503:;	  G->pos= yypos1503; G->thunkpos= yythunkpos1503;
  }  if (!yymatchDot(G)) goto l1499;  goto l1498;
  l1499:;	  G->pos= yypos1499; G->thunkpos= yythunkpos1499;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1497;  if (!yymatchChar(G, '"')) goto l1497;
  yyprintf((stderr, "  ok   TitleDouble"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1497:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TitleDouble"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TitleSingle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TitleSingle"));
  if (!yymatchChar(G, '\'')) goto l1504;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1504;
  l1505:;	
  {  int yypos1506= G->pos, yythunkpos1506= G->thunkpos;
  {  int yypos1507= G->pos, yythunkpos1507= G->thunkpos;  if (!yymatchChar(G, '\'')) goto l1507;
  if (!yy_Sp(G))  goto l1507;

  {  int yypos1508= G->pos, yythunkpos1508= G->thunkpos;  if (!yymatchChar(G, ')')) goto l1509;
  goto l1508;
  l1509:;	  G->pos= yypos1508; G->thunkpos= yythunkpos1508;  if (!yy_Newline(G))  goto l1507;

  }
  l1508:;	  goto l1506;
  l1507:;	  G->pos= yypos1507; G->thunkpos= yythunkpos1507;
  }
  {  int yypos1510= G->pos, yythunkpos1510= G->thunkpos;  if (!yy_BlankLine(G))  goto l1510;
  goto l1506;
  l1510:;	  G->pos= yypos1510; G->thunkpos= yythunkpos1510;
  }  if (!yymatchDot(G)) goto l1506;  goto l1505;
  l1506:;	  G->pos= yypos1506; G->thunkpos= yythunkpos1506;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1504;  if (!yymatchChar(G, '\'')) goto l1504;
  yyprintf((stderr, "  ok   TitleSingle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1504:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TitleSingle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SourceContents(GREG *G)
{  yyprintfv((stderr, "%s\n", "SourceContents"));

  l1512:;	
  {  int yypos1513= G->pos, yythunkpos1513= G->thunkpos;
  {  int yypos1514= G->pos, yythunkpos1514= G->thunkpos;
  {  int yypos1518= G->pos, yythunkpos1518= G->thunkpos;  if (!yymatchChar(G, '(')) goto l1518;
  goto l1515;
  l1518:;	  G->pos= yypos1518; G->thunkpos= yythunkpos1518;
  }
  {  int yypos1519= G->pos, yythunkpos1519= G->thunkpos;  if (!yymatchChar(G, ')')) goto l1519;
  goto l1515;
  l1519:;	  G->pos= yypos1519; G->thunkpos= yythunkpos1519;
  }
  {  int yypos1520= G->pos, yythunkpos1520= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1520;
  goto l1515;
  l1520:;	  G->pos= yypos1520; G->thunkpos= yythunkpos1520;
  }  if (!yy_Nonspacechar(G))  goto l1515;

  l1516:;	
  {  int yypos1517= G->pos, yythunkpos1517= G->thunkpos;
  {  int yypos1521= G->pos, yythunkpos1521= G->thunkpos;  if (!yymatchChar(G, '(')) goto l1521;
  goto l1517;
  l1521:;	  G->pos= yypos1521; G->thunkpos= yythunkpos1521;
  }
  {  int yypos1522= G->pos, yythunkpos1522= G->thunkpos;  if (!yymatchChar(G, ')')) goto l1522;
  goto l1517;
  l1522:;	  G->pos= yypos1522; G->thunkpos= yythunkpos1522;
  }
  {  int yypos1523= G->pos, yythunkpos1523= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1523;
  goto l1517;
  l1523:;	  G->pos= yypos1523; G->thunkpos= yythunkpos1523;
  }  if (!yy_Nonspacechar(G))  goto l1517;
  goto l1516;
  l1517:;	  G->pos= yypos1517; G->thunkpos= yythunkpos1517;
  }  goto l1514;
  l1515:;	  G->pos= yypos1514; G->thunkpos= yythunkpos1514;  if (!yymatchChar(G, '(')) goto l1513;
  if (!yy_SourceContents(G))  goto l1513;
  if (!yymatchChar(G, ')')) goto l1513;

  }
  l1514:;	  goto l1512;
  l1513:;	  G->pos= yypos1513; G->thunkpos= yythunkpos1513;
  }  yyprintf((stderr, "  ok   SourceContents"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
}
YY_RULE(int) yy_Title(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Title"));

  {  int yypos1525= G->pos, yythunkpos1525= G->thunkpos;  if (!yy_TitleSingle(G))  goto l1526;
  goto l1525;
  l1526:;	  G->pos= yypos1525; G->thunkpos= yythunkpos1525;  if (!yy_TitleDouble(G))  goto l1527;
  goto l1525;
  l1527:;	  G->pos= yypos1525; G->thunkpos= yythunkpos1525;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1524;  if (!yymatchString(G, "")) goto l1524;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1524;
  }
  l1525:;	  yyDo(G, yy_1_Title, G->begin, G->end, "yy_1_Title");
  yyprintf((stderr, "  ok   Title"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1524:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Title"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Source(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Source"));

  {  int yypos1529= G->pos, yythunkpos1529= G->thunkpos;  if (!yymatchChar(G, '<')) goto l1530;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1530;  if (!yy_SourceContents(G))  goto l1530;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1530;  if (!yymatchChar(G, '>')) goto l1530;
  goto l1529;
  l1530:;	  G->pos= yypos1529; G->thunkpos= yythunkpos1529;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1528;  if (!yy_SourceContents(G))  goto l1528;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1528;
  }
  l1529:;	  yyDo(G, yy_1_Source, G->begin, G->end, "yy_1_Source");
  yyprintf((stderr, "  ok   Source"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1528:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Source"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawCitationReference(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RawCitationReference"));
  if (!yymatchString(G, "[#")) goto l1531;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1531;
  {  int yypos1534= G->pos, yythunkpos1534= G->thunkpos;  if (!yy_Newline(G))  goto l1534;
  goto l1531;
  l1534:;	  G->pos= yypos1534; G->thunkpos= yythunkpos1534;
  }
  {  int yypos1535= G->pos, yythunkpos1535= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1535;
  goto l1531;
  l1535:;	  G->pos= yypos1535; G->thunkpos= yythunkpos1535;
  }  if (!yymatchDot(G)) goto l1531;
  l1532:;	
  {  int yypos1533= G->pos, yythunkpos1533= G->thunkpos;
  {  int yypos1536= G->pos, yythunkpos1536= G->thunkpos;  if (!yy_Newline(G))  goto l1536;
  goto l1533;
  l1536:;	  G->pos= yypos1536; G->thunkpos= yythunkpos1536;
  }
  {  int yypos1537= G->pos, yythunkpos1537= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1537;
  goto l1533;
  l1537:;	  G->pos= yypos1537; G->thunkpos= yythunkpos1537;
  }  if (!yymatchDot(G)) goto l1533;  goto l1532;
  l1533:;	  G->pos= yypos1533; G->thunkpos= yythunkpos1533;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1531;  if (!yymatchChar(G, ']')) goto l1531;
  yyDo(G, yy_1_RawCitationReference, G->begin, G->end, "yy_1_RawCitationReference");
  yyprintf((stderr, "  ok   RawCitationReference"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1531:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawCitationReference"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CitationReferenceSingle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CitationReferenceSingle"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1538;
  {  int yypos1539= G->pos, yythunkpos1539= G->thunkpos;  if (!yymatchString(G, "[]")) goto l1540;
  if (!yy_Spnl(G))  goto l1540;
  if (!yy_RawCitationReference(G))  goto l1540;
  yyDo(G, yySet, -1, 0, "yySet");
  goto l1539;
  l1540:;	  G->pos= yypos1539; G->thunkpos= yythunkpos1539;  if (!yy_RawCitationReference(G))  goto l1538;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos1541= G->pos, yythunkpos1541= G->thunkpos;  if (!yy_Spnl(G))  goto l1541;
  if (!yymatchString(G, "[]")) goto l1541;
  goto l1542;
  l1541:;	  G->pos= yypos1541; G->thunkpos= yythunkpos1541;
  }
  l1542:;	
  }
  l1539:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1538;  yyDo(G, yy_1_CitationReferenceSingle, G->begin, G->end, "yy_1_CitationReferenceSingle");
  yyprintf((stderr, "  ok   CitationReferenceSingle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1538:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CitationReferenceSingle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CitationReferenceDouble(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "CitationReferenceDouble"));

  {  int yypos1544= G->pos, yythunkpos1544= G->thunkpos;  if (!yymatchString(G, "[]")) goto l1544;
  goto l1543;
  l1544:;	  G->pos= yypos1544; G->thunkpos= yythunkpos1544;
  }
  {  int yypos1545= G->pos, yythunkpos1545= G->thunkpos;  if (!yymatchString(G, "[#")) goto l1545;
  goto l1543;
  l1545:;	  G->pos= yypos1545; G->thunkpos= yythunkpos1545;
  }  if (!yy_Label(G))  goto l1543;
  yyDo(G, yySet, -2, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1543;  if (!yy_Spnl(G))  goto l1543;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1543;
  {  int yypos1546= G->pos, yythunkpos1546= G->thunkpos;  if (!yymatchString(G, "[]")) goto l1546;
  goto l1543;
  l1546:;	  G->pos= yypos1546; G->thunkpos= yythunkpos1546;
  }  if (!yy_RawCitationReference(G))  goto l1543;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_CitationReferenceDouble, G->begin, G->end, "yy_1_CitationReferenceDouble");
  yyprintf((stderr, "  ok   CitationReferenceDouble"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1543:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CitationReferenceDouble"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Label(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Label"));

  {  int yypos1548= G->pos, yythunkpos1548= G->thunkpos;  if (!yymatchChar(G, '[')) goto l1547;
  G->pos= yypos1548; G->thunkpos= yythunkpos1548;
  }  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1547;  if (!yy_BracketedText(G))  goto l1547;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1547;  yyDo(G, yy_1_Label, G->begin, G->end, "yy_1_Label");
  yyprintf((stderr, "  ok   Label"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1547:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Label"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ReferenceLinkSingle(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ReferenceLinkSingle"));
  if (!yy_Label(G))  goto l1549;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1549;
  {  int yypos1550= G->pos, yythunkpos1550= G->thunkpos;  if (!yy_Spnl(G))  goto l1550;
  if (!yymatchString(G, "[]")) goto l1550;
  goto l1551;
  l1550:;	  G->pos= yypos1550; G->thunkpos= yythunkpos1550;
  }
  l1551:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1549;  yyDo(G, yy_1_ReferenceLinkSingle, G->begin, G->end, "yy_1_ReferenceLinkSingle");
  yyprintf((stderr, "  ok   ReferenceLinkSingle"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1549:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ReferenceLinkSingle"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ReferenceLinkDouble(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ReferenceLinkDouble"));
  if (!yy_Label(G))  goto l1552;
  yyDo(G, yySet, -2, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1552;  if (!yy_Spnl(G))  goto l1552;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1552;
  {  int yypos1553= G->pos, yythunkpos1553= G->thunkpos;  if (!yymatchString(G, "[]")) goto l1553;
  goto l1552;
  l1553:;	  G->pos= yypos1553; G->thunkpos= yythunkpos1553;
  }  if (!yy_Label(G))  goto l1552;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_ReferenceLinkDouble, G->begin, G->end, "yy_1_ReferenceLinkDouble");
  yyprintf((stderr, "  ok   ReferenceLinkDouble"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l1552:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ReferenceLinkDouble"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AutoLink(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AutoLink"));

  {  int yypos1555= G->pos, yythunkpos1555= G->thunkpos;  if (!yy_AutoLinkUrl(G))  goto l1556;
  goto l1555;
  l1556:;	  G->pos= yypos1555; G->thunkpos= yythunkpos1555;  if (!yy_AutoLinkEmail(G))  goto l1554;

  }
  l1555:;	  yyprintf((stderr, "  ok   AutoLink"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1554:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AutoLink"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ReferenceLink(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ReferenceLink"));

  {  int yypos1558= G->pos, yythunkpos1558= G->thunkpos;  if (!yy_ReferenceLinkDouble(G))  goto l1559;
  goto l1558;
  l1559:;	  G->pos= yypos1558; G->thunkpos= yythunkpos1558;  if (!yy_ReferenceLinkSingle(G))  goto l1557;

  }
  l1558:;	  yyprintf((stderr, "  ok   ReferenceLink"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1557:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ReferenceLink"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ExplicitLink(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 3, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "ExplicitLink"));
  if (!yy_Label(G))  goto l1560;
  yyDo(G, yySet, -3, 0, "yySet");
  if (!yy_Spnl(G))  goto l1560;
  if (!yymatchChar(G, '(')) goto l1560;
  if (!yy_Sp(G))  goto l1560;
  if (!yy_Source(G))  goto l1560;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_Spnl(G))  goto l1560;
  if (!yy_Title(G))  goto l1560;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Sp(G))  goto l1560;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1560;  if (!yymatchChar(G, ')')) goto l1560;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1560;  yyDo(G, yy_1_ExplicitLink, G->begin, G->end, "yy_1_ExplicitLink");
  yyprintf((stderr, "  ok   ExplicitLink"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 3, 0, "yyPop");
  return 1;
  l1560:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ExplicitLink"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongUlClose(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongUlClose"));
  if (!yymatchString(G, "__")) goto l1561;

  {  int yypos1562= G->pos, yythunkpos1562= G->thunkpos;
  {  int yypos1563= G->pos, yythunkpos1563= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1563;
  goto l1564;
  l1563:;	  G->pos= yypos1563; G->thunkpos= yythunkpos1563;
  }
  l1564:;	
  {  int yypos1565= G->pos, yythunkpos1565= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1565;
  goto l1561;
  l1565:;	  G->pos= yypos1565; G->thunkpos= yythunkpos1565;
  }
  {  int yypos1566= G->pos, yythunkpos1566= G->thunkpos;  if (!yy_Whitespace(G))  goto l1567;
  goto l1566;
  l1567:;	  G->pos= yypos1566; G->thunkpos= yythunkpos1566;  if (!yy_Punctuation(G))  goto l1568;
  goto l1566;
  l1568:;	  G->pos= yypos1566; G->thunkpos= yythunkpos1566;  if (!yy_SpecialChar(G))  goto l1569;
  goto l1566;
  l1569:;	  G->pos= yypos1566; G->thunkpos= yythunkpos1566;  if (!yy_Eof(G))  goto l1561;

  }
  l1566:;	  G->pos= yypos1562; G->thunkpos= yythunkpos1562;
  }  yyprintf((stderr, "  ok   StrongUlClose"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1561:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongUlClose"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongUlOpen(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongUlOpen"));
  if (!yymatchString(G, "__")) goto l1570;

  {  int yypos1571= G->pos, yythunkpos1571= G->thunkpos;  if (!yy_Whitespace(G))  goto l1571;
  goto l1570;
  l1571:;	  G->pos= yypos1571; G->thunkpos= yythunkpos1571;
  }  yyprintf((stderr, "  ok   StrongUlOpen"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1570:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongUlOpen"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongStarClose(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongStarClose"));
  if (!yymatchString(G, "**")) goto l1572;
  yyprintf((stderr, "  ok   StrongStarClose"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1572:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongStarClose"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongStarOpen(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongStarOpen"));
  if (!yymatchString(G, "**")) goto l1573;

  {  int yypos1574= G->pos, yythunkpos1574= G->thunkpos;  if (!yy_Whitespace(G))  goto l1574;
  goto l1573;
  l1574:;	  G->pos= yypos1574; G->thunkpos= yythunkpos1574;
  }  yyprintf((stderr, "  ok   StrongStarOpen"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1573:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongStarOpen"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongUl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongUl"));
  if (!yy_StrongUlOpen(G))  goto l1575;

  {  int yypos1576= G->pos, yythunkpos1576= G->thunkpos;  if (!yy_EmphMatch(G))  goto l1577;
  goto l1576;
  l1577:;	  G->pos= yypos1576; G->thunkpos= yythunkpos1576;  if (!yy_BracketedText(G))  goto l1578;
  goto l1576;
  l1578:;	  G->pos= yypos1576; G->thunkpos= yythunkpos1576;  if (!yy_MathText(G))  goto l1579;
  goto l1576;
  l1579:;	  G->pos= yypos1576; G->thunkpos= yythunkpos1576;
  {  int yypos1580= G->pos, yythunkpos1580= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1580;
  goto l1575;
  l1580:;	  G->pos= yypos1580; G->thunkpos= yythunkpos1580;
  }  if (!yymatchDot(G)) goto l1575;
  }
  l1576:;	
  l1581:;	
  {  int yypos1582= G->pos, yythunkpos1582= G->thunkpos;
  {  int yypos1583= G->pos, yythunkpos1583= G->thunkpos;
  {  int yypos1585= G->pos, yythunkpos1585= G->thunkpos;  if (!yy_Whitespace(G))  goto l1584;
  G->pos= yypos1585; G->thunkpos= yythunkpos1585;
  }  if (!yy_Whitespace(G))  goto l1584;

  {  int yypos1586= G->pos, yythunkpos1586= G->thunkpos;  if (!yy_StrongMatch(G))  goto l1587;
  goto l1586;
  l1587:;	  G->pos= yypos1586; G->thunkpos= yythunkpos1586;  if (!yy_EmphMatch(G))  goto l1584;

  }
  l1586:;	  goto l1583;
  l1584:;	  G->pos= yypos1583; G->thunkpos= yythunkpos1583;
  {  int yypos1589= G->pos, yythunkpos1589= G->thunkpos;  if (!yy_OneTwoStar(G))  goto l1588;
  G->pos= yypos1589; G->thunkpos= yythunkpos1589;
  }
  {  int yypos1590= G->pos, yythunkpos1590= G->thunkpos;  if (!yy_StrongStar(G))  goto l1591;
  goto l1590;
  l1591:;	  G->pos= yypos1590; G->thunkpos= yythunkpos1590;  if (!yy_EmphStar(G))  goto l1588;

  }
  l1590:;	  goto l1583;
  l1588:;	  G->pos= yypos1583; G->thunkpos= yythunkpos1583;  if (!yy_BracketedText(G))  goto l1592;
  goto l1583;
  l1592:;	  G->pos= yypos1583; G->thunkpos= yythunkpos1583;  if (!yy_MathText(G))  goto l1593;
  goto l1583;
  l1593:;	  G->pos= yypos1583; G->thunkpos= yythunkpos1583;
  {  int yypos1594= G->pos, yythunkpos1594= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1594;
  goto l1582;
  l1594:;	  G->pos= yypos1594; G->thunkpos= yythunkpos1594;
  }
  {  int yypos1595= G->pos, yythunkpos1595= G->thunkpos;  if (!yy_BlankLine(G))  goto l1595;
  if (!yy_BlankLine(G))  goto l1595;
  goto l1582;
  l1595:;	  G->pos= yypos1595; G->thunkpos= yythunkpos1595;
  }  if (!yymatchDot(G)) goto l1582;
  }
  l1583:;	  goto l1581;
  l1582:;	  G->pos= yypos1582; G->thunkpos= yythunkpos1582;
  }  if (!yy_StrongUlClose(G))  goto l1575;
  yyprintf((stderr, "  ok   StrongUl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1575:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongUl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphUlClose(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphUlClose"));
  if (!yymatchChar(G, '_')) goto l1596;

  {  int yypos1597= G->pos, yythunkpos1597= G->thunkpos;
  {  int yypos1598= G->pos, yythunkpos1598= G->thunkpos;  if (!yymatchString(G, "__")) goto l1598;
  goto l1599;
  l1598:;	  G->pos= yypos1598; G->thunkpos= yythunkpos1598;
  }
  l1599:;	
  {  int yypos1600= G->pos, yythunkpos1600= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1600;
  goto l1596;
  l1600:;	  G->pos= yypos1600; G->thunkpos= yythunkpos1600;
  }
  {  int yypos1601= G->pos, yythunkpos1601= G->thunkpos;  if (!yy_Whitespace(G))  goto l1602;
  goto l1601;
  l1602:;	  G->pos= yypos1601; G->thunkpos= yythunkpos1601;  if (!yy_Punctuation(G))  goto l1603;
  goto l1601;
  l1603:;	  G->pos= yypos1601; G->thunkpos= yythunkpos1601;  if (!yy_SpecialChar(G))  goto l1604;
  goto l1601;
  l1604:;	  G->pos= yypos1601; G->thunkpos= yythunkpos1601;  if (!yy_Eof(G))  goto l1596;

  }
  l1601:;	  G->pos= yypos1597; G->thunkpos= yythunkpos1597;
  }  yyprintf((stderr, "  ok   EmphUlClose"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1596:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphUlClose"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphUlOpen(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphUlOpen"));
  if (!yymatchChar(G, '_')) goto l1605;

  {  int yypos1606= G->pos, yythunkpos1606= G->thunkpos;  if (!yy_Whitespace(G))  goto l1606;
  goto l1605;
  l1606:;	  G->pos= yypos1606; G->thunkpos= yythunkpos1606;
  }  yyprintf((stderr, "  ok   EmphUlOpen"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1605:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphUlOpen"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongStar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongStar"));
  if (!yy_StrongStarOpen(G))  goto l1607;

  {  int yypos1608= G->pos, yythunkpos1608= G->thunkpos;  if (!yy_EmphMatch(G))  goto l1609;
  goto l1608;
  l1609:;	  G->pos= yypos1608; G->thunkpos= yythunkpos1608;  if (!yy_BracketedText(G))  goto l1610;
  goto l1608;
  l1610:;	  G->pos= yypos1608; G->thunkpos= yythunkpos1608;  if (!yy_MathText(G))  goto l1611;
  goto l1608;
  l1611:;	  G->pos= yypos1608; G->thunkpos= yythunkpos1608;
  {  int yypos1612= G->pos, yythunkpos1612= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1612;
  goto l1607;
  l1612:;	  G->pos= yypos1612; G->thunkpos= yythunkpos1612;
  }  if (!yymatchDot(G)) goto l1607;
  }
  l1608:;	
  l1613:;	
  {  int yypos1614= G->pos, yythunkpos1614= G->thunkpos;
  {  int yypos1615= G->pos, yythunkpos1615= G->thunkpos;
  {  int yypos1617= G->pos, yythunkpos1617= G->thunkpos;  if (!yy_Whitespace(G))  goto l1616;
  G->pos= yypos1617; G->thunkpos= yythunkpos1617;
  }  if (!yy_Whitespace(G))  goto l1616;

  {  int yypos1618= G->pos, yythunkpos1618= G->thunkpos;  if (!yy_StrongMatch(G))  goto l1619;
  goto l1618;
  l1619:;	  G->pos= yypos1618; G->thunkpos= yythunkpos1618;  if (!yy_EmphMatch(G))  goto l1616;

  }
  l1618:;	  goto l1615;
  l1616:;	  G->pos= yypos1615; G->thunkpos= yythunkpos1615;
  {  int yypos1621= G->pos, yythunkpos1621= G->thunkpos;  if (!yy_OneStar(G))  goto l1620;
  G->pos= yypos1621; G->thunkpos= yythunkpos1621;
  }  if (!yy_EmphStar(G))  goto l1620;
  goto l1615;
  l1620:;	  G->pos= yypos1615; G->thunkpos= yythunkpos1615;  if (!yy_BracketedText(G))  goto l1622;
  goto l1615;
  l1622:;	  G->pos= yypos1615; G->thunkpos= yythunkpos1615;  if (!yy_MathText(G))  goto l1623;
  goto l1615;
  l1623:;	  G->pos= yypos1615; G->thunkpos= yythunkpos1615;
  {  int yypos1625= G->pos, yythunkpos1625= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1625;
  goto l1624;
  l1625:;	  G->pos= yypos1625; G->thunkpos= yythunkpos1625;
  }
  {  int yypos1626= G->pos, yythunkpos1626= G->thunkpos;  if (!yy_Whitespace(G))  goto l1626;
  goto l1624;
  l1626:;	  G->pos= yypos1626; G->thunkpos= yythunkpos1626;
  }  if (!yymatchDot(G)) goto l1624;  goto l1615;
  l1624:;	  G->pos= yypos1615; G->thunkpos= yythunkpos1615;
  {  int yypos1627= G->pos, yythunkpos1627= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1627;
  goto l1614;
  l1627:;	  G->pos= yypos1627; G->thunkpos= yythunkpos1627;
  }
  {  int yypos1628= G->pos, yythunkpos1628= G->thunkpos;  if (!yy_BlankLine(G))  goto l1628;
  if (!yy_BlankLine(G))  goto l1628;
  goto l1614;
  l1628:;	  G->pos= yypos1628; G->thunkpos= yythunkpos1628;
  }
  {  int yypos1629= G->pos, yythunkpos1629= G->thunkpos;  if (!yy_Whitespace(G))  goto l1629;
  if (!yymatchChar(G, '*')) goto l1629;
  goto l1614;
  l1629:;	  G->pos= yypos1629; G->thunkpos= yythunkpos1629;
  }  if (!yymatchDot(G)) goto l1614;
  }
  l1615:;	  goto l1613;
  l1614:;	  G->pos= yypos1614; G->thunkpos= yythunkpos1614;
  }  if (!yy_StrongStarClose(G))  goto l1607;
  yyprintf((stderr, "  ok   StrongStar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1607:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongStar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BracketedText(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BracketedText"));

  {  int yypos1631= G->pos, yythunkpos1631= G->thunkpos;  if (!yymatchChar(G, '[')) goto l1630;

  l1632:;	
  {  int yypos1633= G->pos, yythunkpos1633= G->thunkpos;
  {  int yypos1634= G->pos, yythunkpos1634= G->thunkpos;  if (!yy_BlankLine(G))  goto l1634;
  if (!yy_BlankLine(G))  goto l1634;
  goto l1633;
  l1634:;	  G->pos= yypos1634; G->thunkpos= yythunkpos1634;
  }
  {  int yypos1635= G->pos, yythunkpos1635= G->thunkpos;  if (!yymatchChar(G, ']')) goto l1635;
  goto l1633;
  l1635:;	  G->pos= yypos1635; G->thunkpos= yythunkpos1635;
  }  if (!yymatchDot(G)) goto l1633;  goto l1632;
  l1633:;	  G->pos= yypos1633; G->thunkpos= yythunkpos1633;
  }  if (!yymatchChar(G, ']')) goto l1630;
  G->pos= yypos1631; G->thunkpos= yythunkpos1631;
  }  if (!yy_BracketedText2(G))  goto l1630;
  yyprintf((stderr, "  ok   BracketedText"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1630:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BracketedText"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrongMatch(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrongMatch"));

  {  int yypos1637= G->pos, yythunkpos1637= G->thunkpos;  if (!yy_StrongStar(G))  goto l1638;
  goto l1637;
  l1638:;	  G->pos= yypos1637; G->thunkpos= yythunkpos1637;  if (!yy_StrongUl(G))  goto l1636;

  }
  l1637:;	  yyprintf((stderr, "  ok   StrongMatch"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1636:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrongMatch"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ThreeStar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ThreeStar"));
  if (!yymatchString(G, "***")) goto l1639;

  {  int yypos1640= G->pos, yythunkpos1640= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1640;
  goto l1639;
  l1640:;	  G->pos= yypos1640; G->thunkpos= yythunkpos1640;
  }  yyprintf((stderr, "  ok   ThreeStar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1639:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ThreeStar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OneTwoStar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OneTwoStar"));
  if (!yymatchChar(G, '*')) goto l1641;

  {  int yypos1642= G->pos, yythunkpos1642= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1642;
  goto l1643;
  l1642:;	  G->pos= yypos1642; G->thunkpos= yythunkpos1642;
  }
  l1643:;	
  {  int yypos1644= G->pos, yythunkpos1644= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1644;
  goto l1641;
  l1644:;	  G->pos= yypos1644; G->thunkpos= yythunkpos1644;
  }  yyprintf((stderr, "  ok   OneTwoStar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1641:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OneTwoStar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TwoStar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TwoStar"));
  if (!yymatchString(G, "**")) goto l1645;

  {  int yypos1646= G->pos, yythunkpos1646= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1646;
  goto l1645;
  l1646:;	  G->pos= yypos1646; G->thunkpos= yythunkpos1646;
  }  yyprintf((stderr, "  ok   TwoStar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1645:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TwoStar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OneStar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OneStar"));
  if (!yymatchChar(G, '*')) goto l1647;

  {  int yypos1648= G->pos, yythunkpos1648= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1648;
  goto l1647;
  l1648:;	  G->pos= yypos1648; G->thunkpos= yythunkpos1648;
  }  yyprintf((stderr, "  ok   OneStar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1647:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OneStar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphStarClose(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphStarClose"));
  if (!yymatchChar(G, '*')) goto l1649;
  yyprintf((stderr, "  ok   EmphStarClose"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1649:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphStarClose"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphStarOpen(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphStarOpen"));
  if (!yymatchChar(G, '*')) goto l1650;

  {  int yypos1651= G->pos, yythunkpos1651= G->thunkpos;  if (!yy_Whitespace(G))  goto l1651;
  goto l1650;
  l1651:;	  G->pos= yypos1651; G->thunkpos= yythunkpos1651;
  }  yyprintf((stderr, "  ok   EmphStarOpen"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1650:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphStarOpen"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphUl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphUl"));
  if (!yy_EmphUlOpen(G))  goto l1652;

  {  int yypos1653= G->pos, yythunkpos1653= G->thunkpos;  if (!yy_StrongMatch(G))  goto l1654;
  goto l1653;
  l1654:;	  G->pos= yypos1653; G->thunkpos= yythunkpos1653;  if (!yy_BracketedText(G))  goto l1655;
  goto l1653;
  l1655:;	  G->pos= yypos1653; G->thunkpos= yythunkpos1653;  if (!yy_MathText(G))  goto l1656;
  goto l1653;
  l1656:;	  G->pos= yypos1653; G->thunkpos= yythunkpos1653;
  {  int yypos1657= G->pos, yythunkpos1657= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1657;
  goto l1652;
  l1657:;	  G->pos= yypos1657; G->thunkpos= yythunkpos1657;
  }  if (!yymatchDot(G)) goto l1652;
  }
  l1653:;	
  l1658:;	
  {  int yypos1659= G->pos, yythunkpos1659= G->thunkpos;
  {  int yypos1660= G->pos, yythunkpos1660= G->thunkpos;
  {  int yypos1662= G->pos, yythunkpos1662= G->thunkpos;  if (!yy_Whitespace(G))  goto l1661;
  G->pos= yypos1662; G->thunkpos= yythunkpos1662;
  }  if (!yy_Whitespace(G))  goto l1661;

  {  int yypos1663= G->pos, yythunkpos1663= G->thunkpos;  if (!yy_StrongMatch(G))  goto l1664;
  goto l1663;
  l1664:;	  G->pos= yypos1663; G->thunkpos= yythunkpos1663;  if (!yy_EmphMatch(G))  goto l1661;

  }
  l1663:;	  goto l1660;
  l1661:;	  G->pos= yypos1660; G->thunkpos= yythunkpos1660;
  {  int yypos1666= G->pos, yythunkpos1666= G->thunkpos;  if (!yy_OneTwoStar(G))  goto l1665;
  G->pos= yypos1666; G->thunkpos= yythunkpos1666;
  }
  {  int yypos1667= G->pos, yythunkpos1667= G->thunkpos;  if (!yy_StrongStar(G))  goto l1668;
  goto l1667;
  l1668:;	  G->pos= yypos1667; G->thunkpos= yythunkpos1667;  if (!yy_EmphStar(G))  goto l1665;

  }
  l1667:;	  goto l1660;
  l1665:;	  G->pos= yypos1660; G->thunkpos= yythunkpos1660;  if (!yy_BracketedText(G))  goto l1669;
  goto l1660;
  l1669:;	  G->pos= yypos1660; G->thunkpos= yythunkpos1660;  if (!yy_MathText(G))  goto l1670;
  goto l1660;
  l1670:;	  G->pos= yypos1660; G->thunkpos= yythunkpos1660;
  {  int yypos1671= G->pos, yythunkpos1671= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1671;
  goto l1659;
  l1671:;	  G->pos= yypos1671; G->thunkpos= yythunkpos1671;
  }
  {  int yypos1672= G->pos, yythunkpos1672= G->thunkpos;  if (!yy_BlankLine(G))  goto l1672;
  if (!yy_BlankLine(G))  goto l1672;
  goto l1659;
  l1672:;	  G->pos= yypos1672; G->thunkpos= yythunkpos1672;
  }  if (!yymatchDot(G)) goto l1659;
  }
  l1660:;	  goto l1658;
  l1659:;	  G->pos= yypos1659; G->thunkpos= yythunkpos1659;
  }  if (!yy_EmphUlClose(G))  goto l1652;
  yyprintf((stderr, "  ok   EmphUl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1652:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphUl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphStar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphStar"));
  if (!yy_EmphStarOpen(G))  goto l1673;

  {  int yypos1674= G->pos, yythunkpos1674= G->thunkpos;  if (!yy_StrongMatch(G))  goto l1675;
  goto l1674;
  l1675:;	  G->pos= yypos1674; G->thunkpos= yythunkpos1674;  if (!yy_BracketedText(G))  goto l1676;
  goto l1674;
  l1676:;	  G->pos= yypos1674; G->thunkpos= yythunkpos1674;  if (!yy_MathText(G))  goto l1677;
  goto l1674;
  l1677:;	  G->pos= yypos1674; G->thunkpos= yythunkpos1674;
  {  int yypos1678= G->pos, yythunkpos1678= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1678;
  goto l1673;
  l1678:;	  G->pos= yypos1678; G->thunkpos= yythunkpos1678;
  }  if (!yymatchDot(G)) goto l1673;
  }
  l1674:;	
  l1679:;	
  {  int yypos1680= G->pos, yythunkpos1680= G->thunkpos;
  {  int yypos1681= G->pos, yythunkpos1681= G->thunkpos;
  {  int yypos1683= G->pos, yythunkpos1683= G->thunkpos;  if (!yy_Whitespace(G))  goto l1682;
  G->pos= yypos1683; G->thunkpos= yythunkpos1683;
  }  if (!yy_Whitespace(G))  goto l1682;

  {  int yypos1684= G->pos, yythunkpos1684= G->thunkpos;  if (!yy_StrongMatch(G))  goto l1685;
  goto l1684;
  l1685:;	  G->pos= yypos1684; G->thunkpos= yythunkpos1684;  if (!yy_EmphMatch(G))  goto l1682;

  }
  l1684:;	  goto l1681;
  l1682:;	  G->pos= yypos1681; G->thunkpos= yythunkpos1681;
  {  int yypos1687= G->pos, yythunkpos1687= G->thunkpos;  if (!yy_TwoStar(G))  goto l1686;
  G->pos= yypos1687; G->thunkpos= yythunkpos1687;
  }  if (!yy_StrongStar(G))  goto l1686;
  goto l1681;
  l1686:;	  G->pos= yypos1681; G->thunkpos= yythunkpos1681;  if (!yy_BracketedText(G))  goto l1688;
  goto l1681;
  l1688:;	  G->pos= yypos1681; G->thunkpos= yythunkpos1681;  if (!yy_MathText(G))  goto l1689;
  goto l1681;
  l1689:;	  G->pos= yypos1681; G->thunkpos= yythunkpos1681;
  {  int yypos1691= G->pos, yythunkpos1691= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1691;
  goto l1690;
  l1691:;	  G->pos= yypos1691; G->thunkpos= yythunkpos1691;
  }
  {  int yypos1692= G->pos, yythunkpos1692= G->thunkpos;  if (!yy_Whitespace(G))  goto l1692;
  goto l1690;
  l1692:;	  G->pos= yypos1692; G->thunkpos= yythunkpos1692;
  }  if (!yymatchDot(G)) goto l1690;  goto l1681;
  l1690:;	  G->pos= yypos1681; G->thunkpos= yythunkpos1681;
  {  int yypos1693= G->pos, yythunkpos1693= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1693;
  goto l1680;
  l1693:;	  G->pos= yypos1693; G->thunkpos= yythunkpos1693;
  }
  {  int yypos1694= G->pos, yythunkpos1694= G->thunkpos;  if (!yy_BlankLine(G))  goto l1694;
  if (!yy_BlankLine(G))  goto l1694;
  goto l1680;
  l1694:;	  G->pos= yypos1694; G->thunkpos= yythunkpos1694;
  }
  {  int yypos1695= G->pos, yythunkpos1695= G->thunkpos;  if (!yy_Whitespace(G))  goto l1695;
  if (!yymatchChar(G, '*')) goto l1695;
  goto l1680;
  l1695:;	  G->pos= yypos1695; G->thunkpos= yythunkpos1695;
  }  if (!yymatchDot(G)) goto l1680;
  }
  l1681:;	  goto l1679;
  l1680:;	  G->pos= yypos1680; G->thunkpos= yythunkpos1680;
  }  if (!yy_EmphStarClose(G))  goto l1673;
  yyprintf((stderr, "  ok   EmphStar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1673:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphStar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EmphMatch(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EmphMatch"));

  {  int yypos1697= G->pos, yythunkpos1697= G->thunkpos;  if (!yy_EmphStar(G))  goto l1698;
  goto l1697;
  l1698:;	  G->pos= yypos1697; G->thunkpos= yythunkpos1697;  if (!yy_EmphUl(G))  goto l1696;

  }
  l1697:;	  yyprintf((stderr, "  ok   EmphMatch"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1696:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EmphMatch"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Whitespace(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Whitespace"));

  {  int yypos1700= G->pos, yythunkpos1700= G->thunkpos;  if (!yy_Spacechar(G))  goto l1701;
  goto l1700;
  l1701:;	  G->pos= yypos1700; G->thunkpos= yythunkpos1700;  if (!yy_Newline(G))  goto l1702;
  goto l1700;
  l1702:;	  G->pos= yypos1700; G->thunkpos= yythunkpos1700;  if (!yy_Eof(G))  goto l1699;

  }
  l1700:;	  yyprintf((stderr, "  ok   Whitespace"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1699:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Whitespace"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StarLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StarLine"));

  {  int yypos1704= G->pos, yythunkpos1704= G->thunkpos;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1705;  if (!yymatchString(G, "****")) goto l1705;

  l1706:;	
  {  int yypos1707= G->pos, yythunkpos1707= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1707;
  goto l1706;
  l1707:;	  G->pos= yypos1707; G->thunkpos= yythunkpos1707;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1705;  goto l1704;
  l1705:;	  G->pos= yypos1704; G->thunkpos= yythunkpos1704;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1703;  if (!yy_Spacechar(G))  goto l1703;
  if (!yymatchChar(G, '*')) goto l1703;

  l1708:;	
  {  int yypos1709= G->pos, yythunkpos1709= G->thunkpos;  if (!yymatchChar(G, '*')) goto l1709;
  goto l1708;
  l1709:;	  G->pos= yypos1709; G->thunkpos= yythunkpos1709;
  }
  {  int yypos1710= G->pos, yythunkpos1710= G->thunkpos;  if (!yy_Spacechar(G))  goto l1703;
  G->pos= yypos1710; G->thunkpos= yythunkpos1710;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1703;
  }
  l1704:;	  yyprintf((stderr, "  ok   StarLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1703:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StarLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_UlLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "UlLine"));

  {  int yypos1712= G->pos, yythunkpos1712= G->thunkpos;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1713;  if (!yymatchString(G, "____")) goto l1713;

  l1714:;	
  {  int yypos1715= G->pos, yythunkpos1715= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1715;
  goto l1714;
  l1715:;	  G->pos= yypos1715; G->thunkpos= yythunkpos1715;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1713;  goto l1712;
  l1713:;	  G->pos= yypos1712; G->thunkpos= yythunkpos1712;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1711;  if (!yy_Spacechar(G))  goto l1711;
  if (!yymatchChar(G, '_')) goto l1711;

  l1716:;	
  {  int yypos1717= G->pos, yythunkpos1717= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1717;
  goto l1716;
  l1717:;	  G->pos= yypos1717; G->thunkpos= yythunkpos1717;
  }
  {  int yypos1718= G->pos, yythunkpos1718= G->thunkpos;  if (!yy_Spacechar(G))  goto l1711;
  G->pos= yypos1718; G->thunkpos= yythunkpos1718;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1711;
  }
  l1712:;	  yyprintf((stderr, "  ok   UlLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1711:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "UlLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MathSpanText(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "MathSpanText"));
  if (!yymatchChar(G, '\\')) goto l1719;

  {  int yypos1720= G->pos, yythunkpos1720= G->thunkpos;  if (!yymatchString(G, "\\[")) goto l1721;

  l1722:;	
  {  int yypos1723= G->pos, yythunkpos1723= G->thunkpos;
  {  int yypos1724= G->pos, yythunkpos1724= G->thunkpos;  if (!yymatchString(G, "\\\\]")) goto l1724;
  goto l1723;
  l1724:;	  G->pos= yypos1724; G->thunkpos= yythunkpos1724;
  }  if (!yymatchDot(G)) goto l1723;  goto l1722;
  l1723:;	  G->pos= yypos1723; G->thunkpos= yythunkpos1723;
  }  if (!yymatchString(G, "\\\\]")) goto l1721;
  goto l1720;
  l1721:;	  G->pos= yypos1720; G->thunkpos= yythunkpos1720;  if (!yymatchString(G, "\\(")) goto l1719;

  l1725:;	
  {  int yypos1726= G->pos, yythunkpos1726= G->thunkpos;
  {  int yypos1727= G->pos, yythunkpos1727= G->thunkpos;  if (!yymatchString(G, "\\\\)")) goto l1727;
  goto l1726;
  l1727:;	  G->pos= yypos1727; G->thunkpos= yythunkpos1727;
  }  if (!yymatchDot(G)) goto l1726;  goto l1725;
  l1726:;	  G->pos= yypos1726; G->thunkpos= yythunkpos1726;
  }  if (!yymatchString(G, "\\\\)")) goto l1719;

  }
  l1720:;	  yyprintf((stderr, "  ok   MathSpanText"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1719:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MathSpanText"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MathText(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "MathText"));
  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l1728;
  {  int yypos1729= G->pos, yythunkpos1729= G->thunkpos;  if (!yy_MathSpanText(G))  goto l1730;
  goto l1729;
  l1730:;	  G->pos= yypos1729; G->thunkpos= yythunkpos1729;  if (!yy_SingleDollarMathText(G))  goto l1731;
  goto l1729;
  l1731:;	  G->pos= yypos1729; G->thunkpos= yythunkpos1729;  if (!yy_DoubleDollarMathText(G))  goto l1728;

  }
  l1729:;	  yyprintf((stderr, "  ok   MathText"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1728:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MathText"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleDollarMathText(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DoubleDollarMathText"));
  if (!yy_DoubleDollarMathStart(G))  goto l1732;

  l1733:;	
  {  int yypos1734= G->pos, yythunkpos1734= G->thunkpos;
  {  int yypos1735= G->pos, yythunkpos1735= G->thunkpos;  if (!yy_DoubleDollarMathEnd(G))  goto l1735;
  goto l1734;
  l1735:;	  G->pos= yypos1735; G->thunkpos= yythunkpos1735;
  }
  {  int yypos1736= G->pos, yythunkpos1736= G->thunkpos;  if (!yy_BlankLine(G))  goto l1736;
  if (!yy_BlankLine(G))  goto l1736;
  goto l1734;
  l1736:;	  G->pos= yypos1736; G->thunkpos= yythunkpos1736;
  }  if (!yymatchDot(G)) goto l1734;  goto l1733;
  l1734:;	  G->pos= yypos1734; G->thunkpos= yythunkpos1734;
  }  if (!yy_DoubleDollarMathEnd(G))  goto l1732;
  yyprintf((stderr, "  ok   DoubleDollarMathText"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1732:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleDollarMathText"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleDollarMath(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DoubleDollarMath"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1737;  if (!yy_DoubleDollarMathText(G))  goto l1737;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1737;  yyDo(G, yy_1_DoubleDollarMath, G->begin, G->end, "yy_1_DoubleDollarMath");
  yyprintf((stderr, "  ok   DoubleDollarMath"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1737:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleDollarMath"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleDollarMathEnd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DoubleDollarMathEnd"));

  {  int yypos1739= G->pos, yythunkpos1739= G->thunkpos;  if (!yymatchChar(G, '\\')) goto l1739;
  goto l1738;
  l1739:;	  G->pos= yypos1739; G->thunkpos= yythunkpos1739;
  }  if (!yy_Nonspacechar(G))  goto l1738;
  if (!yymatchChar(G, '$')) goto l1738;
  if (!yymatchChar(G, '$')) goto l1738;

  {  int yypos1740= G->pos, yythunkpos1740= G->thunkpos;  if (!yy_NonPunctuation(G))  goto l1740;
  goto l1738;
  l1740:;	  G->pos= yypos1740; G->thunkpos= yythunkpos1740;
  }  yyprintf((stderr, "  ok   DoubleDollarMathEnd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1738:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleDollarMathEnd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DoubleDollarMathStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DoubleDollarMathStart"));
  if (!yymatchChar(G, '$')) goto l1741;
  if (!yymatchChar(G, '$')) goto l1741;

  {  int yypos1742= G->pos, yythunkpos1742= G->thunkpos;
  {  int yypos1743= G->pos, yythunkpos1743= G->thunkpos;  if (!yy_Spacechar(G))  goto l1744;
  goto l1743;
  l1744:;	  G->pos= yypos1743; G->thunkpos= yythunkpos1743;  if (!yy_Newline(G))  goto l1742;

  }
  l1743:;	  goto l1741;
  l1742:;	  G->pos= yypos1742; G->thunkpos= yythunkpos1742;
  }  yyprintf((stderr, "  ok   DoubleDollarMathStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1741:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DoubleDollarMathStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleDollarMathText(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleDollarMathText"));
  if (!yy_SingleDollarMathStart(G))  goto l1745;

  l1746:;	
  {  int yypos1747= G->pos, yythunkpos1747= G->thunkpos;
  {  int yypos1748= G->pos, yythunkpos1748= G->thunkpos;  if (!yy_SingleDollarMathEnd(G))  goto l1748;
  goto l1747;
  l1748:;	  G->pos= yypos1748; G->thunkpos= yythunkpos1748;
  }
  {  int yypos1749= G->pos, yythunkpos1749= G->thunkpos;  if (!yy_BlankLine(G))  goto l1749;
  if (!yy_BlankLine(G))  goto l1749;
  goto l1747;
  l1749:;	  G->pos= yypos1749; G->thunkpos= yythunkpos1749;
  }  if (!yymatchDot(G)) goto l1747;  goto l1746;
  l1747:;	  G->pos= yypos1747; G->thunkpos= yythunkpos1747;
  }  if (!yy_SingleDollarMathEnd(G))  goto l1745;
  yyprintf((stderr, "  ok   SingleDollarMathText"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1745:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleDollarMathText"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleDollarMath(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleDollarMath"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1750;  if (!yy_SingleDollarMathText(G))  goto l1750;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1750;  yyDo(G, yy_1_SingleDollarMath, G->begin, G->end, "yy_1_SingleDollarMath");
  yyprintf((stderr, "  ok   SingleDollarMath"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1750:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleDollarMath"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleDollarMathEnd(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleDollarMathEnd"));

  {  int yypos1752= G->pos, yythunkpos1752= G->thunkpos;  if (!yymatchChar(G, '\\')) goto l1752;
  goto l1751;
  l1752:;	  G->pos= yypos1752; G->thunkpos= yythunkpos1752;
  }
  {  int yypos1753= G->pos, yythunkpos1753= G->thunkpos;  if (!yymatchChar(G, '$')) goto l1753;
  goto l1751;
  l1753:;	  G->pos= yypos1753; G->thunkpos= yythunkpos1753;
  }  if (!yy_Nonspacechar(G))  goto l1751;
  if (!yymatchChar(G, '$')) goto l1751;

  {  int yypos1754= G->pos, yythunkpos1754= G->thunkpos;  if (!yy_NonPunctuation(G))  goto l1754;
  goto l1751;
  l1754:;	  G->pos= yypos1754; G->thunkpos= yythunkpos1754;
  }  yyprintf((stderr, "  ok   SingleDollarMathEnd"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1751:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleDollarMathEnd"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleDollarMathStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleDollarMathStart"));
  if (!yymatchChar(G, '$')) goto l1755;

  {  int yypos1756= G->pos, yythunkpos1756= G->thunkpos;
  {  int yypos1757= G->pos, yythunkpos1757= G->thunkpos;  if (!yy_Spacechar(G))  goto l1758;
  goto l1757;
  l1758:;	  G->pos= yypos1757; G->thunkpos= yythunkpos1757;  if (!yy_Newline(G))  goto l1759;
  goto l1757;
  l1759:;	  G->pos= yypos1757; G->thunkpos= yythunkpos1757;  if (!yymatchChar(G, '$')) goto l1756;

  }
  l1757:;	  goto l1755;
  l1756:;	  G->pos= yypos1756; G->thunkpos= yythunkpos1756;
  }  yyprintf((stderr, "  ok   SingleDollarMathStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1755:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleDollarMathStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AposChunk(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AposChunk"));
  yyText(G, G->begin, G->end);  if (!( ext(EXT_SMART) )) goto l1760;  if (!yymatchChar(G, '\'')) goto l1760;

  {  int yypos1761= G->pos, yythunkpos1761= G->thunkpos;  if (!yy_Alphanumeric(G))  goto l1760;
  G->pos= yypos1761; G->thunkpos= yythunkpos1761;
  }  yyDo(G, yy_1_AposChunk, G->begin, G->end, "yy_1_AposChunk");
  yyprintf((stderr, "  ok   AposChunk"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1760:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AposChunk"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Subscript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Subscript"));
  if (!yymatchChar(G, '~')) goto l1762;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1762;
  {  int yypos1763= G->pos, yythunkpos1763= G->thunkpos;
  {  int yypos1767= G->pos, yythunkpos1767= G->thunkpos;  if (!yymatchChar(G, '~')) goto l1767;
  goto l1764;
  l1767:;	  G->pos= yypos1767; G->thunkpos= yythunkpos1767;
  }  if (!yy_Nonspacechar(G))  goto l1764;

  l1765:;	
  {  int yypos1766= G->pos, yythunkpos1766= G->thunkpos;
  {  int yypos1768= G->pos, yythunkpos1768= G->thunkpos;  if (!yymatchChar(G, '~')) goto l1768;
  goto l1766;
  l1768:;	  G->pos= yypos1768; G->thunkpos= yythunkpos1768;
  }  if (!yy_Nonspacechar(G))  goto l1766;
  goto l1765;
  l1766:;	  G->pos= yypos1766; G->thunkpos= yythunkpos1766;
  }
  {  int yypos1769= G->pos, yythunkpos1769= G->thunkpos;  if (!yymatchChar(G, '~')) goto l1764;
  G->pos= yypos1769; G->thunkpos= yythunkpos1769;
  }  goto l1763;
  l1764:;	  G->pos= yypos1763; G->thunkpos= yythunkpos1763;
  {  int yypos1772= G->pos, yythunkpos1772= G->thunkpos;  if (!yymatchChar(G, '~')) goto l1772;
  goto l1762;
  l1772:;	  G->pos= yypos1772; G->thunkpos= yythunkpos1772;
  }  if (!yy_NonPunctuation(G))  goto l1762;

  l1770:;	
  {  int yypos1771= G->pos, yythunkpos1771= G->thunkpos;
  {  int yypos1773= G->pos, yythunkpos1773= G->thunkpos;  if (!yymatchChar(G, '~')) goto l1773;
  goto l1771;
  l1773:;	  G->pos= yypos1773; G->thunkpos= yythunkpos1773;
  }  if (!yy_NonPunctuation(G))  goto l1771;
  goto l1770;
  l1771:;	  G->pos= yypos1771; G->thunkpos= yythunkpos1771;
  }
  }
  l1763:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1762;
  {  int yypos1774= G->pos, yythunkpos1774= G->thunkpos;  if (!yymatchChar(G, '~')) goto l1774;
  goto l1775;
  l1774:;	  G->pos= yypos1774; G->thunkpos= yythunkpos1774;
  }
  l1775:;	  yyDo(G, yy_1_Subscript, G->begin, G->end, "yy_1_Subscript");
  yyprintf((stderr, "  ok   Subscript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1762:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Subscript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Superscript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Superscript"));
  if (!yymatchChar(G, '^')) goto l1776;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1776;
  {  int yypos1777= G->pos, yythunkpos1777= G->thunkpos;
  {  int yypos1781= G->pos, yythunkpos1781= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1781;
  goto l1778;
  l1781:;	  G->pos= yypos1781; G->thunkpos= yythunkpos1781;
  }  if (!yy_Nonspacechar(G))  goto l1778;

  l1779:;	
  {  int yypos1780= G->pos, yythunkpos1780= G->thunkpos;
  {  int yypos1782= G->pos, yythunkpos1782= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1782;
  goto l1780;
  l1782:;	  G->pos= yypos1782; G->thunkpos= yythunkpos1782;
  }  if (!yy_Nonspacechar(G))  goto l1780;
  goto l1779;
  l1780:;	  G->pos= yypos1780; G->thunkpos= yythunkpos1780;
  }
  {  int yypos1783= G->pos, yythunkpos1783= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1778;
  G->pos= yypos1783; G->thunkpos= yythunkpos1783;
  }  goto l1777;
  l1778:;	  G->pos= yypos1777; G->thunkpos= yythunkpos1777;
  {  int yypos1786= G->pos, yythunkpos1786= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1786;
  goto l1776;
  l1786:;	  G->pos= yypos1786; G->thunkpos= yythunkpos1786;
  }  if (!yy_NonPunctuation(G))  goto l1776;

  l1784:;	
  {  int yypos1785= G->pos, yythunkpos1785= G->thunkpos;
  {  int yypos1787= G->pos, yythunkpos1787= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1787;
  goto l1785;
  l1787:;	  G->pos= yypos1787; G->thunkpos= yythunkpos1787;
  }  if (!yy_NonPunctuation(G))  goto l1785;
  goto l1784;
  l1785:;	  G->pos= yypos1785; G->thunkpos= yythunkpos1785;
  }
  }
  l1777:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1776;
  {  int yypos1788= G->pos, yythunkpos1788= G->thunkpos;  if (!yymatchChar(G, '^')) goto l1788;
  goto l1789;
  l1788:;	  G->pos= yypos1788; G->thunkpos= yythunkpos1788;
  }
  l1789:;	  yyDo(G, yy_1_Superscript, G->begin, G->end, "yy_1_Superscript");
  yyprintf((stderr, "  ok   Superscript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1776:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Superscript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StrChunk(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StrChunk"));

  {  int yypos1791= G->pos, yythunkpos1791= G->thunkpos;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1792;
  {  int yypos1795= G->pos, yythunkpos1795= G->thunkpos;  if (!yy_NormalChar(G))  goto l1796;
  goto l1795;
  l1796:;	  G->pos= yypos1795; G->thunkpos= yythunkpos1795;  if (!yymatchChar(G, '_')) goto l1792;

  l1797:;	
  {  int yypos1798= G->pos, yythunkpos1798= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1798;
  goto l1797;
  l1798:;	  G->pos= yypos1798; G->thunkpos= yythunkpos1798;
  }
  {  int yypos1799= G->pos, yythunkpos1799= G->thunkpos;  if (!yy_Punctuation(G))  goto l1799;
  goto l1792;
  l1799:;	  G->pos= yypos1799; G->thunkpos= yythunkpos1799;
  }
  {  int yypos1800= G->pos, yythunkpos1800= G->thunkpos;  if (!yy_Alphanumeric(G))  goto l1792;
  G->pos= yypos1800; G->thunkpos= yythunkpos1800;
  }
  }
  l1795:;	
  l1793:;	
  {  int yypos1794= G->pos, yythunkpos1794= G->thunkpos;
  {  int yypos1801= G->pos, yythunkpos1801= G->thunkpos;  if (!yy_NormalChar(G))  goto l1802;
  goto l1801;
  l1802:;	  G->pos= yypos1801; G->thunkpos= yythunkpos1801;  if (!yymatchChar(G, '_')) goto l1794;

  l1803:;	
  {  int yypos1804= G->pos, yythunkpos1804= G->thunkpos;  if (!yymatchChar(G, '_')) goto l1804;
  goto l1803;
  l1804:;	  G->pos= yypos1804; G->thunkpos= yythunkpos1804;
  }
  {  int yypos1805= G->pos, yythunkpos1805= G->thunkpos;  if (!yy_Punctuation(G))  goto l1805;
  goto l1794;
  l1805:;	  G->pos= yypos1805; G->thunkpos= yythunkpos1805;
  }
  {  int yypos1806= G->pos, yythunkpos1806= G->thunkpos;  if (!yy_Alphanumeric(G))  goto l1794;
  G->pos= yypos1806; G->thunkpos= yythunkpos1806;
  }
  }
  l1801:;	  goto l1793;
  l1794:;	  G->pos= yypos1794; G->thunkpos= yythunkpos1794;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1792;  yyDo(G, yy_1_StrChunk, G->begin, G->end, "yy_1_StrChunk");
  goto l1791;
  l1792:;	  G->pos= yypos1791; G->thunkpos= yythunkpos1791;  if (!yy_AposChunk(G))  goto l1790;

  }
  l1791:;	  yyprintf((stderr, "  ok   StrChunk"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1790:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StrChunk"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_voidNormalEndline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "voidNormalEndline"));
  if (!yy_Sp(G))  goto l1807;
  if (!yy_Newline(G))  goto l1807;

  {  int yypos1808= G->pos, yythunkpos1808= G->thunkpos;  if (!yy_BlankLine(G))  goto l1808;
  goto l1807;
  l1808:;	  G->pos= yypos1808; G->thunkpos= yythunkpos1808;
  }
  {  int yypos1809= G->pos, yythunkpos1809= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1809;
  goto l1807;
  l1809:;	  G->pos= yypos1809; G->thunkpos= yythunkpos1809;
  }
  {  int yypos1810= G->pos, yythunkpos1810= G->thunkpos;  if (!yy_AtxStart(G))  goto l1810;
  goto l1807;
  l1810:;	  G->pos= yypos1810; G->thunkpos= yythunkpos1810;
  }
  {  int yypos1811= G->pos, yythunkpos1811= G->thunkpos;  if (!yy_RawLine(G))  goto l1811;

  {  int yypos1812= G->pos, yythunkpos1812= G->thunkpos;  if (!yymatchChar(G, '=')) goto l1813;

  l1814:;	
  {  int yypos1815= G->pos, yythunkpos1815= G->thunkpos;  if (!yymatchChar(G, '=')) goto l1815;
  goto l1814;
  l1815:;	  G->pos= yypos1815; G->thunkpos= yythunkpos1815;
  }  goto l1812;
  l1813:;	  G->pos= yypos1812; G->thunkpos= yythunkpos1812;  if (!yymatchChar(G, '-')) goto l1811;

  l1816:;	
  {  int yypos1817= G->pos, yythunkpos1817= G->thunkpos;  if (!yymatchChar(G, '-')) goto l1817;
  goto l1816;
  l1817:;	  G->pos= yypos1817; G->thunkpos= yythunkpos1817;
  }
  }
  l1812:;	  if (!yy_Newline(G))  goto l1811;
  goto l1807;
  l1811:;	  G->pos= yypos1811; G->thunkpos= yythunkpos1811;
  }  yyprintf((stderr, "  ok   voidNormalEndline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1807:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "voidNormalEndline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NormalEndline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NormalEndline"));
  if (!yy_Sp(G))  goto l1818;
  if (!yy_Newline(G))  goto l1818;

  {  int yypos1819= G->pos, yythunkpos1819= G->thunkpos;  if (!yy_BlankLine(G))  goto l1819;
  goto l1818;
  l1819:;	  G->pos= yypos1819; G->thunkpos= yythunkpos1819;
  }
  {  int yypos1820= G->pos, yythunkpos1820= G->thunkpos;  if (!yymatchChar(G, '>')) goto l1820;
  goto l1818;
  l1820:;	  G->pos= yypos1820; G->thunkpos= yythunkpos1820;
  }
  {  int yypos1821= G->pos, yythunkpos1821= G->thunkpos;  if (!yy_AtxStart(G))  goto l1821;
  goto l1818;
  l1821:;	  G->pos= yypos1821; G->thunkpos= yythunkpos1821;
  }
  {  int yypos1822= G->pos, yythunkpos1822= G->thunkpos;  if (!yy_RawLine(G))  goto l1822;

  {  int yypos1823= G->pos, yythunkpos1823= G->thunkpos;  if (!yymatchChar(G, '=')) goto l1824;

  l1825:;	
  {  int yypos1826= G->pos, yythunkpos1826= G->thunkpos;  if (!yymatchChar(G, '=')) goto l1826;
  goto l1825;
  l1826:;	  G->pos= yypos1826; G->thunkpos= yythunkpos1826;
  }  goto l1823;
  l1824:;	  G->pos= yypos1823; G->thunkpos= yythunkpos1823;  if (!yymatchChar(G, '-')) goto l1822;

  l1827:;	
  {  int yypos1828= G->pos, yythunkpos1828= G->thunkpos;  if (!yymatchChar(G, '-')) goto l1828;
  goto l1827;
  l1828:;	  G->pos= yypos1828; G->thunkpos= yythunkpos1828;
  }
  }
  l1823:;	  if (!yy_Newline(G))  goto l1822;
  goto l1818;
  l1822:;	  G->pos= yypos1822; G->thunkpos= yythunkpos1822;
  }  yyDo(G, yy_1_NormalEndline, G->begin, G->end, "yy_1_NormalEndline");
  yyprintf((stderr, "  ok   NormalEndline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1818:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NormalEndline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TerminalEndline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TerminalEndline"));
  if (!yy_Sp(G))  goto l1829;
  if (!yy_Newline(G))  goto l1829;
  if (!yy_Eof(G))  goto l1829;
  yyDo(G, yy_1_TerminalEndline, G->begin, G->end, "yy_1_TerminalEndline");
  yyprintf((stderr, "  ok   TerminalEndline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1829:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TerminalEndline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_LineBreak(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "LineBreak"));

  {  int yypos1831= G->pos, yythunkpos1831= G->thunkpos;  if (!yymatchString(G, "  ")) goto l1832;
  goto l1831;
  l1832:;	  G->pos= yypos1831; G->thunkpos= yythunkpos1831;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) && ext(EXT_ESCAPED_LINE_BREAKS) )) goto l1830;  if (!yy_Sp(G))  goto l1830;
  if (!yymatchChar(G, '\\')) goto l1830;

  }
  l1831:;	  if (!yy_NormalEndline(G))  goto l1830;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_LineBreak, G->begin, G->end, "yy_1_LineBreak");
  yyprintf((stderr, "  ok   LineBreak"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1830:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "LineBreak"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Smart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Smart"));
  yyText(G, G->begin, G->end);  if (!( ext(EXT_SMART) )) goto l1833;
  {  int yypos1834= G->pos, yythunkpos1834= G->thunkpos;  if (!yy_Ellipsis(G))  goto l1835;
  goto l1834;
  l1835:;	  G->pos= yypos1834; G->thunkpos= yythunkpos1834;  if (!yy_Dash(G))  goto l1836;
  goto l1834;
  l1836:;	  G->pos= yypos1834; G->thunkpos= yythunkpos1834;  if (!yy_SingleQuoted(G))  goto l1837;
  goto l1834;
  l1837:;	  G->pos= yypos1834; G->thunkpos= yythunkpos1834;  if (!yy_DoubleQuoted(G))  goto l1838;
  goto l1834;
  l1838:;	  G->pos= yypos1834; G->thunkpos= yythunkpos1834;  if (!yy_BackTickQuoted(G))  goto l1839;
  goto l1834;
  l1839:;	  G->pos= yypos1834; G->thunkpos= yythunkpos1834;  if (!yy_Apostrophe(G))  goto l1833;

  }
  l1834:;	  yyprintf((stderr, "  ok   Smart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1833:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Smart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MarkdownHtmlTagOpen(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "MarkdownHtmlTagOpen"));
  if (!yy_StartList(G))  goto l1840;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yymatchChar(G, '<')) goto l1840;
  yyDo(G, yy_1_MarkdownHtmlTagOpen, G->begin, G->end, "yy_1_MarkdownHtmlTagOpen");
  if (!yy_Spnl(G))  goto l1840;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1840;  if (!yy_HtmlBlockType(G))  goto l1840;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1840;  yyDo(G, yy_2_MarkdownHtmlTagOpen, G->begin, G->end, "yy_2_MarkdownHtmlTagOpen");

  {  int yypos1841= G->pos, yythunkpos1841= G->thunkpos;  if (!yy_Spacechar(G))  goto l1840;
  G->pos= yypos1841; G->thunkpos= yythunkpos1841;
  }  if (!yy_Spnl(G))  goto l1840;

  l1842:;	
  {  int yypos1843= G->pos, yythunkpos1843= G->thunkpos;
  {  int yypos1844= G->pos, yythunkpos1844= G->thunkpos;  if (!yy_MarkdownHtmlAttribute(G))  goto l1844;
  goto l1843;
  l1844:;	  G->pos= yypos1844; G->thunkpos= yythunkpos1844;
  }  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1843;  if (!yy_HtmlAttribute(G))  goto l1843;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1843;  yyDo(G, yy_3_MarkdownHtmlTagOpen, G->begin, G->end, "yy_3_MarkdownHtmlTagOpen");
  goto l1842;
  l1843:;	  G->pos= yypos1843; G->thunkpos= yythunkpos1843;
  }  if (!yy_MarkdownHtmlAttribute(G))  goto l1840;

  l1845:;	
  {  int yypos1846= G->pos, yythunkpos1846= G->thunkpos;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1846;  if (!yy_HtmlAttribute(G))  goto l1846;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1846;  yyDo(G, yy_4_MarkdownHtmlTagOpen, G->begin, G->end, "yy_4_MarkdownHtmlTagOpen");
  goto l1845;
  l1846:;	  G->pos= yypos1846; G->thunkpos= yythunkpos1846;
  }  if (!yymatchChar(G, '>')) goto l1840;
  yyDo(G, yy_5_MarkdownHtmlTagOpen, G->begin, G->end, "yy_5_MarkdownHtmlTagOpen");
  yyDo(G, yy_6_MarkdownHtmlTagOpen, G->begin, G->end, "yy_6_MarkdownHtmlTagOpen");
  yyprintf((stderr, "  ok   MarkdownHtmlTagOpen"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l1840:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MarkdownHtmlTagOpen"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Code(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Code"));

  {  int yypos1848= G->pos, yythunkpos1848= G->thunkpos;  if (!yy_Ticks1(G))  goto l1849;
  if (!yy_Sp(G))  goto l1849;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1849;
  {  int yypos1852= G->pos, yythunkpos1852= G->thunkpos;
  {  int yypos1856= G->pos, yythunkpos1856= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1856;
  goto l1853;
  l1856:;	  G->pos= yypos1856; G->thunkpos= yythunkpos1856;
  }  if (!yy_Nonspacechar(G))  goto l1853;

  l1854:;	
  {  int yypos1855= G->pos, yythunkpos1855= G->thunkpos;
  {  int yypos1857= G->pos, yythunkpos1857= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1857;
  goto l1855;
  l1857:;	  G->pos= yypos1857; G->thunkpos= yythunkpos1857;
  }  if (!yy_Nonspacechar(G))  goto l1855;
  goto l1854;
  l1855:;	  G->pos= yypos1855; G->thunkpos= yythunkpos1855;
  }  goto l1852;
  l1853:;	  G->pos= yypos1852; G->thunkpos= yythunkpos1852;
  {  int yypos1859= G->pos, yythunkpos1859= G->thunkpos;  if (!yy_Ticks1(G))  goto l1859;
  goto l1858;
  l1859:;	  G->pos= yypos1859; G->thunkpos= yythunkpos1859;
  }  if (!yymatchChar(G, '`')) goto l1858;

  l1860:;	
  {  int yypos1861= G->pos, yythunkpos1861= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1861;
  goto l1860;
  l1861:;	  G->pos= yypos1861; G->thunkpos= yythunkpos1861;
  }  goto l1852;
  l1858:;	  G->pos= yypos1852; G->thunkpos= yythunkpos1852;
  {  int yypos1862= G->pos, yythunkpos1862= G->thunkpos;  if (!yy_Sp(G))  goto l1862;
  if (!yy_Ticks1(G))  goto l1862;
  goto l1849;
  l1862:;	  G->pos= yypos1862; G->thunkpos= yythunkpos1862;
  }
  {  int yypos1863= G->pos, yythunkpos1863= G->thunkpos;  if (!yy_Spacechar(G))  goto l1864;
  goto l1863;
  l1864:;	  G->pos= yypos1863; G->thunkpos= yythunkpos1863;  if (!yy_Newline(G))  goto l1849;

  {  int yypos1865= G->pos, yythunkpos1865= G->thunkpos;  if (!yy_BlankLine(G))  goto l1865;
  goto l1849;
  l1865:;	  G->pos= yypos1865; G->thunkpos= yythunkpos1865;
  }
  }
  l1863:;	
  }
  l1852:;	
  l1850:;	
  {  int yypos1851= G->pos, yythunkpos1851= G->thunkpos;
  {  int yypos1866= G->pos, yythunkpos1866= G->thunkpos;
  {  int yypos1870= G->pos, yythunkpos1870= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1870;
  goto l1867;
  l1870:;	  G->pos= yypos1870; G->thunkpos= yythunkpos1870;
  }  if (!yy_Nonspacechar(G))  goto l1867;

  l1868:;	
  {  int yypos1869= G->pos, yythunkpos1869= G->thunkpos;
  {  int yypos1871= G->pos, yythunkpos1871= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1871;
  goto l1869;
  l1871:;	  G->pos= yypos1871; G->thunkpos= yythunkpos1871;
  }  if (!yy_Nonspacechar(G))  goto l1869;
  goto l1868;
  l1869:;	  G->pos= yypos1869; G->thunkpos= yythunkpos1869;
  }  goto l1866;
  l1867:;	  G->pos= yypos1866; G->thunkpos= yythunkpos1866;
  {  int yypos1873= G->pos, yythunkpos1873= G->thunkpos;  if (!yy_Ticks1(G))  goto l1873;
  goto l1872;
  l1873:;	  G->pos= yypos1873; G->thunkpos= yythunkpos1873;
  }  if (!yymatchChar(G, '`')) goto l1872;

  l1874:;	
  {  int yypos1875= G->pos, yythunkpos1875= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1875;
  goto l1874;
  l1875:;	  G->pos= yypos1875; G->thunkpos= yythunkpos1875;
  }  goto l1866;
  l1872:;	  G->pos= yypos1866; G->thunkpos= yythunkpos1866;
  {  int yypos1876= G->pos, yythunkpos1876= G->thunkpos;  if (!yy_Sp(G))  goto l1876;
  if (!yy_Ticks1(G))  goto l1876;
  goto l1851;
  l1876:;	  G->pos= yypos1876; G->thunkpos= yythunkpos1876;
  }
  {  int yypos1877= G->pos, yythunkpos1877= G->thunkpos;  if (!yy_Spacechar(G))  goto l1878;
  goto l1877;
  l1878:;	  G->pos= yypos1877; G->thunkpos= yythunkpos1877;  if (!yy_Newline(G))  goto l1851;

  {  int yypos1879= G->pos, yythunkpos1879= G->thunkpos;  if (!yy_BlankLine(G))  goto l1879;
  goto l1851;
  l1879:;	  G->pos= yypos1879; G->thunkpos= yythunkpos1879;
  }
  }
  l1877:;	
  }
  l1866:;	  goto l1850;
  l1851:;	  G->pos= yypos1851; G->thunkpos= yythunkpos1851;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1849;  if (!yy_Sp(G))  goto l1849;
  if (!yy_Ticks1(G))  goto l1849;
  goto l1848;
  l1849:;	  G->pos= yypos1848; G->thunkpos= yythunkpos1848;  if (!yy_Ticks2(G))  goto l1880;
  if (!yy_Sp(G))  goto l1880;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1880;
  {  int yypos1883= G->pos, yythunkpos1883= G->thunkpos;
  {  int yypos1887= G->pos, yythunkpos1887= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1887;
  goto l1884;
  l1887:;	  G->pos= yypos1887; G->thunkpos= yythunkpos1887;
  }  if (!yy_Nonspacechar(G))  goto l1884;

  l1885:;	
  {  int yypos1886= G->pos, yythunkpos1886= G->thunkpos;
  {  int yypos1888= G->pos, yythunkpos1888= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1888;
  goto l1886;
  l1888:;	  G->pos= yypos1888; G->thunkpos= yythunkpos1888;
  }  if (!yy_Nonspacechar(G))  goto l1886;
  goto l1885;
  l1886:;	  G->pos= yypos1886; G->thunkpos= yythunkpos1886;
  }  goto l1883;
  l1884:;	  G->pos= yypos1883; G->thunkpos= yythunkpos1883;
  {  int yypos1890= G->pos, yythunkpos1890= G->thunkpos;  if (!yy_Ticks2(G))  goto l1890;
  goto l1889;
  l1890:;	  G->pos= yypos1890; G->thunkpos= yythunkpos1890;
  }  if (!yymatchChar(G, '`')) goto l1889;

  l1891:;	
  {  int yypos1892= G->pos, yythunkpos1892= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1892;
  goto l1891;
  l1892:;	  G->pos= yypos1892; G->thunkpos= yythunkpos1892;
  }  goto l1883;
  l1889:;	  G->pos= yypos1883; G->thunkpos= yythunkpos1883;
  {  int yypos1893= G->pos, yythunkpos1893= G->thunkpos;  if (!yy_Sp(G))  goto l1893;
  if (!yy_Ticks2(G))  goto l1893;
  goto l1880;
  l1893:;	  G->pos= yypos1893; G->thunkpos= yythunkpos1893;
  }
  {  int yypos1894= G->pos, yythunkpos1894= G->thunkpos;  if (!yy_Spacechar(G))  goto l1895;
  goto l1894;
  l1895:;	  G->pos= yypos1894; G->thunkpos= yythunkpos1894;  if (!yy_Newline(G))  goto l1880;

  {  int yypos1896= G->pos, yythunkpos1896= G->thunkpos;  if (!yy_BlankLine(G))  goto l1896;
  goto l1880;
  l1896:;	  G->pos= yypos1896; G->thunkpos= yythunkpos1896;
  }
  }
  l1894:;	
  }
  l1883:;	
  l1881:;	
  {  int yypos1882= G->pos, yythunkpos1882= G->thunkpos;
  {  int yypos1897= G->pos, yythunkpos1897= G->thunkpos;
  {  int yypos1901= G->pos, yythunkpos1901= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1901;
  goto l1898;
  l1901:;	  G->pos= yypos1901; G->thunkpos= yythunkpos1901;
  }  if (!yy_Nonspacechar(G))  goto l1898;

  l1899:;	
  {  int yypos1900= G->pos, yythunkpos1900= G->thunkpos;
  {  int yypos1902= G->pos, yythunkpos1902= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1902;
  goto l1900;
  l1902:;	  G->pos= yypos1902; G->thunkpos= yythunkpos1902;
  }  if (!yy_Nonspacechar(G))  goto l1900;
  goto l1899;
  l1900:;	  G->pos= yypos1900; G->thunkpos= yythunkpos1900;
  }  goto l1897;
  l1898:;	  G->pos= yypos1897; G->thunkpos= yythunkpos1897;
  {  int yypos1904= G->pos, yythunkpos1904= G->thunkpos;  if (!yy_Ticks2(G))  goto l1904;
  goto l1903;
  l1904:;	  G->pos= yypos1904; G->thunkpos= yythunkpos1904;
  }  if (!yymatchChar(G, '`')) goto l1903;

  l1905:;	
  {  int yypos1906= G->pos, yythunkpos1906= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1906;
  goto l1905;
  l1906:;	  G->pos= yypos1906; G->thunkpos= yythunkpos1906;
  }  goto l1897;
  l1903:;	  G->pos= yypos1897; G->thunkpos= yythunkpos1897;
  {  int yypos1907= G->pos, yythunkpos1907= G->thunkpos;  if (!yy_Sp(G))  goto l1907;
  if (!yy_Ticks2(G))  goto l1907;
  goto l1882;
  l1907:;	  G->pos= yypos1907; G->thunkpos= yythunkpos1907;
  }
  {  int yypos1908= G->pos, yythunkpos1908= G->thunkpos;  if (!yy_Spacechar(G))  goto l1909;
  goto l1908;
  l1909:;	  G->pos= yypos1908; G->thunkpos= yythunkpos1908;  if (!yy_Newline(G))  goto l1882;

  {  int yypos1910= G->pos, yythunkpos1910= G->thunkpos;  if (!yy_BlankLine(G))  goto l1910;
  goto l1882;
  l1910:;	  G->pos= yypos1910; G->thunkpos= yythunkpos1910;
  }
  }
  l1908:;	
  }
  l1897:;	  goto l1881;
  l1882:;	  G->pos= yypos1882; G->thunkpos= yythunkpos1882;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1880;  if (!yy_Sp(G))  goto l1880;
  if (!yy_Ticks2(G))  goto l1880;
  goto l1848;
  l1880:;	  G->pos= yypos1848; G->thunkpos= yythunkpos1848;  if (!yy_Ticks3(G))  goto l1911;
  if (!yy_Sp(G))  goto l1911;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1911;
  {  int yypos1914= G->pos, yythunkpos1914= G->thunkpos;
  {  int yypos1918= G->pos, yythunkpos1918= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1918;
  goto l1915;
  l1918:;	  G->pos= yypos1918; G->thunkpos= yythunkpos1918;
  }  if (!yy_Nonspacechar(G))  goto l1915;

  l1916:;	
  {  int yypos1917= G->pos, yythunkpos1917= G->thunkpos;
  {  int yypos1919= G->pos, yythunkpos1919= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1919;
  goto l1917;
  l1919:;	  G->pos= yypos1919; G->thunkpos= yythunkpos1919;
  }  if (!yy_Nonspacechar(G))  goto l1917;
  goto l1916;
  l1917:;	  G->pos= yypos1917; G->thunkpos= yythunkpos1917;
  }  goto l1914;
  l1915:;	  G->pos= yypos1914; G->thunkpos= yythunkpos1914;
  {  int yypos1921= G->pos, yythunkpos1921= G->thunkpos;  if (!yy_Ticks3(G))  goto l1921;
  goto l1920;
  l1921:;	  G->pos= yypos1921; G->thunkpos= yythunkpos1921;
  }  if (!yymatchChar(G, '`')) goto l1920;

  l1922:;	
  {  int yypos1923= G->pos, yythunkpos1923= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1923;
  goto l1922;
  l1923:;	  G->pos= yypos1923; G->thunkpos= yythunkpos1923;
  }  goto l1914;
  l1920:;	  G->pos= yypos1914; G->thunkpos= yythunkpos1914;
  {  int yypos1924= G->pos, yythunkpos1924= G->thunkpos;  if (!yy_Sp(G))  goto l1924;
  if (!yy_Ticks3(G))  goto l1924;
  goto l1911;
  l1924:;	  G->pos= yypos1924; G->thunkpos= yythunkpos1924;
  }
  {  int yypos1925= G->pos, yythunkpos1925= G->thunkpos;  if (!yy_Spacechar(G))  goto l1926;
  goto l1925;
  l1926:;	  G->pos= yypos1925; G->thunkpos= yythunkpos1925;  if (!yy_Newline(G))  goto l1911;

  {  int yypos1927= G->pos, yythunkpos1927= G->thunkpos;  if (!yy_BlankLine(G))  goto l1927;
  goto l1911;
  l1927:;	  G->pos= yypos1927; G->thunkpos= yythunkpos1927;
  }
  }
  l1925:;	
  }
  l1914:;	
  l1912:;	
  {  int yypos1913= G->pos, yythunkpos1913= G->thunkpos;
  {  int yypos1928= G->pos, yythunkpos1928= G->thunkpos;
  {  int yypos1932= G->pos, yythunkpos1932= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1932;
  goto l1929;
  l1932:;	  G->pos= yypos1932; G->thunkpos= yythunkpos1932;
  }  if (!yy_Nonspacechar(G))  goto l1929;

  l1930:;	
  {  int yypos1931= G->pos, yythunkpos1931= G->thunkpos;
  {  int yypos1933= G->pos, yythunkpos1933= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1933;
  goto l1931;
  l1933:;	  G->pos= yypos1933; G->thunkpos= yythunkpos1933;
  }  if (!yy_Nonspacechar(G))  goto l1931;
  goto l1930;
  l1931:;	  G->pos= yypos1931; G->thunkpos= yythunkpos1931;
  }  goto l1928;
  l1929:;	  G->pos= yypos1928; G->thunkpos= yythunkpos1928;
  {  int yypos1935= G->pos, yythunkpos1935= G->thunkpos;  if (!yy_Ticks3(G))  goto l1935;
  goto l1934;
  l1935:;	  G->pos= yypos1935; G->thunkpos= yythunkpos1935;
  }  if (!yymatchChar(G, '`')) goto l1934;

  l1936:;	
  {  int yypos1937= G->pos, yythunkpos1937= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1937;
  goto l1936;
  l1937:;	  G->pos= yypos1937; G->thunkpos= yythunkpos1937;
  }  goto l1928;
  l1934:;	  G->pos= yypos1928; G->thunkpos= yythunkpos1928;
  {  int yypos1938= G->pos, yythunkpos1938= G->thunkpos;  if (!yy_Sp(G))  goto l1938;
  if (!yy_Ticks3(G))  goto l1938;
  goto l1913;
  l1938:;	  G->pos= yypos1938; G->thunkpos= yythunkpos1938;
  }
  {  int yypos1939= G->pos, yythunkpos1939= G->thunkpos;  if (!yy_Spacechar(G))  goto l1940;
  goto l1939;
  l1940:;	  G->pos= yypos1939; G->thunkpos= yythunkpos1939;  if (!yy_Newline(G))  goto l1913;

  {  int yypos1941= G->pos, yythunkpos1941= G->thunkpos;  if (!yy_BlankLine(G))  goto l1941;
  goto l1913;
  l1941:;	  G->pos= yypos1941; G->thunkpos= yythunkpos1941;
  }
  }
  l1939:;	
  }
  l1928:;	  goto l1912;
  l1913:;	  G->pos= yypos1913; G->thunkpos= yythunkpos1913;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1911;  if (!yy_Sp(G))  goto l1911;
  if (!yy_Ticks3(G))  goto l1911;
  goto l1848;
  l1911:;	  G->pos= yypos1848; G->thunkpos= yythunkpos1848;  if (!yy_Ticks4(G))  goto l1942;
  if (!yy_Sp(G))  goto l1942;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1942;
  {  int yypos1945= G->pos, yythunkpos1945= G->thunkpos;
  {  int yypos1949= G->pos, yythunkpos1949= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1949;
  goto l1946;
  l1949:;	  G->pos= yypos1949; G->thunkpos= yythunkpos1949;
  }  if (!yy_Nonspacechar(G))  goto l1946;

  l1947:;	
  {  int yypos1948= G->pos, yythunkpos1948= G->thunkpos;
  {  int yypos1950= G->pos, yythunkpos1950= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1950;
  goto l1948;
  l1950:;	  G->pos= yypos1950; G->thunkpos= yythunkpos1950;
  }  if (!yy_Nonspacechar(G))  goto l1948;
  goto l1947;
  l1948:;	  G->pos= yypos1948; G->thunkpos= yythunkpos1948;
  }  goto l1945;
  l1946:;	  G->pos= yypos1945; G->thunkpos= yythunkpos1945;
  {  int yypos1952= G->pos, yythunkpos1952= G->thunkpos;  if (!yy_Ticks4(G))  goto l1952;
  goto l1951;
  l1952:;	  G->pos= yypos1952; G->thunkpos= yythunkpos1952;
  }  if (!yymatchChar(G, '`')) goto l1951;

  l1953:;	
  {  int yypos1954= G->pos, yythunkpos1954= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1954;
  goto l1953;
  l1954:;	  G->pos= yypos1954; G->thunkpos= yythunkpos1954;
  }  goto l1945;
  l1951:;	  G->pos= yypos1945; G->thunkpos= yythunkpos1945;
  {  int yypos1955= G->pos, yythunkpos1955= G->thunkpos;  if (!yy_Sp(G))  goto l1955;
  if (!yy_Ticks4(G))  goto l1955;
  goto l1942;
  l1955:;	  G->pos= yypos1955; G->thunkpos= yythunkpos1955;
  }
  {  int yypos1956= G->pos, yythunkpos1956= G->thunkpos;  if (!yy_Spacechar(G))  goto l1957;
  goto l1956;
  l1957:;	  G->pos= yypos1956; G->thunkpos= yythunkpos1956;  if (!yy_Newline(G))  goto l1942;

  {  int yypos1958= G->pos, yythunkpos1958= G->thunkpos;  if (!yy_BlankLine(G))  goto l1958;
  goto l1942;
  l1958:;	  G->pos= yypos1958; G->thunkpos= yythunkpos1958;
  }
  }
  l1956:;	
  }
  l1945:;	
  l1943:;	
  {  int yypos1944= G->pos, yythunkpos1944= G->thunkpos;
  {  int yypos1959= G->pos, yythunkpos1959= G->thunkpos;
  {  int yypos1963= G->pos, yythunkpos1963= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1963;
  goto l1960;
  l1963:;	  G->pos= yypos1963; G->thunkpos= yythunkpos1963;
  }  if (!yy_Nonspacechar(G))  goto l1960;

  l1961:;	
  {  int yypos1962= G->pos, yythunkpos1962= G->thunkpos;
  {  int yypos1964= G->pos, yythunkpos1964= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1964;
  goto l1962;
  l1964:;	  G->pos= yypos1964; G->thunkpos= yythunkpos1964;
  }  if (!yy_Nonspacechar(G))  goto l1962;
  goto l1961;
  l1962:;	  G->pos= yypos1962; G->thunkpos= yythunkpos1962;
  }  goto l1959;
  l1960:;	  G->pos= yypos1959; G->thunkpos= yythunkpos1959;
  {  int yypos1966= G->pos, yythunkpos1966= G->thunkpos;  if (!yy_Ticks4(G))  goto l1966;
  goto l1965;
  l1966:;	  G->pos= yypos1966; G->thunkpos= yythunkpos1966;
  }  if (!yymatchChar(G, '`')) goto l1965;

  l1967:;	
  {  int yypos1968= G->pos, yythunkpos1968= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1968;
  goto l1967;
  l1968:;	  G->pos= yypos1968; G->thunkpos= yythunkpos1968;
  }  goto l1959;
  l1965:;	  G->pos= yypos1959; G->thunkpos= yythunkpos1959;
  {  int yypos1969= G->pos, yythunkpos1969= G->thunkpos;  if (!yy_Sp(G))  goto l1969;
  if (!yy_Ticks4(G))  goto l1969;
  goto l1944;
  l1969:;	  G->pos= yypos1969; G->thunkpos= yythunkpos1969;
  }
  {  int yypos1970= G->pos, yythunkpos1970= G->thunkpos;  if (!yy_Spacechar(G))  goto l1971;
  goto l1970;
  l1971:;	  G->pos= yypos1970; G->thunkpos= yythunkpos1970;  if (!yy_Newline(G))  goto l1944;

  {  int yypos1972= G->pos, yythunkpos1972= G->thunkpos;  if (!yy_BlankLine(G))  goto l1972;
  goto l1944;
  l1972:;	  G->pos= yypos1972; G->thunkpos= yythunkpos1972;
  }
  }
  l1970:;	
  }
  l1959:;	  goto l1943;
  l1944:;	  G->pos= yypos1944; G->thunkpos= yythunkpos1944;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1942;  if (!yy_Sp(G))  goto l1942;
  if (!yy_Ticks4(G))  goto l1942;
  goto l1848;
  l1942:;	  G->pos= yypos1848; G->thunkpos= yythunkpos1848;  if (!yy_Ticks5(G))  goto l1847;
  if (!yy_Sp(G))  goto l1847;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l1847;
  {  int yypos1975= G->pos, yythunkpos1975= G->thunkpos;
  {  int yypos1979= G->pos, yythunkpos1979= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1979;
  goto l1976;
  l1979:;	  G->pos= yypos1979; G->thunkpos= yythunkpos1979;
  }  if (!yy_Nonspacechar(G))  goto l1976;

  l1977:;	
  {  int yypos1978= G->pos, yythunkpos1978= G->thunkpos;
  {  int yypos1980= G->pos, yythunkpos1980= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1980;
  goto l1978;
  l1980:;	  G->pos= yypos1980; G->thunkpos= yythunkpos1980;
  }  if (!yy_Nonspacechar(G))  goto l1978;
  goto l1977;
  l1978:;	  G->pos= yypos1978; G->thunkpos= yythunkpos1978;
  }  goto l1975;
  l1976:;	  G->pos= yypos1975; G->thunkpos= yythunkpos1975;
  {  int yypos1982= G->pos, yythunkpos1982= G->thunkpos;  if (!yy_Ticks5(G))  goto l1982;
  goto l1981;
  l1982:;	  G->pos= yypos1982; G->thunkpos= yythunkpos1982;
  }  if (!yymatchChar(G, '`')) goto l1981;

  l1983:;	
  {  int yypos1984= G->pos, yythunkpos1984= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1984;
  goto l1983;
  l1984:;	  G->pos= yypos1984; G->thunkpos= yythunkpos1984;
  }  goto l1975;
  l1981:;	  G->pos= yypos1975; G->thunkpos= yythunkpos1975;
  {  int yypos1985= G->pos, yythunkpos1985= G->thunkpos;  if (!yy_Sp(G))  goto l1985;
  if (!yy_Ticks5(G))  goto l1985;
  goto l1847;
  l1985:;	  G->pos= yypos1985; G->thunkpos= yythunkpos1985;
  }
  {  int yypos1986= G->pos, yythunkpos1986= G->thunkpos;  if (!yy_Spacechar(G))  goto l1987;
  goto l1986;
  l1987:;	  G->pos= yypos1986; G->thunkpos= yythunkpos1986;  if (!yy_Newline(G))  goto l1847;

  {  int yypos1988= G->pos, yythunkpos1988= G->thunkpos;  if (!yy_BlankLine(G))  goto l1988;
  goto l1847;
  l1988:;	  G->pos= yypos1988; G->thunkpos= yythunkpos1988;
  }
  }
  l1986:;	
  }
  l1975:;	
  l1973:;	
  {  int yypos1974= G->pos, yythunkpos1974= G->thunkpos;
  {  int yypos1989= G->pos, yythunkpos1989= G->thunkpos;
  {  int yypos1993= G->pos, yythunkpos1993= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1993;
  goto l1990;
  l1993:;	  G->pos= yypos1993; G->thunkpos= yythunkpos1993;
  }  if (!yy_Nonspacechar(G))  goto l1990;

  l1991:;	
  {  int yypos1992= G->pos, yythunkpos1992= G->thunkpos;
  {  int yypos1994= G->pos, yythunkpos1994= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1994;
  goto l1992;
  l1994:;	  G->pos= yypos1994; G->thunkpos= yythunkpos1994;
  }  if (!yy_Nonspacechar(G))  goto l1992;
  goto l1991;
  l1992:;	  G->pos= yypos1992; G->thunkpos= yythunkpos1992;
  }  goto l1989;
  l1990:;	  G->pos= yypos1989; G->thunkpos= yythunkpos1989;
  {  int yypos1996= G->pos, yythunkpos1996= G->thunkpos;  if (!yy_Ticks5(G))  goto l1996;
  goto l1995;
  l1996:;	  G->pos= yypos1996; G->thunkpos= yythunkpos1996;
  }  if (!yymatchChar(G, '`')) goto l1995;

  l1997:;	
  {  int yypos1998= G->pos, yythunkpos1998= G->thunkpos;  if (!yymatchChar(G, '`')) goto l1998;
  goto l1997;
  l1998:;	  G->pos= yypos1998; G->thunkpos= yythunkpos1998;
  }  goto l1989;
  l1995:;	  G->pos= yypos1989; G->thunkpos= yythunkpos1989;
  {  int yypos1999= G->pos, yythunkpos1999= G->thunkpos;  if (!yy_Sp(G))  goto l1999;
  if (!yy_Ticks5(G))  goto l1999;
  goto l1974;
  l1999:;	  G->pos= yypos1999; G->thunkpos= yythunkpos1999;
  }
  {  int yypos2000= G->pos, yythunkpos2000= G->thunkpos;  if (!yy_Spacechar(G))  goto l2001;
  goto l2000;
  l2001:;	  G->pos= yypos2000; G->thunkpos= yythunkpos2000;  if (!yy_Newline(G))  goto l1974;

  {  int yypos2002= G->pos, yythunkpos2002= G->thunkpos;  if (!yy_BlankLine(G))  goto l2002;
  goto l1974;
  l2002:;	  G->pos= yypos2002; G->thunkpos= yythunkpos2002;
  }
  }
  l2000:;	
  }
  l1989:;	  goto l1973;
  l1974:;	  G->pos= yypos1974; G->thunkpos= yythunkpos1974;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l1847;  if (!yy_Sp(G))  goto l1847;
  if (!yy_Ticks5(G))  goto l1847;

  }
  l1848:;	  yyDo(G, yy_1_Code, G->begin, G->end, "yy_1_Code");
  yyprintf((stderr, "  ok   Code"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l1847:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Code"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Image(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Image"));
  if (!yymatchChar(G, '!')) goto l2003;

  {  int yypos2004= G->pos, yythunkpos2004= G->thunkpos;  if (!yy_AutoLink(G))  goto l2004;
  goto l2003;
  l2004:;	  G->pos= yypos2004; G->thunkpos= yythunkpos2004;
  }  if (!yy_Link(G))  goto l2003;
  yyDo(G, yy_1_Image, G->begin, G->end, "yy_1_Image");
  yyprintf((stderr, "  ok   Image"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2003:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Image"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Link(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Link"));

  {  int yypos2006= G->pos, yythunkpos2006= G->thunkpos;  if (!yy_ExplicitLink(G))  goto l2007;
  goto l2006;
  l2007:;	  G->pos= yypos2006; G->thunkpos= yythunkpos2006;  if (!yy_ReferenceLink(G))  goto l2008;
  goto l2006;
  l2008:;	  G->pos= yypos2006; G->thunkpos= yythunkpos2006;  if (!yy_AutoLink(G))  goto l2005;

  }
  l2006:;	  yyprintf((stderr, "  ok   Link"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2005:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Link"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NoteReference(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NoteReference"));
  yyText(G, G->begin, G->end);  if (!( ext(EXT_NOTES) )) goto l2009;  if (!yymatchString(G, "[^")) goto l2009;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2009;
  {  int yypos2012= G->pos, yythunkpos2012= G->thunkpos;  if (!yy_Newline(G))  goto l2012;
  if (!yy_BlankLine(G))  goto l2012;
  goto l2009;
  l2012:;	  G->pos= yypos2012; G->thunkpos= yythunkpos2012;
  }
  {  int yypos2013= G->pos, yythunkpos2013= G->thunkpos;  if (!yymatchChar(G, ']')) goto l2013;
  goto l2009;
  l2013:;	  G->pos= yypos2013; G->thunkpos= yythunkpos2013;
  }  if (!yy_RawInline(G))  goto l2009;

  l2010:;	
  {  int yypos2011= G->pos, yythunkpos2011= G->thunkpos;
  {  int yypos2014= G->pos, yythunkpos2014= G->thunkpos;  if (!yy_Newline(G))  goto l2014;
  if (!yy_BlankLine(G))  goto l2014;
  goto l2011;
  l2014:;	  G->pos= yypos2014; G->thunkpos= yythunkpos2014;
  }
  {  int yypos2015= G->pos, yythunkpos2015= G->thunkpos;  if (!yymatchChar(G, ']')) goto l2015;
  goto l2011;
  l2015:;	  G->pos= yypos2015; G->thunkpos= yythunkpos2015;
  }  if (!yy_RawInline(G))  goto l2011;
  goto l2010;
  l2011:;	  G->pos= yypos2011; G->thunkpos= yythunkpos2011;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2009;  if (!yymatchChar(G, ']')) goto l2009;
  yyDo(G, yy_1_NoteReference, G->begin, G->end, "yy_1_NoteReference");
  yyprintf((stderr, "  ok   NoteReference"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2009:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NoteReference"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Variable(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Variable"));
  if (!yymatchString(G, "[%")) goto l2016;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2016;
  {  int yypos2019= G->pos, yythunkpos2019= G->thunkpos;  if (!yy_Newline(G))  goto l2019;
  goto l2016;
  l2019:;	  G->pos= yypos2019; G->thunkpos= yythunkpos2019;
  }
  {  int yypos2020= G->pos, yythunkpos2020= G->thunkpos;  if (!yymatchChar(G, ']')) goto l2020;
  goto l2016;
  l2020:;	  G->pos= yypos2020; G->thunkpos= yythunkpos2020;
  }  if (!yymatchDot(G)) goto l2016;
  l2017:;	
  {  int yypos2018= G->pos, yythunkpos2018= G->thunkpos;
  {  int yypos2021= G->pos, yythunkpos2021= G->thunkpos;  if (!yy_Newline(G))  goto l2021;
  goto l2018;
  l2021:;	  G->pos= yypos2021; G->thunkpos= yythunkpos2021;
  }
  {  int yypos2022= G->pos, yythunkpos2022= G->thunkpos;  if (!yymatchChar(G, ']')) goto l2022;
  goto l2018;
  l2022:;	  G->pos= yypos2022; G->thunkpos= yythunkpos2022;
  }  if (!yymatchDot(G)) goto l2018;  goto l2017;
  l2018:;	  G->pos= yypos2018; G->thunkpos= yythunkpos2018;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2016;  if (!yymatchChar(G, ']')) goto l2016;
  yyDo(G, yy_1_Variable, G->begin, G->end, "yy_1_Variable");
  yyprintf((stderr, "  ok   Variable"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2016:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Variable"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CitationReference(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CitationReference"));

  {  int yypos2024= G->pos, yythunkpos2024= G->thunkpos;  if (!yy_CitationReferenceDouble(G))  goto l2025;
  goto l2024;
  l2025:;	  G->pos= yypos2024; G->thunkpos= yythunkpos2024;  if (!yy_CitationReferenceSingle(G))  goto l2023;

  }
  l2024:;	  yyprintf((stderr, "  ok   CitationReference"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2023:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CitationReference"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Emph(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Emph"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2026;  if (!yy_EmphMatch(G))  goto l2026;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2026;  yyDo(G, yy_1_Emph, G->begin, G->end, "yy_1_Emph");
  yyprintf((stderr, "  ok   Emph"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2026:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Emph"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Strong(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Strong"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2027;  if (!yy_StrongMatch(G))  goto l2027;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2027;  yyDo(G, yy_1_Strong, G->begin, G->end, "yy_1_Strong");
  yyprintf((stderr, "  ok   Strong"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2027:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Strong"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Space(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Space"));
  if (!yy_Spacechar(G))  goto l2028;

  l2029:;	
  {  int yypos2030= G->pos, yythunkpos2030= G->thunkpos;  if (!yy_Spacechar(G))  goto l2030;
  goto l2029;
  l2030:;	  G->pos= yypos2030; G->thunkpos= yythunkpos2030;
  }  yyDo(G, yy_1_Space, G->begin, G->end, "yy_1_Space");
  yyprintf((stderr, "  ok   Space"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2028:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Space"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_UlOrStarLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "UlOrStarLine"));

  {  int yypos2032= G->pos, yythunkpos2032= G->thunkpos;  if (!yy_UlLine(G))  goto l2033;
  goto l2032;
  l2033:;	  G->pos= yypos2032; G->thunkpos= yythunkpos2032;  if (!yy_StarLine(G))  goto l2031;

  }
  l2032:;	  yyDo(G, yy_1_UlOrStarLine, G->begin, G->end, "yy_1_UlOrStarLine");
  yyprintf((stderr, "  ok   UlOrStarLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2031:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "UlOrStarLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MathSpan(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "MathSpan"));
  if (!yymatchChar(G, '\\')) goto l2034;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2034;
  {  int yypos2035= G->pos, yythunkpos2035= G->thunkpos;  if (!yymatchString(G, "\\[")) goto l2036;

  l2037:;	
  {  int yypos2038= G->pos, yythunkpos2038= G->thunkpos;
  {  int yypos2039= G->pos, yythunkpos2039= G->thunkpos;  if (!yymatchString(G, "\\\\]")) goto l2039;
  goto l2038;
  l2039:;	  G->pos= yypos2039; G->thunkpos= yythunkpos2039;
  }  if (!yymatchDot(G)) goto l2038;  goto l2037;
  l2038:;	  G->pos= yypos2038; G->thunkpos= yythunkpos2038;
  }  if (!yymatchString(G, "\\\\]")) goto l2036;
  goto l2035;
  l2036:;	  G->pos= yypos2035; G->thunkpos= yythunkpos2035;  if (!yymatchString(G, "\\(")) goto l2034;

  l2040:;	
  {  int yypos2041= G->pos, yythunkpos2041= G->thunkpos;
  {  int yypos2042= G->pos, yythunkpos2042= G->thunkpos;  if (!yymatchString(G, "\\\\)")) goto l2042;
  goto l2041;
  l2042:;	  G->pos= yypos2042; G->thunkpos= yythunkpos2042;
  }  if (!yymatchDot(G)) goto l2041;  goto l2040;
  l2041:;	  G->pos= yypos2041; G->thunkpos= yythunkpos2041;
  }  if (!yymatchString(G, "\\\\)")) goto l2034;

  }
  l2035:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2034;  yyDo(G, yy_1_MathSpan, G->begin, G->end, "yy_1_MathSpan");
  yyprintf((stderr, "  ok   MathSpan"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2034:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MathSpan"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Str(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Str"));
  if (!yy_StartList(G))  goto l2043;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2043;  if (!yy_NormalChar(G))  goto l2043;

  l2044:;	
  {  int yypos2045= G->pos, yythunkpos2045= G->thunkpos;  if (!yy_NormalChar(G))  goto l2045;
  goto l2044;
  l2045:;	  G->pos= yypos2045; G->thunkpos= yythunkpos2045;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2043;  yyDo(G, yy_1_Str, G->begin, G->end, "yy_1_Str");

  l2046:;	
  {  int yypos2047= G->pos, yythunkpos2047= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2047;  if (!yy_StrChunk(G))  goto l2047;
  yyDo(G, yy_2_Str, G->begin, G->end, "yy_2_Str");
  goto l2046;
  l2047:;	  G->pos= yypos2047; G->thunkpos= yythunkpos2047;
  }
  l2048:;	
  {  int yypos2049= G->pos, yythunkpos2049= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2049;
  {  int yypos2050= G->pos, yythunkpos2050= G->thunkpos;  if (!yy_Superscript(G))  goto l2051;
  goto l2050;
  l2051:;	  G->pos= yypos2050; G->thunkpos= yythunkpos2050;  if (!yy_Subscript(G))  goto l2049;

  }
  l2050:;	  yyDo(G, yy_3_Str, G->begin, G->end, "yy_3_Str");
  goto l2048;
  l2049:;	  G->pos= yypos2049; G->thunkpos= yythunkpos2049;
  }  yyDo(G, yy_4_Str, G->begin, G->end, "yy_4_Str");
  yyprintf((stderr, "  ok   Str"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2043:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Str"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DollarMath(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DollarMath"));

  {  int yypos2053= G->pos, yythunkpos2053= G->thunkpos;  if (!yy_SingleDollarMath(G))  goto l2054;
  goto l2053;
  l2054:;	  G->pos= yypos2053; G->thunkpos= yythunkpos2053;  if (!yy_DoubleDollarMath(G))  goto l2052;

  }
  l2053:;	  yyprintf((stderr, "  ok   DollarMath"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2052:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DollarMath"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CriticMarkup(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CriticMarkup"));

  {  int yypos2056= G->pos, yythunkpos2056= G->thunkpos;  if (!yymatchChar(G, '{')) goto l2055;
  G->pos= yypos2056; G->thunkpos= yythunkpos2056;
  }
  {  int yypos2057= G->pos, yythunkpos2057= G->thunkpos;  if (!yy_CriticAddition(G))  goto l2058;
  goto l2057;
  l2058:;	  G->pos= yypos2057; G->thunkpos= yythunkpos2057;  if (!yy_CriticDeletion(G))  goto l2059;
  goto l2057;
  l2059:;	  G->pos= yypos2057; G->thunkpos= yythunkpos2057;  if (!yy_CriticSubstitution(G))  goto l2060;
  goto l2057;
  l2060:;	  G->pos= yypos2057; G->thunkpos= yythunkpos2057;  if (!yy_CriticHighlight(G))  goto l2061;
  goto l2057;
  l2061:;	  G->pos= yypos2057; G->thunkpos= yythunkpos2057;  if (!yy_CriticComment(G))  goto l2055;

  }
  l2057:;	  yyprintf((stderr, "  ok   CriticMarkup"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2055:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CriticMarkup"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_voidEndline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "voidEndline"));

  {  int yypos2063= G->pos, yythunkpos2063= G->thunkpos;
  {  int yypos2065= G->pos, yythunkpos2065= G->thunkpos;  if (!yymatchString(G, "  ")) goto l2066;
  goto l2065;
  l2066:;	  G->pos= yypos2065; G->thunkpos= yythunkpos2065;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) && ext(EXT_ESCAPED_LINE_BREAKS) )) goto l2064;  if (!yy_Sp(G))  goto l2064;
  if (!yymatchChar(G, '\\')) goto l2064;

  }
  l2065:;	  if (!yy_voidNormalEndline(G))  goto l2064;
  goto l2063;
  l2064:;	  G->pos= yypos2063; G->thunkpos= yythunkpos2063;  if (!yy_Sp(G))  goto l2067;
  if (!yy_Newline(G))  goto l2067;
  if (!yy_Eof(G))  goto l2067;
  goto l2063;
  l2067:;	  G->pos= yypos2063; G->thunkpos= yythunkpos2063;  if (!yy_voidNormalEndline(G))  goto l2062;

  }
  l2063:;	  yyprintf((stderr, "  ok   voidEndline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2062:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "voidEndline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Inlines(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Inlines"));
  if (!yy_StartList(G))  goto l2068;
  yyDo(G, yySet, -2, 0, "yySet");

  {  int yypos2071= G->pos, yythunkpos2071= G->thunkpos;
  {  int yypos2073= G->pos, yythunkpos2073= G->thunkpos;  if (!yy_Endline(G))  goto l2073;
  goto l2072;
  l2073:;	  G->pos= yypos2073; G->thunkpos= yythunkpos2073;
  }  if (!yy_Inline(G))  goto l2072;
  yyDo(G, yy_1_Inlines, G->begin, G->end, "yy_1_Inlines");
  goto l2071;
  l2072:;	  G->pos= yypos2071; G->thunkpos= yythunkpos2071;  if (!yy_Endline(G))  goto l2068;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2074= G->pos, yythunkpos2074= G->thunkpos;  if (!yy_Inline(G))  goto l2068;
  G->pos= yypos2074; G->thunkpos= yythunkpos2074;
  }  yyDo(G, yy_2_Inlines, G->begin, G->end, "yy_2_Inlines");

  }
  l2071:;	
  l2069:;	
  {  int yypos2070= G->pos, yythunkpos2070= G->thunkpos;
  {  int yypos2075= G->pos, yythunkpos2075= G->thunkpos;
  {  int yypos2077= G->pos, yythunkpos2077= G->thunkpos;  if (!yy_Endline(G))  goto l2077;
  goto l2076;
  l2077:;	  G->pos= yypos2077; G->thunkpos= yythunkpos2077;
  }  if (!yy_Inline(G))  goto l2076;
  yyDo(G, yy_1_Inlines, G->begin, G->end, "yy_1_Inlines");
  goto l2075;
  l2076:;	  G->pos= yypos2075; G->thunkpos= yythunkpos2075;  if (!yy_Endline(G))  goto l2070;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2078= G->pos, yythunkpos2078= G->thunkpos;  if (!yy_Inline(G))  goto l2070;
  G->pos= yypos2078; G->thunkpos= yythunkpos2078;
  }  yyDo(G, yy_2_Inlines, G->begin, G->end, "yy_2_Inlines");

  }
  l2075:;	  goto l2069;
  l2070:;	  G->pos= yypos2070; G->thunkpos= yythunkpos2070;
  }
  {  int yypos2079= G->pos, yythunkpos2079= G->thunkpos;  if (!yy_voidEndline(G))  goto l2079;
  goto l2080;
  l2079:;	  G->pos= yypos2079; G->thunkpos= yythunkpos2079;
  }
  l2080:;	  yyDo(G, yy_3_Inlines, G->begin, G->end, "yy_3_Inlines");
  yyprintf((stderr, "  ok   Inlines"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2068:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Inlines"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Entity(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Entity"));

  {  int yypos2082= G->pos, yythunkpos2082= G->thunkpos;  if (!yy_HexEntity(G))  goto l2083;
  goto l2082;
  l2083:;	  G->pos= yypos2082; G->thunkpos= yythunkpos2082;  if (!yy_DecEntity(G))  goto l2084;
  goto l2082;
  l2084:;	  G->pos= yypos2082; G->thunkpos= yythunkpos2082;  if (!yy_CharEntity(G))  goto l2081;

  }
  l2082:;	  yyDo(G, yy_1_Entity, G->begin, G->end, "yy_1_Entity");
  yyprintf((stderr, "  ok   Entity"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2081:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Entity"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_EscapedChar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "EscapedChar"));
  if (!yymatchChar(G, '\\')) goto l2085;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2085;  if (!yymatchClass(G, (const unsigned char *)"\000\004\000\000\236\157\000\120\000\000\000\370\001\000\000\170\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "-\\\\`|*_{}[\\]()#+.!$><'\"\"\\n~^")) goto l2085;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2085;  yyDo(G, yy_1_EscapedChar, G->begin, G->end, "yy_1_EscapedChar");
  yyprintf((stderr, "  ok   EscapedChar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2085:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "EscapedChar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Symbol(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Symbol"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2086;  if (!yy_SpecialChar(G))  goto l2086;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2086;  yyDo(G, yy_1_Symbol, G->begin, G->end, "yy_1_Symbol");
  yyprintf((stderr, "  ok   Symbol"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2086:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Symbol"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OptionallyIndentedLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OptionallyIndentedLine"));

  {  int yypos2088= G->pos, yythunkpos2088= G->thunkpos;  if (!yy_Indent(G))  goto l2088;
  goto l2089;
  l2088:;	  G->pos= yypos2088; G->thunkpos= yythunkpos2088;
  }
  l2089:;	  if (!yy_Line(G))  goto l2087;
  yyprintf((stderr, "  ok   OptionallyIndentedLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2087:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OptionallyIndentedLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_IndentedLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "IndentedLine"));
  if (!yy_Indent(G))  goto l2090;
  if (!yy_Line(G))  goto l2090;
  yyprintf((stderr, "  ok   IndentedLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2090:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "IndentedLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Indent(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Indent"));

  {  int yypos2092= G->pos, yythunkpos2092= G->thunkpos;  if (!yymatchChar(G, '\t')) goto l2093;
  goto l2092;
  l2093:;	  G->pos= yypos2092; G->thunkpos= yythunkpos2092;  if (!yymatchString(G, "    ")) goto l2091;

  }
  l2092:;	  yyprintf((stderr, "  ok   Indent"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2091:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Indent"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_CharEntity(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "CharEntity"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2094;  if (!yymatchChar(G, '&')) goto l2094;
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z0-9")) goto l2094;

  l2095:;	
  {  int yypos2096= G->pos, yythunkpos2096= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z0-9")) goto l2096;
  goto l2095;
  l2096:;	  G->pos= yypos2096; G->thunkpos= yythunkpos2096;
  }  if (!yymatchChar(G, ';')) goto l2094;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2094;  yyprintf((stderr, "  ok   CharEntity"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2094:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "CharEntity"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DecEntity(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "DecEntity"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2097;  if (!yymatchChar(G, '&')) goto l2097;
  if (!yymatchChar(G, '#')) goto l2097;
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l2097;

  l2098:;	
  {  int yypos2099= G->pos, yythunkpos2099= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l2099;
  goto l2098;
  l2099:;	  G->pos= yypos2099; G->thunkpos= yythunkpos2099;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2097;  if (!yymatchChar(G, ';')) goto l2097;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2097;  yyprintf((stderr, "  ok   DecEntity"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2097:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DecEntity"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HexEntity(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HexEntity"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2100;  if (!yymatchChar(G, '&')) goto l2100;
  if (!yymatchChar(G, '#')) goto l2100;
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "Xx")) goto l2100;
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\176\000\000\000\176\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9a-fA-F")) goto l2100;

  l2101:;	
  {  int yypos2102= G->pos, yythunkpos2102= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\176\000\000\000\176\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9a-fA-F")) goto l2102;
  goto l2101;
  l2102:;	  G->pos= yypos2102; G->thunkpos= yythunkpos2102;
  }  if (!yymatchChar(G, ';')) goto l2100;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2100;  yyprintf((stderr, "  ok   HexEntity"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2100:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HexEntity"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Digit(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Digit"));
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9")) goto l2103;
  yyprintf((stderr, "  ok   Digit"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2103:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Digit"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Alphanumeric(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Alphanumeric"));

  {  int yypos2105= G->pos, yythunkpos2105= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "0-9A-Za-z")) goto l2106;
  goto l2105;
  l2106:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\200")) goto l2107;
  goto l2105;
  l2107:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\201")) goto l2108;
  goto l2105;
  l2108:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\202")) goto l2109;
  goto l2105;
  l2109:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\203")) goto l2110;
  goto l2105;
  l2110:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\204")) goto l2111;
  goto l2105;
  l2111:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\205")) goto l2112;
  goto l2105;
  l2112:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\206")) goto l2113;
  goto l2105;
  l2113:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\207")) goto l2114;
  goto l2105;
  l2114:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\210")) goto l2115;
  goto l2105;
  l2115:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\211")) goto l2116;
  goto l2105;
  l2116:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\212")) goto l2117;
  goto l2105;
  l2117:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\213")) goto l2118;
  goto l2105;
  l2118:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\214")) goto l2119;
  goto l2105;
  l2119:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\215")) goto l2120;
  goto l2105;
  l2120:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\216")) goto l2121;
  goto l2105;
  l2121:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\217")) goto l2122;
  goto l2105;
  l2122:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\220")) goto l2123;
  goto l2105;
  l2123:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\221")) goto l2124;
  goto l2105;
  l2124:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\222")) goto l2125;
  goto l2105;
  l2125:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\223")) goto l2126;
  goto l2105;
  l2126:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\224")) goto l2127;
  goto l2105;
  l2127:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\225")) goto l2128;
  goto l2105;
  l2128:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\226")) goto l2129;
  goto l2105;
  l2129:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\227")) goto l2130;
  goto l2105;
  l2130:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\230")) goto l2131;
  goto l2105;
  l2131:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\231")) goto l2132;
  goto l2105;
  l2132:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\232")) goto l2133;
  goto l2105;
  l2133:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\233")) goto l2134;
  goto l2105;
  l2134:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\234")) goto l2135;
  goto l2105;
  l2135:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\235")) goto l2136;
  goto l2105;
  l2136:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\236")) goto l2137;
  goto l2105;
  l2137:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\237")) goto l2138;
  goto l2105;
  l2138:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\240")) goto l2139;
  goto l2105;
  l2139:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\241")) goto l2140;
  goto l2105;
  l2140:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\242")) goto l2141;
  goto l2105;
  l2141:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\243")) goto l2142;
  goto l2105;
  l2142:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\244")) goto l2143;
  goto l2105;
  l2143:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\245")) goto l2144;
  goto l2105;
  l2144:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\246")) goto l2145;
  goto l2105;
  l2145:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\247")) goto l2146;
  goto l2105;
  l2146:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\250")) goto l2147;
  goto l2105;
  l2147:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\251")) goto l2148;
  goto l2105;
  l2148:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\252")) goto l2149;
  goto l2105;
  l2149:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\253")) goto l2150;
  goto l2105;
  l2150:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\254")) goto l2151;
  goto l2105;
  l2151:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\255")) goto l2152;
  goto l2105;
  l2152:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\256")) goto l2153;
  goto l2105;
  l2153:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\257")) goto l2154;
  goto l2105;
  l2154:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\260")) goto l2155;
  goto l2105;
  l2155:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\261")) goto l2156;
  goto l2105;
  l2156:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\262")) goto l2157;
  goto l2105;
  l2157:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\263")) goto l2158;
  goto l2105;
  l2158:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\264")) goto l2159;
  goto l2105;
  l2159:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\265")) goto l2160;
  goto l2105;
  l2160:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\266")) goto l2161;
  goto l2105;
  l2161:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\267")) goto l2162;
  goto l2105;
  l2162:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\270")) goto l2163;
  goto l2105;
  l2163:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\271")) goto l2164;
  goto l2105;
  l2164:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\272")) goto l2165;
  goto l2105;
  l2165:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\273")) goto l2166;
  goto l2105;
  l2166:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\274")) goto l2167;
  goto l2105;
  l2167:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\275")) goto l2168;
  goto l2105;
  l2168:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\276")) goto l2169;
  goto l2105;
  l2169:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\277")) goto l2170;
  goto l2105;
  l2170:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\300")) goto l2171;
  goto l2105;
  l2171:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\301")) goto l2172;
  goto l2105;
  l2172:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\302")) goto l2173;
  goto l2105;
  l2173:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\303")) goto l2174;
  goto l2105;
  l2174:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\304")) goto l2175;
  goto l2105;
  l2175:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\305")) goto l2176;
  goto l2105;
  l2176:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\306")) goto l2177;
  goto l2105;
  l2177:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\307")) goto l2178;
  goto l2105;
  l2178:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\310")) goto l2179;
  goto l2105;
  l2179:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\311")) goto l2180;
  goto l2105;
  l2180:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\312")) goto l2181;
  goto l2105;
  l2181:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\313")) goto l2182;
  goto l2105;
  l2182:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\314")) goto l2183;
  goto l2105;
  l2183:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\315")) goto l2184;
  goto l2105;
  l2184:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\316")) goto l2185;
  goto l2105;
  l2185:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\317")) goto l2186;
  goto l2105;
  l2186:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\320")) goto l2187;
  goto l2105;
  l2187:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\321")) goto l2188;
  goto l2105;
  l2188:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\322")) goto l2189;
  goto l2105;
  l2189:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\323")) goto l2190;
  goto l2105;
  l2190:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\324")) goto l2191;
  goto l2105;
  l2191:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\325")) goto l2192;
  goto l2105;
  l2192:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\326")) goto l2193;
  goto l2105;
  l2193:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\327")) goto l2194;
  goto l2105;
  l2194:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\330")) goto l2195;
  goto l2105;
  l2195:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\331")) goto l2196;
  goto l2105;
  l2196:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\332")) goto l2197;
  goto l2105;
  l2197:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\333")) goto l2198;
  goto l2105;
  l2198:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\334")) goto l2199;
  goto l2105;
  l2199:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\335")) goto l2200;
  goto l2105;
  l2200:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\336")) goto l2201;
  goto l2105;
  l2201:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\337")) goto l2202;
  goto l2105;
  l2202:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\340")) goto l2203;
  goto l2105;
  l2203:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\341")) goto l2204;
  goto l2105;
  l2204:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\342")) goto l2205;
  goto l2105;
  l2205:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\343")) goto l2206;
  goto l2105;
  l2206:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\344")) goto l2207;
  goto l2105;
  l2207:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\345")) goto l2208;
  goto l2105;
  l2208:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\346")) goto l2209;
  goto l2105;
  l2209:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\347")) goto l2210;
  goto l2105;
  l2210:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\350")) goto l2211;
  goto l2105;
  l2211:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\351")) goto l2212;
  goto l2105;
  l2212:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\352")) goto l2213;
  goto l2105;
  l2213:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\353")) goto l2214;
  goto l2105;
  l2214:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\354")) goto l2215;
  goto l2105;
  l2215:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\355")) goto l2216;
  goto l2105;
  l2216:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\356")) goto l2217;
  goto l2105;
  l2217:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\357")) goto l2218;
  goto l2105;
  l2218:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\360")) goto l2219;
  goto l2105;
  l2219:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\361")) goto l2220;
  goto l2105;
  l2220:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\362")) goto l2221;
  goto l2105;
  l2221:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\363")) goto l2222;
  goto l2105;
  l2222:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\364")) goto l2223;
  goto l2105;
  l2223:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\365")) goto l2224;
  goto l2105;
  l2224:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\366")) goto l2225;
  goto l2105;
  l2225:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\367")) goto l2226;
  goto l2105;
  l2226:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\370")) goto l2227;
  goto l2105;
  l2227:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\371")) goto l2228;
  goto l2105;
  l2228:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\372")) goto l2229;
  goto l2105;
  l2229:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\373")) goto l2230;
  goto l2105;
  l2230:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\374")) goto l2231;
  goto l2105;
  l2231:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\375")) goto l2232;
  goto l2105;
  l2232:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\376")) goto l2233;
  goto l2105;
  l2233:;	  G->pos= yypos2105; G->thunkpos= yythunkpos2105;  if (!yymatchString(G, "\377")) goto l2104;

  }
  l2105:;	  yyprintf((stderr, "  ok   Alphanumeric"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2104:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Alphanumeric"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockScript(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockScript"));
  if (!yy_HtmlBlockOpenScript(G))  goto l2234;

  l2235:;	
  {  int yypos2236= G->pos, yythunkpos2236= G->thunkpos;
  {  int yypos2237= G->pos, yythunkpos2237= G->thunkpos;  if (!yy_HtmlBlockCloseScript(G))  goto l2237;
  goto l2236;
  l2237:;	  G->pos= yypos2237; G->thunkpos= yythunkpos2237;
  }  if (!yymatchDot(G)) goto l2236;  goto l2235;
  l2236:;	  G->pos= yypos2236; G->thunkpos= yythunkpos2236;
  }  if (!yy_HtmlBlockCloseScript(G))  goto l2234;
  yyprintf((stderr, "  ok   HtmlBlockScript"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2234:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockScript"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawHtml(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RawHtml"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2238;
  {  int yypos2239= G->pos, yythunkpos2239= G->thunkpos;  if (!yy_HtmlComment(G))  goto l2240;
  goto l2239;
  l2240:;	  G->pos= yypos2239; G->thunkpos= yythunkpos2239;  if (!yy_HtmlBlockScript(G))  goto l2241;
  goto l2239;
  l2241:;	  G->pos= yypos2239; G->thunkpos= yythunkpos2239;  if (!yy_HtmlTag(G))  goto l2238;

  }
  l2239:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2238;  yyDo(G, yy_1_RawHtml, G->begin, G->end, "yy_1_RawHtml");
  yyprintf((stderr, "  ok   RawHtml"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2238:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawHtml"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlTag(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlTag"));
  if (!yymatchChar(G, '<')) goto l2242;
  if (!yy_Spnl(G))  goto l2242;

  {  int yypos2243= G->pos, yythunkpos2243= G->thunkpos;  if (!yymatchChar(G, '/')) goto l2243;
  goto l2244;
  l2243:;	  G->pos= yypos2243; G->thunkpos= yythunkpos2243;
  }
  l2244:;	  if (!yy_AlphanumericAscii(G))  goto l2242;

  l2245:;	
  {  int yypos2246= G->pos, yythunkpos2246= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l2246;
  goto l2245;
  l2246:;	  G->pos= yypos2246; G->thunkpos= yythunkpos2246;
  }  if (!yy_Spnl(G))  goto l2242;

  l2247:;	
  {  int yypos2248= G->pos, yythunkpos2248= G->thunkpos;  if (!yy_HtmlAttribute(G))  goto l2248;
  goto l2247;
  l2248:;	  G->pos= yypos2248; G->thunkpos= yythunkpos2248;
  }
  {  int yypos2249= G->pos, yythunkpos2249= G->thunkpos;  if (!yymatchChar(G, '/')) goto l2249;
  goto l2250;
  l2249:;	  G->pos= yypos2249; G->thunkpos= yythunkpos2249;
  }
  l2250:;	  if (!yy_Spnl(G))  goto l2242;
  if (!yymatchChar(G, '>')) goto l2242;
  yyprintf((stderr, "  ok   HtmlTag"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2242:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlTag"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlComment(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlComment"));
  if (!yymatchString(G, "<!--")) goto l2251;

  l2252:;	
  {  int yypos2253= G->pos, yythunkpos2253= G->thunkpos;
  {  int yypos2254= G->pos, yythunkpos2254= G->thunkpos;  if (!yymatchString(G, "-->")) goto l2254;
  goto l2253;
  l2254:;	  G->pos= yypos2254; G->thunkpos= yythunkpos2254;
  }  if (!yymatchDot(G)) goto l2253;  goto l2252;
  l2253:;	  G->pos= yypos2253; G->thunkpos= yythunkpos2253;
  }  if (!yymatchString(G, "-->")) goto l2251;
  yyprintf((stderr, "  ok   HtmlComment"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2251:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlComment"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlAttribute(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlAttribute"));

  {  int yypos2258= G->pos, yythunkpos2258= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l2259;
  goto l2258;
  l2259:;	  G->pos= yypos2258; G->thunkpos= yythunkpos2258;  if (!yymatchChar(G, '-')) goto l2260;
  goto l2258;
  l2260:;	  G->pos= yypos2258; G->thunkpos= yythunkpos2258;  if (!yymatchChar(G, ':')) goto l2255;

  }
  l2258:;	
  l2256:;	
  {  int yypos2257= G->pos, yythunkpos2257= G->thunkpos;
  {  int yypos2261= G->pos, yythunkpos2261= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l2262;
  goto l2261;
  l2262:;	  G->pos= yypos2261; G->thunkpos= yythunkpos2261;  if (!yymatchChar(G, '-')) goto l2263;
  goto l2261;
  l2263:;	  G->pos= yypos2261; G->thunkpos= yythunkpos2261;  if (!yymatchChar(G, ':')) goto l2257;

  }
  l2261:;	  goto l2256;
  l2257:;	  G->pos= yypos2257; G->thunkpos= yythunkpos2257;
  }  if (!yy_Spnl(G))  goto l2255;

  {  int yypos2264= G->pos, yythunkpos2264= G->thunkpos;  if (!yymatchChar(G, '=')) goto l2264;
  if (!yy_Spnl(G))  goto l2264;

  {  int yypos2266= G->pos, yythunkpos2266= G->thunkpos;  if (!yy_Quoted(G))  goto l2267;
  goto l2266;
  l2267:;	  G->pos= yypos2266; G->thunkpos= yythunkpos2266;
  {  int yypos2270= G->pos, yythunkpos2270= G->thunkpos;  if (!yymatchChar(G, '>')) goto l2270;
  goto l2264;
  l2270:;	  G->pos= yypos2270; G->thunkpos= yythunkpos2270;
  }  if (!yy_Nonspacechar(G))  goto l2264;

  l2268:;	
  {  int yypos2269= G->pos, yythunkpos2269= G->thunkpos;
  {  int yypos2271= G->pos, yythunkpos2271= G->thunkpos;  if (!yymatchChar(G, '>')) goto l2271;
  goto l2269;
  l2271:;	  G->pos= yypos2271; G->thunkpos= yythunkpos2271;
  }  if (!yy_Nonspacechar(G))  goto l2269;
  goto l2268;
  l2269:;	  G->pos= yypos2269; G->thunkpos= yythunkpos2269;
  }
  }
  l2266:;	  goto l2265;
  l2264:;	  G->pos= yypos2264; G->thunkpos= yythunkpos2264;
  }
  l2265:;	  if (!yy_Spnl(G))  goto l2255;
  yyprintf((stderr, "  ok   HtmlAttribute"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2255:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlAttribute"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Quoted(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Quoted"));

  {  int yypos2273= G->pos, yythunkpos2273= G->thunkpos;  if (!yymatchChar(G, '"')) goto l2274;

  l2275:;	
  {  int yypos2276= G->pos, yythunkpos2276= G->thunkpos;
  {  int yypos2277= G->pos, yythunkpos2277= G->thunkpos;  if (!yymatchChar(G, '"')) goto l2277;
  goto l2276;
  l2277:;	  G->pos= yypos2277; G->thunkpos= yythunkpos2277;
  }  if (!yymatchDot(G)) goto l2276;  goto l2275;
  l2276:;	  G->pos= yypos2276; G->thunkpos= yythunkpos2276;
  }  if (!yymatchChar(G, '"')) goto l2274;
  goto l2273;
  l2274:;	  G->pos= yypos2273; G->thunkpos= yythunkpos2273;  if (!yymatchChar(G, '\'')) goto l2272;

  l2278:;	
  {  int yypos2279= G->pos, yythunkpos2279= G->thunkpos;
  {  int yypos2280= G->pos, yythunkpos2280= G->thunkpos;  if (!yymatchChar(G, '\'')) goto l2280;
  goto l2279;
  l2280:;	  G->pos= yypos2280; G->thunkpos= yythunkpos2280;
  }  if (!yymatchDot(G)) goto l2279;  goto l2278;
  l2279:;	  G->pos= yypos2279; G->thunkpos= yythunkpos2279;
  }  if (!yymatchChar(G, '\'')) goto l2272;

  }
  l2273:;	  yyprintf((stderr, "  ok   Quoted"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2272:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Quoted"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NonPunctuation(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NonPunctuation"));

  {  int yypos2282= G->pos, yythunkpos2282= G->thunkpos;
  {  int yypos2283= G->pos, yythunkpos2283= G->thunkpos;  if (!yy_Punctuation(G))  goto l2284;
  goto l2283;
  l2284:;	  G->pos= yypos2283; G->thunkpos= yythunkpos2283;  if (!yy_SpecialChar(G))  goto l2285;
  goto l2283;
  l2285:;	  G->pos= yypos2283; G->thunkpos= yythunkpos2283;  if (!yy_Spacechar(G))  goto l2286;
  goto l2283;
  l2286:;	  G->pos= yypos2283; G->thunkpos= yythunkpos2283;  if (!yy_Newline(G))  goto l2282;

  }
  l2283:;	  goto l2281;
  l2282:;	  G->pos= yypos2282; G->thunkpos= yythunkpos2282;
  }  if (!yymatchDot(G)) goto l2281;  yyprintf((stderr, "  ok   NonPunctuation"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2281:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NonPunctuation"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Punctuation(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Punctuation"));

  {  int yypos2288= G->pos, yythunkpos2288= G->thunkpos;  if (!yymatchChar(G, '.')) goto l2289;
  goto l2288;
  l2289:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchChar(G, ',')) goto l2290;
  goto l2288;
  l2290:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchChar(G, '?')) goto l2291;
  goto l2288;
  l2291:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchChar(G, '!')) goto l2292;
  goto l2288;
  l2292:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchChar(G, ';')) goto l2293;
  goto l2288;
  l2293:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchChar(G, ':')) goto l2294;
  goto l2288;
  l2294:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchString(G, "。")) goto l2295;
  goto l2288;
  l2295:;	  G->pos= yypos2288; G->thunkpos= yythunkpos2288;  if (!yymatchString(G, "、")) goto l2287;

  }
  l2288:;	  yyprintf((stderr, "  ok   Punctuation"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2287:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Punctuation"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ExtendedSpecialChar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ExtendedSpecialChar"));

  {  int yypos2297= G->pos, yythunkpos2297= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( ext(EXT_SMART) )) goto l2298;
  {  int yypos2299= G->pos, yythunkpos2299= G->thunkpos;  if (!yymatchChar(G, '.')) goto l2300;
  goto l2299;
  l2300:;	  G->pos= yypos2299; G->thunkpos= yythunkpos2299;  if (!yymatchChar(G, '-')) goto l2301;
  goto l2299;
  l2301:;	  G->pos= yypos2299; G->thunkpos= yythunkpos2299;  if (!yymatchChar(G, '\'')) goto l2302;
  goto l2299;
  l2302:;	  G->pos= yypos2299; G->thunkpos= yythunkpos2299;  if (!yymatchChar(G, '"')) goto l2298;

  }
  l2299:;	  goto l2297;
  l2298:;	  G->pos= yypos2297; G->thunkpos= yythunkpos2297;  yyText(G, G->begin, G->end);  if (!( ext(EXT_NOTES) )) goto l2303;  if (!yymatchChar(G, '^')) goto l2303;
  goto l2297;
  l2303:;	  G->pos= yypos2297; G->thunkpos= yythunkpos2297;  yyText(G, G->begin, G->end);  if (!( ext(EXT_CRITIC) )) goto l2304;  if (!yymatchChar(G, '{')) goto l2304;
  goto l2297;
  l2304:;	  G->pos= yypos2297; G->thunkpos= yythunkpos2297;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2296;
  {  int yypos2305= G->pos, yythunkpos2305= G->thunkpos;  if (!yymatchChar(G, '~')) goto l2306;
  goto l2305;
  l2306:;	  G->pos= yypos2305; G->thunkpos= yythunkpos2305;  if (!yymatchChar(G, '|')) goto l2296;

  }
  l2305:;	
  }
  l2297:;	  yyprintf((stderr, "  ok   ExtendedSpecialChar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2296:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ExtendedSpecialChar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SpecialChar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SpecialChar"));

  {  int yypos2308= G->pos, yythunkpos2308= G->thunkpos;  if (!yymatchChar(G, '*')) goto l2309;
  goto l2308;
  l2309:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '_')) goto l2310;
  goto l2308;
  l2310:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '`')) goto l2311;
  goto l2308;
  l2311:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '&')) goto l2312;
  goto l2308;
  l2312:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '[')) goto l2313;
  goto l2308;
  l2313:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, ']')) goto l2314;
  goto l2308;
  l2314:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '(')) goto l2315;
  goto l2308;
  l2315:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, ')')) goto l2316;
  goto l2308;
  l2316:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '<')) goto l2317;
  goto l2308;
  l2317:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '!')) goto l2318;
  goto l2308;
  l2318:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '#')) goto l2319;
  goto l2308;
  l2319:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '\\')) goto l2320;
  goto l2308;
  l2320:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '\'')) goto l2321;
  goto l2308;
  l2321:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '"')) goto l2322;
  goto l2308;
  l2322:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '?')) goto l2323;
  goto l2308;
  l2323:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, ',')) goto l2324;
  goto l2308;
  l2324:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, ';')) goto l2325;
  goto l2308;
  l2325:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '/')) goto l2326;
  goto l2308;
  l2326:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchChar(G, '.')) goto l2327;
  goto l2308;
  l2327:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchString(G, "。")) goto l2328;
  goto l2308;
  l2328:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yymatchString(G, "、")) goto l2329;
  goto l2308;
  l2329:;	  G->pos= yypos2308; G->thunkpos= yythunkpos2308;  if (!yy_ExtendedSpecialChar(G))  goto l2307;

  }
  l2308:;	  yyprintf((stderr, "  ok   SpecialChar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2307:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SpecialChar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NormalChar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NormalChar"));

  {  int yypos2331= G->pos, yythunkpos2331= G->thunkpos;
  {  int yypos2332= G->pos, yythunkpos2332= G->thunkpos;  if (!yy_SpecialChar(G))  goto l2333;
  goto l2332;
  l2333:;	  G->pos= yypos2332; G->thunkpos= yythunkpos2332;  if (!yy_Spacechar(G))  goto l2334;
  goto l2332;
  l2334:;	  G->pos= yypos2332; G->thunkpos= yythunkpos2332;  if (!yy_Newline(G))  goto l2331;

  }
  l2332:;	  goto l2330;
  l2331:;	  G->pos= yypos2331; G->thunkpos= yythunkpos2331;
  }  if (!yymatchDot(G)) goto l2330;  yyprintf((stderr, "  ok   NormalChar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2330:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NormalChar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Nonspacechar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Nonspacechar"));

  {  int yypos2336= G->pos, yythunkpos2336= G->thunkpos;  if (!yy_Spacechar(G))  goto l2336;
  goto l2335;
  l2336:;	  G->pos= yypos2336; G->thunkpos= yythunkpos2336;
  }
  {  int yypos2337= G->pos, yythunkpos2337= G->thunkpos;  if (!yy_Newline(G))  goto l2337;
  goto l2335;
  l2337:;	  G->pos= yypos2337; G->thunkpos= yythunkpos2337;
  }  if (!yymatchDot(G)) goto l2335;  yyprintf((stderr, "  ok   Nonspacechar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2335:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Nonspacechar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Spnl(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Spnl"));
  if (!yy_Sp(G))  goto l2338;

  {  int yypos2339= G->pos, yythunkpos2339= G->thunkpos;  if (!yy_Newline(G))  goto l2339;
  if (!yy_Sp(G))  goto l2339;
  goto l2340;
  l2339:;	  G->pos= yypos2339; G->thunkpos= yythunkpos2339;
  }
  l2340:;	  yyprintf((stderr, "  ok   Spnl"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2338:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Spnl"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Spacechar(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Spacechar"));

  {  int yypos2342= G->pos, yythunkpos2342= G->thunkpos;  if (!yymatchChar(G, ' ')) goto l2343;
  goto l2342;
  l2343:;	  G->pos= yypos2342; G->thunkpos= yythunkpos2342;  if (!yymatchChar(G, '\t')) goto l2341;

  }
  l2342:;	  yyprintf((stderr, "  ok   Spacechar"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2341:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Spacechar"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NonMatchingRawLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NonMatchingRawLine"));

  {  int yypos2345= G->pos, yythunkpos2345= G->thunkpos;
  l2347:;	
  {  int yypos2348= G->pos, yythunkpos2348= G->thunkpos;
  {  int yypos2349= G->pos, yythunkpos2349= G->thunkpos;  if (!yymatchChar(G, '\r')) goto l2349;
  goto l2348;
  l2349:;	  G->pos= yypos2349; G->thunkpos= yythunkpos2349;
  }
  {  int yypos2350= G->pos, yythunkpos2350= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l2350;
  goto l2348;
  l2350:;	  G->pos= yypos2350; G->thunkpos= yythunkpos2350;
  }  if (!yymatchDot(G)) goto l2348;  goto l2347;
  l2348:;	  G->pos= yypos2348; G->thunkpos= yythunkpos2348;
  }  if (!yy_Newline(G))  goto l2346;
  goto l2345;
  l2346:;	  G->pos= yypos2345; G->thunkpos= yythunkpos2345;  if (!yymatchDot(G)) goto l2344;
  l2351:;	
  {  int yypos2352= G->pos, yythunkpos2352= G->thunkpos;  if (!yymatchDot(G)) goto l2352;  goto l2351;
  l2352:;	  G->pos= yypos2352; G->thunkpos= yythunkpos2352;
  }  if (!yy_Eof(G))  goto l2344;

  }
  l2345:;	  yyprintf((stderr, "  ok   NonMatchingRawLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2344:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NonMatchingRawLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Eof(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Eof"));

  {  int yypos2354= G->pos, yythunkpos2354= G->thunkpos;  if (!yymatchDot(G)) goto l2354;  goto l2353;
  l2354:;	  G->pos= yypos2354; G->thunkpos= yythunkpos2354;
  }  yyprintf((stderr, "  ok   Eof"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2353:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Eof"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Line(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Line"));
  if (!yy_RawLine(G))  goto l2355;
  yyDo(G, yy_1_Line, G->begin, G->end, "yy_1_Line");
  yyprintf((stderr, "  ok   Line"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2355:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Line"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BlockQuoteMarker(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BlockQuoteMarker"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2356;  if (!yymatchChar(G, '>')) goto l2356;

  {  int yypos2357= G->pos, yythunkpos2357= G->thunkpos;  if (!yymatchChar(G, ' ')) goto l2357;
  goto l2358;
  l2357:;	  G->pos= yypos2357; G->thunkpos= yythunkpos2357;
  }
  l2358:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2356;  yyDo(G, yy_1_BlockQuoteMarker, G->begin, G->end, "yy_1_BlockQuoteMarker");
  yyprintf((stderr, "  ok   BlockQuoteMarker"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2356:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BlockQuoteMarker"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BlockQuoteRaw(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 3, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "BlockQuoteRaw"));
  if (!yy_StartList(G))  goto l2359;
  yyDo(G, yySet, -3, 0, "yySet");
  if (!yy_StartList(G))  goto l2359;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_NonindentSpace(G))  goto l2359;
  if (!yy_BlockQuoteMarker(G))  goto l2359;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Line(G))  goto l2359;
  yyDo(G, yy_1_BlockQuoteRaw, G->begin, G->end, "yy_1_BlockQuoteRaw");

  l2362:;	
  {  int yypos2363= G->pos, yythunkpos2363= G->thunkpos;
  {  int yypos2364= G->pos, yythunkpos2364= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l2364;
  if (!yymatchChar(G, '>')) goto l2364;
  goto l2363;
  l2364:;	  G->pos= yypos2364; G->thunkpos= yythunkpos2364;
  }
  {  int yypos2365= G->pos, yythunkpos2365= G->thunkpos;  if (!yy_BlankLine(G))  goto l2365;
  goto l2363;
  l2365:;	  G->pos= yypos2365; G->thunkpos= yythunkpos2365;
  }  if (!yy_Line(G))  goto l2363;
  yyDo(G, yy_2_BlockQuoteRaw, G->begin, G->end, "yy_2_BlockQuoteRaw");
  goto l2362;
  l2363:;	  G->pos= yypos2363; G->thunkpos= yythunkpos2363;
  }
  l2366:;	
  {  int yypos2367= G->pos, yythunkpos2367= G->thunkpos;  if (!yy_BlankLine(G))  goto l2367;
  yyDo(G, yy_3_BlockQuoteRaw, G->begin, G->end, "yy_3_BlockQuoteRaw");
  goto l2366;
  l2367:;	  G->pos= yypos2367; G->thunkpos= yythunkpos2367;
  }
  l2360:;	
  {  int yypos2361= G->pos, yythunkpos2361= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l2361;
  if (!yy_BlockQuoteMarker(G))  goto l2361;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Line(G))  goto l2361;
  yyDo(G, yy_1_BlockQuoteRaw, G->begin, G->end, "yy_1_BlockQuoteRaw");

  l2368:;	
  {  int yypos2369= G->pos, yythunkpos2369= G->thunkpos;
  {  int yypos2370= G->pos, yythunkpos2370= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l2370;
  if (!yymatchChar(G, '>')) goto l2370;
  goto l2369;
  l2370:;	  G->pos= yypos2370; G->thunkpos= yythunkpos2370;
  }
  {  int yypos2371= G->pos, yythunkpos2371= G->thunkpos;  if (!yy_BlankLine(G))  goto l2371;
  goto l2369;
  l2371:;	  G->pos= yypos2371; G->thunkpos= yythunkpos2371;
  }  if (!yy_Line(G))  goto l2369;
  yyDo(G, yy_2_BlockQuoteRaw, G->begin, G->end, "yy_2_BlockQuoteRaw");
  goto l2368;
  l2369:;	  G->pos= yypos2369; G->thunkpos= yythunkpos2369;
  }
  l2372:;	
  {  int yypos2373= G->pos, yythunkpos2373= G->thunkpos;  if (!yy_BlankLine(G))  goto l2373;
  yyDo(G, yy_3_BlockQuoteRaw, G->begin, G->end, "yy_3_BlockQuoteRaw");
  goto l2372;
  l2373:;	  G->pos= yypos2373; G->thunkpos= yythunkpos2373;
  }  goto l2360;
  l2361:;	  G->pos= yypos2361; G->thunkpos= yythunkpos2361;
  }  yyDo(G, yy_4_BlockQuoteRaw, G->begin, G->end, "yy_4_BlockQuoteRaw");
  yyprintf((stderr, "  ok   BlockQuoteRaw"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 3, 0, "yyPop");
  return 1;
  l2359:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BlockQuoteRaw"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Endline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Endline"));

  {  int yypos2375= G->pos, yythunkpos2375= G->thunkpos;  if (!yy_LineBreak(G))  goto l2376;
  goto l2375;
  l2376:;	  G->pos= yypos2375; G->thunkpos= yythunkpos2375;  if (!yy_TerminalEndline(G))  goto l2377;
  goto l2375;
  l2377:;	  G->pos= yypos2375; G->thunkpos= yythunkpos2375;  if (!yy_NormalEndline(G))  goto l2374;

  }
  l2375:;	  yyprintf((stderr, "  ok   Endline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2374:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Endline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SetextHeading2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "SetextHeading2"));

  {  int yypos2379= G->pos, yythunkpos2379= G->thunkpos;  if (!yy_RawLine(G))  goto l2378;
  if (!yy_SetextBottom2(G))  goto l2378;
  G->pos= yypos2379; G->thunkpos= yythunkpos2379;
  }  if (!yy_StartList(G))  goto l2378;
  yyDo(G, yySet, -2, 0, "yySet");

  {  int yypos2382= G->pos, yythunkpos2382= G->thunkpos;  if (!yy_Endline(G))  goto l2382;
  goto l2378;
  l2382:;	  G->pos= yypos2382; G->thunkpos= yythunkpos2382;
  }
  {  int yypos2383= G->pos, yythunkpos2383= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2383;  if (!yy_Sp(G))  goto l2383;
  if (!yy_AutoLabel(G))  goto l2383;
  goto l2378;
  l2383:;	  G->pos= yypos2383; G->thunkpos= yythunkpos2383;
  }  if (!yy_Inline(G))  goto l2378;
  yyDo(G, yy_1_SetextHeading2, G->begin, G->end, "yy_1_SetextHeading2");

  l2380:;	
  {  int yypos2381= G->pos, yythunkpos2381= G->thunkpos;
  {  int yypos2384= G->pos, yythunkpos2384= G->thunkpos;  if (!yy_Endline(G))  goto l2384;
  goto l2381;
  l2384:;	  G->pos= yypos2384; G->thunkpos= yythunkpos2384;
  }
  {  int yypos2385= G->pos, yythunkpos2385= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2385;  if (!yy_Sp(G))  goto l2385;
  if (!yy_AutoLabel(G))  goto l2385;
  goto l2381;
  l2385:;	  G->pos= yypos2385; G->thunkpos= yythunkpos2385;
  }  if (!yy_Inline(G))  goto l2381;
  yyDo(G, yy_1_SetextHeading2, G->begin, G->end, "yy_1_SetextHeading2");
  goto l2380;
  l2381:;	  G->pos= yypos2381; G->thunkpos= yythunkpos2381;
  }
  {  int yypos2386= G->pos, yythunkpos2386= G->thunkpos;  if (!yy_Sp(G))  goto l2386;
  if (!yy_AutoLabel(G))  goto l2386;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_2_SetextHeading2, G->begin, G->end, "yy_2_SetextHeading2");
  if (!yy_Sp(G))  goto l2386;
  goto l2387;
  l2386:;	  G->pos= yypos2386; G->thunkpos= yythunkpos2386;
  }
  l2387:;	  if (!yy_Sp(G))  goto l2378;
  if (!yy_Newline(G))  goto l2378;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2378;  if (!yy_SetextBottom2(G))  goto l2378;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2378;  yyDo(G, yy_3_SetextHeading2, G->begin, G->end, "yy_3_SetextHeading2");
  yyprintf((stderr, "  ok   SetextHeading2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2378:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SetextHeading2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SetextHeading1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "SetextHeading1"));

  {  int yypos2389= G->pos, yythunkpos2389= G->thunkpos;  if (!yy_RawLine(G))  goto l2388;
  if (!yy_SetextBottom1(G))  goto l2388;
  G->pos= yypos2389; G->thunkpos= yythunkpos2389;
  }  if (!yy_StartList(G))  goto l2388;
  yyDo(G, yySet, -2, 0, "yySet");

  {  int yypos2392= G->pos, yythunkpos2392= G->thunkpos;  if (!yy_Endline(G))  goto l2392;
  goto l2388;
  l2392:;	  G->pos= yypos2392; G->thunkpos= yythunkpos2392;
  }
  {  int yypos2393= G->pos, yythunkpos2393= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2393;  if (!yy_Sp(G))  goto l2393;
  if (!yy_AutoLabel(G))  goto l2393;
  goto l2388;
  l2393:;	  G->pos= yypos2393; G->thunkpos= yythunkpos2393;
  }  if (!yy_Inline(G))  goto l2388;
  yyDo(G, yy_1_SetextHeading1, G->begin, G->end, "yy_1_SetextHeading1");

  l2390:;	
  {  int yypos2391= G->pos, yythunkpos2391= G->thunkpos;
  {  int yypos2394= G->pos, yythunkpos2394= G->thunkpos;  if (!yy_Endline(G))  goto l2394;
  goto l2391;
  l2394:;	  G->pos= yypos2394; G->thunkpos= yythunkpos2394;
  }
  {  int yypos2395= G->pos, yythunkpos2395= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2395;  if (!yy_Sp(G))  goto l2395;
  if (!yy_AutoLabel(G))  goto l2395;
  goto l2391;
  l2395:;	  G->pos= yypos2395; G->thunkpos= yythunkpos2395;
  }  if (!yy_Inline(G))  goto l2391;
  yyDo(G, yy_1_SetextHeading1, G->begin, G->end, "yy_1_SetextHeading1");
  goto l2390;
  l2391:;	  G->pos= yypos2391; G->thunkpos= yythunkpos2391;
  }
  {  int yypos2396= G->pos, yythunkpos2396= G->thunkpos;  if (!yy_Sp(G))  goto l2396;
  if (!yy_AutoLabel(G))  goto l2396;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_2_SetextHeading1, G->begin, G->end, "yy_2_SetextHeading1");
  if (!yy_Sp(G))  goto l2396;
  goto l2397;
  l2396:;	  G->pos= yypos2396; G->thunkpos= yythunkpos2396;
  }
  l2397:;	  if (!yy_Sp(G))  goto l2388;
  if (!yy_Newline(G))  goto l2388;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2388;  if (!yy_SetextBottom1(G))  goto l2388;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2388;  yyDo(G, yy_3_SetextHeading1, G->begin, G->end, "yy_3_SetextHeading1");
  yyprintf((stderr, "  ok   SetextHeading1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2388:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SetextHeading1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_NonindentSpace(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "NonindentSpace"));

  {  int yypos2399= G->pos, yythunkpos2399= G->thunkpos;  if (!yymatchString(G, "   ")) goto l2400;
  goto l2399;
  l2400:;	  G->pos= yypos2399; G->thunkpos= yythunkpos2399;  if (!yymatchString(G, "  ")) goto l2401;
  goto l2399;
  l2401:;	  G->pos= yypos2399; G->thunkpos= yythunkpos2399;  if (!yymatchChar(G, ' ')) goto l2402;
  goto l2399;
  l2402:;	  G->pos= yypos2399; G->thunkpos= yythunkpos2399;  if (!yymatchString(G, "")) goto l2398;

  }
  l2399:;	  yyprintf((stderr, "  ok   NonindentSpace"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2398:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "NonindentSpace"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AtxStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AtxStart"));
  if (!yy_NonindentSpace(G))  goto l2403;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2403;
  {  int yypos2404= G->pos, yythunkpos2404= G->thunkpos;  if (!yymatchString(G, "######")) goto l2405;
  goto l2404;
  l2405:;	  G->pos= yypos2404; G->thunkpos= yythunkpos2404;  if (!yymatchString(G, "#####")) goto l2406;
  goto l2404;
  l2406:;	  G->pos= yypos2404; G->thunkpos= yythunkpos2404;  if (!yymatchString(G, "####")) goto l2407;
  goto l2404;
  l2407:;	  G->pos= yypos2404; G->thunkpos= yythunkpos2404;  if (!yymatchString(G, "###")) goto l2408;
  goto l2404;
  l2408:;	  G->pos= yypos2404; G->thunkpos= yythunkpos2404;  if (!yymatchString(G, "##")) goto l2409;
  goto l2404;
  l2409:;	  G->pos= yypos2404; G->thunkpos= yythunkpos2404;  if (!yymatchChar(G, '#')) goto l2403;

  }
  l2404:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2403;  yyDo(G, yy_1_AtxStart, G->begin, G->end, "yy_1_AtxStart");
  yyprintf((stderr, "  ok   AtxStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2403:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AtxStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Inline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Inline"));

  {  int yypos2411= G->pos, yythunkpos2411= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( ext(EXT_CRITIC) )) goto l2412;  if (!yy_CriticMarkup(G))  goto l2412;
  goto l2411;
  l2412:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;
  {  int yypos2414= G->pos, yythunkpos2414= G->thunkpos;  if (!yymatchChar(G, '$')) goto l2413;
  G->pos= yypos2414; G->thunkpos= yythunkpos2414;
  }  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2413;  if (!yy_DollarMath(G))  goto l2413;
  goto l2411;
  l2413:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Str(G))  goto l2415;
  goto l2411;
  l2415:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;
  {  int yypos2417= G->pos, yythunkpos2417= G->thunkpos;  if (!yymatchString(G, "\\\\")) goto l2416;
  G->pos= yypos2417; G->thunkpos= yythunkpos2417;
  }  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2416;  if (!yy_MathSpan(G))  goto l2416;
  goto l2411;
  l2416:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Endline(G))  goto l2418;
  goto l2411;
  l2418:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_UlOrStarLine(G))  goto l2419;
  goto l2411;
  l2419:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Space(G))  goto l2420;
  goto l2411;
  l2420:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Strong(G))  goto l2421;
  goto l2411;
  l2421:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Emph(G))  goto l2422;
  goto l2411;
  l2422:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;
  {  int yypos2424= G->pos, yythunkpos2424= G->thunkpos;  if (!yymatchChar(G, '[')) goto l2423;
  G->pos= yypos2424; G->thunkpos= yythunkpos2424;
  }
  {  int yypos2425= G->pos, yythunkpos2425= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2426;  if (!yy_CitationReference(G))  goto l2426;
  goto l2425;
  l2426:;	  G->pos= yypos2425; G->thunkpos= yythunkpos2425;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2427;  if (!yy_Variable(G))  goto l2427;
  goto l2425;
  l2427:;	  G->pos= yypos2425; G->thunkpos= yythunkpos2425;  if (!yy_NoteReference(G))  goto l2428;
  goto l2425;
  l2428:;	  G->pos= yypos2425; G->thunkpos= yythunkpos2425;  if (!yy_Link(G))  goto l2423;

  }
  l2425:;	  goto l2411;
  l2423:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;
  {  int yypos2430= G->pos, yythunkpos2430= G->thunkpos;  if (!yymatchString(G, "![")) goto l2429;
  G->pos= yypos2430; G->thunkpos= yythunkpos2430;
  }  if (!yy_Image(G))  goto l2429;
  goto l2411;
  l2429:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Code(G))  goto l2431;
  goto l2411;
  l2431:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;
  {  int yypos2433= G->pos, yythunkpos2433= G->thunkpos;  if (!yymatchChar(G, '<')) goto l2432;
  G->pos= yypos2433; G->thunkpos= yythunkpos2433;
  }
  {  int yypos2434= G->pos, yythunkpos2434= G->thunkpos;  if (!yy_Link(G))  goto l2435;
  goto l2434;
  l2435:;	  G->pos= yypos2434; G->thunkpos= yythunkpos2434;  if (!yy_MarkdownHtmlTagOpen(G))  goto l2436;
  goto l2434;
  l2436:;	  G->pos= yypos2434; G->thunkpos= yythunkpos2434;  if (!yy_RawHtml(G))  goto l2432;

  }
  l2434:;	  goto l2411;
  l2432:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Entity(G))  goto l2437;
  goto l2411;
  l2437:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_EscapedChar(G))  goto l2438;
  goto l2411;
  l2438:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Smart(G))  goto l2439;
  goto l2411;
  l2439:;	  G->pos= yypos2411; G->thunkpos= yythunkpos2411;  if (!yy_Symbol(G))  goto l2410;

  }
  l2411:;	  yyprintf((stderr, "  ok   Inline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2410:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Inline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AutoLabel(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AutoLabel"));
  if (!yymatchChar(G, '[')) goto l2440;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2440;
  {  int yypos2441= G->pos, yythunkpos2441= G->thunkpos;  if (!yy_Newline(G))  goto l2441;
  goto l2440;
  l2441:;	  G->pos= yypos2441; G->thunkpos= yythunkpos2441;
  }
  {  int yypos2442= G->pos, yythunkpos2442= G->thunkpos;  if (!yymatchChar(G, '^')) goto l2442;
  goto l2440;
  l2442:;	  G->pos= yypos2442; G->thunkpos= yythunkpos2442;
  }
  {  int yypos2443= G->pos, yythunkpos2443= G->thunkpos;  if (!yymatchChar(G, '#')) goto l2443;
  goto l2440;
  l2443:;	  G->pos= yypos2443; G->thunkpos= yythunkpos2443;
  }
  {  int yypos2444= G->pos, yythunkpos2444= G->thunkpos;  if (!yymatchChar(G, '%')) goto l2444;
  goto l2440;
  l2444:;	  G->pos= yypos2444; G->thunkpos= yythunkpos2444;
  }  if (!yymatchDot(G)) goto l2440;
  {  int yypos2447= G->pos, yythunkpos2447= G->thunkpos;  if (!yy_Newline(G))  goto l2447;
  goto l2440;
  l2447:;	  G->pos= yypos2447; G->thunkpos= yythunkpos2447;
  }
  {  int yypos2448= G->pos, yythunkpos2448= G->thunkpos;  if (!yymatchChar(G, ']')) goto l2448;
  goto l2440;
  l2448:;	  G->pos= yypos2448; G->thunkpos= yythunkpos2448;
  }
  {  int yypos2449= G->pos, yythunkpos2449= G->thunkpos;  if (!yymatchChar(G, '[')) goto l2449;
  goto l2440;
  l2449:;	  G->pos= yypos2449; G->thunkpos= yythunkpos2449;
  }  if (!yymatchDot(G)) goto l2440;
  l2445:;	
  {  int yypos2446= G->pos, yythunkpos2446= G->thunkpos;
  {  int yypos2450= G->pos, yythunkpos2450= G->thunkpos;  if (!yy_Newline(G))  goto l2450;
  goto l2446;
  l2450:;	  G->pos= yypos2450; G->thunkpos= yythunkpos2450;
  }
  {  int yypos2451= G->pos, yythunkpos2451= G->thunkpos;  if (!yymatchChar(G, ']')) goto l2451;
  goto l2446;
  l2451:;	  G->pos= yypos2451; G->thunkpos= yythunkpos2451;
  }
  {  int yypos2452= G->pos, yythunkpos2452= G->thunkpos;  if (!yymatchChar(G, '[')) goto l2452;
  goto l2446;
  l2452:;	  G->pos= yypos2452; G->thunkpos= yythunkpos2452;
  }  if (!yymatchDot(G)) goto l2446;  goto l2445;
  l2446:;	  G->pos= yypos2446; G->thunkpos= yythunkpos2446;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2440;  if (!yymatchChar(G, ']')) goto l2440;

  {  int yypos2453= G->pos, yythunkpos2453= G->thunkpos;
  {  int yypos2454= G->pos, yythunkpos2454= G->thunkpos;  if (!yy_Sp(G))  goto l2454;

  {  int yypos2455= G->pos, yythunkpos2455= G->thunkpos;  if (!yymatchChar(G, '(')) goto l2456;
  goto l2455;
  l2456:;	  G->pos= yypos2455; G->thunkpos= yythunkpos2455;  if (!yymatchChar(G, '[')) goto l2454;

  }
  l2455:;	  goto l2440;
  l2454:;	  G->pos= yypos2454; G->thunkpos= yythunkpos2454;
  }  G->pos= yypos2453; G->thunkpos= yythunkpos2453;
  }  yyDo(G, yy_1_AutoLabel, G->begin, G->end, "yy_1_AutoLabel");
  yyprintf((stderr, "  ok   AutoLabel"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2440:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AutoLabel"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AtxInline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AtxInline"));

  {  int yypos2458= G->pos, yythunkpos2458= G->thunkpos;  if (!yy_Newline(G))  goto l2458;
  goto l2457;
  l2458:;	  G->pos= yypos2458; G->thunkpos= yythunkpos2458;
  }
  {  int yypos2459= G->pos, yythunkpos2459= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2459;  if (!yy_Sp(G))  goto l2459;
  if (!yy_AutoLabel(G))  goto l2459;
  if (!yy_Sp(G))  goto l2459;

  l2460:;	
  {  int yypos2461= G->pos, yythunkpos2461= G->thunkpos;  if (!yymatchChar(G, '#')) goto l2461;
  goto l2460;
  l2461:;	  G->pos= yypos2461; G->thunkpos= yythunkpos2461;
  }  if (!yy_Sp(G))  goto l2459;
  if (!yy_Newline(G))  goto l2459;
  goto l2457;
  l2459:;	  G->pos= yypos2459; G->thunkpos= yythunkpos2459;
  }
  {  int yypos2462= G->pos, yythunkpos2462= G->thunkpos;  if (!yy_Sp(G))  goto l2462;

  l2463:;	
  {  int yypos2464= G->pos, yythunkpos2464= G->thunkpos;  if (!yymatchChar(G, '#')) goto l2464;
  goto l2463;
  l2464:;	  G->pos= yypos2464; G->thunkpos= yythunkpos2464;
  }  if (!yy_Sp(G))  goto l2462;
  if (!yy_Newline(G))  goto l2462;
  goto l2457;
  l2462:;	  G->pos= yypos2462; G->thunkpos= yythunkpos2462;
  }  if (!yy_Inline(G))  goto l2457;
  yyprintf((stderr, "  ok   AtxInline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2457:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AtxInline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AtxHeading(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 3, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "AtxHeading"));
  if (!yy_AtxStart(G))  goto l2465;
  yyDo(G, yySet, -3, 0, "yySet");
  if (!yy_Sp(G))  goto l2465;
  if (!yy_StartList(G))  goto l2465;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_AtxInline(G))  goto l2465;
  yyDo(G, yy_1_AtxHeading, G->begin, G->end, "yy_1_AtxHeading");

  l2466:;	
  {  int yypos2467= G->pos, yythunkpos2467= G->thunkpos;  if (!yy_AtxInline(G))  goto l2467;
  yyDo(G, yy_1_AtxHeading, G->begin, G->end, "yy_1_AtxHeading");
  goto l2466;
  l2467:;	  G->pos= yypos2467; G->thunkpos= yythunkpos2467;
  }
  {  int yypos2468= G->pos, yythunkpos2468= G->thunkpos;  if (!yy_Sp(G))  goto l2468;
  if (!yy_AutoLabel(G))  goto l2468;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_2_AtxHeading, G->begin, G->end, "yy_2_AtxHeading");
  goto l2469;
  l2468:;	  G->pos= yypos2468; G->thunkpos= yythunkpos2468;
  }
  l2469:;	
  {  int yypos2470= G->pos, yythunkpos2470= G->thunkpos;  if (!yy_Sp(G))  goto l2470;

  l2472:;	
  {  int yypos2473= G->pos, yythunkpos2473= G->thunkpos;  if (!yymatchChar(G, '#')) goto l2473;
  goto l2472;
  l2473:;	  G->pos= yypos2473; G->thunkpos= yythunkpos2473;
  }  if (!yy_Sp(G))  goto l2470;
  goto l2471;
  l2470:;	  G->pos= yypos2470; G->thunkpos= yythunkpos2470;
  }
  l2471:;	  if (!yy_Sp(G))  goto l2465;
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2465;  if (!yy_Newline(G))  goto l2465;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2465;  yyDo(G, yy_3_AtxHeading, G->begin, G->end, "yy_3_AtxHeading");
  yyprintf((stderr, "  ok   AtxHeading"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 3, 0, "yyPop");
  return 1;
  l2465:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AtxHeading"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HeadingSectionBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HeadingSectionBlock"));

  l2475:;	
  {  int yypos2476= G->pos, yythunkpos2476= G->thunkpos;  if (!yy_BlankLine(G))  goto l2476;
  goto l2475;
  l2476:;	  G->pos= yypos2476; G->thunkpos= yythunkpos2476;
  }
  {  int yypos2477= G->pos, yythunkpos2477= G->thunkpos;  if (!yy_Heading(G))  goto l2477;
  goto l2474;
  l2477:;	  G->pos= yypos2477; G->thunkpos= yythunkpos2477;
  }
  {  int yypos2478= G->pos, yythunkpos2478= G->thunkpos;  if (!yy_BlockQuote(G))  goto l2479;
  goto l2478;
  l2479:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2480;  if (!yy_Fenced(G))  goto l2480;
  goto l2478;
  l2480:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_Verbatim(G))  goto l2481;
  goto l2478;
  l2481:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2482;  if (!yy_DefinitionList(G))  goto l2482;
  goto l2478;
  l2482:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2483;  if (!yy_Glossary(G))  goto l2483;
  goto l2478;
  l2483:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_Note(G))  goto l2484;
  goto l2478;
  l2484:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_LinkReference(G))  goto l2485;
  goto l2478;
  l2485:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2486;  if (!yy_Abbreviation(G))  goto l2486;
  goto l2478;
  l2486:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_HorizontalRule(G))  goto l2487;
  goto l2478;
  l2487:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_OrderedList(G))  goto l2488;
  goto l2478;
  l2488:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_BulletList(G))  goto l2489;
  goto l2478;
  l2489:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_HtmlBlock(G))  goto l2490;
  goto l2478;
  l2490:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_MarkdownHtmlBlock(G))  goto l2491;
  goto l2478;
  l2491:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_StyleBlock(G))  goto l2492;
  goto l2478;
  l2492:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2493;  if (!yy_Table(G))  goto l2493;
  goto l2478;
  l2493:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2494;  if (!yy_ImageBlock(G))  goto l2494;
  goto l2478;
  l2494:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2495;  if (!yy_TOC(G))  goto l2495;
  goto l2478;
  l2495:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;
  {  int yypos2497= G->pos, yythunkpos2497= G->thunkpos;  if (!yy_Sp(G))  goto l2497;
  if (!yy_HtmlBlockInTags(G))  goto l2497;
  goto l2496;
  l2497:;	  G->pos= yypos2497; G->thunkpos= yythunkpos2497;
  }  if (!yy_Para(G))  goto l2496;
  goto l2478;
  l2496:;	  G->pos= yypos2478; G->thunkpos= yythunkpos2478;  if (!yy_Plain(G))  goto l2474;

  }
  l2478:;	  yyprintf((stderr, "  ok   HeadingSectionBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2474:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HeadingSectionBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Plain(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Plain"));
  if (!yy_Inlines(G))  goto l2498;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_Plain, G->begin, G->end, "yy_1_Plain");
  yyprintf((stderr, "  ok   Plain"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2498:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Plain"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Para(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Para"));
  if (!yy_NonindentSpace(G))  goto l2499;
  if (!yy_Inlines(G))  goto l2499;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_BlankLine(G))  goto l2499;

  l2500:;	
  {  int yypos2501= G->pos, yythunkpos2501= G->thunkpos;  if (!yy_BlankLine(G))  goto l2501;
  goto l2500;
  l2501:;	  G->pos= yypos2501; G->thunkpos= yythunkpos2501;
  }  yyDo(G, yy_1_Para, G->begin, G->end, "yy_1_Para");
  yyprintf((stderr, "  ok   Para"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2499:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Para"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlockInTags(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlockInTags"));

  {  int yypos2503= G->pos, yythunkpos2503= G->thunkpos;  if (!yy_HtmlBlockAddress(G))  goto l2504;
  goto l2503;
  l2504:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockArticle(G))  goto l2505;
  goto l2503;
  l2505:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockAside(G))  goto l2506;
  goto l2503;
  l2506:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockCanvas(G))  goto l2507;
  goto l2503;
  l2507:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockBlockquote(G))  goto l2508;
  goto l2503;
  l2508:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockCenter(G))  goto l2509;
  goto l2503;
  l2509:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockDir(G))  goto l2510;
  goto l2503;
  l2510:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockDiv(G))  goto l2511;
  goto l2503;
  l2511:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockDl(G))  goto l2512;
  goto l2503;
  l2512:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockFieldset(G))  goto l2513;
  goto l2503;
  l2513:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockFigure(G))  goto l2514;
  goto l2503;
  l2514:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockFooter(G))  goto l2515;
  goto l2503;
  l2515:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockForm(G))  goto l2516;
  goto l2503;
  l2516:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockHeader(G))  goto l2517;
  goto l2503;
  l2517:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockHgroup(G))  goto l2518;
  goto l2503;
  l2518:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockH1(G))  goto l2519;
  goto l2503;
  l2519:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockH2(G))  goto l2520;
  goto l2503;
  l2520:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockH3(G))  goto l2521;
  goto l2503;
  l2521:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockH4(G))  goto l2522;
  goto l2503;
  l2522:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockH5(G))  goto l2523;
  goto l2503;
  l2523:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockH6(G))  goto l2524;
  goto l2503;
  l2524:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockMenu(G))  goto l2525;
  goto l2503;
  l2525:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockNoframes(G))  goto l2526;
  goto l2503;
  l2526:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockNoscript(G))  goto l2527;
  goto l2503;
  l2527:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockOl(G))  goto l2528;
  goto l2503;
  l2528:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockPre(G))  goto l2529;
  goto l2503;
  l2529:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockProgress(G))  goto l2530;
  goto l2503;
  l2530:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockP(G))  goto l2531;
  goto l2503;
  l2531:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockSection(G))  goto l2532;
  goto l2503;
  l2532:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockTable(G))  goto l2533;
  goto l2503;
  l2533:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockUl(G))  goto l2534;
  goto l2503;
  l2534:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockVideo(G))  goto l2535;
  goto l2503;
  l2535:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockDd(G))  goto l2536;
  goto l2503;
  l2536:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockDt(G))  goto l2537;
  goto l2503;
  l2537:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockFrameset(G))  goto l2538;
  goto l2503;
  l2538:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockLi(G))  goto l2539;
  goto l2503;
  l2539:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockTbody(G))  goto l2540;
  goto l2503;
  l2540:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockTd(G))  goto l2541;
  goto l2503;
  l2541:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockTfoot(G))  goto l2542;
  goto l2503;
  l2542:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockThead(G))  goto l2543;
  goto l2503;
  l2543:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockTh(G))  goto l2544;
  goto l2503;
  l2544:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockTr(G))  goto l2545;
  goto l2503;
  l2545:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockScript(G))  goto l2546;
  goto l2503;
  l2546:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockHead(G))  goto l2547;
  goto l2503;
  l2547:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockMain(G))  goto l2548;
  goto l2503;
  l2548:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockNav(G))  goto l2549;
  goto l2503;
  l2549:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockDel(G))  goto l2550;
  goto l2503;
  l2550:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockIns(G))  goto l2551;
  goto l2503;
  l2551:;	  G->pos= yypos2503; G->thunkpos= yythunkpos2503;  if (!yy_HtmlBlockMark(G))  goto l2502;

  }
  l2503:;	  yyprintf((stderr, "  ok   HtmlBlockInTags"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2502:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlockInTags"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_TOC(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "TOC"));
  if (!yymatchString(G, "{{TOC}}")) goto l2552;
  if (!yy_Sp(G))  goto l2552;
  if (!yy_Newline(G))  goto l2552;
  yyDo(G, yy_1_TOC, G->begin, G->end, "yy_1_TOC");
  yyprintf((stderr, "  ok   TOC"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2552:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "TOC"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_ImageBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "ImageBlock"));
  if (!yy_Image(G))  goto l2553;
  if (!yy_Sp(G))  goto l2553;
  if (!yy_Newline(G))  goto l2553;
  if (!yy_BlankLine(G))  goto l2553;

  l2554:;	
  {  int yypos2555= G->pos, yythunkpos2555= G->thunkpos;  if (!yy_BlankLine(G))  goto l2555;
  goto l2554;
  l2555:;	  G->pos= yypos2555; G->thunkpos= yythunkpos2555;
  }  yyDo(G, yy_1_ImageBlock, G->begin, G->end, "yy_1_ImageBlock");
  yyprintf((stderr, "  ok   ImageBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2553:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "ImageBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Table(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Table"));
  if (!yy_StartList(G))  goto l2556;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_StartList(G))  goto l2556;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2557= G->pos, yythunkpos2557= G->thunkpos;  if (!yy_TableCaption(G))  goto l2557;
  yyDo(G, yy_1_Table, G->begin, G->end, "yy_1_Table");
  goto l2558;
  l2557:;	  G->pos= yypos2557; G->thunkpos= yythunkpos2557;
  }
  l2558:;	
  {  int yypos2559= G->pos, yythunkpos2559= G->thunkpos;  if (!yy_TableBody(G))  goto l2559;
  yyDo(G, yy_2_Table, G->begin, G->end, "yy_2_Table");
  goto l2560;
  l2559:;	  G->pos= yypos2559; G->thunkpos= yythunkpos2559;
  }
  l2560:;	  if (!yy_SeparatorLine(G))  goto l2556;
  yyDo(G, yy_3_Table, G->begin, G->end, "yy_3_Table");
  if (!yy_TableBody(G))  goto l2556;
  yyDo(G, yy_4_Table, G->begin, G->end, "yy_4_Table");

  l2561:;	
  {  int yypos2562= G->pos, yythunkpos2562= G->thunkpos;  if (!yy_BlankLine(G))  goto l2562;

  {  int yypos2563= G->pos, yythunkpos2563= G->thunkpos;  if (!yy_TableCaption(G))  goto l2563;
  goto l2562;
  l2563:;	  G->pos= yypos2563; G->thunkpos= yythunkpos2563;
  }  if (!yy_TableBody(G))  goto l2562;
  yyDo(G, yy_5_Table, G->begin, G->end, "yy_5_Table");

  {  int yypos2564= G->pos, yythunkpos2564= G->thunkpos;
  {  int yypos2565= G->pos, yythunkpos2565= G->thunkpos;  if (!yy_TableCaption(G))  goto l2566;
  goto l2565;
  l2566:;	  G->pos= yypos2565; G->thunkpos= yythunkpos2565;  if (!yy_BlankLine(G))  goto l2567;
  goto l2565;
  l2567:;	  G->pos= yypos2565; G->thunkpos= yythunkpos2565;  if (!yy_Heading(G))  goto l2562;

  }
  l2565:;	  G->pos= yypos2564; G->thunkpos= yythunkpos2564;
  }  goto l2561;
  l2562:;	  G->pos= yypos2562; G->thunkpos= yythunkpos2562;
  }
  {  int yypos2568= G->pos, yythunkpos2568= G->thunkpos;  if (!yy_TableCaption(G))  goto l2569;
  yyDo(G, yy_6_Table, G->begin, G->end, "yy_6_Table");

  {  int yypos2570= G->pos, yythunkpos2570= G->thunkpos;  if (!yy_BlankLine(G))  goto l2569;
  G->pos= yypos2570; G->thunkpos= yythunkpos2570;
  }  goto l2568;
  l2569:;	  G->pos= yypos2568; G->thunkpos= yythunkpos2568;
  {  int yypos2572= G->pos, yythunkpos2572= G->thunkpos;  if (!yy_BlankLine(G))  goto l2571;
  G->pos= yypos2572; G->thunkpos= yythunkpos2572;
  }  goto l2568;
  l2571:;	  G->pos= yypos2568; G->thunkpos= yythunkpos2568;
  {  int yypos2573= G->pos, yythunkpos2573= G->thunkpos;  if (!yy_Heading(G))  goto l2556;
  G->pos= yypos2573; G->thunkpos= yythunkpos2573;
  }
  }
  l2568:;	  yyDo(G, yy_7_Table, G->begin, G->end, "yy_7_Table");
  yyprintf((stderr, "  ok   Table"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2556:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Table"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StyleBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StyleBlock"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2574;  if (!yy_InStyleTags(G))  goto l2574;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2574;
  l2575:;	
  {  int yypos2576= G->pos, yythunkpos2576= G->thunkpos;  if (!yy_BlankLine(G))  goto l2576;
  goto l2575;
  l2576:;	  G->pos= yypos2576; G->thunkpos= yythunkpos2576;
  }  yyDo(G, yy_1_StyleBlock, G->begin, G->end, "yy_1_StyleBlock");
  yyprintf((stderr, "  ok   StyleBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2574:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StyleBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MarkdownHtmlBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "MarkdownHtmlBlock"));

  {  int yypos2578= G->pos, yythunkpos2578= G->thunkpos;  if (!yy_MarkdownHtmlTagOpen(G))  goto l2577;
  G->pos= yypos2578; G->thunkpos= yythunkpos2578;
  }  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2577;
  {  int yypos2579= G->pos, yythunkpos2579= G->thunkpos;  if (!yy_HtmlBlockInTags(G))  goto l2580;
  goto l2579;
  l2580:;	  G->pos= yypos2579; G->thunkpos= yythunkpos2579;  if (!yy_HtmlComment(G))  goto l2581;
  goto l2579;
  l2581:;	  G->pos= yypos2579; G->thunkpos= yythunkpos2579;  if (!yy_HtmlBlockSelfClosing(G))  goto l2577;

  }
  l2579:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2577;  if (!yy_BlankLine(G))  goto l2577;

  l2582:;	
  {  int yypos2583= G->pos, yythunkpos2583= G->thunkpos;  if (!yy_BlankLine(G))  goto l2583;
  goto l2582;
  l2583:;	  G->pos= yypos2583; G->thunkpos= yythunkpos2583;
  }  yyDo(G, yy_1_MarkdownHtmlBlock, G->begin, G->end, "yy_1_MarkdownHtmlBlock");
  yyprintf((stderr, "  ok   MarkdownHtmlBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2577:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MarkdownHtmlBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BulletList(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BulletList"));

  {  int yypos2585= G->pos, yythunkpos2585= G->thunkpos;  if (!yy_Bullet(G))  goto l2584;
  G->pos= yypos2585; G->thunkpos= yythunkpos2585;
  }
  {  int yypos2586= G->pos, yythunkpos2586= G->thunkpos;  if (!yy_ListTight(G))  goto l2587;
  goto l2586;
  l2587:;	  G->pos= yypos2586; G->thunkpos= yythunkpos2586;  if (!yy_ListLoose(G))  goto l2584;

  }
  l2586:;	  yyDo(G, yy_1_BulletList, G->begin, G->end, "yy_1_BulletList");
  yyprintf((stderr, "  ok   BulletList"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2584:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BulletList"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_OrderedList(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "OrderedList"));

  {  int yypos2589= G->pos, yythunkpos2589= G->thunkpos;  if (!yy_Enumerator(G))  goto l2588;
  G->pos= yypos2589; G->thunkpos= yythunkpos2589;
  }
  {  int yypos2590= G->pos, yythunkpos2590= G->thunkpos;  if (!yy_ListTight(G))  goto l2591;
  goto l2590;
  l2591:;	  G->pos= yypos2590; G->thunkpos= yythunkpos2590;  if (!yy_ListLoose(G))  goto l2588;

  }
  l2590:;	  yyDo(G, yy_1_OrderedList, G->begin, G->end, "yy_1_OrderedList");
  yyprintf((stderr, "  ok   OrderedList"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2588:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "OrderedList"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Heading(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Heading"));

  {  int yypos2593= G->pos, yythunkpos2593= G->thunkpos;  if (!yy_SetextHeading(G))  goto l2594;
  goto l2593;
  l2594:;	  G->pos= yypos2593; G->thunkpos= yythunkpos2593;  if (!yy_AtxHeading(G))  goto l2592;

  }
  l2593:;	  yyprintf((stderr, "  ok   Heading"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2592:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Heading"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HeadingSection(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "HeadingSection"));
  if (!yy_StartList(G))  goto l2595;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Heading(G))  goto l2595;
  yyDo(G, yy_1_HeadingSection, G->begin, G->end, "yy_1_HeadingSection");

  l2596:;	
  {  int yypos2597= G->pos, yythunkpos2597= G->thunkpos;  if (!yy_HeadingSectionBlock(G))  goto l2597;
  yyDo(G, yy_2_HeadingSection, G->begin, G->end, "yy_2_HeadingSection");
  goto l2596;
  l2597:;	  G->pos= yypos2597; G->thunkpos= yythunkpos2597;
  }  yyDo(G, yy_3_HeadingSection, G->begin, G->end, "yy_3_HeadingSection");
  yyprintf((stderr, "  ok   HeadingSection"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2595:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HeadingSection"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HorizontalRule(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HorizontalRule"));
  if (!yy_NonindentSpace(G))  goto l2598;

  {  int yypos2599= G->pos, yythunkpos2599= G->thunkpos;  if (!yymatchChar(G, '*')) goto l2600;
  if (!yy_Sp(G))  goto l2600;
  if (!yymatchChar(G, '*')) goto l2600;
  if (!yy_Sp(G))  goto l2600;
  if (!yymatchChar(G, '*')) goto l2600;

  l2601:;	
  {  int yypos2602= G->pos, yythunkpos2602= G->thunkpos;  if (!yy_Sp(G))  goto l2602;
  if (!yymatchChar(G, '*')) goto l2602;
  goto l2601;
  l2602:;	  G->pos= yypos2602; G->thunkpos= yythunkpos2602;
  }  goto l2599;
  l2600:;	  G->pos= yypos2599; G->thunkpos= yythunkpos2599;  if (!yymatchChar(G, '-')) goto l2603;
  if (!yy_Sp(G))  goto l2603;
  if (!yymatchChar(G, '-')) goto l2603;
  if (!yy_Sp(G))  goto l2603;
  if (!yymatchChar(G, '-')) goto l2603;

  l2604:;	
  {  int yypos2605= G->pos, yythunkpos2605= G->thunkpos;  if (!yy_Sp(G))  goto l2605;
  if (!yymatchChar(G, '-')) goto l2605;
  goto l2604;
  l2605:;	  G->pos= yypos2605; G->thunkpos= yythunkpos2605;
  }  goto l2599;
  l2603:;	  G->pos= yypos2599; G->thunkpos= yythunkpos2599;  if (!yymatchChar(G, '_')) goto l2598;
  if (!yy_Sp(G))  goto l2598;
  if (!yymatchChar(G, '_')) goto l2598;
  if (!yy_Sp(G))  goto l2598;
  if (!yymatchChar(G, '_')) goto l2598;

  l2606:;	
  {  int yypos2607= G->pos, yythunkpos2607= G->thunkpos;  if (!yy_Sp(G))  goto l2607;
  if (!yymatchChar(G, '_')) goto l2607;
  goto l2606;
  l2607:;	  G->pos= yypos2607; G->thunkpos= yythunkpos2607;
  }
  }
  l2599:;	  if (!yy_Sp(G))  goto l2598;
  if (!yy_Newline(G))  goto l2598;

  l2608:;	
  {  int yypos2609= G->pos, yythunkpos2609= G->thunkpos;  if (!yy_BlankLine(G))  goto l2609;
  goto l2608;
  l2609:;	  G->pos= yypos2609; G->thunkpos= yythunkpos2609;
  }  yyDo(G, yy_1_HorizontalRule, G->begin, G->end, "yy_1_HorizontalRule");
  yyprintf((stderr, "  ok   HorizontalRule"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2598:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HorizontalRule"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Abbreviation(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Abbreviation"));
  if (!yymatchChar(G, '*')) goto l2610;
  if (!yy_Label(G))  goto l2610;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_Sp(G))  goto l2610;
  if (!yymatchChar(G, ':')) goto l2610;
  if (!yy_Sp(G))  goto l2610;
  if (!yy_RawLine(G))  goto l2610;
  yyDo(G, yy_1_Abbreviation, G->begin, G->end, "yy_1_Abbreviation");
  yyprintf((stderr, "  ok   Abbreviation"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2610:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Abbreviation"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_LinkReference(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 4, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "LinkReference"));
  if (!yy_StartList(G))  goto l2611;
  yyDo(G, yySet, -4, 0, "yySet");
  if (!yy_NonindentSpace(G))  goto l2611;

  {  int yypos2612= G->pos, yythunkpos2612= G->thunkpos;  if (!yymatchString(G, "[]")) goto l2612;
  goto l2611;
  l2612:;	  G->pos= yypos2612; G->thunkpos= yythunkpos2612;
  }  if (!yy_Label(G))  goto l2611;
  yyDo(G, yySet, -3, 0, "yySet");
  if (!yymatchChar(G, ':')) goto l2611;
  if (!yy_Spnl(G))  goto l2611;
  if (!yy_RefSrc(G))  goto l2611;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_RefTitle(G))  goto l2611;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2613= G->pos, yythunkpos2613= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2613;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2613;  if (!yy_Attributes(G))  goto l2613;
  yyDo(G, yy_1_LinkReference, G->begin, G->end, "yy_1_LinkReference");
  goto l2614;
  l2613:;	  G->pos= yypos2613; G->thunkpos= yythunkpos2613;
  }
  l2614:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2611;  if (!yy_BlankLine(G))  goto l2611;

  l2615:;	
  {  int yypos2616= G->pos, yythunkpos2616= G->thunkpos;  if (!yy_BlankLine(G))  goto l2616;
  goto l2615;
  l2616:;	  G->pos= yypos2616; G->thunkpos= yythunkpos2616;
  }  yyDo(G, yy_2_LinkReference, G->begin, G->end, "yy_2_LinkReference");
  yyprintf((stderr, "  ok   LinkReference"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 4, 0, "yyPop");
  return 1;
  l2611:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "LinkReference"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Note(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Note"));
  yyText(G, G->begin, G->end);  if (!( ext(EXT_NOTES) )) goto l2617;  if (!yy_NonindentSpace(G))  goto l2617;
  if (!yy_RawNoteReference(G))  goto l2617;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yymatchChar(G, ':')) goto l2617;
  if (!yy_Sp(G))  goto l2617;
  if (!yy_StartList(G))  goto l2617;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_RawNoteBlock(G))  goto l2617;
  yyDo(G, yy_1_Note, G->begin, G->end, "yy_1_Note");

  l2618:;	
  {  int yypos2619= G->pos, yythunkpos2619= G->thunkpos;
  {  int yypos2620= G->pos, yythunkpos2620= G->thunkpos;  if (!yy_Indent(G))  goto l2619;
  G->pos= yypos2620; G->thunkpos= yythunkpos2620;
  }  if (!yy_RawNoteBlock(G))  goto l2619;
  yyDo(G, yy_2_Note, G->begin, G->end, "yy_2_Note");
  goto l2618;
  l2619:;	  G->pos= yypos2619; G->thunkpos= yythunkpos2619;
  }  yyDo(G, yy_3_Note, G->begin, G->end, "yy_3_Note");
  yyprintf((stderr, "  ok   Note"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2617:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Note"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Glossary(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Glossary"));
  yyText(G, G->begin, G->end);  if (!( ext(EXT_NOTES) )) goto l2621;  if (!yy_StartList(G))  goto l2621;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_NonindentSpace(G))  goto l2621;
  if (!yy_RawNoteReference(G))  goto l2621;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yymatchChar(G, ':')) goto l2621;
  if (!yy_Sp(G))  goto l2621;
  if (!yymatchString(G, "glossary:")) goto l2621;
  if (!yy_Sp(G))  goto l2621;
  if (!yy_GlossaryTerm(G))  goto l2621;
  yyDo(G, yy_1_Glossary, G->begin, G->end, "yy_1_Glossary");

  {  int yypos2622= G->pos, yythunkpos2622= G->thunkpos;  if (!yy_GlossarySortKey(G))  goto l2622;
  yyDo(G, yy_2_Glossary, G->begin, G->end, "yy_2_Glossary");
  goto l2623;
  l2622:;	  G->pos= yypos2622; G->thunkpos= yythunkpos2622;
  }
  l2623:;	  if (!yy_Newline(G))  goto l2621;
  if (!yy_RawNoteBlock(G))  goto l2621;
  yyDo(G, yy_3_Glossary, G->begin, G->end, "yy_3_Glossary");

  l2624:;	
  {  int yypos2625= G->pos, yythunkpos2625= G->thunkpos;
  {  int yypos2626= G->pos, yythunkpos2626= G->thunkpos;  if (!yy_Indent(G))  goto l2625;
  G->pos= yypos2626; G->thunkpos= yythunkpos2626;
  }  if (!yy_RawNoteBlock(G))  goto l2625;
  yyDo(G, yy_4_Glossary, G->begin, G->end, "yy_4_Glossary");
  goto l2624;
  l2625:;	  G->pos= yypos2625; G->thunkpos= yythunkpos2625;
  }  yyDo(G, yy_5_Glossary, G->begin, G->end, "yy_5_Glossary");
  yyprintf((stderr, "  ok   Glossary"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2621:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Glossary"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DefinitionList(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "DefinitionList"));
  if (!yy_StartList(G))  goto l2627;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2628= G->pos, yythunkpos2628= G->thunkpos;  if (!yy_TermLine(G))  goto l2627;

  l2629:;	
  {  int yypos2630= G->pos, yythunkpos2630= G->thunkpos;  if (!yy_TermLine(G))  goto l2630;
  goto l2629;
  l2630:;	  G->pos= yypos2630; G->thunkpos= yythunkpos2630;
  }
  {  int yypos2631= G->pos, yythunkpos2631= G->thunkpos;  if (!yy_Newline(G))  goto l2631;
  goto l2632;
  l2631:;	  G->pos= yypos2631; G->thunkpos= yythunkpos2631;
  }
  l2632:;	  if (!yy_NonindentSpace(G))  goto l2627;
  if (!yymatchChar(G, ':')) goto l2627;
  G->pos= yypos2628; G->thunkpos= yythunkpos2628;
  }  if (!yy_Term(G))  goto l2627;
  yyDo(G, yy_1_DefinitionList, G->begin, G->end, "yy_1_DefinitionList");

  l2635:;	
  {  int yypos2636= G->pos, yythunkpos2636= G->thunkpos;  if (!yy_Term(G))  goto l2636;
  yyDo(G, yy_1_DefinitionList, G->begin, G->end, "yy_1_DefinitionList");
  goto l2635;
  l2636:;	  G->pos= yypos2636; G->thunkpos= yythunkpos2636;
  }
  {  int yypos2637= G->pos, yythunkpos2637= G->thunkpos;  if (!yy_BlankLine(G))  goto l2637;
  goto l2638;
  l2637:;	  G->pos= yypos2637; G->thunkpos= yythunkpos2637;
  }
  l2638:;	  if (!yy_Definition(G))  goto l2627;
  yyDo(G, yy_2_DefinitionList, G->begin, G->end, "yy_2_DefinitionList");

  l2639:;	
  {  int yypos2640= G->pos, yythunkpos2640= G->thunkpos;  if (!yy_Definition(G))  goto l2640;
  yyDo(G, yy_2_DefinitionList, G->begin, G->end, "yy_2_DefinitionList");
  goto l2639;
  l2640:;	  G->pos= yypos2640; G->thunkpos= yythunkpos2640;
  }
  l2641:;	
  {  int yypos2642= G->pos, yythunkpos2642= G->thunkpos;  if (!yy_BlankLine(G))  goto l2642;
  goto l2641;
  l2642:;	  G->pos= yypos2642; G->thunkpos= yythunkpos2642;
  }
  l2633:;	
  {  int yypos2634= G->pos, yythunkpos2634= G->thunkpos;  if (!yy_Term(G))  goto l2634;
  yyDo(G, yy_1_DefinitionList, G->begin, G->end, "yy_1_DefinitionList");

  l2643:;	
  {  int yypos2644= G->pos, yythunkpos2644= G->thunkpos;  if (!yy_Term(G))  goto l2644;
  yyDo(G, yy_1_DefinitionList, G->begin, G->end, "yy_1_DefinitionList");
  goto l2643;
  l2644:;	  G->pos= yypos2644; G->thunkpos= yythunkpos2644;
  }
  {  int yypos2645= G->pos, yythunkpos2645= G->thunkpos;  if (!yy_BlankLine(G))  goto l2645;
  goto l2646;
  l2645:;	  G->pos= yypos2645; G->thunkpos= yythunkpos2645;
  }
  l2646:;	  if (!yy_Definition(G))  goto l2634;
  yyDo(G, yy_2_DefinitionList, G->begin, G->end, "yy_2_DefinitionList");

  l2647:;	
  {  int yypos2648= G->pos, yythunkpos2648= G->thunkpos;  if (!yy_Definition(G))  goto l2648;
  yyDo(G, yy_2_DefinitionList, G->begin, G->end, "yy_2_DefinitionList");
  goto l2647;
  l2648:;	  G->pos= yypos2648; G->thunkpos= yythunkpos2648;
  }
  l2649:;	
  {  int yypos2650= G->pos, yythunkpos2650= G->thunkpos;  if (!yy_BlankLine(G))  goto l2650;
  goto l2649;
  l2650:;	  G->pos= yypos2650; G->thunkpos= yythunkpos2650;
  }  goto l2633;
  l2634:;	  G->pos= yypos2634; G->thunkpos= yythunkpos2634;
  }  yyDo(G, yy_3_DefinitionList, G->begin, G->end, "yy_3_DefinitionList");
  yyprintf((stderr, "  ok   DefinitionList"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2627:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DefinitionList"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Verbatim(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Verbatim"));

  l2652:;	
  {  int yypos2653= G->pos, yythunkpos2653= G->thunkpos;  if (!yy_BlankLine(G))  goto l2653;
  goto l2652;
  l2653:;	  G->pos= yypos2653; G->thunkpos= yythunkpos2653;
  }  if (!yy_StartList(G))  goto l2651;
  yyDo(G, yySet, -1, 0, "yySet");
  if (!yy_VerbatimChunk(G))  goto l2651;
  yyDo(G, yy_1_Verbatim, G->begin, G->end, "yy_1_Verbatim");

  l2654:;	
  {  int yypos2655= G->pos, yythunkpos2655= G->thunkpos;  if (!yy_VerbatimChunk(G))  goto l2655;
  yyDo(G, yy_1_Verbatim, G->begin, G->end, "yy_1_Verbatim");
  goto l2654;
  l2655:;	  G->pos= yypos2655; G->thunkpos= yythunkpos2655;
  }
  l2656:;	
  {  int yypos2657= G->pos, yythunkpos2657= G->thunkpos;  if (!yy_BlankLine(G))  goto l2657;
  goto l2656;
  l2657:;	  G->pos= yypos2657; G->thunkpos= yythunkpos2657;
  }  yyDo(G, yy_2_Verbatim, G->begin, G->end, "yy_2_Verbatim");
  yyprintf((stderr, "  ok   Verbatim"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2651:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Verbatim"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Fenced(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Fenced"));
  if (!yy_NonindentSpace(G))  goto l2658;

  {  int yypos2659= G->pos, yythunkpos2659= G->thunkpos;  if (!yy_Ticks3(G))  goto l2660;
  if (!yy_FenceType(G))  goto l2660;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2660;
  l2661:;	
  {  int yypos2662= G->pos, yythunkpos2662= G->thunkpos;
  {  int yypos2663= G->pos, yythunkpos2663= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l2663;
  if (!yy_Ticks3(G))  goto l2663;
  goto l2662;
  l2663:;	  G->pos= yypos2663; G->thunkpos= yythunkpos2663;
  }  if (!yy_NonMatchingRawLine(G))  goto l2662;
  goto l2661;
  l2662:;	  G->pos= yypos2662; G->thunkpos= yythunkpos2662;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2660;  if (!yy_NonindentSpace(G))  goto l2660;
  if (!yy_Ticks3(G))  goto l2660;
  if (!yy_Sp(G))  goto l2660;
  if (!yy_Newline(G))  goto l2660;
  goto l2659;
  l2660:;	  G->pos= yypos2659; G->thunkpos= yythunkpos2659;  if (!yy_Ticks4(G))  goto l2664;
  if (!yy_FenceType(G))  goto l2664;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2664;
  l2665:;	
  {  int yypos2666= G->pos, yythunkpos2666= G->thunkpos;
  {  int yypos2667= G->pos, yythunkpos2667= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l2667;
  if (!yy_Ticks4(G))  goto l2667;
  goto l2666;
  l2667:;	  G->pos= yypos2667; G->thunkpos= yythunkpos2667;
  }  if (!yy_NonMatchingRawLine(G))  goto l2666;
  goto l2665;
  l2666:;	  G->pos= yypos2666; G->thunkpos= yythunkpos2666;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2664;  if (!yy_NonindentSpace(G))  goto l2664;
  if (!yy_Ticks4(G))  goto l2664;
  if (!yy_Sp(G))  goto l2664;
  if (!yy_Newline(G))  goto l2664;
  goto l2659;
  l2664:;	  G->pos= yypos2659; G->thunkpos= yythunkpos2659;  if (!yy_Ticks5(G))  goto l2658;
  if (!yy_FenceType(G))  goto l2658;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2658;
  l2668:;	
  {  int yypos2669= G->pos, yythunkpos2669= G->thunkpos;
  {  int yypos2670= G->pos, yythunkpos2670= G->thunkpos;  if (!yy_NonindentSpace(G))  goto l2670;
  if (!yy_Ticks5(G))  goto l2670;
  goto l2669;
  l2670:;	  G->pos= yypos2670; G->thunkpos= yythunkpos2670;
  }  if (!yy_NonMatchingRawLine(G))  goto l2669;
  goto l2668;
  l2669:;	  G->pos= yypos2669; G->thunkpos= yythunkpos2669;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2658;  if (!yy_NonindentSpace(G))  goto l2658;
  if (!yy_Ticks5(G))  goto l2658;
  if (!yy_Sp(G))  goto l2658;
  if (!yy_Newline(G))  goto l2658;

  }
  l2659:;	  yyDo(G, yy_1_Fenced, G->begin, G->end, "yy_1_Fenced");
  yyprintf((stderr, "  ok   Fenced"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2658:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Fenced"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BlockQuote(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "BlockQuote"));
  if (!yy_BlockQuoteRaw(G))  goto l2671;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_BlockQuote, G->begin, G->end, "yy_1_BlockQuote");
  yyprintf((stderr, "  ok   BlockQuote"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2671:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BlockQuote"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SetextBottom2(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SetextBottom2"));
  if (!yy_NonindentSpace(G))  goto l2672;
  if (!yymatchChar(G, '-')) goto l2672;

  l2673:;	
  {  int yypos2674= G->pos, yythunkpos2674= G->thunkpos;  if (!yymatchChar(G, '-')) goto l2674;
  goto l2673;
  l2674:;	  G->pos= yypos2674; G->thunkpos= yythunkpos2674;
  }  if (!yy_Sp(G))  goto l2672;
  if (!yy_Newline(G))  goto l2672;
  yyprintf((stderr, "  ok   SetextBottom2"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2672:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SetextBottom2"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SetextBottom1(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SetextBottom1"));
  if (!yy_NonindentSpace(G))  goto l2675;
  if (!yymatchChar(G, '=')) goto l2675;

  l2676:;	
  {  int yypos2677= G->pos, yythunkpos2677= G->thunkpos;  if (!yymatchChar(G, '=')) goto l2677;
  goto l2676;
  l2677:;	  G->pos= yypos2677; G->thunkpos= yythunkpos2677;
  }  if (!yy_Sp(G))  goto l2675;
  if (!yy_Newline(G))  goto l2675;
  yyprintf((stderr, "  ok   SetextBottom1"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2675:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SetextBottom1"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_HtmlBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "HtmlBlock"));

  {  int yypos2679= G->pos, yythunkpos2679= G->thunkpos;  if (!yy_MarkdownHtmlTagOpen(G))  goto l2679;
  goto l2678;
  l2679:;	  G->pos= yypos2679; G->thunkpos= yythunkpos2679;
  }  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2678;
  {  int yypos2680= G->pos, yythunkpos2680= G->thunkpos;  if (!yy_HtmlBlockInTags(G))  goto l2681;
  goto l2680;
  l2681:;	  G->pos= yypos2680; G->thunkpos= yythunkpos2680;  if (!yy_HtmlComment(G))  goto l2682;
  goto l2680;
  l2682:;	  G->pos= yypos2680; G->thunkpos= yythunkpos2680;  if (!yy_HtmlBlockSelfClosing(G))  goto l2678;

  }
  l2680:;	  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2678;  if (!yy_BlankLine(G))  goto l2678;

  l2683:;	
  {  int yypos2684= G->pos, yythunkpos2684= G->thunkpos;  if (!yy_BlankLine(G))  goto l2684;
  goto l2683;
  l2684:;	  G->pos= yypos2684; G->thunkpos= yythunkpos2684;
  }  yyDo(G, yy_1_HtmlBlock, G->begin, G->end, "yy_1_HtmlBlock");
  yyprintf((stderr, "  ok   HtmlBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2678:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "HtmlBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SkipBlock(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SkipBlock"));

  {  int yypos2686= G->pos, yythunkpos2686= G->thunkpos;  if (!yy_HtmlBlock(G))  goto l2687;
  yyDo(G, yy_1_SkipBlock, G->begin, G->end, "yy_1_SkipBlock");
  goto l2686;
  l2687:;	  G->pos= yypos2686; G->thunkpos= yythunkpos2686;
  {  int yypos2691= G->pos, yythunkpos2691= G->thunkpos;  if (!yymatchChar(G, '#')) goto l2691;
  goto l2688;
  l2691:;	  G->pos= yypos2691; G->thunkpos= yythunkpos2691;
  }
  {  int yypos2692= G->pos, yythunkpos2692= G->thunkpos;  if (!yy_SetextBottom1(G))  goto l2692;
  goto l2688;
  l2692:;	  G->pos= yypos2692; G->thunkpos= yythunkpos2692;
  }
  {  int yypos2693= G->pos, yythunkpos2693= G->thunkpos;  if (!yy_SetextBottom2(G))  goto l2693;
  goto l2688;
  l2693:;	  G->pos= yypos2693; G->thunkpos= yythunkpos2693;
  }
  {  int yypos2694= G->pos, yythunkpos2694= G->thunkpos;  if (!yy_BlankLine(G))  goto l2694;
  goto l2688;
  l2694:;	  G->pos= yypos2694; G->thunkpos= yythunkpos2694;
  }  if (!yy_RawLine(G))  goto l2688;

  l2689:;	
  {  int yypos2690= G->pos, yythunkpos2690= G->thunkpos;
  {  int yypos2695= G->pos, yythunkpos2695= G->thunkpos;  if (!yymatchChar(G, '#')) goto l2695;
  goto l2690;
  l2695:;	  G->pos= yypos2695; G->thunkpos= yythunkpos2695;
  }
  {  int yypos2696= G->pos, yythunkpos2696= G->thunkpos;  if (!yy_SetextBottom1(G))  goto l2696;
  goto l2690;
  l2696:;	  G->pos= yypos2696; G->thunkpos= yythunkpos2696;
  }
  {  int yypos2697= G->pos, yythunkpos2697= G->thunkpos;  if (!yy_SetextBottom2(G))  goto l2697;
  goto l2690;
  l2697:;	  G->pos= yypos2697; G->thunkpos= yythunkpos2697;
  }
  {  int yypos2698= G->pos, yythunkpos2698= G->thunkpos;  if (!yy_BlankLine(G))  goto l2698;
  goto l2690;
  l2698:;	  G->pos= yypos2698; G->thunkpos= yythunkpos2698;
  }  if (!yy_RawLine(G))  goto l2690;
  goto l2689;
  l2690:;	  G->pos= yypos2690; G->thunkpos= yythunkpos2690;
  }
  l2699:;	
  {  int yypos2700= G->pos, yythunkpos2700= G->thunkpos;  if (!yy_BlankLine(G))  goto l2700;
  goto l2699;
  l2700:;	  G->pos= yypos2700; G->thunkpos= yythunkpos2700;
  }  goto l2686;
  l2688:;	  G->pos= yypos2686; G->thunkpos= yythunkpos2686;  if (!yy_BlankLine(G))  goto l2701;

  l2702:;	
  {  int yypos2703= G->pos, yythunkpos2703= G->thunkpos;  if (!yy_BlankLine(G))  goto l2703;
  goto l2702;
  l2703:;	  G->pos= yypos2703; G->thunkpos= yythunkpos2703;
  }  goto l2686;
  l2701:;	  G->pos= yypos2686; G->thunkpos= yythunkpos2686;  if (!yy_RawLine(G))  goto l2685;

  }
  l2686:;	  yyprintf((stderr, "  ok   SkipBlock"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2685:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SkipBlock"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_DocForMetaDataOnly(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "DocForMetaDataOnly"));

  {  int yypos2705= G->pos, yythunkpos2705= G->thunkpos;  if (!yy_BOM(G))  goto l2705;
  goto l2706;
  l2705:;	  G->pos= yypos2705; G->thunkpos= yythunkpos2705;
  }
  l2706:;	  if (!yy_StartList(G))  goto l2704;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2707= G->pos, yythunkpos2707= G->thunkpos;
  {  int yypos2709= G->pos, yythunkpos2709= G->thunkpos;
  {  int yypos2710= G->pos, yythunkpos2710= G->thunkpos;  if (!yy_YAMLStart(G))  goto l2710;
  goto l2711;
  l2710:;	  G->pos= yypos2710; G->thunkpos= yythunkpos2710;
  }
  l2711:;	  if (!yy_MetaDataKey(G))  goto l2707;
  if (!yy_Sp(G))  goto l2707;
  if (!yymatchChar(G, ':')) goto l2707;
  if (!yy_Sp(G))  goto l2707;

  {  int yypos2712= G->pos, yythunkpos2712= G->thunkpos;  if (!yy_Newline(G))  goto l2712;
  goto l2707;
  l2712:;	  G->pos= yypos2712; G->thunkpos= yythunkpos2712;
  }  G->pos= yypos2709; G->thunkpos= yythunkpos2709;
  }  if (!yy_MetaData(G))  goto l2707;
  yyDo(G, yy_1_DocForMetaDataOnly, G->begin, G->end, "yy_1_DocForMetaDataOnly");
  goto l2708;
  l2707:;	  G->pos= yypos2707; G->thunkpos= yythunkpos2707;
  }
  l2708:;	
  l2713:;	
  {  int yypos2714= G->pos, yythunkpos2714= G->thunkpos;  if (!yymatchDot(G)) goto l2714;  goto l2713;
  l2714:;	  G->pos= yypos2714; G->thunkpos= yythunkpos2714;
  }
  l2715:;	
  {  int yypos2716= G->pos, yythunkpos2716= G->thunkpos;  if (!yy_BlankLine(G))  goto l2716;
  goto l2715;
  l2716:;	  G->pos= yypos2716; G->thunkpos= yythunkpos2716;
  }  yyDo(G, yy_2_DocForMetaDataOnly, G->begin, G->end, "yy_2_DocForMetaDataOnly");
  yyprintf((stderr, "  ok   DocForMetaDataOnly"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2704:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "DocForMetaDataOnly"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_RawLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "RawLine"));

  {  int yypos2718= G->pos, yythunkpos2718= G->thunkpos;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2719;
  l2720:;	
  {  int yypos2721= G->pos, yythunkpos2721= G->thunkpos;
  {  int yypos2722= G->pos, yythunkpos2722= G->thunkpos;  if (!yymatchChar(G, '\r')) goto l2722;
  goto l2721;
  l2722:;	  G->pos= yypos2722; G->thunkpos= yythunkpos2722;
  }
  {  int yypos2723= G->pos, yythunkpos2723= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l2723;
  goto l2721;
  l2723:;	  G->pos= yypos2723; G->thunkpos= yythunkpos2723;
  }  if (!yymatchDot(G)) goto l2721;  goto l2720;
  l2721:;	  G->pos= yypos2721; G->thunkpos= yythunkpos2721;
  }  if (!yy_Newline(G))  goto l2719;
  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2719;  goto l2718;
  l2719:;	  G->pos= yypos2718; G->thunkpos= yythunkpos2718;  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2717;  if (!yymatchDot(G)) goto l2717;
  l2724:;	
  {  int yypos2725= G->pos, yythunkpos2725= G->thunkpos;  if (!yymatchDot(G)) goto l2725;  goto l2724;
  l2725:;	  G->pos= yypos2725; G->thunkpos= yythunkpos2725;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2717;  if (!yy_Eof(G))  goto l2717;

  }
  l2718:;	  yyprintf((stderr, "  ok   RawLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2717:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "RawLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SingleLineMetaKeyValue(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SingleLineMetaKeyValue"));
  if (!yy_MetaDataKey(G))  goto l2726;
  if (!yy_Sp(G))  goto l2726;
  if (!yymatchChar(G, ':')) goto l2726;
  if (!yy_Sp(G))  goto l2726;

  l2727:;	
  {  int yypos2728= G->pos, yythunkpos2728= G->thunkpos;
  {  int yypos2729= G->pos, yythunkpos2729= G->thunkpos;  if (!yy_Newline(G))  goto l2729;
  goto l2728;
  l2729:;	  G->pos= yypos2729; G->thunkpos= yythunkpos2729;
  }  if (!yymatchDot(G)) goto l2728;  goto l2727;
  l2728:;	  G->pos= yypos2728; G->thunkpos= yythunkpos2728;
  }  yyprintf((stderr, "  ok   SingleLineMetaKeyValue"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2726:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SingleLineMetaKeyValue"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_AlphanumericAscii(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "AlphanumericAscii"));
  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\377\003\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z0-9")) goto l2730;
  yyprintf((stderr, "  ok   AlphanumericAscii"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2730:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "AlphanumericAscii"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MetaDataValue(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "MetaDataValue"));
  if (!yy_StartList(G))  goto l2731;
  yyDo(G, yySet, -1, 0, "yySet");
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2731;
  l2732:;	
  {  int yypos2733= G->pos, yythunkpos2733= G->thunkpos;
  {  int yypos2734= G->pos, yythunkpos2734= G->thunkpos;  if (!yy_Newline(G))  goto l2734;
  goto l2733;
  l2734:;	  G->pos= yypos2734; G->thunkpos= yythunkpos2734;
  }  if (!yymatchDot(G)) goto l2733;  goto l2732;
  l2733:;	  G->pos= yypos2733; G->thunkpos= yythunkpos2733;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2731;  yyDo(G, yy_1_MetaDataValue, G->begin, G->end, "yy_1_MetaDataValue");

  {  int yypos2735= G->pos, yythunkpos2735= G->thunkpos;  if (!yy_Newline(G))  goto l2736;

  {  int yypos2737= G->pos, yythunkpos2737= G->thunkpos;
  {  int yypos2738= G->pos, yythunkpos2738= G->thunkpos;  if (!yy_BlankLine(G))  goto l2738;
  goto l2736;
  l2738:;	  G->pos= yypos2738; G->thunkpos= yythunkpos2738;
  }
  {  int yypos2739= G->pos, yythunkpos2739= G->thunkpos;  if (!yy_SingleLineMetaKeyValue(G))  goto l2739;
  goto l2736;
  l2739:;	  G->pos= yypos2739; G->thunkpos= yythunkpos2739;
  }  if (!yy_Sp(G))  goto l2736;
  if (!yy_RawLine(G))  goto l2736;
  G->pos= yypos2737; G->thunkpos= yythunkpos2737;
  }  yyDo(G, yy_2_MetaDataValue, G->begin, G->end, "yy_2_MetaDataValue");
  goto l2735;
  l2736:;	  G->pos= yypos2735; G->thunkpos= yythunkpos2735;  if (!yy_Newline(G))  goto l2731;

  }
  l2735:;	
  l2740:;	
  {  int yypos2741= G->pos, yythunkpos2741= G->thunkpos;
  {  int yypos2742= G->pos, yythunkpos2742= G->thunkpos;  if (!yy_BlankLine(G))  goto l2742;
  goto l2741;
  l2742:;	  G->pos= yypos2742; G->thunkpos= yythunkpos2742;
  }
  {  int yypos2743= G->pos, yythunkpos2743= G->thunkpos;  if (!yy_SingleLineMetaKeyValue(G))  goto l2743;
  goto l2741;
  l2743:;	  G->pos= yypos2743; G->thunkpos= yythunkpos2743;
  }
  {  int yypos2744= G->pos, yythunkpos2744= G->thunkpos;  if (!yy_YAMLStop(G))  goto l2744;
  goto l2741;
  l2744:;	  G->pos= yypos2744; G->thunkpos= yythunkpos2744;
  }  if (!yy_Sp(G))  goto l2741;
  if (!yy_RawLine(G))  goto l2741;
  yyDo(G, yy_3_MetaDataValue, G->begin, G->end, "yy_3_MetaDataValue");
  goto l2740;
  l2741:;	  G->pos= yypos2741; G->thunkpos= yythunkpos2741;
  }  yyDo(G, yy_4_MetaDataValue, G->begin, G->end, "yy_4_MetaDataValue");
  yyprintf((stderr, "  ok   MetaDataValue"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2731:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MetaDataValue"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_YAMLStop(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "YAMLStop"));

  {  int yypos2746= G->pos, yythunkpos2746= G->thunkpos;  if (!yymatchString(G, "---")) goto l2747;
  goto l2746;
  l2747:;	  G->pos= yypos2746; G->thunkpos= yythunkpos2746;  if (!yymatchString(G, "...")) goto l2745;

  }
  l2746:;	  if (!yy_BlankLine(G))  goto l2745;
  yyprintf((stderr, "  ok   YAMLStop"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2745:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "YAMLStop"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MetaDataKeyValue(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "MetaDataKeyValue"));
  if (!yy_MetaDataKey(G))  goto l2748;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_Sp(G))  goto l2748;
  if (!yymatchChar(G, ':')) goto l2748;
  if (!yy_Sp(G))  goto l2748;
  if (!yy_MetaDataValue(G))  goto l2748;
  yyDo(G, yySet, -1, 0, "yySet");
  yyDo(G, yy_1_MetaDataKeyValue, G->begin, G->end, "yy_1_MetaDataKeyValue");
  yyprintf((stderr, "  ok   MetaDataKeyValue"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2748:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MetaDataKeyValue"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_SetextHeading(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "SetextHeading"));
  if (!yy_NonindentSpace(G))  goto l2749;

  {  int yypos2750= G->pos, yythunkpos2750= G->thunkpos;  if (!yy_SetextHeading1(G))  goto l2751;
  goto l2750;
  l2751:;	  G->pos= yypos2750; G->thunkpos= yythunkpos2750;  if (!yy_SetextHeading2(G))  goto l2749;

  }
  l2750:;	  yyprintf((stderr, "  ok   SetextHeading"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2749:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "SetextHeading"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BlankLine(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BlankLine"));
  if (!yy_Sp(G))  goto l2752;
  if (!yy_Newline(G))  goto l2752;
  yyprintf((stderr, "  ok   BlankLine"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2752:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BlankLine"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Block(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Block"));

  l2754:;	
  {  int yypos2755= G->pos, yythunkpos2755= G->thunkpos;  if (!yy_BlankLine(G))  goto l2755;
  goto l2754;
  l2755:;	  G->pos= yypos2755; G->thunkpos= yythunkpos2755;
  }
  {  int yypos2756= G->pos, yythunkpos2756= G->thunkpos;  if (!yy_BlockQuote(G))  goto l2757;
  goto l2756;
  l2757:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2758;  if (!yy_Fenced(G))  goto l2758;
  goto l2756;
  l2758:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_Verbatim(G))  goto l2759;
  goto l2756;
  l2759:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2760;  if (!yy_DefinitionList(G))  goto l2760;
  goto l2756;
  l2760:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2761;  if (!yy_Glossary(G))  goto l2761;
  goto l2756;
  l2761:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_Note(G))  goto l2762;
  goto l2756;
  l2762:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_LinkReference(G))  goto l2763;
  goto l2756;
  l2763:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2764;  if (!yy_Abbreviation(G))  goto l2764;
  goto l2756;
  l2764:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_HorizontalRule(G))  goto l2765;
  goto l2756;
  l2765:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( ext(EXT_HEADINGSECTION) )) goto l2766;  if (!yy_HeadingSection(G))  goto l2766;
  goto l2756;
  l2766:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_Heading(G))  goto l2767;
  goto l2756;
  l2767:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_OrderedList(G))  goto l2768;
  goto l2756;
  l2768:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_BulletList(G))  goto l2769;
  goto l2756;
  l2769:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_HtmlBlock(G))  goto l2770;
  goto l2756;
  l2770:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_MarkdownHtmlBlock(G))  goto l2771;
  goto l2756;
  l2771:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_StyleBlock(G))  goto l2772;
  goto l2756;
  l2772:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2773;  if (!yy_Table(G))  goto l2773;
  goto l2756;
  l2773:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2774;  if (!yy_ImageBlock(G))  goto l2774;
  goto l2756;
  l2774:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) )) goto l2775;  if (!yy_TOC(G))  goto l2775;
  goto l2756;
  l2775:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;
  {  int yypos2777= G->pos, yythunkpos2777= G->thunkpos;  if (!yy_Sp(G))  goto l2777;
  if (!yy_HtmlBlockInTags(G))  goto l2777;
  goto l2776;
  l2777:;	  G->pos= yypos2777; G->thunkpos= yythunkpos2777;
  }  if (!yy_Para(G))  goto l2776;
  goto l2756;
  l2776:;	  G->pos= yypos2756; G->thunkpos= yythunkpos2756;  if (!yy_Plain(G))  goto l2753;

  }
  l2756:;	  yyprintf((stderr, "  ok   Block"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2753:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Block"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_MetaData(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 1, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "MetaData"));
  if (!yy_StartList(G))  goto l2778;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2779= G->pos, yythunkpos2779= G->thunkpos;  if (!yy_YAMLStart(G))  goto l2780;
  goto l2779;
  l2780:;	  G->pos= yypos2779; G->thunkpos= yythunkpos2779;
  {  int yypos2781= G->pos, yythunkpos2781= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z")) goto l2781;

  l2782:;	
  {  int yypos2783= G->pos, yythunkpos2783= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z")) goto l2783;
  goto l2782;
  l2783:;	  G->pos= yypos2783; G->thunkpos= yythunkpos2783;
  }  if (!yymatchString(G, "://")) goto l2781;
  goto l2778;
  l2781:;	  G->pos= yypos2781; G->thunkpos= yythunkpos2781;
  }
  {  int yypos2784= G->pos, yythunkpos2784= G->thunkpos;  if (!yy_SetextHeading(G))  goto l2784;
  goto l2778;
  l2784:;	  G->pos= yypos2784; G->thunkpos= yythunkpos2784;
  }
  }
  l2779:;	  if (!yy_MetaDataKeyValue(G))  goto l2778;
  yyDo(G, yy_1_MetaData, G->begin, G->end, "yy_1_MetaData");

  l2785:;	
  {  int yypos2786= G->pos, yythunkpos2786= G->thunkpos;  if (!yy_MetaDataKeyValue(G))  goto l2786;
  yyDo(G, yy_1_MetaData, G->begin, G->end, "yy_1_MetaData");
  goto l2785;
  l2786:;	  G->pos= yypos2786; G->thunkpos= yythunkpos2786;
  }
  {  int yypos2787= G->pos, yythunkpos2787= G->thunkpos;  if (!yy_YAMLStop(G))  goto l2787;
  goto l2788;
  l2787:;	  G->pos= yypos2787; G->thunkpos= yythunkpos2787;
  }
  l2788:;	  yyDo(G, yy_2_MetaData, G->begin, G->end, "yy_2_MetaData");
  yyprintf((stderr, "  ok   MetaData"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 1, 0, "yyPop");
  return 1;
  l2778:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MetaData"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Newline(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "Newline"));

  {  int yypos2790= G->pos, yythunkpos2790= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l2791;
  goto l2790;
  l2791:;	  G->pos= yypos2790; G->thunkpos= yythunkpos2790;  if (!yymatchChar(G, '\r')) goto l2789;

  {  int yypos2792= G->pos, yythunkpos2792= G->thunkpos;  if (!yymatchChar(G, '\n')) goto l2792;
  goto l2793;
  l2792:;	  G->pos= yypos2792; G->thunkpos= yythunkpos2792;
  }
  l2793:;	
  }
  l2790:;	  yyprintf((stderr, "  ok   Newline"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2789:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Newline"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Sp(GREG *G)
{  yyprintfv((stderr, "%s\n", "Sp"));

  l2795:;	
  {  int yypos2796= G->pos, yythunkpos2796= G->thunkpos;  if (!yy_Spacechar(G))  goto l2796;
  goto l2795;
  l2796:;	  G->pos= yypos2796; G->thunkpos= yythunkpos2796;
  }  yyprintf((stderr, "  ok   Sp"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
}
YY_RULE(int) yy_MetaDataKey(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "MetaDataKey"));
  yyText(G, G->begin, G->end);  if (!(YY_BEGIN)) goto l2797;
  {  int yypos2798= G->pos, yythunkpos2798= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z")) goto l2798;

  l2799:;	
  {  int yypos2800= G->pos, yythunkpos2800= G->thunkpos;  if (!yymatchClass(G, (const unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000", "A-Za-z")) goto l2800;
  goto l2799;
  l2800:;	  G->pos= yypos2800; G->thunkpos= yythunkpos2800;
  }  if (!yymatchString(G, "://")) goto l2798;
  goto l2797;
  l2798:;	  G->pos= yypos2798; G->thunkpos= yythunkpos2798;
  }  if (!yy_AlphanumericAscii(G))  goto l2797;

  l2801:;	
  {  int yypos2802= G->pos, yythunkpos2802= G->thunkpos;  if (!yy_Sp(G))  goto l2802;

  {  int yypos2805= G->pos, yythunkpos2805= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l2806;
  goto l2805;
  l2806:;	  G->pos= yypos2805; G->thunkpos= yythunkpos2805;  if (!yymatchChar(G, '_')) goto l2807;
  goto l2805;
  l2807:;	  G->pos= yypos2805; G->thunkpos= yythunkpos2805;  if (!yymatchChar(G, ' ')) goto l2808;
  goto l2805;
  l2808:;	  G->pos= yypos2805; G->thunkpos= yythunkpos2805;  if (!yymatchChar(G, '-')) goto l2809;
  goto l2805;
  l2809:;	  G->pos= yypos2805; G->thunkpos= yythunkpos2805;  if (!yymatchChar(G, '.')) goto l2802;

  }
  l2805:;	
  l2803:;	
  {  int yypos2804= G->pos, yythunkpos2804= G->thunkpos;
  {  int yypos2810= G->pos, yythunkpos2810= G->thunkpos;  if (!yy_AlphanumericAscii(G))  goto l2811;
  goto l2810;
  l2811:;	  G->pos= yypos2810; G->thunkpos= yythunkpos2810;  if (!yymatchChar(G, '_')) goto l2812;
  goto l2810;
  l2812:;	  G->pos= yypos2810; G->thunkpos= yythunkpos2810;  if (!yymatchChar(G, ' ')) goto l2813;
  goto l2810;
  l2813:;	  G->pos= yypos2810; G->thunkpos= yythunkpos2810;  if (!yymatchChar(G, '-')) goto l2814;
  goto l2810;
  l2814:;	  G->pos= yypos2810; G->thunkpos= yythunkpos2810;  if (!yymatchChar(G, '.')) goto l2804;

  }
  l2810:;	  goto l2803;
  l2804:;	  G->pos= yypos2804; G->thunkpos= yythunkpos2804;
  }  goto l2801;
  l2802:;	  G->pos= yypos2802; G->thunkpos= yythunkpos2802;
  }  yyText(G, G->begin, G->end);  if (!(YY_END)) goto l2797;  yyDo(G, yy_1_MetaDataKey, G->begin, G->end, "yy_1_MetaDataKey");
  yyprintf((stderr, "  ok   MetaDataKey"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2797:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "MetaDataKey"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_YAMLStart(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "YAMLStart"));
  if (!yymatchString(G, "---")) goto l2815;
  if (!yy_BlankLine(G))  goto l2815;
  yyprintf((stderr, "  ok   YAMLStart"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2815:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "YAMLStart"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_StartList(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "StartList"));

  {  int yypos2817= G->pos, yythunkpos2817= G->thunkpos;  if (!yymatchDot(G)) goto l2816;  G->pos= yypos2817; G->thunkpos= yythunkpos2817;
  }  yyDo(G, yy_1_StartList, G->begin, G->end, "yy_1_StartList");
  yyprintf((stderr, "  ok   StartList"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2816:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "StartList"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_BOM(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyprintfv((stderr, "%s\n", "BOM"));
  if (!yymatchString(G, "\357\273\277")) goto l2818;
  yyprintf((stderr, "  ok   BOM"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));

  return 1;
  l2818:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "BOM"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}
YY_RULE(int) yy_Doc(GREG *G)
{  int yypos0= G->pos, yythunkpos0= G->thunkpos;  yyDo(G, yyPush, 2, 0, "yyPush");
  yyprintfv((stderr, "%s\n", "Doc"));

  {  int yypos2820= G->pos, yythunkpos2820= G->thunkpos;  if (!yy_BOM(G))  goto l2820;
  goto l2821;
  l2820:;	  G->pos= yypos2820; G->thunkpos= yythunkpos2820;
  }
  l2821:;	  if (!yy_StartList(G))  goto l2819;
  yyDo(G, yySet, -2, 0, "yySet");
  if (!yy_StartList(G))  goto l2819;
  yyDo(G, yySet, -1, 0, "yySet");

  {  int yypos2822= G->pos, yythunkpos2822= G->thunkpos;  yyText(G, G->begin, G->end);  if (!( !ext(EXT_COMPATIBILITY) && !ext(EXT_NO_METADATA) )) goto l2822;
  {  int yypos2824= G->pos, yythunkpos2824= G->thunkpos;
  {  int yypos2825= G->pos, yythunkpos2825= G->thunkpos;  if (!yy_YAMLStart(G))  goto l2825;
  goto l2826;
  l2825:;	  G->pos= yypos2825; G->thunkpos= yythunkpos2825;
  }
  l2826:;	  if (!yy_MetaDataKey(G))  goto l2822;
  if (!yy_Sp(G))  goto l2822;
  if (!yymatchChar(G, ':')) goto l2822;
  if (!yy_Sp(G))  goto l2822;

  {  int yypos2827= G->pos, yythunkpos2827= G->thunkpos;  if (!yy_Newline(G))  goto l2827;
  goto l2822;
  l2827:;	  G->pos= yypos2827; G->thunkpos= yythunkpos2827;
  }  G->pos= yypos2824; G->thunkpos= yythunkpos2824;
  }  if (!yy_MetaData(G))  goto l2822;
  yyDo(G, yy_1_Doc, G->begin, G->end, "yy_1_Doc");
  goto l2823;
  l2822:;	  G->pos= yypos2822; G->thunkpos= yythunkpos2822;
  }
  l2823:;	
  l2828:;	
  {  int yypos2829= G->pos, yythunkpos2829= G->thunkpos;  if (!yy_Block(G))  goto l2829;
  yyDo(G, yy_2_Doc, G->begin, G->end, "yy_2_Doc");
  goto l2828;
  l2829:;	  G->pos= yypos2829; G->thunkpos= yythunkpos2829;
  }
  l2830:;	
  {  int yypos2831= G->pos, yythunkpos2831= G->thunkpos;  if (!yy_BlankLine(G))  goto l2831;
  goto l2830;
  l2831:;	  G->pos= yypos2831; G->thunkpos= yythunkpos2831;
  }  yyDo(G, yy_3_Doc, G->begin, G->end, "yy_3_Doc");
  yyprintf((stderr, "  ok   Doc"));
  yyprintfGcontext;
  yyprintf((stderr, "\n"));
  yyDo(G, yyPop, 2, 0, "yyPop");
  return 1;
  l2819:;	  G->pos= yypos0; G->thunkpos= yythunkpos0;  yyprintfv((stderr, "  fail %s", "Doc"));
  yyprintfvGcontext;
  yyprintfv((stderr, "\n"));

  return 0;
}

#ifndef YY_PART

typedef int (*yyrule)(GREG *G);

YY_PARSE(int) YY_NAME(parse_from)(GREG *G, yyrule yystart)
{
  int yyok;
  if (!G->buflen)
    {
      G->buflen= YY_BUFFER_START_SIZE;
      G->buf= (char*)YY_ALLOC(G->buflen, G->data);
      G->textlen= YY_BUFFER_START_SIZE;
      G->text= (char*)YY_ALLOC(G->textlen, G->data);
      G->thunkslen= YY_STACK_SIZE;
      G->thunks= (yythunk*)YY_ALLOC(sizeof(yythunk) * G->thunkslen, G->data);
      G->valslen= YY_STACK_SIZE;
      G->vals= (YYSTYPE*)YY_ALLOC(sizeof(YYSTYPE) * G->valslen, G->data);
      G->begin= G->end= G->pos= G->limit= G->thunkpos= 0;
    }
  G->pos = 0;
  G->begin= G->end= G->pos;
  G->thunkpos= 0;
  G->val= G->vals;
  yyok= yystart(G);
  if (yyok) yyDone(G);
  yyCommit(G);
  return yyok;
  (void)yyrefill;
  (void)yymatchDot;
  (void)yymatchChar;
  (void)yymatchString;
  (void)yymatchClass;
  (void)yyDo;
  (void)yyText;
  (void)yyDone;
  (void)yyCommit;
  (void)yyAccept;
  (void)yyPush;
  (void)yyPop;
  (void)yySet;
}

YY_PARSE(int) YY_NAME(parse)(GREG *G)
{
  return YY_NAME(parse_from)(G, yy_Doc);
}

YY_PARSE(void) YY_NAME(init)(GREG *G)
{
    memset(G, 0, sizeof(GREG));
}
YY_PARSE(void) YY_NAME(deinit)(GREG *G)
{
    if (G->buf) YY_FREE(G->buf);
    if (G->text) YY_FREE(G->text);
    if (G->thunks) YY_FREE(G->thunks);
    if (G->vals) YY_FREE((void*)G->vals);
}
YY_PARSE(GREG *) YY_NAME(parse_new)(YY_XTYPE data)
{
  GREG *G = (GREG *)YY_CALLOC(1, sizeof(GREG), G->data);
  G->data = data;
  return G;
}

YY_PARSE(void) YY_NAME(parse_free)(GREG *G)
{
  YY_NAME(deinit)(G);
  YY_FREE(G);
}

#endif


/* process_raw_blocks -- follow the tree and process any RAW nodes and insert them
	into the tree */
node * process_raw_blocks(node * n, unsigned long extensions) {
	/* from the parser data we get the parent node and pointer to reference list */
	node *current = NULL;
	node *last_child = NULL;
	char *contents;
	char *saveptr = NULL;
	GREG g;

	current = n;
	
	while (current != NULL) {
		if (current->key == RAW) {
			/* Process this RAW block */
			
			yyinit(&g);
			contents = strtok_r(current->str, "\001", &saveptr);
			current->key = LIST;
			g.data = mk_parser_data(contents, (extensions | EXT_NO_METADATA ));
			
			/*
				An endless loop was discovered by a user:

				https://github.com/fletcher/MultiMarkdown-5/issues/30

				It seems that for some reason, a list item consisting only of a "\",
				under certain circumstances, generates an endless loop:

					1. \

				The parser repeatedly asks for yy_input_func, which returns 0.  And the 
				parser then cycles through every possible match over and over and over.

				I haven't found the problem, but can institute a failsafe by ensuring that
				there is something left in the buffer.

				TODO: \todo: Would like to actually fix this, and not just avoid it.
			*/

			parser_data * d = (parser_data *)g.data;

			//while (yyparse(&g));

			while ((yyparse(&g)) && (*d->charbuf != '\0'));
			
			current->children = ((parser_data *)g.data)->result;
			
			free((parser_data *)g.data);	/* we're not using free_parser_data to preserve result tree */
			
			yydeinit(&g);
			
			last_child = current->children;
			while ((contents = strtok_r(NULL, "\001", &saveptr))) {
				while (last_child->next != NULL) 
					last_child = last_child->next;
					
					yyinit(&g);
					g.data = mk_parser_data(contents, (extensions | EXT_NO_METADATA ));
					while (yyparse(&g));
					last_child->next = ((parser_data *)g.data)->result;
					free((parser_data *)g.data);
					yydeinit(&g);
			}
			free(current->str);
			current->str = NULL;
		}
		if (current->children != NULL) {
			/* Recurse into children */
			current->children = process_raw_blocks(current->children, extensions);
		}
		current = current->next;
	}
	return n;
}


node * markdown_chunk_to_node(const char * source, unsigned long extensions) {
	/* 
		Designed for parsing 'chunks' of markdown from inside a specific range,
		e.g. a label from '[' ... ']' that can have various markup inside

		Prevents situations where the parser gets greedy and goes beyond the 
		intended boundaries.
	*/

	/* fprintf(stderr, "Process '%s'\n",source); */

	GREG g;
	yyinit(&g);
	node * result;

	g.data = mk_parser_data(source, extensions);

	while (yyparse(&g));

	result = process_raw_blocks(((parser_data *)g.data)->result, extensions);

	((parser_data *)g.data)->result = NULL;

	free_parser_data((parser_data *)g.data);
	yydeinit(&g);

	return result;
}


node * parse_markdown(const char * source, unsigned long extensions, int format) {
	char *formatted;
	char *critic_resolved;
	char *target_meta_key = FALSE;
	char *temp;
	node *refined;
	GREG g;               /* create parser context */
	yyinit(&g);

	/* Check for beamer mode in metadata */
	target_meta_key = extract_metadata_value(source, extensions, "latexmode");
	if (target_meta_key != NULL) {
		temp = label_from_string(target_meta_key);
		if (strcmp(temp, "beamer") == 0) {
				extensions = extensions | EXT_HEADINGSECTION;				
		}
		free(temp);
	}
	free(target_meta_key);

	/* Resolve Critic Markup before parsing */
	if ((extensions & EXT_CRITIC_ACCEPT) || (extensions & EXT_CRITIC_REJECT)) {
		g.data = mk_parser_data(source, extensions);

		while (yyparse_from(&g, yy_DocForCritic));
		
		if (extensions & EXT_CRITIC_REJECT) {
			if ((extensions & EXT_CRITIC_ACCEPT) && (format == HTML_FORMAT))
				critic_resolved = export_node_tree(((parser_data *)g.data)->result, CRITIC_HTML_HIGHLIGHT_FORMAT, extensions);
			else
				critic_resolved = export_node_tree(((parser_data *)g.data)->result, CRITIC_REJECT_FORMAT, extensions);
		} else {
			critic_resolved = export_node_tree(((parser_data *)g.data)->result, CRITIC_ACCEPT_FORMAT , extensions);
		}

		free_parser_data((parser_data *)g.data);
		yydeinit(&g);
		yyinit(&g);

		formatted = preformat_text(critic_resolved);
		free(critic_resolved);
	} else {
		formatted = preformat_text(source);
	}
	
	g.data = mk_parser_data(formatted,extensions);
	
	if (format == OPML_FORMAT) {
		while (yyparse_from(&g, yy_DocForOPML));	/* We want simpler version */
	} else if (format == TOC_FORMAT) {
		while (yyparse_from(&g, yy_DocForTOC));		/* We want simpler version */
	} else {
		while (yyparse(&g));       /* parse */
	}

	if (((parser_data *)g.data)->parse_aborted) {
		/*
			2015-11-28 - I don't believe this error had occurred in years.  More recently,
			however, the check_timeout() function has been disabled. - FTP
		*/

		/* clean up */
		free_parser_data((parser_data *)g.data);
		yydeinit(&g);
		
		free(formatted);
		
		return NULL;
	}

	refined = process_raw_blocks(((parser_data *)g.data)->result, extensions);    /* iteratively parse RAW bits */

	/* move autolabels to main parse tree */
	if (((parser_data *)g.data)->autolabels != NULL) {
//		fprintf(stderr, "We have autolabels\n");
		append_list(((parser_data *)g.data)->autolabels,refined);
		((parser_data *)g.data)->autolabels = NULL;	
	} else {
//		fprintf(stderr, "No autolabels\n");
	}
	
	/* clean up */
	free_parser_data_preserving_result((parser_data *)g.data);
	yydeinit(&g);
	
	free(formatted);

	return refined;
}


char * markdown_to_string(const char * source, unsigned long extensions, int format) { 
	char * output;
	node * parse_tree;

	/* Parse source (Multi)Markdown text */
	parse_tree = parse_markdown(source, extensions, format);

	if (parse_tree == NULL) {
		output = strdup("");
		return output;
	}

	/* Convert to desired output format */
	output = export_node_tree(parse_tree, format, extensions);

	free_node_tree(parse_tree);
	return output;
}


/* has_metadata -- determine whether metadata exists or not */
bool has_metadata(const char *source, unsigned long extensions) {
	char *formatted;
	GREG g;
	yyinit(&g);
	node *result;
	bool answer = FALSE;
	
	formatted = preformat_text(source);
	g.data = mk_parser_data(formatted, extensions);
    
	while (yyparse_from(&g, yy_DocForMetaDataOnly));	/* We want simpler version */

	result = ((parser_data *)g.data)->result;

	if ((result != NULL) && (result->key == METADATA)) {
		answer = TRUE;
    }

	free_parser_data((parser_data *)g.data);
	yydeinit(&g);
	
	free(formatted);
	return answer;
}


/* extract_metadata_keys -- return list of metadata keys as "\n" separated list */
char * extract_metadata_keys(const char *source, unsigned long extensions) {
	char *out;
	char *formatted;
	GREG g;
	yyinit(&g);
	
	/* don't preformat if doing syntax highlighting */
	formatted = preformat_text(source);
	g.data = mk_parser_data(formatted,extensions);
	
	while (yyparse_from(&g, yy_DocForMetaDataOnly));	/* We want simpler version */

	if (((parser_data *)g.data)->parse_aborted) {
		out = strdup("MultiMarkdown was unable to parse this file.");
	} else {
		out = metadata_keys(((parser_data *)g.data)->result);
	}
	
	free_parser_data((parser_data *)g.data);
	yydeinit(&g);
	
	free(formatted);
	return out;
}


/* extract_metadata_value -- find the value and return it */
char * extract_metadata_value(const char *source, unsigned long extensions, char *key) {
	char *out;
	char *formatted;
	GREG g;
	yyinit(&g);
	
	/* don't preformat if doing syntax highlighting */
	formatted = preformat_text(source);
	g.data = mk_parser_data(formatted,extensions);
	
	while (yyparse_from(&g, yy_DocForMetaDataOnly));	/* We want simpler version */

	if (((parser_data *)g.data)->parse_aborted) {
		out = strdup("MultiMarkdown was unable to parse this file.");
	} else {
		out = metavalue_for_key(key,((parser_data *)g.data)->result);
	}
	
	
	free_parser_data((parser_data *)g.data);
	yydeinit(&g);
	
	free(formatted);
	return out;
}

